#!/usr/bin/perl 

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$abid = $CGI->param("abid");
$pid = getPlayerID();

#Fill Variables
$db = dbconnect();
local($tab) = $db->prepare("explain abilities");
$tab->execute;
$i = 0;
while (@arrtemp = $tab->fetchrow_array)
{
  $arr[$i] = $arrtemp[0];
  $arrTypes[$i] = $arrtemp[1];
  #print "$arr[$i] - $arrTypes[$i]<br>\n";
  $i++;
}
$numFields = $i;
$tab->finish;
local($query) = $db->prepare("select * from abilities where abid = $abid");
$query->execute;
@cqquery = $query->fetchrow_array;
for ($k=0;$k<$tab->rows;$k++)
{
$cqquery[$k] =~ s/'/\\'/g;
$cqquery[$k] =~ s/"/\"/g;
#print "\$$arr[$k] = $cqquery[$k]<br>\n";
    if ($arrTypes[$k] eq 'tinyint(1)')
    {
	if ($cqquery[$k] > 0)
	{
	    eval("\$$arr[$k] = 'yes'");
	}
	else
	{
	    eval("\$$arr[$k] = 'no'");
	}
    }
    else
    {
	eval("\$$arr[$k] = '$cqquery[$k]'");
    }
}
$query->finish;

print $CGI->header();
print"<html>\n";
print"<head>\n";
print"<link href=\"../brassy.css\" rel=\"stylesheet\" type=\"text/css\">\n";
print"<title>$name</title>\n";
print"</head>\n";
print"<body>\n";

local ($asholy) = treatasholy() + 0;
if ($asholy > 0)
{
  $type = 'Celestial';
  $effect =~ s/Infernal/Celestial/g;
  $other_constraints =~ s/Infernal/Celestial/g;
}

print"<H1>$name</H1>\n";
print"<p>\n";

print"<b>Ability Type:</b> $type<BR><BR>\n";

print"<b>Ability Category:</b> $category\n";

if ($defend eq "yes")
{
   print" -- defend";
}

print "<BR><BR>\n";

print"<b>Ability Cost Type:</b> $difficulty\n";


if ($difficulty eq "Cost")
{
	print"-- $cost<BR><BR>\n";
}
	
print"<BR><BR>\n";

$effect =~ s/\n/<BR>/g;
print"<b>Effect:</b><BR>\n";
print"$effect<BR><BR>\n";

print"<b>Challenge:</b>\n";
print"$challenge";
if ($challenge ne "Unchallenged")
{
   print" vs. $challenge_defense\n";
}

print"<BR><BR>\n";

if ($type eq "Spell")
{
   print"<b>Time to Prepare:</b>  $time\n"; 
}
else
{
   print"<b>Time to Use:</b>  $time\n"; 
}

print"<b>Number of Uses:</b>  $uses<BR><BR>\n";

$other_constraints =~ s/\n/<BR>/g;
print"<b>Other Constraints:</b><BR>\n";
print"$other_constraints<BR><BR>\n";

print"<b>Level of Availability:</b> $allowed\n";

print"</p>\n";
if ($type eq "Resource")
{
	showResourceLinks();
}

if ($type eq "Spell")
{
	showComponents();
}

print"</body>\n";
print"</html>\n";

$db->disconnect;

exit 0;


sub showResourceLinks()
{
	local ($sql) = "select a.type, b.level from resourcetypes a, resourcetypelink b where a.typeid=b.typeid and b.abid=$abid;";
	#print "$sql<BR>";
	local($query) = $db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	   print "<HR>\n";
	   print "<H2>Resource Links</H2>\n";
	   print "<p><i>Resources allow you different types of access during the game.  The levels may change over the course of the game.</i><BR><BR>\n";
	   $levels[0] = "Bankrupt";
	   $levels[1] = "Low";
	   $levels[2] = "Average";
	   $levels[3] = "High";
	   $levels[4] = "Super";
	   print "<ul>\n";
	   while (@array = $query->fetchrow_array())
	   {
	     print "<li style=\"font-family : Arial, Helvetica, sans-serif; font-size: 12;\"><b>$array[0]:</b>  $levels[$array[1]]</li>";
	   }
	   print "</ul>\n";
	   print "</p>\n";
	}
	$query->finish;
}

sub showComponents()
{
	if (getAccessLevel($pid) < $gm_access)
	{
	   $sql = "select b.scname, a.sideeffect, b.scorigin, c.charid from spellcomponentslink a, spellcomponents b, spellcomponentscharacterlink c where a.scid=b.scid and a.abid=$abid and a.sclid=c.sclid order by b.scname;";
	}
	else
	{
	   $sql = "select b.scname, a.sideeffect, b.scorigin, 0 from spellcomponentslink a, spellcomponents b where a.scid=b.scid and a.abid=$abid order by b.scname;";
	}
	#print "$sql<BR>";
	local($query) = $db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	   print "<HR>\n";
	   print "<H2>Spell Components</H2>\n";
	   print "<p><i>Different components have different effects on the spell.  Players are welcome to experiment with different components for different spells.</i><BR><BR>\n";
	   print "<table border=1>\n";
	   print "<tr>\n";
	   print "<td><b>Name</b></td>\n";
	   print "<td><b>Effect</b></td>\n";
	   print "<td><b>Found In</b></td>\n";
	   print "</tr>\n";
	   while (@array = $query->fetchrow_array())
	   {
	     local($mypid) = getPIDFromCharID($array[3]);
	     if ($array[3] == 0 || "$mypid" eq "$pid")
	     {
	   	print "<tr>\n";
	   	print "<td>$array[0]</td>\n";
	   	print "<td>$array[1]</td>\n";
	   	print "<td>$array[2]</td>\n";
	   	print "</tr>\n";
	     }
	   }
	   print "</table>\n";
	   print "</p>\n";
	}
	$query->finish;
}


sub treatasholy()
{
	local ($sql) = "select charid from charabilityallowed where abid=$abid and asholy=1;";
	#print "$sql<BR>";
	local($query) = $db->prepare($sql);
	$query->execute;
	$retval = -1;
	if ($query->rows > 0)
	{
	  local (@array);
	  while (@array = $query->fetchrow_array())
	  {
	    local($charid) = $array[0];
	    local($mypid) = getPIDFromCharID($charid);
	    #print "$charid -- $mypid -- $pid<BR>";
	    if ("$mypid" eq "$pid")
	    {
	       $retval = $pid;
	    }
	  }
	}
	$query->finish;
	return $retval;
}
