#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "action.pl";
$table = "actionitems";
$heading = "Action Item";
$keyfield = "acid";
$keyvalue = $CGI->param($keyfield);
$namefield = "name";
$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
$tplfile = "action.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $namevalue</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">";
	if ($tplfile eq "")
	{
		local($dbvar) = dbconnect();
		local($query) = $dbvar->prepare("explain $table");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $dbvar->prepare("select * from $table where $keyfield = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$dbvar->disconnect;
		print "</table>";
	}
	else
	{
	     fillvars();
	     ParseForm($tplfile);
	}
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$SQL = "delete from playeractionitems where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Deleted"));
}
elsif ($action eq "assign")
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s: Assign Players to: $namevalue";
	ParseForm($header);
		
	print "<H1>$doctitle </h1>\n";

	local($db) = dbconnect();
	local ($sql) = "select playerid, pfirst, plast, psecurity from players where psecurity >= $writer_access order by psecurity, plast;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1 width=100%>\n";
	print "<tr>\n";
	print "<td><b>Player Name</b></td>\n";
	print "<td><b>Level</b></td>\n";
	print "<td><b>Assigned</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	local (@array);
	while (@array = $query->fetchrow_array())
	{
	   $isassigned = dosql("select count(playerid) from playeractionitems where playerid=$array[0] and $keyfield = $keyvalue;") + 0;
	   $assigned = min($assigned,1);
	   print "<tr>\n";
	   print "<td>$array[1] $array[2]</td>\n";
	   print "<td>$playertype[$array[3]]</td>\n";
	   print "<td>$yesnob[$isassigned]</td>\n";
	   print "<td>";
	   if ($isassigned == 0)
	   {
	      print "<a href=\"$thispage?action=addpl&$keyfield=$keyvalue&playerid=$array[0]\">Assign</a>\n";
	   }
	   else
	   {
	      print "<a href=\"$thispage?action=rempl&$keyfield=$keyvalue&playerid=$array[0]\">Revoke</a>\n";
	   }
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
	
	print "<br><hr><a href=\"$thispage\">Return</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "addpl")
{
	#print $CGI->header;
	$playerid = $CGI->param("playerid");
	$SQL = "insert into playeractionitems (acid, playerid) values ($keyvalue, $playerid);";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?$keyfield=$keyvalue&action=assign");
}
elsif ($action eq "rempl")
{
	$playerid = $CGI->param("playerid");
	$SQL = "delete from playeractionitems where playerid=$playerid and $keyfield = $keyvalue;";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?$keyfield=$keyvalue&action=assign");
}
elsif ($action eq "status")
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s: Update Status for: $namevalue";
	ParseForm($header);
		
	print "<H1>$doctitle</h1>\n";

	print "<form action=\"$thispage\" method=\"post\">";

	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"updatestatus\">\n";

	$table = "playeractionitems";
	$keyvalue .= " and playerid = $pid";
	filltable();
	
	$status =~ s/\n/<BR>\n/g;
	ParseForm("actionstatus.tpl");

	print "<input type=\"submit\" name=\"submit\" value=\"Update\"><BR>";
	print "</form>";
	
	print "<br><hr><a href=\"$thispage\">Return</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "updatestatus")
{
	#print $CGI->header();
	# Update and Redirect
	$status = dosql("select status from playeractionitems where $keyfield=$keyvalue and playerid = $pid");
	
	$newstatus = $CGI->param("status");
	if ("$newstatus" ne "")
	{
	   $myname =  getFullNameFromID($pid);
	   $date = getDate();
	   $status .= "\n\n<b>$date - $myname</b>\n";
	   $status .= $newstatus;
	}
		
	$status =~ s/<BR>/\n/g;
	$status =~ s/'/''/g;
	
	$completed = $CGI->param("completed") + 0;
	$datecompleted = getDBDate();

	$SQL = "update playeractionitems set status='$status', completed = $completed, datecompleted='$datecompleted' where $keyfield=$keyvalue and playerid = $pid;";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Status Updated"));
}
elsif ($action eq "mailremind")
{
	# Mail and Redirect
	#print $CGI->header;
	local($dbvar) = dbconnect();
	$sql = "select playerid from players";
	local ($query) = $dbvar->prepare($sql);
	$query->execute;
	local @array;
	while (@array = $query->fetchrow_array())
	{
	   $sql = "select * from playeractionitems a, actionitems b where a.acid=b.acid and a.playerid=$array[0] and a.completed=0;";
	   local ($query2) = $dbvar->prepare($sql);
	   $query2->execute;
	   if ($query2->rows > 0)
	   {
	      $email = getEmailFromID($array[0]);
	      local ($resptr);
	      $message = "This is a reminder from the $campaign Action Item System.\n\n";
	      $message .= "The following are your incomplete action items.\n\n";
	      $message .= "Please go to the $campaign database to mark your action items completed.\n\n";
	      while ($resptr = $query2->fetchrow_hashref())
	      {
	   	$message .= $resptr->{"$namefield"};
	   	$message .= ".  Due: ";
	   	$message .= $resptr->{"duedate"} ."\n";
	   	$message .= $resptr->{"description"} ."\n\n";
	      }
	      $query2->finish;
	      $sql = "select * from actionitems a;";
	      #print "$sql<BR>";
	      $query2 = $dbvar->prepare($sql);
	      $query2->execute;
	      if ($query2->rows > 0)
	      {
	           $message .= "\n\nThe following action items are unassigned.\n\n";
	           while ($resptr = $query2->fetchrow_hashref())
	           {
	      	     $sql = "select playerid from playeractionitems where acid=" . $resptr->{"acid"};
	      	     #print "$sql<BR>\n";
	             if (dosql($sql) + 0 == 0)
	             {
	   	        $message .= $resptr->{"$namefield"};
	   	        $message .= ".  Due: ";
	   	        $message .= $resptr->{"duedate"} ."\n";
	   	        $message .= $resptr->{"description"} ."\n\n";
	             }
	           }
	      }
	      $query2->finish;
	      #$message =~ s/\n/<BR>\n/g;
	      #print "$message<BR>";
	      sendDBMail($email, "Your $campaign Action Items Reminder", $message);
	   }
	}
	$query->finish;
	
	$dbvar->disconnect;	
	print $CGI->redirect("$thispage?error=" . encodeURL("Mailed Status Reminders"));
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s";
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle </h1>\n";

	print "<a href=\"$thispage?action=new\">ADD a NEW $heading</a><BR><BR>\n";
	
	print "<a href=\"$thispage?action=mailremind\">Mail Action Item Reminders</a><BR><BR>\n";
	
	print "<H2>Your Items</H2>\n";
	showmyitems();
	
	print "<H2>All Items</H2>\n";
	showdata(0);

	print "<H2>Completed Items</H2>\n";
	showdata(1);

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showmyitems()
{
	$db = dbconnect();
	local ($sql) = "select * from $table a, playeractionitems b where a.$keyfield=b.$keyfield and b.playerid=$pid order by a.duedate, a.$namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1 width=100%>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Assigned To</b></td>\n";
	print "<td><b>Description</b></td>\n";
	print "<td><b>Due</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $key = $resptr->{"$keyfield"};
	   if (!iscompleted($key))
	   {
		   print "<tr>\n";
		   print "<td>$name</td>\n";
		   print "<td>".listassigned($key)."</td>\n";
		   print "<td>".$resptr->{"description"}."</td>\n";
		   if ($resptr->{"completed"} > 0)
		   {
		       print "<td><font color=#0000CC>You have completed this, but others have not.</font></td>\n";
		   }
		   elsif (overdue($resptr->{"duedate"}))
		   {
		       print "<td><font color=#DD0000>".$resptr->{"duedate"}." -- Overdue</font></td>\n";
		   }
		   else
		   {
		       print "<td>".$resptr->{"duedate"}."</td>\n";
		   }
		   print "<td>";
		   print "<a href=\"$thispage?action=status&$keyfield=$key\">Update Status</a>\n";
		   print "</td></tr>\n";
	   }
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub showdata()
{
        $showcompleted = $_[0];
	$db = dbconnect();
	local ($sql) = "select * from $table order by duedate, $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1 width=100%>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Assigned To</b></td>\n";
	print "<td><b>Description</b></td>\n";
	print "<td><b>Due</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $key = $resptr->{"$keyfield"};
	   $iscomp = iscompleted($key);
	   if ($iscomp == $showcompleted)
	   {
	   	   $duedate = $resptr->{"duedate"};
		   print "<tr>\n";
		   print "<td>$name</td>\n";
		   print "<td>".listassigned($key)."</td>\n";
		   print "<td>".$resptr->{"description"}."</td>\n";
		   if ($iscomp)
		   {
		       print "<td><font color=#00CC00>Completed</font></td>\n";
		   }
		   elsif (overdue($duedate))
		   {
		       print "<td><font color=#DD0000>$duedate -- Overdue</font></td>\n";
		   }
		   else
		   {
		       print "<td>$duedate</td>\n";
		   }
		   print "<td>";
		   print "<a href=\"$thispage?action=edit&$keyfield=$key\">Edit</a>\n";
		   $name =~ s/'//g;
		   print " -- <a href=\"javascript:deleteConfirm('$name',$key);\">Delete</a>\n";
		   print " -- <a href=\"$thispage?action=assign&$keyfield=$key\">Assign</a>\n";
		   print "</td></tr>\n";
	   }
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub listassigned()
{
	local ($varID) = $_[0];
	local ($sql) = "select playerid from playeractionitems where acid = $varID;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retVal = "";
	if ($query->rows > 0)
	{
	   local @array;
	   while (@array = $query->fetchrow_array())
	   {
	   	   $retVal .= emailTagFromID($array[0]) . "<BR>";
	   }
	}
	else
	{
	   $retVal .=  "None";
	}
	$query->finish;
	
	return $retVal;
}


sub fillvars()
{
	filltable();
	if ("$keyvalue" eq "")
	{
		$datecreated = getDBDate();
		$duedate = getDBDate();
	}
}

sub overdue()
{
	local ($duedate) = $_[0];
	local ($today) = getDBDate();
	
	$dueyear = $duedate;
	$dueyear =~ s/-(.*)$//;

	$toyear = $today;
	$toyear =~ s/-(.*)$//;
	
	if ($toyear > $dueyear)
	{
		return 1;	
	}
	if ($toyear < $dueyear)
	{
		return 0;	
	}
	
	$duemonth = $duedate;
	$duemonth =~ s/-/x/;
	$duemonth =~ s/(.*)x//;
	$duemonth =~ s/-(.*)$//;
	
	$tomonth = $today;
	$tomonth =~ s/-/x/;
	$tomonth =~ s/(.*)x//;
	$tomonth =~ s/-(.*)$//;
	
	if ($tomonth > $duemonth)
	{
		return 1;	
	}
	if ($tomonth < $duemonth)
	{
		return 0;	
	}
	
	$duedate =~ s/(.*)-//;

	$today =~ s/(.*)-//;
	
	if ($today > $duedate)
	{
		return 1;	
	}
	
	return 0;
}

sub iscompleted()
{
	local ($varID) = $_[0];

	$numassigned = dosql("select count(playerid) from playeractionitems where acid=$varID");
	$numcompleted = dosql("select count(playerid) from playeractionitems where acid=$varID and completed > 0");
	return (($numassigned == $numcompleted) && ($numassigned > 0));
}

