#!/usr/bin/perl

# Require and Use
# * These statements alert perl.exe that
# * you are going to be using functions, 
# * subroutines, and methods from other
# * perl programs. "require" is used for a
# * perl library, and the "use" statement 
# * is usually used to reference a perl
# * object (usually referred to as a 
# * module).
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$pid = getPlayerID();
$charid = $CGI->param("charid");
$fullname = getFullNameFromID($pid);
$charname = getCharName($charid);

local($db) = dbconnect();
local($query) =$db->prepare("select pcplayerid from playercharacters where pccharid = " . $charid);
$query->execute;
@array = $query->fetchrow_array;
if ($query->rows > 0)
{
$email = getEmailFromID($array[0]);
$query->finish;
}
#update charstory
$SQL = "update characters set charstoryapproved=2 where charid=$charid";
local($db) = dbconnect();
$db->do($SQL);
$db->disconnect;

#print $CGI->header();
#print "$pid<BR>";
#print "$charid<BR>";
#print "$fullname<BR>";
#print "$charname<BR>";

# Retrieve Date
$date = getDate();
#print "$date<BR>";

# Send E-Mail
open(MAIL, "| /usr/sbin/sendmail  -oi -t") or die "couldn't send mail: $!";
print MAIL "From: $contact\n";
print MAIL "To: $gmlist\n";
print MAIL "Cc: $email\n";
print MAIL "Subject: Character history approved for $charname\n";
print MAIL "\n";
print MAIL "The history for $charname has been approved by $fullname.  Congratulations.\n";
print MAIL "Today's date: $date\n";
print MAIL "---------------------------------------------------------------------------\n";
close(MAIL);
   
#print "done<br>";

# Return HTML Page or Redirect User
print $CGI->redirect("gmchars.pl");
