#!/usr/bin/perl

require 'stat_inc.pl';
require 'g_invest.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "restok.pl";
$table = "character";
$heading = "x";
$keyfield = "x";
$keyvalue = $CGI->param($keyfield);
$namefield = "x";
$tplfile = "x.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to visit this page!"));
}
elsif ($CGI->param("xl") ne "")
{
	#print $CGI->header;
	print $CGI->header(-type  =>  'application/vnd.ms-excel', -filename  =>  'badges.xls');
				
	$db = dbconnect();
	local ($sql) = "select c.pccharid from players a, eventplayers b, playercharacters c, characters d, chartypetraitlink e, chartypetraits f where a.playerid=b.playerid and b.eventid=$current_episode and b.reglevel > 1 and c.pcplayerid=a.playerid and c.pccharid > 0 and d.charid=c.pccharid and d.chartype=e.ctypeid and e.cttid = f.cttid and f.traitname = 'pack' and e.value=1 order by a.plast;";
	#print "$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	
	print "<table border=0>\n";
        print "<tr>\n";
        print "<td><b>CharName</b></td>\n";
        print "<td><b>PlayerName</b></td>\n";
        print "<td><b>Status</b></td>\n";
        print "<td><b>Effective Status</b></td>\n";
        print "<td><b>HP</b></td>\n";
        print "<td><b>HPx2</b></td>\n";
        print "</tr>\n";
	while (@array = $query->fetchrow_array())
	{
	   $charid = $array[0];
	   $status = dosql ("select status from characterSTATs where charid=$charid;");
	   $effstat = $status + getlevel("GENUINE CURIOUSITY/FAMOUS") - getlevel("SOCIAL STIGMA ______________");
	   $hp = dosql ("select (str + will) from characterSTATs where charid=$charid;");
	   $hp += getlevel("HEALTHY");
	   print "<tr>\n";
	   print "<td>".getCharName($charid)."</td>\n";
	   print "<td>".getFullNameFromCharID($charid)."</td>\n";
	   print "<td>$status</td>\n";
	   print "<td>$effstat</td>\n";
	   print "<td>$hp</td>\n";
	   print "<td>".($hp*2)."</td>\n";
	   showstigmas();
	   print "</tr>\n";
	}
	print "</table>\n";
	
	$query->finish;
	
	$db->disconnect;
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<h1>Print Name Badges</H1>\n";
	print "<p><i>This will only show character types whose pack trait is 1.  <a href=\"chartypes.pl\">Manage character types</a></i></p>\n";
	
	print "<p>1.  Step One.  Download the Microsoft XL Document.<BR>\n";
	print "Save this document as badges.xls in your Brassy's folder:\n";
	print "<a href=\"badges.pl?xl=1\" target=_new>Click me</a></p>\n";
		
	print "<p>2.  Step Two.  Download the Microsoft Word Document.<BR>\n";
	print "Save this document as badges.doc in your Brassy's folder:\n";
	print "<a href=\"doclib/badges.doc\" target=_new>Click me</a>.<BR>\n";
	print "<i>It is strongly suggested that you make your own badges document</i></p>\n";
		
	print "<p>3.  Step Three.  Open and the Microsoft Word Document.<BR>\n";
	print "Open badges.doc in Microsoft Word.  Perform the mail merge.</p>\n";
		
	print "<p>4.  Step Four.  Add the Social Stigmas.<BR>\n";
	print "Open the social stigmas icon file.  Copy the correct stigmas to the correct badge in the merged document.  Then print.</p>\n";

	print "<hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
exit 0;

sub showstigmas()
{
	$db = dbconnect();
	local ($sql) = "select b.text from abilities a, characterabilities b where b.charid=$charid and a.abid=b.abid and a.name='SOCIAL STIGMA ______________';";
	#print "$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	while (@array = $query->fetchrow_array())
	{
	   print "<td>$array[0]</td>\n";
	}
	
	$query->finish;
	
	$num = haskeyrole("Arbiter of Propriety");
	if ($num > 0)
	{
	   print "<td>Arbiter of Propriety</td>\n";
	}
	
	$num = getlevel("GENUINE CURIOUSITY/FAMOUS");
	if ($num > 0)
	{
	   print "<td>Curiousity/Famous</td>\n";
	}
	
	$db->disconnect;
}
