#!/usr/bin/perl

require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI::Session;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "blackmail.pl";
$table = "blackmail";
$heading = "Blackmail";
$keyfield = "bid";
$keyvalue = $CGI->param($keyfield);
$namefield = "text";
$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
$tplfile = "blackmail.tpl";
$errstr = $CGI->param("error");

$numper = 2; #the number of clues per level of Dark Secret

$sid = $CGI->cookie($cookiename) || undef;
#print "[$sid]<BR>\n";
$session = new CGI::Session(undef, $sid, {Directory=>"/tmp"});
#print $session->id()."<BR>\n";

$baseaction = $session->param("baseaction");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "newpc" || $action eq "editpc")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $heading</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">\n";

     	fillpcvars();
	ParseForm($tplfile);
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"hidden\" name=\"action\" value=\"addpc\">\n";
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"hidden\" name=\"action\" value=\"changepc\">\n";
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "addpc")
{
	# Insert and Redirect
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=$baseaction&error=" . encodeURL("$heading Added"));
}
elsif ($action eq "changepc")
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=$baseaction&error=" . encodeURL("$namevalue Updated"));
}
elsif ($action eq "deletepc")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$db->do($SQL);
	$SQL = "delete from blackmailcharacters where $keyfield = $keyvalue;";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=$baseaction&error=" . encodeURL("$namevalue Deleted"));
}
elsif ($action eq "newnpcsecret" || $action eq "editnpcsecret")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add NPC Secret</H1>\n";
	}
	else
	{
        	print "<H1>Edit NPC Secret</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">\n";

	$table = "npcsecrets";
	$keyfield = "npcsid";
	$keyvalue = $CGI->param($keyfield);
     	fillnpcsecretvars();
	ParseForm("npcsecret.tpl");
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"hidden\" name=\"action\" value=\"addnpcsecret\">\n";
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"hidden\" name=\"action\" value=\"changenpcsecret\">\n";
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "addnpcsecret")
{
	# Insert and Redirect
	#print $CGI->header();
	$table = "npcsecrets";
	$keyfield = "npcsid";
	$keyvalue = $CGI->param($keyfield);
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=$baseaction&error=" . encodeURL("$heading Added"));
}
elsif ($action eq "changenpcsecret")
{
	#print $CGI->header();
	# Update and Redirect
	$table = "npcsecrets";
	$keyfield = "npcsid";
	$keyvalue = $CGI->param($keyfield);
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=$baseaction&error=" . encodeURL("$namevalue Updated"));
}
elsif ($action eq "deletenpcsecret")
{
	# delete and Redirect
	$table = "npcsecrets";
	$keyvalue = $CGI->param($keyfield);
	local($db) = dbconnect();
	$SQL = "delete from $table where npcsid = $keyvalue;";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=$baseaction&error=" . encodeURL("NPC Secret Deleted"));
}
elsif ($action eq "newnpcclue" || $action eq "editnpcclue")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $heading</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">\n";

     	fillnpccluesvars();
	ParseForm($tplfile);
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"hidden\" name=\"action\" value=\"addpc\">\n";
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"hidden\" name=\"action\" value=\"changepc\">\n";
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "editallclues")
{
	print $CGI->header();
	ParseForm($header);
        print "<H1>Edit Clues</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";
	
	$npcsid = $CGI->param("npcsid");
	$secret_text = dosql("select text from npcsecrets where npcsid=$npcsid;");
	$charname = dosql("select charname from npcsecrets where npcsid=$npcsid;");
	$level = dosql("select level from npcsecrets where npcsid=$npcsid;") * $numper;

	local($db) = dbconnect();
	local ($sql) = "select *, a.text as clue_text, b.text as secret_text from $table a join npcsecrets b on a.linkid=b.npcsid where b.npcsid=$npcsid order by a.linkid;";
	#print "$sql<BR>";  

	local ($query) = $db->prepare($sql);
	$query->execute;

	print "<h2>$charname: $secret_text</H2><BR>\n";

	$num = 1;
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "<b>Clue #$num</b>:  <BR>\n";
	   print "<textarea name=\"text_$num\" COLS=80 ROWS=3>".$resptr->{"clue_text"}."</textarea><BR><BR>\n";
	   print "<input type=\"hidden\" name=\"bid_$num\" value=\"".$resptr->{"bid"}."\">\n";
	   $num++;
	}
	$query->finish;
	$db->disconnect;
	
	for (;$num <= $level; $num++)
	{
	   print "<b>Clue #$num</b>:  <BR>\n";
	   print "<textarea name=\"text_$num\" COLS=80 ROWS=3>Enter clue here</textarea><BR><BR>\n";
	   print "<input type=\"hidden\" name=\"bid_$num\" value=\"0\">\n";
	}
	
	print "<input type=\"hidden\" name=\"isplayersecret\" value=\"0\">\n";
	print "<input type=\"hidden\" name=\"num_clues\" value=\"$num\">\n";
	print "<input type=\"hidden\" name=\"linkid\" value=\"$npcsid\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"updateclues\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Update\"><BR>";
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "editpcclues")
{
	print $CGI->header();
	ParseForm($header);
        print "<H1>Edit Clues</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";
	
	$caid = $CGI->param("caid");
	$secret_text = dosql("select text from characterabilities where caid=$caid;");
	$charid = dosql("select charid from characterabilities where caid=$caid;");
	$charname = getCharPlayerStr($charid);
	$level = dosql("select level from characterabilities where caid=$caid;") * $numper;

	local($db) = dbconnect();
	local ($sql) = "select * from $table where linkid=$caid and isplayersecret=1;";
	#print "$sql<BR>";  

	local ($query) = $db->prepare($sql);
	$query->execute;

	print "<h2>$charname: $secret_text</H2><BR>\n";

	$num = 1;
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "<b>Clue #$num</b>:  <BR>\n";
	   print "<textarea name=\"text_$num\" COLS=80 ROWS=3>".$resptr->{"text"}."</textarea><BR><BR>\n";
	   print "<input type=\"hidden\" name=\"bid_$num\" value=\"".$resptr->{"bid"}."\">\n";
	   $num++;
	}
	$query->finish;
	$db->disconnect;
	
	for (;$num <= $level; $num++)
	{
	   print "<b>Clue #$num</b>:  <BR>\n";
	   print "<textarea name=\"text_$num\" COLS=80 ROWS=3>Enter clue here</textarea><BR><BR>\n";
	   print "<input type=\"hidden\" name=\"bid_$num\" value=\"0\">\n";
	}
	
	print "<input type=\"hidden\" name=\"isplayersecret\" value=\"1\">\n";
	print "<input type=\"hidden\" name=\"num_clues\" value=\"$num\">\n";
	print "<input type=\"hidden\" name=\"linkid\" value=\"$caid\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"updateclues\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Update\"><BR>";
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "updateclues")
{
	#print $CGI->header();
	$linkid = $CGI->param("linkid");
	$num_clues = $CGI->param("num_clues");
	$isplayersecret = $CGI->param("isplayersecret");
	
	local($db) = dbconnect();
	for ($i = 1; $i < $num_clues; $i++)
	{
	   $text = $CGI->param("text_$i");
	   $text =~ s/'/''/g;
	   $bid = $CGI->param("bid_$i") + 0;
	   if ($bid > 0)
	   {
	     $sql = "update blackmail set text='$text' where bid=$bid;";
	   }
	   else
	   {
	     $sql = "insert into blackmail (text,linkid,isplayersecret) values ('$text',$linkid,$isplayersecret);";
	   }
	   #print "$sql<BR>\n";
	   $db->do($sql);
	}
	$db->disconnect;
	print $CGI->redirect("$thispage?action=$baseaction&error=" . encodeURL("Updated"));
}
elsif ($action eq "linkchars")
{
	print $CGI->header();
	$doctitle = "Manage ".$heading;
	ParseForm($header);
	print "<H1>$doctitle </h1>\n";

	print "<p>The following characters know the blackmail snippet: ";
	print "<i>$namevalue</i></p>\n";
	
	print "<table border = 1>\n";
	print "<tr>\n";
	print "<td><b>Character Name</b></td>\n";
	print "<td><b>Knows Snippet?</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	local($db) = dbconnect();
	local($query) = $db->prepare("select charid from characters where chartype <= $cast_character order by clast");
	$query->execute;
	while (@array = $query->fetchrow_array)
	{
	  print "<tr>\n";
	  local ($charid) = $array[0];
	  print "<td>".getCharName($array[0])." (".getFullNameFromCharID($charid).")</td>\n";
	  local ($sql) = "select charid from blackmailcharacters where charid=$charid and $keyfield=$keyvalue";
	  #print "$sql<BR>";
	  local($query2) = $db->prepare($sql);
	  $query2->execute;
	  if ($query2->rows > 0)
	  {
		print "<td><b>Yes</b></td>\n";
		print "<td><a href=\"$thispage?action=remaccess&charid=$charid&$keyfield=$keyvalue\">Remove Access</a></td>\n";
		print "</tr>\n";
	  }
	  else
	  {
		print "<td>No</td>\n";
		print "<td><a href=\"$thispage?action=addaccess&charid=$charid&$keyfield=$keyvalue\">Give Access</a></td>\n";
		print "</tr>\n";
	  }
	  $query2->finish;
	}
	$query->finish;
	$db->disconnect;
	print "</table><BR>\n";

	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "addaccess")
{
	# add and Redirect
	local ($charid) = $CGI->param("charid");
	$SQL = "insert into blackmailcharacters (charid, $keyfield, entrydate) values ($charid, $keyvalue, CURDATE());";
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=linkchars&$keyfield=$keyvalue");
}
elsif ($action eq "remaccess")
{
	# Remove and Redirect
	local ($charid) = $CGI->param("charid");
	$SQL = "delete from blackmailcharacters where charid=$charid and $keyfield=$keyvalue;";
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=linkchars&$keyfield=$keyvalue");
}
elsif ($action eq "npcsecrets")
{
	print $CGI->header;
	$doctitle = "Manage NPC Dark Secrets";
	ParseForm($header);
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle</h1>\n";	
	
	print "<H2>NPC Blackmail -- Secrets</h2>\n";

	print "<a href=\"$thispage?action=newnpcsecret\">ADD NEW Secret</a><BR><BR>\n";
	
	shownpcsecrets();
		
	$showall = $CGI->param("showall") + 0;
	$session->param("baseaction", "npcsecrets&showall=$showall");

	if ($showall > 0)
	{
		print "<H2>NPC Blackmail -- Clues</h2>\n";

		print "<a href=\"$thispage?action=newnpcclue\">ADD NEW Clue</a><BR><BR>\n";

		shownpcclues();
	}
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid, action;\n";
	print "function deleteConfirm(action, delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=\"+action+\"&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";

	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "pcds")
{
	print $CGI->header;
	$doctitle = "Manage PC Dark Secrets";
	ParseForm($header);
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid, action;\n";
	print "function deleteConfirm(action, delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=\"+action+\"&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";

	$showall = $CGI->param("showall") + 0;
	$session->param("baseaction", "pcds&showall=$showall");

	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle</h1>\n";	
	
	
	print "<H2>PC Blackmail -- Secrets</h2>\n";
	
	showdsdata($showall, 0);
	
	if ($showall > 0)
	{
		print "<H2>PC Blackmail -- Clues</h2>\n";

		showpcdata($charid);
	}
	
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "onepcblack")
{
	print $CGI->header;
	
	$charid = $CGI->param("charid");
	$charname = getCharName($charid);
	$session->param("baseaction", "onepcblack&charid=$charid");
	
	$doctitle = "Manage PC Dark Secrets for $charname";
	ParseForm($header);
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid, action;\n";
	print "function deleteConfirm(action, delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=\"+action+\"&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";

	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle</h1>\n";	
	
	print "<H2>PC Blackmail -- Secrets</h2>\n";
	
	showdsdata(1,$charid);
	
	print "<H2>PC Blackmail -- Snippets</h2>\n";

	showpcdata($charid);
		
	print "<H2>PC Blackmail -- Snippets Known</h2>\n";

	showknown($charid);
	
	print "<form action=\"$thispage\" method=\"post\">\n";

	print "<H2>Assign Random Snippets to PC</h2>\n";
	
	print "<b>Number of Snippets:</b> ";
	print "<input type=\"text\" name=\"numsnip\" size=\"3\"><BR>\n";

	print "<input type=\"hidden\" name=\"action\" value=\"asssnip\">\n";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Do it\"><BR>\n";

	print "</form>\n";

		
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "asssnip")
{
	#print $CGI->header;
	$numsnip = $CGI->param("numsnip") + 0;
	$charid = $CGI->param("charid") + 0;

	$sql = "SELECT bid FROM blackmail ORDER BY RAND() LIMIT $numsnip;";
   	#print "$sql<BR>";
	local($db) = dbconnect();
   	local ($query) = $db->prepare($sql);
   	$query->execute;
	local (@array);
   	while (@array = $query->fetchrow_array())
        {
	   #print "$array[0]<BR>\n";
       	   $sql = "insert into blackmailcharacters (bid,charid,entrydate) values ($array[0], $charid, CURDATE());";
       	   #print "$sql<BR>";
       	   $db->do($sql);
	}
	$db->disconnect;
	
	print $CGI->redirect("$thispage?action=$baseaction&error=" . encodeURL("$numsnip Snippets added"));
}
elsif ($action eq "assrandall")
{
	print $CGI->header;
   	local($db) = dbconnect();
	$sql = "select charid, level from characterabilities where abid=25";
   	#print"$sql<BR>";
   	$query = $db->prepare($sql);
   	$query->execute;
	
   	while (@array = $query->fetchrow_array())
        {
           $charid = $array[0];
           $level = $array[1];
       	   #print "for charid $charid<BR>\n";
    	   for ($i = 1; $i <= $level; $i++)
     	   {
	   	$sql = "SELECT a.bid FROM blackmail a JOIN blackmailcharacters b ON a.bid != b.bid WHERE b.charid=$charid or b.charid is NULL ORDER BY RAND() LIMIT 1;";
       		$bid = dosql($sql) + 0;
       		if ($bid == 0)
       		{
		   $sql = "SELECT a.bid FROM blackmail a ORDER BY RAND() LIMIT 1;";
		   $bid = dosql($sql) + 0;
       		}
       		#print "$bid<BR>\n";
       		$sql = "insert into blackmailcharacters (bid,charid,entrydate) values ($bid, $charid, CURDATE());";
       		#print "$sql";
       		$db->do($sql);
       		
    	   }
   	}
   	$query->finish;
   	$db->disconnect;
   	print $CGI->redirect("$thispage?error=" . encodeURL("Blackmail snippets updated."));
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading;
	ParseForm($header);
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	$session->param("baseaction", "");
	
	print "<H1>$doctitle </h1>\n";	

	print "<H2>Player Character Blackmail</h2><BR>\n";
	print "<ul>\n";
	print "<li><a href=\"$thispage?action=pcds&showall=0\">Show Only PC Dark Secrets that need Blackmail Snippets</a><BR>\n";
	print "<li><a href=\"$thispage?action=pcds&showall=1\">Show <b>ALL</b> PC Dark Secrets and Blackmail Snippets</a><BR>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"onepcblack\">\n";
	print "<li>Show PC Dark Secrets and Blackmail Snippets for: \n";
	print makeDropDown("characters", "charid", "concat(cfirst, ' ', clast)", "chartype=$player_character or chartype=$cast_character order by clast");
	print "<input type=submit name=\"submit\" value=\"Go\"><BR>";
	print "</form>\n";
	print "<li><a href=\"javascript:assignConfirm();\">Assign Random Blackmail Snippets to Players.</a><BR>\n";
	print "</ul>\n";
	
		print "<BR><H2>NPC Blackmail</h2><BR>\n";
	print "<ul>\n";
	print "<li><a href=\"$thispage?action=npcsecrets&showall=0\">Edit NPC Dark Secrets</a><BR>\n";
	print "<li><a href=\"$thispage?action=npcsecrets&showall=1\">Show <b>ALL</b> NPC Dark Secrets and Blackmail Snippets</a><BR>\n";
	print "</ul>\n";
	
	print "<script language=\"javascript\">\n";
	print "function assignConfirm()\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"This will make a permanent change to the database and should only be done once before each event.  Are you sure?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=assrandall\"\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";

	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}

exit 0;

sub showpcdata()
{
	local ($charid) = $_[0];
	local (@pccluearray);
	local($db) = dbconnect();
	local ($sql) = "select * from $table where isplayersecret=1 order by linkid;";
	if ($charid > 0)
	{
		$sql = "select a.* from $table a join characterabilities b on a.linkid=b.caid where a.isplayersecret=1 and b.charid=$charid order by linkid;";
	}
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Character</b></td>\n";
	print "<td><b>Secret</b></td>\n";
	print "<td><b>Text</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $key = $resptr->{"$keyfield"};
	   $linkid = $resptr->{"linkid"};
	   $charid = dosql("select charid from characterabilities where caid = $linkid;");
	   $secrettext = dosql("select text from characterabilities where caid = $linkid;");
	   $level = dosql("select level from characterabilities where caid = $linkid;") * $numper;
	   $pccluearray[$linkid]++;
	   print "<tr>\n";
	   print "<td>".getCharPlayerStr($charid)."</td>\n";
	   print "<td>$secrettext<BR><i>($pccluearray[$linkid] of $level)</i></td>\n";
	   print "<td>$name</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=editpc&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('deletepc','$name',$key);\">Delete</a>\n";
	   print " -- <a href=\"$thispage?action=linkchars&$keyfield=$key\">Link Characters</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillpcvars()
{
	filltable();
	$darkdrop = makeDropDown("characterabilities a, characters b", "a.caid", "concat(b.cfirst,'  ', b.clast, ' -- ', a.text)", "a.charid=b.charid and a.abid=8 order by b.clast", "", $linkid);
	$darkdrop =~ s/a.caid/linkid/;
	$isplayersecret = 1;
}


sub shownpcsecrets()
{
	local($db) = dbconnect();
	local ($sql) = "select * from npcsecrets order by charname;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1 width=100%>\n";
	print "<tr>\n";
	print "<td><b>Character</b></td>\n";
	print "<td><b>Secret</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $key = $resptr->{"npcsid"};
	   $numclues = dosql("select count(bid) from blackmail where linkid=$key and isplayersecret=0;") + 0;
	   $reqclues = $resptr->{"level"} * $numper;
	   print "<tr>\n";
	   print "<td>".$resptr->{"charname"}." (".$statusText[$resptr->{"status"}].")</td>\n";
	   print "<td>".$resptr->{"text"}."<BR>\n";
	   print "<i>$numclues out of $reqclues have been entered</i></td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=editnpcsecret&npcsid=$key\">Edit</a>\n";
	   print " -- <a href=\"$thispage?action=editallclues&npcsid=$key\">Edit Clues</a>\n";
	   $name = $resptr->{"text"};
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('deletenpcsecret','$name',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillnpcsecretvars()
{
	filltable();
}

sub shownpcclues()
{
	local (@pccluearray);
	local($db) = dbconnect();
	local ($sql) = "select *, a.text as clue_text, b.text as secret_text from $table a join npcsecrets b on a.linkid=b.npcsid where a.isplayersecret=0 order by a.linkid;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Character</b></td>\n";
	print "<td><b>Secret</b></td>\n";
	print "<td><b>Text</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	local($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"clue_text"};
	   $key = $resptr->{"$keyfield"};
	   $linkid = $resptr->{"linkid"};
	   $secrettext = $resptr->{"secret_text"};
	   $level = $resptr->{"level"} * $numper;
	   $pccluearray[$linkid]++;
	   print "<tr>\n";
	   print "<td>".$resptr->{"charname"}." (".$statusText[$resptr->{"status"}].")</td>\n";
	   print "<td>$secrettext<BR><i>($pccluearray[$linkid] of $level)</i></td>\n";
	   print "<td>$name</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=editnpcclue&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('deletepc','$name',$key);\">Delete</a>\n";
	   print " -- <a href=\"$thispage?action=linkchars&$keyfield=$key\">Link Characters</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillnpccluesvars()
{
	filltable();
	$darkdrop = makeDropDown("npcsecrets", "npcsid", "concat(charname, ' -- ', text)", "", "", $linkid);
	$darkdrop =~ s/npcsid/linkid/;
	$isplayersecret = 0;
}

sub showdsdata()
{
	local ($showall) = $_[0];
	local ($charid) = $_[1];
	local($db) = dbconnect();
	$sql = "select * from characterabilities join characters on characterabilities.charid=characters.charid where abid=8 order by clast;";
	if ($charid > 0)
	{
		$sql = "select * from characterabilities join characters on characterabilities.charid=characters.charid where abid=8 and characters.charid=$charid order by clast;";
	}
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Character</b></td>\n";
	print "<td><b>Type</b></td>\n";
	print "<td><b>Secret</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $key = $resptr->{"caid"};
	   $charid = $resptr->{"charid"};
	   $secrettext = $resptr->{"text"};
	   $level = $resptr->{"level"} * $numper;
	   $num = dosql("select count(bid) from blackmail where isplayersecret=1 and linkid=$key;");
	   if (($showall > 0) or ($num < $level))
	   {
		print "<tr>\n";
		print "<td>".getCharPlayerStr($charid)."</td>\n";
		print "<td>".$chartype[$resptr->{"chartype"}]."</td>\n";
		print "<td>$secrettext<BR><i>(Requires $level clues; $num clues exist)</i></td>\n";
		print "<td>";
		print "<a href=\"$thispage?action=editpcclues&caid=$key\">Edit Clues</a>\n";
	   	print "</td></tr>\n";
	   }
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub showknown()
{
	local ($charid) = $_[0];
	local (@pccluearray);
	local($db) = dbconnect();
	$sql = "select * from $table a join blackmailcharacters b on a.bid=b.bid where b.charid=$charid order by a.linkid;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Character</b></td>\n";
	print "<td><b>Secret</b></td>\n";
	print "<td><b>Text</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $key = $resptr->{"$keyfield"};
	   $linkid = $resptr->{"linkid"};
	   if ($resptr->{"isplayersecret"} == 1)
	   {
	   	$lcid = dosql("select charid from characterabilities where caid = $linkid;");
	   	$secretchar = getCharPlayerStr($lcid);
	   	$secrettext = dosql("select text from characterabilities where caid = $linkid;");
	   	$level = dosql("select level from characterabilities where caid = $linkid;") * $numper;
	   	$deltext = "deletepc";
	   }
	   else
	   {
	   	$secretchar = dosql("select charname from npcsecrets where npcsid = $linkid;");
	   	$secrettext = dosql("select text from npcsecrets where npcsid = $linkid;");
	   	$level = dosql("select level from npcsecrets where npcsid = $linkid;");
	   	$deltext = "deletenpcsecret";
	   }
	   print "<tr>\n";
	   print "<td>$secretchar</td>\n";
	   print "<td>$secrettext<BR><i>($level clues)</i></td>\n";
	   print "<td>$name</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=editpc&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('$deltext','$name',$key);\">Delete</a>\n";
	   print " -- <a href=\"$thispage?action=linkchars&$keyfield=$key\">Link Characters</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}
