#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$tplfile = "bulk.tpl";
$errstr = $CGI->param("error");

$allsend = 0;
$confsend = 1;
$regsend = 2;
$confregsend = 3;
$charsend = 4;
$testsend = 5;
$cval[$allsend] = "";
$cval[$confsend] = "";
$cval[$regsend] = "";
$cval[$confregsend] = "";
$cval[$charsend] = "";
$cval[$testsend] = "";
$sendtype = $CGI->param("sendtype");
$cval[$sendtype] = "CHECKED";

$subject = $CGI->param("subject");
$lettertext = $CGI->param("lettertext");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to visit this page!"));
}
elsif ($submit eq "Send")
{
	print $CGI->header;
	$doctitle = "Bulk E-Mail";
	ParseForm($header);

	$charset = 0;
	if ($sendtype == $allsend)
	{
	  $sql = "select playerid from players;";
	}
	elsif ($sendtype == $confsend)
	{
	  $sql = "select a.playerid from players a join eventplayers b on a.playerid=b.playerid where b.reglevel = $confirmed and eventid=$current_episode;";
	}
	elsif ($sendtype == $regsend)
	{
	  $sql = "select a.playerid from players a join eventplayers b on a.playerid=b.playerid where b.reglevel = $registered and eventid=$current_episode;";
	}
	elsif ($sendtype == $confregsend)
	{
	  $sql = "select a.playerid from players a join eventplayers b on a.playerid=b.playerid where b.reglevel >= $registered and eventid=$current_episode;";
	}
	elsif ($sendtype == $charsend)
	{
	  $sql = "select pcplayerid, pccharid from playercharacters;";
	  $charset = 1;
	}
	else #assume GM test
	{
	  $sql = "select playerid from players where psecurity>=$gm_access;";
	}
	
	$db = dbconnect();
	#print "$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);

	print "Sent to:<BR>\n";
	while (@array = $query->fetchrow_array())
	{
	   $playerid = $array[0];
	   $charid = $array[1];
	   prepletter($playerid, $charset, $charid);
	   mailletter($playerid);
	   print "$pfirst $plast ($toemail)<BR>\n";
	}

	$query->finish;

	$db->disconnect;

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
else
{
	print $CGI->header;
	$doctitle = "Bulk E-Mail";
	ParseForm($header);
	
	print "<h1>$doctitle</H1>\n";
	print "<i>Warning: This page may send e-mail to everyone in the database.  Use with caution</i><BR><BR>\n";
	
	print "<form action=\"bulk.pl\" method=\"post\">\n";
	print "Send this e-mail to:<BR>";

	print "<input type=radio name=sendtype value=\"$allsend\" $cval[$allsend]>All players</input><BR>\n";
	print "<input type=radio name=sendtype value=\"$confsend\"  $cval[$confsend]>Confirmed players</input><BR>\n";
	print "<input type=radio name=sendtype value=\"$regsend\"  $cval[$regsend]>Registered players</input><BR>\n";
	print "<input type=radio name=sendtype value=\"$confregsend\"  $cval[$confregsend]>Confirmed & Registered players</input><BR>\n";
	print "<input type=radio name=sendtype value=\"$charsend\"  $cval[$charsend]>All Characters</input><BR>\n";
	print "<input type=radio name=sendtype value=\"$testsend\"  $cval[$testsend]>Test E-Mail to the GMs</input><BR>\n";
	
	print "<BR>Subject: <input type=text name=subject value=\"$subject\" size=80><BR><BR>\n";
	
	print "<textarea name=\"lettertext\" COLS=80 ROWS=10>$lettertext</textarea><BR><BR>\n";

	print "<input type=submit name=submit value=Preview><BR>\n";
	if ($submit eq "Preview")
	{
		print "<input type=submit name=submit value=Send><BR>\n";
	}

	print "</form><hr>\n";	
	
	if ($submit eq "Preview")
	{
		$playernum = dosql("select count(playerid) from players;") + 1; 
	print "playernum  - $playernum<BR>\n";
		$playernum = int(rand($playernum));
	print "playernum  - $playernum<BR>\n";
		prepletter($playernum,0,0);
		$ppassword =~ s/./\*/g;
		displayletter($playernum);
	}
	
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
exit 0;

sub prepletter()
{
	$table = "players";
	$keyfield = "playerid";
	$keyvalue = $_[0];
	$charset = $_[1];
	$charid = $_[2];
	filltable();
	
	print "player id  - $keyvalue<BR>\n";
	
	if ($charset == 0)
	{
		$charid = dosql("select a.charid from characters a, playercharacters b where a.charid=b.pccharid and a.charid > 0 and b.pcplayerid=$keyvalue;");
	}
	$charname = getCharName($charid);
		
	print "charid  - $charid<BR>\n";

	$table = "characters";
	$keyfield = "charid";
	$keyvalue = $charid;
	filltable();

	$gmid = dosql("select a.playerid from players a, GMcharacters b where b.gmccharid = $charid and a.playerid = b.gmcGMid");
	$gmname = getFullNameFromID($gmid);
	$gmemail = getEmailFromID($gmid);
	
	$chartypetext = dosql("select ctypedesc from chartypes where ctypeid = $chartype");
	
	$reglevel = dosql("select reglevel from eventplayers where playerid=$keyvalue and eventid=$current_episode;");
	$balance = dosql("select balance from eventplayers where playerid=$keyvalue and eventid=$current_episode;");
	
	if ($reglevel == $registered)
	{
	  $balance = 100;
	}
	
	$balreminder = "";
	if (0)
	{
	  $balreminder = "<b>Balance Note:</b>\n\n";
	  $balreminder .= "<i>We note that you still owe $balance dollars for the game.  You may paypal that money to ambug666\@gmail.com or you may bring cash or a check made out to Mike Young at the game.  We will not provide you with a character packet until you have paid in full.  Sorry.</i>";
	}
	
	$htmlfile = "";
	$htmlfile = dosql("select chtmllink from characters where charid=$charid;");

	$toemail = getEmailFromID($_[0]);
}

sub displayletter()
{

      $tempStr = ParseString($lettertext);
      $tempStr =~ s/\n/<BR>\n/g;
      print $tempStr;

}

sub mailletter()
{
	open(MAIL, "| /usr/sbin/sendmail  -oi -t") or die "couldn't send mail: $!";
	print MAIL "From: \"The $campaign GMs\" <$contact>\n";
	print MAIL "To: $toemail\n";
	print MAIL "Subject: $subject\n";
	print MAIL "\n";
	print MAIL ParseString($lettertext);
	print MAIL "--\n";
	print MAIL "This e-mail sent via the $campaign database.\n";
	print MAIL "$siteURL\n";
	print MAIL "E-mail $contact for questions/comments.\n";
	close(MAIL);

}

sub ParseString 
{
      $varStr = $_[0];
      $varStr =~ s/"/\\"/g;               
      
      return eval qq/"$varStr"/;     
}
