#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "characters.pl";
$table = "characters";
$heading = "your Character";
$keyfield = "charid";
$keyvalue = $CGI->param($keyfield);
$namefield = "clast";
$tplfile = "characters.tpl";
$errstr = $CGI->param("error");

$allowunlock = 0;
#set to 0 to keep players from unlocking their stats.

if ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $heading</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">";
	if ($tplfile eq "")
	{
		local($dbvar) = dbconnect();
		local($query) = $dbvar->prepare("explain $table");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $dbvar->prepare("select * from $table where $keyfield = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$dbvar->disconnect;
		print "</table>";
	}
	else
	{
	     fillvars();
	     ParseForm($tplfile);
	}
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	#print $CGI->header();
	# Insert and Redirect
	@names = $CGI->param;
	$SQL = "INSERT into $table (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		$SQL .= "$i, ";
	    }

	}
	chop $SQL;
	chop $SQL;
	$SQL .= ") values (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		local($myCGI) = $CGI->param($i);
		$myCGI =~ s/'/''/g;
		$SQL .= "'" . $myCGI . "', ";
	    }
	 }
	chop $SQL;
	chop $SQL;
	$SQL .= ");";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
        $query = $dbvar->prepare("Select max(charid) from characters");
        $query->execute;
        @arrCharID = $query->fetchrow_array;
        $SQL = "insert into playercharacters (pcplayerid, pccharid) values ($pid, $arrCharID[0])";
        #print "TRACE-" . $SQL . "\n<br>\n";
        $dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	@names = $CGI->param;
	$SQL = "UPDATE $table set ";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		local($myCGI) = $CGI->param($i);
		$myCGI =~ s/'/''/g;
		$SQL .= "$i = '" . $myCGI . "', ";
	    }
	}
	chop $SQL;
	chop $SQL;
	$SQL .= " where $keyfield = $keyvalue;";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$SQL = "delete from charactergroupmembers where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Deleted"));
}
elsif ($action eq "unlock")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$SQL = "update $table set charstatsapproved=0 where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("stats.pl?$keyfield=$keyvalue");
}
else
{
	print $CGI->header;
	ParseForm($header);
		
	print "<table border = 0><tr>\n";
	print "<td width=120><img src=icons/charcreate.png align=left></td>\n";
	print "<td><font color=red>$errstr</font><BR>\n";
	
	print "<H1>Manage Your Characters</h1>\n";

	if ($al >= $charcreatelevel)
	{
		print "<BR><a href=\"$thispage?action=new\">CREATE a NEW Character</a><BR>\n";
	}
	print "</td>\n";
	print "</tr></table><BR>\n";
	
	showchars();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showchars()
{
	local($dbvar) = dbconnect();
	local ($sql) = "Select * from characters, playercharacters, chartypes where pccharid = charid and chartype = ctypeid and pcplayerid = $pid order by chartype, clast";
	#print "$sql<BR>";
	local($query) = $dbvar->prepare($sql);
	$query->execute;

	while ($resptr = $query->fetchrow_hashref())
	{
	  displaythechar($resptr);
	}
	print "<br>\n";

	if ($al >= $charcreatelevel)
	{
		print "<b><u>Notes:</u></b><BR>\n";

		if ($reqcharquest == 1)
		{
			print("<i>You must fill out a character questionnaire before your characters can be approved.</i><BR><BR>\n");

			print("<sup>*</sup><i>Use the \"Alert GMs\" link to let the GMs know your character is ready for review.  Use it wisely.  If you change your character questionnaire after it is approved, it will have to go through review again.</i><BR><BR>\n");
		}
		else
		{
			print("<sup>*</sup><i>Use the \"Alert GMs\" link to let the GMs know your character is ready for review.</i><BR><BR>\n");
		}
	}
	
	if ($allowunlock > 0)
	{
	   print("<sup>+</sup><i>Only unlock your STATs if you wish to make major changes to them after trying them at game one.  If you unlock your STATs, the GMs will have to validate and approve them before game two.  The GMs reserve the right to modify STATs/Abilities as we see fit.  You will have the opportunity to spend XP to update your STATs/Abilities without having to unlock them.</i><BR><BR>\n");
	}
}

sub displaythechar()
{
    local($resptr) = $_[0];
    $mytype = $resptr->{"chartype"} + 0;
    $charid = $resptr->{"charid"};
    #$bgcolors[$player_character] = "white";
    #$hdcolors[$player_character] = "#EEEEEE";
    #$bgcolors[$cast_character] = #FFFFEE";
    #$hdcolors[$cast_character] = "#EEEEDD";
    #$bgcolors[$test_character] = "#EEEEEE";
    #$hdcolors[$test_character] = "#DDDDDD";
    #$bgcolors[$secret_character] = "#FFEEEE";
    #$hdcolors[$secret_character] = "#EEDDDD";
    #$bgcolors[$alias_character] = "#EEFFEE";
    #$hdcolors[$alias_character] = "#DDEEDD";
    
    filltraits($mytype);
    
    print "<table width=100% border=0 cellspacing=0 style=\"border: thin solid Black;\">\n";
    print "<tr>\n";
    print "<td style=\"font-weight: bold; background-color: $headercolor; border-bottom: thin dashed Black;\">\n";
    if ($al >= $charcreatelevel)
    {
    	print "<A NAME=\"".$resptr->{"charid"}."\"></A><a href=\"$thispage?action=edit&charid=$charid\" Title=\"Click to Edit Character Details\">".getCharName($resptr->{"charid"})."</a>";
    }
    else
    {
    	print getCharName($resptr->{"charid"});
    }
    print "</td>\n";
    print "<td width=30% style=\"font-weight: bold; background-color: $headercolor; border-bottom: thin dashed Black;\">\n";
    $mychartype = dosql("select ctypedesc from chartypes where ctypeid=$mytype;");
    print $mychartype;
    print "</td>";
    print "</tr>\n";

    print "<tr>\n";
    print "<td width=50% style=\"background-color: $backgroundcolor;\">\n";
    print "<b>Character History:</b> ";
    $charquest = $charquest + 0;
    if ($charquest > 0 && $al >= $charcreatelevel)
    {
      $cq = dosql("select count(cqcharid) from charquest2 where cqcharid = $charid;") + 0;
      if ($cq > 0)
      {
	 print "Entered. (<a href=\"charquest.pl?mode=edit&charid=$charid\">Edit</a>) ";
	 if ($resptr->{"charstoryapproved"} == 0)
	 {
	      print "<a href=\"alertGM.pl?mode=history&charid=$charid\">Alert GMs</a><sup>*</sup>";
	 }
	 elsif ($resptr->{"charstoryapproved"} == 1)
	 {
	    print "<i>Approval Pending</i>";
	 }
	 elsif ($resptr->{"charstoryapproved"} >= 2)
	 {
	     print "<i>Approved</i>";
	 }
      }
      else
      {
	  print "Not Entered. (<a href=\"charquest.pl?mode=new&charid=$charid\">Fill out</a>)";
      }
    }
    elsif ($reqcharquest == 0)
    {
	 if ($resptr->{"charstoryapproved"} == 0)
	 {
	      print "<a href=\"alertGM.pl?mode=history&charid=$charid\">Alert GMs</a><sup>*</sup>";
	 }
	 elsif ($resptr->{"charstoryapproved"} == 1)
	 {
	    print "<i>Approval Pending</i>";
	 }
	 elsif ($resptr->{"charstoryapproved"} >= 2)
	 {
	     print "<i>Approved</i>";
	 }
    }
    else
    {
       print"N/A";
    }
    print "</td>\n";
    print "<td width=50% style=\"background-color: $backgroundcolor;\">\n";
    print "<b>STATs:</b> ";
    $dostats = $dostats + 0;
    if ($dostats > 0 || $al >= $gm_access)
    {
       if ($resptr->{"charstatsapproved"} > 0)
       {
	  print"Approved.  <a href=\"dispstats.pl?charid=$charid\">View STATs</a>.  ";
	  if ($allowunlock > 0)
	  {
	    print"<a href=\"characters.pl?action=unlock&charid=$charid\">Unlock</a><sup>+</sup>";
	  }
	  if ($al >= $charcreatelevel && $gamestage >= 2)
	  {
	     print"   <a href=\"stats.pl?charid=$charid\">Edit STATs</a>.  ";
	  }
	  
	  if ($al >= $charcreatelevel  && $gamestage >= 2)
	  {
	  	print "<a href=\"xp.pl?charid=$charid\">Spend XP</a>\n";
	  }

       }
       elsif ($al >= $charcreatelevel && $dostats > 0)
       {
	  print"<a href=\"stats.pl?charid=$charid\">Edit STATs</a>.  ";
	  print "<a href=\"validate.pl?charid=$charid\">Validate</a>";
       }
       else
       {
       	  print"N/A";
       }
    }
    else
    {
       print"N/A";
    }
    print "</td>\n";
    print "</tr>\n";
    
    print "<tr>\n";
    print "<td colspan=2 style=\"background-color: $backgroundcolor; border-bottom: thin dashed Black;\">\n";
    print "<b>Contact GMs:</b> ";
    $sql = "select gmcGMid from GMcharacters where gmccharid = ".$resptr->{"charid"}.";";
    local($query2) = $dbvar->prepare($sql);
    $query2->execute;
    if ($query2->rows > 0)
    {
	while (@array = $query2->fetchrow_array)
	{
	   print emailTagFromID($array[0])." ";
	}
    }
    else
    {
	print"None";
    }
    $query2->finish;
    print "</td>\n";
    print "</tr>\n";
    
    print "<tr>\n";
    print "<td colspan=2 style=\"background-color: $backgroundcolor;\">\n"; 
    if ($al >= $charcreatelevel)
    {
    	print"<a href=\"charinfo.pl?charid=$charid\">Edit Public Info Page</a>\n";
    }
    if ($resptr->{"chtmllink"} ne "")
    {
    	print " -- <a href=\"charhtml/".$resptr->{"chtmllink"}."\" target=_new>View Character Sheet</a>";
    }
    $allowjournal = $allowjournal + 0;
    if ($allowjournal > 0)
    {
       print" -- <a href=\"journal.pl?charid=$charid\">Manage Journal</a>\n";
    }
    if ($mytype == $player_character && $al >= $charcreatelevel && $gamestage >= 2)
    {
       print" -- <a href=\"bga.pl?charid=$charid\">Between Game Actions</a>\n";
    }
    print "</td>";
    print "</tr>\n";
    print "</table>\n";
}


sub fillvars()
{
	filltable();

	$chartypes = makeDropDown('chartypes','ctypeid','ctypedesc',"","",$chartype);
	$chartypes =~ s/ctypeid/chartype/g;
	
	$gender =  "<select name=\"charsex\">\n";
	$gender .= "<option value=\"M\" ";
	if ("$charsex" eq "M")
	{
	  $gender .= "SELECTED";
	}
	$gender .= ">Male</option>\n";
	$gender .= "<option value=\"F\" ";
	if ("$charsex" eq "F")
	{
	  $gender .= "SELECTED";
	}
	$gender .= ">Female</option>\n";
	$gender .= "<option value=\"N\" ";
	if ("$charsex" eq "N")
	{
	  $gender .= "SELECTED";
	}
	$gender .= ">Neutral</option>\n";
	$gender .= "</select><BR>";
	
}
