#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "charfreebies.pl";
$table = "charactersubstatpoints";
$heading = "Character Substatus Freebies";
$keyfield = "csspid";
$keyvalue = $CGI->param($keyfield);
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading!"));
}
elsif ($action eq "handle")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$SQL = "update $table set handled = 1 where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue handled"));
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s";
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle </h1>\n";

	print "<a href=\"$thispage?action=new\">ADD a NEW $heading</a><BR><BR>\n";
	
	showdata();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table a, substatus_freebies b where a.points < 0 and a.notes=b.name order by handled, $keyfield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Character</b></td>\n";
	print "<td><b>Freebie</b></td>\n";
	print "<td><b>Description</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $handled = $resptr->{"handled"};
	   $charid = $resptr->{"charid"};
	   $charname = getCharPlayerStr($charid);
	   $key = $resptr->{"csspid"};
	   $descr = $resptr->{"description"};
	   if ($handled == 0)
	   {
	   	print "<tr bgcolor=#FFFFFF>\n";
	   }
	   else
	   {
	   	print "<tr bgcolor=#EEEEEE>\n";
	   }
	   print "<td>$charname</td>\n";
	   print "<td>".$resptr->{"notes"}."</td>\n";
	   print "<td>$descr</td>\n";
	   print "<td>";
	   if ($handled == 0)
	   {
	      print "<a href=\"$thispage?action=handle&$keyfield=$key\">Mark as Handled</a>\n";
	   }
	   else
	   {
	   	print "Handled\n";
	   }
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	filltable();
}

