#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "chartypes.pl";
$table = "chartypes";
$heading = "Character Type";
$keyfield = "ctypeid";
$keyvalue = $CGI->param($keyfield);
$namefield = "ctypedesc";
$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
$tplfile = "chartypes.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("main.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	if ($keyvalue eq "")
	{
		$doctitle = "Add $heading";
	}
	else
	{
        	$doctitle = "Edit $namevalue";
	}
	ParseForm($header);
     	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";
	fillvars();
	ParseForm($tplfile);
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"main.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	$sql = filltablefromCGI($table, 1);
	#print "$sql<BR>";
	$db = dbconnect();
	$db->do($sql);
	updatetraits();
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$sql = filltablefromCGI($table, 0);
	#print "$sql<BR>";
	$db = dbconnect();
	$db->do($sql);
	updatetraits();
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$sql<BR>";
	local($db) = dbconnect();
	$sql = "delete from $table where $keyfield = $keyvalue;";
	$db->do($sql);
	$sql = "delete from chartypetraitlink where $keyfield = $keyvalue;";
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Deleted"));
}
elsif ($action eq "newtrait" || $action eq "edittrait")
{
	print $CGI->header();
	$table = "chartypetraits";
	$keyfield = "cttid";
	$keyvalue = $CGI->param($keyfield);

	if ($keyvalue eq "")
	{
		$doctitle = "Add Trait";
	}
	else
	{
        	$doctitle = "Edit Trait";
	}
	ParseForm($header);
     	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";
	local($db) = dbconnect();
	local($query) = $db->prepare("explain $table");
	local(@array);
	local(@arrNames);
	$query->execute;
	local($ind) = 0;
	    while (@arrCols = $query->fetchrow_array)
	    {
	    $arrNames[$ind] = $arrCols[0];
	    $array[$ind] = $arrCols[1];
	    $ind++;
	    }
	$query->finish;
	$query = $db->prepare("select * from $table where $keyfield = $keyvalue");
	$query->execute;
	local($indFirstRecord) = 0;
	print "<table border=0>\n";
	@arrVals = $query->fetchrow_array;
	$input = $arrVals[0];
	print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
	local($i) = 0;    
	    for($i=1;$i<$ind;$i++)
	    {
		if ($array[$i] eq "tinyint(1)")
		{
		    if ($arrVals[$i] eq "on")
		    {
		    $checked = " CHECKED";
		    }
		    else
		    {
		    $checked = "";
		    }
		$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
		}
		elsif ($array[$i] eq "mediumtext")
		{
		$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
		}
		else
		{
		$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
		}
	    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
	    }
	$indFirstRecord = 1;
	$query->finish;
	$db->disconnect;
	print "</table>";
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add Trait\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change Trait\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"main.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add Trait")
{
	# Insert and Redirect
	$table = "chartypetraits";
	$keyfield = "cttid";
	$keyvalue = $CGI->param($keyfield);
	$heading = "Trait";
	$sql = filltablefromCGI($table, 1);
	#print "$sql<BR>";
	$db = dbconnect();
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change Trait")
{
	#print $CGI->header();
	# Update and Redirect
	$table = "chartypetraits";
	$keyfield = "cttid";
	$keyvalue = $CGI->param($keyfield);
	$heading = "Trait";
	$sql = filltablefromCGI($table, 0);
	#print "$sql<BR>";
	$db = dbconnect();
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "deletetrait")
{
	# delete and Redirect
	$table = "chartypetraits";
	$keyfield = "cttid";
	$keyvalue = $CGI->param($keyfield);
	$heading = "Trait";
	#print "$sql<BR>";
	local($db) = dbconnect();
	$sql = "delete from $table where $keyfield = $keyvalue;";
	$db->do($sql);
	$sql = "delete from chartypetraitlink where $keyfield = $keyvalue;";
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Deleted"));
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s";
	ParseForm($header);
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle </h1>\n";

	print "<a href=\"$thispage?action=new\">ADD a NEW $heading</a><BR><BR>\n";
	
	$db = dbconnect();
	showdata();

	print "<br><hr><br>\n"; 

	print "<a href=\"$thispage?action=newtrait\">ADD a NEW Character Type Trait</a><BR><BR>\n";
	
	showdata2();
	$db->disconnect;

	print "<br><hr><a href=\"main.pl\">Main menu</a>.\n"; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, action, jscharid;\n";
	print "function deleteConfirm(delName, action, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=\"+action+\"&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local ($sql) = "select * from $table order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Traits</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	local ($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $key = $resptr->{"$keyfield"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>".showtraits($key)."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('$name','delete',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
}

sub showdata2()
{
	local ($sql) = "select * from chartypetraits order by traitname;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Description</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"traitname"};
	   $descr = $resptr->{"descr"};
	   $key = $resptr->{"cttid"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>$descr</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edittrait&cttid=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('$name','deleteTrait',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
}

sub fillvars()
{
	filltable();
	
	$traitstr = "";
	local($db) = dbconnect();
	local ($sql) = "select * from chartypetraits order by traitname;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$traitstr .= "<table border=1>\n";
	$traitstr .= "<tr>\n";
	$traitstr .= "<td><b>Trait</b></td>\n";
	$traitstr .= "<td><b>Description</b></td>\n";
	$traitstr .= "<td><b>Value</b></td>\n";
	$traitstr .= "</tr>\n";
	local($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   local($traitname) = $resptr->{"traitname"};
	   local($cttid) = $resptr->{"cttid"};
	   local($val) = dosql("select value from chartypetraitlink where cttid=$cttid and $keyfield=$keyvalue;");
	   $traitstr .= "<tr>\n";
	   $traitstr .= "<td>$traitname</td>\n";
	   $traitstr .= "<td>".$resptr->{"descr"}."</td>\n";
	   $traitstr .= "<td>\n";
	   $traitstr .= "<input type=\"text\" name=\"trait_$cttid\" value=\"$val\" maxsize=\"80\" size=\"20\">\n";
	   $traitstr .= "</td></tr>\n";
	}
	$traitstr .= "</table>\n";
	$query->finish;
	$db->disconnect;
}

#assumes db has already been defined
sub updatetraits()
{
	filltable();
	
	$sql = "delete from chartypetraitlink where $keyfield = $keyvalue;";
	#print "$sql<BR>";  
	$db->do($sql);

	$sql = "select cttid from chartypetraits order by traitname;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local(@array);
	while (@array = $query->fetchrow_array)
	{
	   $val = $CGI->param("trait_$array[0]");
	   $val =~ s/'/''/g;
	   $sql = "insert into chartypetraitlink (ctypeid, cttid, value) values ($keyvalue, $array[0], '$val');";
	   #print "$sql<BR>";  
	   dosql($sql);
	}
	$query->finish;
}

sub showtraits()
{
	$varID = $_[0];
	local ($sql) = "select * from chartypetraits a, chartypetraitlink b where a.cttid=b.cttid and b.ctypeid=$varID order by a.traitname;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local($num) = 0;
	$retstr = "";
	local ($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"traitname"};
	   $val = $resptr->{"value"};
	   if ($num > 0)
	   {
		$retstr .= "; ";
	   }
	   $retstr .= "$name=$val";
	   $num++;
	}
	$query->finish;
	return $retstr;
}
