#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "components.pl";
$table = "spellcomponents";
$heading = "Spell Component";
$keyfield = "scid";
$keyvalue = $CGI->param($keyfield);
$namefield = "scname";
#$tplfile = "jobs.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $heading</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">";
	if ($tplfile eq "")
	{
		local($dbvar) = dbconnect();
		local($query) = $dbvar->prepare("explain $table");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $dbvar->prepare("select * from $table where $keyfield = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$dbvar->disconnect;
		print "</table>";
	}
	else
	{
	     fillvars();
	     ParseForm($tplfile);
	}
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	@names = $CGI->param;
	$SQL = "INSERT into $table (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		$SQL .= "$i, ";
	    }

	}
	chop $SQL;
	chop $SQL;
	$SQL .= ") values (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		local($myCGI) = $CGI->param($i);
		$myCGI =~ s/'/''/g;
		$SQL .= "'" . $myCGI . "', ";
	    }
	 }
	chop $SQL;
	chop $SQL;
	$SQL .= ");";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	@names = $CGI->param;
	$SQL = "UPDATE $table set ";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		local($myCGI) = $CGI->param($i);
		$myCGI =~ s/'/''/g;
		$SQL .= "$i = '" . $myCGI . "', ";
	    }
	}
	chop $SQL;
	chop $SQL;
	$SQL .= " where $keyfield = $keyvalue;";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Deleted"));
}
elsif ($action eq "addabilities")
{
	print $CGI->header();
	ParseForm($header);
	fillvars();
	print "<font color=red>$errstr</font><BR><BR>\n";
	print "<h1>Add/Edit Spells for $scname</H1>\n";
	print "<form action=\"$thispage\" name=\"myform\" method=\"post\">\n";
	$myabilities = getmyabilities();
	$abilitiesstr = getabilitiesstr();
	print "<H2>These Spells use $scname</h2>\n";
	print "$myabilities<BR>\n";
	print "<a href=\"javascript:createredirect('$thispage?action=updateabilities');\">Update</a>&nbsp;&nbsp;&nbsp;&nbsp;\n";
	print "<a href=\"javascript:createredirect('$thispage?action=finishabilities');\">Done</a>\n";
	print "<H2>Available Spells</h2>\n";
	print "$abilitiesstr<BR>\n";
	ParseForm("stats/stats-js.tpl");
	print "<input type=hidden name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "</form>\n";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($submit eq "AddAbility")
{
	#print $CGI->header();
	updateAbilities();

	local ($abid) = $CGI->param("abid");
	local($db) = dbconnect();
	$sql = "insert into spellcomponentslink ($keyfield, abid) values ($keyvalue, $abid);";
	#print "$sql<BR>";
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=addabilities&$keyfield=$keyvalue");
}
elsif ($submit eq "RemoveAbility")
{
	#print $CGI->header();
	local ($sclid) = $CGI->param("sclid");
	updateAbilities();

	local($db) = dbconnect();
	$sql = "delete from spellcomponentslink where sclid=$sclid;";
	#print "$sql<BR>";
	$db->do($sql);
	$db->disconnect;

	print $CGI->redirect("$thispage?action=addabilities&$keyfield=$keyvalue");
}
elsif ($action eq "updateabilities")
{
	#print $CGI->header();
	updateAbilities();
	
	print $CGI->redirect("$thispage?action=addabilities&$keyfield=$keyvalue");
}
elsif ($action eq "finishabilities")
{
	#print $CGI->header();
	updateAbilities();
	
	print $CGI->redirect("$thispage");
}
elsif ($action eq "choosecombo")
{
	print $CGI->header();
	local ($abid) = $CGI->param("abid");
	ParseForm($header);
	if ($abid ne "")
	{
		$table="abilities";
		$keyfield = "abid";
		$keyvalue = $CGI->param($keyfield);
		$namefield = "name";
		fillvars();
		print "<h1>Add/Edit Characters for $name</H1>\n";
		$sql = "select a.sclid, a.abid, b.name, c.scname from spellcomponentslink a, abilities b, spellcomponents c where a.abid=$abid and a.abid=b.abid and a.scid=c.scid;";
	  	
	}
	else
	{
		fillvars();
		print "<h1>Add/Edit Characters for $scname</H1>\n";
		$sql = "select a.sclid, a.abid, b.name, c.scname from spellcomponentslink a, abilities b, spellcomponents c where a.scid=$scid and a.abid=b.abid and a.scid=c.scid;";
	}
	print "<i>Not all characters know the effects of all the components for a spell.  Thus is research and experimentation done</i>\n";
	print "<h2>Choose your Spell/Component Combo</h2>\n";
	local($db) = dbconnect();
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Ability</b></td>\n";
	print "<td><b>Component</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
		print "<tr>\n";
		print "<td><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">".$resptr->{"name"}."</a></td>\n";
		print "<td>".$resptr->{"scname"}."</td>";
		print "<td><a href=\"$thispage?sclid=".$resptr->{"sclid"}."&action=editcharacters\">Edit Characters</a></td>\n";
		print "</tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
	print "<a href=\"$thispage\">Done</a>\n";
	ParseForm($footer);
}
elsif ($action eq "editcharacters")
{
	print $CGI->header();
	$table="spellcomponentscharacterlink";
	$keyfield = "sclid";
	$keyvalue = $CGI->param($keyfield);
	local ($sclid) = $CGI->param("sclid");
	$sql = "select b.name, c.scname from spellcomponentslink a, abilities b, spellcomponents c where a.sclid=$sclid and a.abid=b.abid and a.scid=c.scid;";
	local($db) = dbconnect();
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	@array = $query->fetchrow_array();
	$name = $array[0];
	$scname = $array[1];
	$query->finish;
	$db->disconnect;
	ParseForm($header);
	print "<h1>Add/Edit Characters for $scname -- $name</H1>\n";
	print "<i>Not all characters know the effects of all the components for a spell.  Thus is research and experimentation done</i><BR><BR>\n";
	print "<a href=\"$thispage\">Done</a><BR><BR>\n";
	showChars($sclid);
	print "<BR><a href=\"$thispage\">Done</a>\n";
	ParseForm($footer);
}
elsif ($action eq "addchar")
{
	#print $CGI->header();
	local ($charid) = $CGI->param("charid");
	local ($sclid) = $CGI->param("sclid");
	local($db) = dbconnect();
	$SQL = "insert into spellcomponentscharacterlink (charid, sclid) values ($charid, $sclid);";
	#print "$SQL<BR>\n";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=editcharacters&sclid=$sclid");
}
elsif ($action eq "delchar")
{
	#print $CGI->header();
	local ($charid) = $CGI->param("charid");
	local ($sclid) = $CGI->param("sclid");
	local($db) = dbconnect();
	$SQL = "delete from spellcomponentscharacterlink where charid=$charid and sclid=$sclid;";
	#print "$SQL<BR>\n";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=editcharacters&sclid=$sclid");
}
elsif ($action eq "editcomps")
{
	print $CGI->header();
	ParseForm($header);
	$table="abilities";
	$keyfield = "abid";
	$keyvalue = $CGI->param($keyfield);
	$namefield = "name";
	fillvars();
	print "<font color=red>$errstr</font><BR><BR>\n";
	print "<h1>Add/Edit Components for $name</H1>\n";
	print "<form action=\"$thispage\" name=\"myform\" method=\"post\">\n";
	print "<h2><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=$abid','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">$name</a> uses these components</h2>\n";
	print "<BR>".getmycomponents()."<BR>\n";	
	print "<a href=\"javascript:createredirect('$thispage?abid=$abid&action=updatecomponents');\">Update</a>&nbsp;&nbsp;&nbsp;&nbsp;\n";
	print "<a href=\"javascript:createredirect('$thispage?action=finishabilities');\">Done</a>\n";
	print "<h2>Available components</h2>\n";
	print "<BR>".getcomponentsstr()."<BR>\n";		
	ParseForm("stats/stats-js.tpl");
	print "<input type=hidden name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "</form>\n";
	print "<a href=\"$thispage?action=new\">ADD a NEW $heading</a><BR><BR>\n";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($submit eq "AddComponent")
{
	#print $CGI->header();
	updateAbilities();

	local ($abid) = $CGI->param("abid");
	local($db) = dbconnect();
	$sql = "insert into spellcomponentslink ($keyfield, abid) values ($keyvalue, $abid);";
	#print "$sql<BR>";
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=editcomps&abid=$abid");
}
elsif ($submit eq "RemoveComponent")
{
	#print $CGI->header();
	updateAbilities();

	local ($sclid) = $CGI->param("sclid");
	local ($abid) = $CGI->param("abid");
	local($db) = dbconnect();
	$sql = "delete from spellcomponentslink where sclid=$sclid;";
	#print "$sql<BR>";
	$db->do($sql);
	$db->disconnect;

	print $CGI->redirect("$thispage?action=editcomps&abid=$abid");
}
elsif ($action eq "updatecomponents")
{
	#print $CGI->header();
	local ($abid) = $CGI->param("abid");
	updateAbilities();
	
	print $CGI->redirect("$thispage?action=editcomps&abid=$abid");
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>Manage ".$heading."s</h1>\n";

	print "<a href=\"$thispage?action=new\">ADD a NEW $heading</a><BR><BR>\n";
	
	showcomponents();
	
	print "<H2>Show Spells</h2>\n";	

	print showspells();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showspells()
{
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select * from abilities where type='Spell' order by name;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Name</b></td>\n";
	$retstr .= "<td><b>Action</b></td>\n";
	$retstr .= "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
		$retstr .= "<tr>\n";
		$retstr .= "<td>".$resptr->{"name"}."</td>\n";
		$retstr .= "<td><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">Display</a>\n";
		$retstr .= " -- <a href=\"$thispage?abid=".$resptr->{"abid"}."&action=editcomps\">Edit Components</a>\n";
	   	$retstr .= " -- <a href=\"$thispage?action=choosecombo&abid=".$resptr->{"abid"}."\">Add Characters</a>\n";
		$retstr .= "</td></tr>\n";
	}
	$retstr .= "</table>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}

sub showcomponents()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Component Name</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield=".$resptr->{"$keyfield"}."\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('$name',".$resptr->{"$keyfield"}.");\">Delete</a>\n";
	   print " -- <a href=\"$thispage?action=choosecombo&$keyfield=".$resptr->{"$keyfield"}."\">Add Characters</a>\n";
	   print " -- <a href=\"$thispage?action=addabilities&$keyfield=".$resptr->{"$keyfield"}."\">Add Spells</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	filltable();
}

sub getmyabilities()
{
	$totalcost = 0;
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select a.sclid, b.name, a.sideeffect, a.abid from spellcomponentslink a, abilities b where a.$keyfield=$keyvalue and a.abid=b.abid order by b.name;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Name</b></td>\n";
	$retstr .= "<td><b>Side Effect</b></td>\n";
	$retstr .= "<td><b>Action</b></td>\n";
	$retstr .= "</tr>\n";
	local ($num) = 0;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $retstr .= "<tr>\n";
	   $retstr .= "<td>\n";
	   $retstr .= "<input type=hidden name=\"sclid_$num\" value=\"".$resptr->{"sclid"}."\">\n";
	   $retstr .= "<a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">".$resptr->{"name"}."</a></td>\n";
	   $retstr .= "<td><input type=text name=\"sideeffect_$num\" value=\"".$resptr->{"sideeffect"}."\" size=70></td>\n";
	   $retstr .= "<td><a href=\"javascript:createredirect('$thispage?sclid=".$resptr->{"sclid"}."&submit=RemoveAbility')\">Remove</a></td>";
	   $retstr .= "</tr>\n";
	   $num++;
	}
	$retstr .= "</table>\n";
	$retstr .= "<input type=hidden name=num_abs value=$num>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}

sub getabilitiesstr()
{
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select * from abilities where type='Spell' order by name;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Name</b></td>\n";
	$retstr .= "<td><b>Action</b></td>\n";
	$retstr .= "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
		$retstr .= "<tr>\n";
		$retstr .= "<td>".$resptr->{"name"}."</td>\n";
		$retstr .= "<td><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">Display</a>\n";
		$retstr .= " -- <a href=\"javascript:createredirect('$thispage?abid=".$resptr->{"abid"}."&submit=AddAbility')\">Add</a>\n";
		$retstr .= "</tr>\n";
	}
	$retstr .= "</table>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}

sub updateAbilities()
{
	#print $CGI->header;
	local ($numabs) = $CGI->param("num_abs") * 1;
	local($db) = dbconnect();
	for ($num = 0; $num < $numabs; $num++)
	{
	  local ($sclid) = $CGI->param("sclid_$num");
	  local ($sideeffect) = $CGI->param("sideeffect_$num");
	  $sideeffect =~ s/'/''/g;
	  $sql = "update spellcomponentslink set sideeffect='$sideeffect' where sclid=$sclid;";   
	  #print "$sql<BR><BR>";
	  $db->do($sql);
	}
	$db->disconnect;
}

sub getmycomponents()
{
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select a.sclid, b.scname, a.sideeffect, a.scid from spellcomponentslink a, spellcomponents b where a.scid=b.scid and a.abid=$abid order by b.scname;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Name</b></td>\n";
	$retstr .= "<td><b>Side Effect</b></td>\n";
	$retstr .= "<td><b>Action</b></td>\n";
	$retstr .= "</tr>\n";
	local ($num) = 0;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $retstr .= "<tr>\n";
	   $retstr .= "<td>\n";
	   $retstr .= "<input type=hidden name=\"sclid_$num\" value=\"".$resptr->{"sclid"}."\">\n";
	   $retstr .= $resptr->{"scname"}."</td>\n";
	   $retstr .= "<td><input type=text name=\"sideeffect_$num\" value=\"".$resptr->{"sideeffect"}."\" size=70></td>\n";
	   $retstr .= "<td><a href=\"javascript:createredirect('$thispage?sclid=".$resptr->{"sclid"}."&abid=$abid&submit=RemoveComponent')\">Remove</a></td>";
	   $retstr .= "</tr>\n";
	   $num++;
	}
	$retstr .= "</table>\n";
	$retstr .= "<input type=hidden name=num_abs value=$num>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}

sub getcomponentsstr()
{
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "SELECT spellcomponents.* FROM spellcomponents order by scname";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Name</b></td>\n";
	$retstr .= "<td><b>Action</b></td>\n";
	$retstr .= "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
		$retstr .= "<tr>\n";
		$retstr .= "<td>".$resptr->{"scname"}."</td>\n";
		$retstr .= "<TD><a href=\"javascript:createredirect('$thispage?abid=$abid&scid=".$resptr->{"scid"}."&submit=AddComponent')\">Add</a>\n";
		$retstr .= "</tr>\n";
	}
	$retstr .= "</table>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}


sub showChars()
{
  	local($sclid) = $_[0];
	local($db) = dbconnect();
	$SQL = "select charid from characters order by clast;";
	#print "$SQL<BR>";
	local($query) = $db->prepare($SQL);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Character Name</b></td>\n";
	print "<td><b>In the Know</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	if ($query->rows > 0)
	{
	   local (@array);
	   while (@array = $query->fetchrow_array)
	   {
		   print "<tr>\n";
		   print "<td><a href=\"charquest.pl?mode=review&cqcharid=$array[0]\" target=_new>".getCharName($array[0])."</a> <i>(".getFullNameFromCharID($array[0]).")</i></td>\n";
		   if (isLinked($array[0],$sclid))
		   {
			print "<td><b>Yes</b></td>\n";
			print "<td><a href=\"$thispage?action=delchar&charid=$array[0]&sclid=$sclid\">Remove</a>\n";
		   }
		   else
		   {
			print "<td>No</td>\n";
			print "<td><a href=\"$thispage?action=addchar&charid=$array[0]&sclid=$sclid\">Add</a>\n";
		   }
		   print "</td></tr>\n";
	   }
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}


sub isLinked()
{
  local($charid) = $_[0];
  local($sclid) = $_[1];
  local($db) = dbconnect();
  local ($SQL) = "select * from spellcomponentscharacterlink where charid=$charid and sclid=$sclid;";
  #print "$SQL<BR>";
  local($query) = $db->prepare($SQL);
  $query->execute;
  local ($retval) = $query->rows;
  $query->finish;
  $db->disconnect;
  return $retval;
}
