#!/usr/bin/perl

require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "cqreport.pl";
$table = "charquest2";
$keyvalue = $CGI->param($keyfield);
$errstr = $CGI->param("error");

$cqmstatic = 4;


if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to visit this page!"));
}
else
{
	#print $CGI->header;
	print $CGI->header(-type  =>  'application/vnd.ms-excel', -filename  =>  'charquest.xls');
				
	$db = dbconnect();

	print "<table border=0>\n";
        print "<tr>\n";
        print "<td>CharName</td>\n";
        print "<td>PlayerName</td>\n";
        print "<td>CharType</td>\n";
        
        local ($sql) = "select cqmname, cqmtype from cqmeta order by cqmorder;";
	local ($query) = $db->prepare($sql);
	$query->execute;
	
	while ($resptr = $query->fetchrow_hashref())
	{
	   if ($resptr->{"cqmtype"} != $cqmstatic)
	   {
	   	print "<td>".$resptr->{"cqmname"}."</td>\n";
	   }
	}
	$query->finish;
        
        
        print "</tr>\n";


	$sql = "select * from players a, playercharacters b, characters c, chartypes d where a.playerid=b.pcplayerid and b.pccharid = c.charid and c.chartype=d.ctypeid order by a.plast;";
	#print "$sql<BR>";
	$query = $db->prepare($sql);
	$query->execute;
	
	while ($resptr = $query->fetchrow_hashref())
	{
	   $charid = $resptr->{"charid"};
	   print "<tr>\n";
	   print "<td>".getCharName($charid)."</td>\n";
	   print "<td>".$resptr->{"plast"} . ", " . $resptr->{"pfirst"}."</td>\n";
	   print "<td>".$resptr->{"ctypedesc"}."</td>\n";
	   
	   $sql = "select * from charquest2 a, cqmeta b where a.cqcharid=$charid and a.cqmid=b.cqmid order by b.cqmorder;";
	   $query2 = $db->prepare($sql);
	   $query2->execute;

	   while ($resptr = $query2->fetchrow_hashref())
	   {
	      if ($resptr->{"cqmtype"} != $cqmstatic)
	      {
		  print "<td>".$resptr->{"cqdata"}."</td>\n";
	      }
	   }
	   $query2->finish;
	   
	   print "</tr>\n";
	}
	print "</table>\n";
	
	$query->finish;
	
	$db->disconnect;
}
exit 0;
