-- MySQL dump 9.09
--
-- Host: db53d.pair.com    Database: myoung_brassy
-- ------------------------------------------------------
-- Server version	4.0.13-standard-log

CREATE TABLE `announcement` (
 `announcementid` int(11) NOT NULL auto_increment,
 `playerid` int(11) default '0',
 `title` varchar(80)  default NULL,
 `madeby` varchar(80)  default NULL,
 `article` text,
 `display` tinyint(1) default '0',
 `entrydate` date default NULL,
 `displaydate` date default NULL,
 PRIMARY KEY  (`announcementid`)
) ENGINE=MyISAM;

--
-- Table structure for table `GMcharacters`
--

CREATE TABLE `GMcharacters` (
  `gmcid` int(11) NOT NULL auto_increment,
  `gmcGMid` int(11) NOT NULL default '0',
  `gmccharid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`gmcid`)
) TYPE=MyISAM;

--
-- Table structure for table `GMwriters`
--

CREATE TABLE `GMwriters` (
  `gmwid` int(11) NOT NULL auto_increment,
  `writerid` int(11) NOT NULL default '0',
  `charid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`gmwid`)
) TYPE=MyISAM;

--
-- Table structure for table `VLaccess`
--

CREATE TABLE `VLaccess` (
  `vlid` int(11) NOT NULL default '0',
  `charid` int(11) NOT NULL default '0',
  `vla_fancy` int(11) default '0',
  `vla_secure` int(11) default '0',
  `vla_location` int(11) default '0',
  `vla_inventory` int(11) default '0'
) TYPE=MyISAM;

--
-- Table structure for table `VLstatlink`
--

CREATE TABLE `VLstatlink` (
  `vlid` int(11) NOT NULL default '0',
  `vlsid` int(11) NOT NULL default '0',
  `charid` int(11) NOT NULL default '0',
  `vlslevel` int(11) default '0'
) TYPE=MyISAM;

--
-- Table structure for table `VLstats`
--

CREATE TABLE `VLstats` (
  `vlsid` int(11) NOT NULL auto_increment,
  `vlsname` varchar(50) default NULL,
  `vlsdesc` mediumtext,
  `vlcanupdate` tinyint(1) default '0',
  PRIMARY KEY  (`vlsid`)
) TYPE=MyISAM;

--
-- Table structure for table `WS_parts`
--

CREATE TABLE `WS_parts` (
  `wpid` int(11) NOT NULL auto_increment,
  `wpname` varchar(80) default NULL,
  `wpcost` int(11) NOT NULL default '0',
  `wpcanpurchase` tinyint(1) default '0',
  `wpmfid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`wpid`)
) TYPE=MyISAM;

--
-- Table structure for table `WS_plans`
--

CREATE TABLE `WS_plans` (
  `planid` int(11) NOT NULL auto_increment,
  `name` varchar(160) default NULL,
  `entrydate` date default NULL,
  `level` int(11) NOT NULL default '0',
  `complexity` int(11) NOT NULL default '0',
  `description` mediumtext,
  `value` int(11) NOT NULL default '0',
  `gmnotes` mediumtext,
  `stateid` int(11) NOT NULL default '0',
  `stateknown` tinyint(1) default '0',
  PRIMARY KEY  (`planid`)
) TYPE=MyISAM;

--
-- Table structure for table `abilities`
--

CREATE TABLE `abilities` (
  `abid` int(11) NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `type` varchar(30) default NULL,
  `category` varchar(30) default NULL,
  `defend` tinyint(1) default '0',
  `cost` int(11) default '0',
  `difficulty` varchar(30) default NULL,
  `effect` mediumtext,
  `challenge` varchar(50) default NULL,
  `challenge_defense` varchar(50) default NULL,
  `time` varchar(50) default NULL,
  `uses` varchar(50) default NULL,
  `other_constraints` mediumtext,
  `allowed` varchar(30) default NULL,
  `req_text` tinyint(1) default '0',
  PRIMARY KEY  (`abid`)
) TYPE=MyISAM;

--
-- Table structure for table `abilityallowed`
--

CREATE TABLE `abilityallowed` (
  `allid` int(11) NOT NULL auto_increment,
  `allowed` varchar(30) default NULL,
  PRIMARY KEY  (`allid`)
) TYPE=MyISAM;

--
-- Table structure for table `abilitycategories`
--

CREATE TABLE `abilitycategories` (
  `catid` int(11) NOT NULL auto_increment,
  `category` varchar(30) default NULL,
  PRIMARY KEY  (`catid`)
) TYPE=MyISAM;

--
-- Table structure for table `abilitychallenge`
--

CREATE TABLE `abilitychallenge` (
  `challengeid` int(11) NOT NULL auto_increment,
  `challenge` varchar(50) default NULL,
  PRIMARY KEY  (`challengeid`)
) TYPE=MyISAM;

--
-- Table structure for table `abilitydifficulty`
--

CREATE TABLE `abilitydifficulty` (
  `diffid` int(11) NOT NULL auto_increment,
  `difficulty` varchar(30) default NULL,
  `explanation` varchar(60) default NULL,
  PRIMARY KEY  (`diffid`)
) TYPE=MyISAM;

--
-- Table structure for table `abilitytypes`
--

CREATE TABLE `abilitytypes` (
  `typeid` int(11) NOT NULL auto_increment,
  `type` varchar(30) default NULL,
  `basestat` varchar(30) default NULL,
  PRIMARY KEY  (`typeid`)
) TYPE=MyISAM;

--
-- Table structure for table `actionitems`
--

CREATE TABLE `actionitems` (
  `acid` int(11) NOT NULL auto_increment,
  `name` varchar(80) default NULL,
  `description` mediumtext,
  `duedate` date default NULL,
  `datecreated` date default NULL,
  PRIMARY KEY  (`acid`)
) TYPE=MyISAM;

--
-- Table structure for table `applications`
--

CREATE TABLE `applications` (
  `aid` int(11) NOT NULL auto_increment,
  `aname` varchar(30) default NULL,
  `adesc` text,
  `amfid` int(11) NOT NULL default '0',
  `abaseid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`aid`)
) TYPE=MyISAM;

--
-- Table structure for table `bgas`
--

CREATE TABLE `bgas` (
  `bgaid` int(11) NOT NULL auto_increment,
  `charid` int(11) default '0',
  `btid` int(11) default '0',
  `data` mediumtext,
  `money` int(11) default '0',
  `priority` int(11) default '0',
  `handled` tinyint(1) default '0',
  `result` mediumtext,
  `conspirators` mediumtext,
  `period` int(11) default '1',
  `secretdata` mediumtext,
  PRIMARY KEY  (`bgaid`)
) TYPE=MyISAM;

--
-- Table structure for table `bgatypes`
--

CREATE TABLE `bgatypes` (
  `btid` int(11) NOT NULL auto_increment,
  `text` varchar(100) default NULL,
  `explanation` mediumtext,
  `stat_req` varchar(80) default NULL,
  `auto` tinyint(1) default '0',
  PRIMARY KEY  (`btid`)
) TYPE=MyISAM;

--
-- Table structure for table `blackmail`
--

CREATE TABLE `blackmail` (
  `bid` int(11) NOT NULL auto_increment,
  `text` mediumtext,
  `linkid` int(11) default '0',
  `isplayersecret` tinyint(1) default '0',
  PRIMARY KEY  (`bid`)
) TYPE=MyISAM;

--
-- Table structure for table `blackmailcharacters`
--

CREATE TABLE `blackmailcharacters` (
  `bid` int(11) default '0',
  `charid` int(11) default '0',
  `entrydate` date default NULL
) TYPE=MyISAM;

--
-- Table structure for table `blackres`
--

CREATE TABLE `blackres` (
  `brid` int(11) NOT NULL auto_increment,
  `npcsid` int(11) default '0',
  `charid` int(11) default '0',
  `result` int(11) default '0',
  `money` tinyint(1) default '0',
  `votes` tinyint(1) default '0',
  `subfree` tinyint(1) default '0',
  `bga` tinyint(1) default '0',
  PRIMARY KEY  (`brid`)
) TYPE=MyISAM;

--
-- Table structure for table `boxcategories`
--

CREATE TABLE `boxcategories` (
  `bcid` int(11) NOT NULL auto_increment,
  `boxid` int(11) NOT NULL default '0',
  `bcname` varchar(30) default NULL,
  `bcdesc` mediumtext,
  PRIMARY KEY  (`bcid`)
) TYPE=MyISAM;

--
-- Table structure for table `boxes`
--

CREATE TABLE `boxes` (
  `boxid` int(11) NOT NULL auto_increment,
  `boxname` varchar(20) default NULL,
  `boxdesc` mediumtext,
  PRIMARY KEY  (`boxid`)
) TYPE=MyISAM;

--
-- Table structure for table `charabilityallowed`
--

CREATE TABLE `charabilityallowed` (
  `abid` int(11) NOT NULL default '0',
  `charid` int(11) NOT NULL default '0',
  `asholy` tinyint(1) default NULL
) TYPE=MyISAM;

--
-- Table structure for table `characterMFallowed`
--

CREATE TABLE `characterMFallowed` (
  `mfid` int(11) default '0',
  `charid` int(11) default '0'
) TYPE=MyISAM;

--
-- Table structure for table `characterSTATs`
--

CREATE TABLE `characterSTATs` (
  `csid` int(11) NOT NULL auto_increment,
  `charid` int(11) NOT NULL default '0',
  `str` int(11) default '0',
  `dex` int(11) default '0',
  `iq` int(11) default '0',
  `will` int(11) default '0',
  `status` int(11) default '0',
  `holy` int(11) default '0',
  `unholy` int(11) default '0',
  `mana` int(11) default '0',
  `inspiration` int(11) default '0',
  `weirdscience` int(11) default '0',
  `vlpoints` int(11) default '0',
  `substatus` int(11) default '0',
  `unholyallowed` tinyint(1) default '0',
  `vlspecialpoints` int(11) default '0',
  `lastBGincome` int(11) default '0',
  PRIMARY KEY  (`csid`)
) TYPE=MyISAM;

--
-- Table structure for table `characterabilities`
--

CREATE TABLE `characterabilities` (
  `caid` int(11) NOT NULL auto_increment,
  `charid` int(11) NOT NULL default '0',
  `abid` int(11) NOT NULL default '0',
  `level` int(11) NOT NULL default '0',
  `text` varchar(80) default NULL,
  `difficulty` varchar(30) default NULL,
  `cost` int(11) default '0',
  PRIMARY KEY  (`caid`)
) TYPE=MyISAM;

--
-- Table structure for table `characterapplications`
--

CREATE TABLE `characterapplications` (
  `aid` int(11) default '0',
  `charid` int(11) default '0',
  `level` int(11) default '0'
) TYPE=MyISAM;

--
-- Table structure for table `charactergroupmembers`
--

CREATE TABLE `charactergroupmembers` (
  `charid` int(11) default NULL,
  `groupid` int(11) default NULL,
  `secret` tinyint(1) default NULL,
  `notes` mediumtext,
  `leader` tinyint(1) default '0',
  `officer` tinyint(1) default '0',
   KEY `charid` (`charid`,`groupid`)
) TYPE=MyISAM;

--
-- Table structure for table `charactergroups`
--

CREATE TABLE `charactergroups` (
  `groupid` int(11) NOT NULL auto_increment,
  `groupname` varchar(30) default NULL,
  `groupdesc` mediumtext,
  `candobga` tinyint(1) default '0',
  `allowedbudget` tinyint(1) default '0',
  `budget` int(11) default '0',
  `allowedpress` tinyint(1) default '0',
  `presslevel` int(11) default '0',
  PRIMARY KEY  (`groupid`)
) TYPE=MyISAM;

--
-- Table structure for table `charactermotiveforces`
--

CREATE TABLE `charactermotiveforces` (
  `mfid` int(11) default '0',
  `charid` int(11) default '0',
  `level` int(11) default '0'
) TYPE=MyISAM;

--
-- Table structure for table `characteroccupations`
--

CREATE TABLE `characteroccupations` (
  `oid` int(11) default '0',
  `charid` int(11) default '0'
) TYPE=MyISAM;

--
-- Table structure for table `characterplans`
--

CREATE TABLE `characterplans` (
  `planid` int(11) NOT NULL default '0',
  `charid` int(11) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Table structure for table `characterresourcetypelink`
--

CREATE TABLE `characterresourcetypelink` (
  `typeid` int(11) NOT NULL default '0',
  `abid` int(11) NOT NULL default '0',
  `charid` int(11) NOT NULL default '0',
  `level` int(11) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Table structure for table `characters`
--

CREATE TABLE `characters` (
  `charid` int(11) NOT NULL auto_increment,
  `cfirst` varchar(30) default NULL,
  `clast` varchar(30) default NULL,
  `cmiddle` varchar(30) default NULL,
  `calias` varchar(100) default NULL,
  `chartype` int(11) default NULL,
  `charstoryapproved` int(11) default '0',
  `charstatsapproved` int(11) default '0',
  `charsex` char(1) default NULL,
  `ctitle` varchar(50) default NULL,
  `cpiclink` varchar(80) default NULL,
  `charplotapproved` int(11) default '0',
  `cdoclink` varchar(80) default NULL,
  `chtmllink` varchar(100) default NULL,
  PRIMARY KEY  (`charid`)
) TYPE=MyISAM;

--
-- Table structure for table `charactersubfree`
--

CREATE TABLE `charactersubfree` (
  `sfid` int(11) NOT NULL default '0',
  `charid` int(11) NOT NULL default '0',
  `handled` tinyint(1) default '0'
) TYPE=MyISAM;

--
-- Table structure for table `charactersubfree2`
--

CREATE TABLE `charactersubfree2` (
  `csfid` int(11) NOT NULL auto_increment,
  `sfid` int(11) NOT NULL default '0',
  `charid` int(11) NOT NULL default '0',
  `handled` tinyint(1) default '0',
  PRIMARY KEY  (`csfid`)
) TYPE=MyISAM;

--
-- Table structure for table `charactersubstatpoints`
--

CREATE TABLE `charactersubstatpoints` (
  `csspid` int(11) NOT NULL auto_increment,
  `charid` int(11) NOT NULL default '0',
  `points` int(11) NOT NULL default '0',
  `entrydate` date default NULL,
  `notes` varchar(160) default NULL,
  `handled` tinyint(1) default '0',
  PRIMARY KEY  (`csspid`)
) TYPE=MyISAM;

--
-- Table structure for table `charinfo`
--

CREATE TABLE `charinfo` (
  `ciid` int(11) NOT NULL auto_increment,
  `charid` int(11) default '0',
  `template` int(11) default '0',
  `showplayer` tinyint(1) default '0',
  `showbirthday` tinyint(1) default '0',
  `showpic` tinyint(1) default '0',
  `shownationality` tinyint(1) default '0',
  `showstatus` tinyint(1) default '0',
  `showmaritalstatus` tinyint(1) default '0',
  `showspousename` tinyint(1) default '0',
  `showaddress` tinyint(1) default '0',
  `showreligion` tinyint(1) default '0',
  `showoccupation` tinyint(1) default '0',
  `info` mediumtext,
  `showkeyroles` tinyint(1) default '0',
  PRIMARY KEY  (`ciid`)
) TYPE=MyISAM;

--
-- Table structure for table `charquestionnaires`
--

CREATE TABLE `charquestionnaires` (
  `cqcharid` int(11) NOT NULL default '0',
  `cqrtlb` varchar(100) default NULL,
  `cqcharaddress` varchar(100) default NULL,
  `cqcharcitystate` varchar(100) default NULL,
  `cqcharnationality` varchar(100) default NULL,
  `cqchardob` date default NULL,
  `cqcharethnic` varchar(100) default NULL,
  `cqrelpractice` varchar(100) default NULL,
  `cqrelraised` varchar(100) default NULL,
  `cqrelcurrent` varchar(100) default NULL,
  `cqedulevel` varchar(100) default NULL,
  `cqcollegename` varchar(100) default NULL,
  `cqcollegeclass` varchar(100) default NULL,
  `cqfamily` mediumtext,
  `cqmarried` int(1) default '0',
  `cqspouse` mediumtext,
  `cqsofriends` mediumtext,
  `cqcharoccupation` mediumtext,
  `cqcharhobbies` mediumtext,
  `cqstatusgen` varchar(15) default NULL,
  `cqcharstory` longtext,
  `cqplothooks` mediumtext,
  `cqgmnotes` longtext,
  `cqdate` timestamp(6) NOT NULL,
  PRIMARY KEY  (`cqcharid`)
) TYPE=MyISAM;

--
-- Table structure for table `cqmeta`
--

CREATE TABLE `charquest2` (
  `cqcharid` int(11) NOT NULL default '0',
  `cqmid` int(11) NOT NULL default '0',
  `cqdata` mediumtext,
  KEY  cqmid (`cqmid`, `cqcharid`)
) TYPE=MyISAM;

--
-- Table structure for table `cqmeta`
--

CREATE TABLE `cqmeta` (
  `cqmid` int(11) NOT NULL auto_increment,
  `cqmname` varchar(100) default NULL,
  `cqmtype` int(11) NOT NULL default '0',
  `cqmorder` int(11) NOT NULL default '0',
  `cqmdata` mediumtext,
  `cqmnotes` mediumtext,
  PRIMARY KEY  (`cqmid`)
) TYPE=MyISAM;

--
-- Table structure for table `chartypes`
--

CREATE TABLE `chartypes` (
  `ctypeid` int(11) NOT NULL auto_increment,
  `ctypedesc` varchar(50) default NULL,
  PRIMARY KEY  (`ctypeid`)
) TYPE=MyISAM;

--
-- Table structure for table `chartypetraits`
--

CREATE TABLE `chartypetraits` (
  `cttid` int(11) NOT NULL auto_increment,
  `traitname` varchar(50) default NULL,
  `descr` varchar(80) default NULL,
  PRIMARY KEY  (`cttid`)
) TYPE=MyISAM;

--
-- Table structure for table `chartypetraitlink`
--

CREATE TABLE `chartypetraitlink` (
  `ctypeid` int(11) default 0,
  `cttid` int(11) default 0,
  `value` varchar(80) default NULL
) TYPE=MyISAM;

--
-- Table structure for table `damagechart`
--

CREATE TABLE `damagechart` (
  `dcid` int(11) NOT NULL auto_increment,
  `charid` int(11) default '0',
  `itemid` int(11) default '0',
  `roll1` varchar(80) default NULL,
  `roll2` varchar(80) default NULL,
  `roll3` varchar(80) default NULL,
  `roll4` varchar(80) default NULL,
  `roll5` varchar(80) default NULL,
  `roll6` varchar(80) default NULL,
  `roll7` varchar(80) default NULL,
  `roll8` varchar(80) default NULL,
  `roll9` varchar(80) default NULL,
  `roll0` varchar(80) default NULL,
  PRIMARY KEY  (`dcid`)
) TYPE=MyISAM;

--
-- Table structure for table `district_votes`
--

CREATE TABLE `district_votes` (
  `dvid` int(11) NOT NULL auto_increment,
  `charid` int(11) default '0',
  `votes` int(11) default '0',
  PRIMARY KEY  (`dvid`)
) TYPE=MyISAM;

--
-- Table structure for table `docket`
--

CREATE TABLE `docket` (
  `did` int(11) NOT NULL auto_increment,
  `dname` varchar(60) default NULL,
  `ddesc` mediumtext,
  `url` varchar(160) default NULL,
  `doc` varchar(160) default NULL,
  `weight` int(11) default '0',
  `eventid` int(11) default '0',
  `submittor` int(11) default '0',
  `for_reasons` mediumtext,
  `against_reasons` mediumtext,
  `predict_pass` mediumtext,
  `predict_fail` mediumtext,
  `gm_notes` mediumtext,
  `weight_min` int(11) default '0',
  `weight_max` int(11) default '0',
  PRIMARY KEY  (`did`)
) TYPE=MyISAM;

--
-- Table structure for table `doclib2`
--

CREATE TABLE `doclib2` (
  `docid` int(11) NOT NULL auto_increment,
  `filename` varchar(80) default NULL,
  `creator` int(11) default '0',
  `status` int(11) default '0',
  `access` int(11) default '1',
  `entrydate` date default NULL,
  `notes` mediumtext,
  `dfid` int(11) default '0',
  `ispicture` tinyint(1) default '0',
  PRIMARY KEY  (`docid`)
) TYPE=MyISAM;

--
-- Table structure for table `doclibfolders`
--

CREATE TABLE `doclibfolders` (
  `dfid` int(11) NOT NULL auto_increment,
  `foldername` varchar(80) default NULL,
  `description` mediumtext,
  `creator` int(11) default '0',
  `access` int(11) default '1',
  `entrydate` date default NULL,
  `parent` int(11) default '0',
  `haspictures` tinyint(1) default '0',
  PRIMARY KEY  (`dfid`)
) TYPE=MyISAM;

--
-- Table structure for table `eventplayers`
--

CREATE TABLE `eventplayers` (
  `epid` int(11) NOT NULL auto_increment,
  `eventid` int(11) default NULL,
  `playerid` int(11) default NULL,
  `reglevel` int(11) default NULL,
  `hasroom` tinyint(1) default NULL,
  `balance` float default '0',
  `priority` int(11) default '0',
  PRIMARY KEY  (`epid`)
) TYPE=MyISAM;

--
-- Table structure for table `eventregstates`
--

CREATE TABLE `eventregstates` (
  `regstate` int(11) NOT NULL auto_increment,
  `regname` varchar(100) default NULL,
  PRIMARY KEY  (`regstate`)
) TYPE=MyISAM;

--
-- Table structure for table `events`
--

CREATE TABLE `events` (
  `eventid` int(11) NOT NULL auto_increment,
  `eventname` varchar(100) default NULL,
  `eventstart` datetime default NULL,
  `eventend` datetime default NULL,
  `eventstarttime` varchar(100) default NULL,
  `eventendtime` varchar(100) default NULL,
  `etid` int(11) default NULL,
  `venueid` int(11) default NULL,
  `eventcost` varchar(100) default NULL,
  `eventtext` longtext,
  `eventgmnotes` longtext,
  `eventregavailable` tinyint(1) default NULL,
  `realcost` float default '0',
  `paypalemail` varchar(100) default NULL,  
  `showchildpolicy` tinyint(1) default 0,
  PRIMARY KEY  (`eventid`)
) TYPE=MyISAM;

--
-- Table structure for table `eventtypes`
--

CREATE TABLE `eventtypes` (
  `etid` int(11) NOT NULL auto_increment,
  `ettext` varchar(50) default NULL,
  PRIMARY KEY  (`etid`)
) TYPE=MyISAM;

--
-- Table structure for table `eventreglevels`
--

CREATE TABLE `eventreglevels` (
  `erlid` int(11) NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `description` mediumtext,
  `picloc` varchar(50) default NULL,
  PRIMARY KEY  (`erlid`)
) TYPE=MyISAM;

--
-- Table structure for table `eventsreglevelslink`
--

CREATE TABLE `eventsreglevelslink` (
  `erlid` int(11) default 0,
  `eventid` int(11) default 0,
  `cost` varchar(100) default NULL,
  `realcost` float default '0'
) TYPE=MyISAM;

--
-- Table structure for table `global_variables`
--

CREATE TABLE `global_variables` (
  `gvid` int(11) NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `description` mediumtext,
  `level` int(11) NOT NULL default '0',
  `min_range` int(11) NOT NULL default '0',
  `max_range` int(11) NOT NULL default '0',
  `speechable` tinyint(1) default '0',
  PRIMARY KEY  (`gvid`)
) TYPE=MyISAM;

--
-- Table structure for table `gmlinktables`
--

CREATE TABLE `gmlinktables` (
  `gltid` int(11) NOT NULL auto_increment,
  `linktable` varchar(80) default NULL,
  `linkfield` varchar(80) default NULL,
  `tablename` varchar(80) default NULL,
  `linknamefield` varchar(80) default NULL,
  `wherefield` varchar(80) default NULL,
  `editpage` varchar(80) default NULL,
  PRIMARY KEY  (`gltid`)
) TYPE=MyISAM;

--
-- Table structure for table `gmnotes`
--

CREATE TABLE `gmnotes` (
  `gmnid` int(11) NOT NULL auto_increment,
  `playerid` int(11) default '0',
  `summary` varchar(80) default NULL,
  `notes` mediumtext,
  `entrydate` date default NULL,
  `status` int(11) default '0',
  PRIMARY KEY  (`gmnid`)
) TYPE=MyISAM;

--
-- Table structure for table `inventory`
--

CREATE TABLE `inventory` (
  `iid` int(11) NOT NULL auto_increment,
  `name` varchar(80) default NULL,
  `cost` int(11) NOT NULL default '0',
  `description` mediumtext,
  `gmnotes` mediumtext,
  `owner` int(11) NOT NULL default '0',
  PRIMARY KEY  (`iid`)
) TYPE=MyISAM;

--
-- Table structure for table `inventory_dev`
--

CREATE TABLE `inventory_dev` (
  `isdid` int(11) NOT NULL auto_increment,
  `planid` int(11) NOT NULL default '0',
  `charid` int(11) NOT NULL default '0',
  `amount` int(11) NOT NULL default '0',
  `stateid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`isdid`)
) TYPE=MyISAM;

--
-- Table structure for table `inventory_sc`
--

CREATE TABLE `inventory_sc` (
  `iscid` int(11) NOT NULL auto_increment,
  `scid` int(11) NOT NULL default '0',
  `charid` int(11) NOT NULL default '0',
  `amount` int(11) NOT NULL default '0',
  PRIMARY KEY  (`iscid`)
) TYPE=MyISAM;

--
-- Table structure for table `inventory_ws`
--

CREATE TABLE `inventory_ws` (
  `iwsid` int(11) NOT NULL auto_increment,
  `wpid` int(11) NOT NULL default '0',
  `charid` int(11) NOT NULL default '0',
  `amount` int(11) NOT NULL default '0',
  PRIMARY KEY  (`iwsid`)
) TYPE=MyISAM;

--
-- Table structure for table `journal`
--

CREATE TABLE `journal` (
  `jid` int(11) NOT NULL auto_increment,
  `charid` int(11) default '0',
  `title` varchar(160) default NULL,
  `entry` longtext,
  `entrydate` date default NULL,
  `gmcomments` longtext,
  PRIMARY KEY  (`jid`)
) TYPE=MyISAM;

--
-- Table structure for table `keyroleabilities`
--

CREATE TABLE `keyroleabilities` (
  `kraid` int(11) NOT NULL auto_increment,
  `krid` int(11) NOT NULL default '0',
  `abid` int(11) NOT NULL default '0',
  `level` int(11) NOT NULL default '0',
  `text` varchar(50) default NULL,
  `difficulty` varchar(50) default NULL,
  `cost` int(11) NOT NULL default '0',
  PRIMARY KEY  (`kraid`)
) TYPE=MyISAM;

--
-- Table structure for table `keyrolecharacters`
--

CREATE TABLE `keyrolecharacters` (
  `krid` int(11) NOT NULL default '0',
  `charid` int(11) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Table structure for table `keyrolerresourcetypelink`
--

CREATE TABLE `keyrolerresourcetypelink` (
  `typeid` int(11) NOT NULL default '0',
  `abid` int(11) NOT NULL default '0',
  `krid` int(11) NOT NULL default '0',
  `level` int(11) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Table structure for table `keyroles`
--

CREATE TABLE `keyroles` (
  `krid` int(11) NOT NULL auto_increment,
  `krname` varchar(30) default NULL,
  `krdescription` mediumtext,
  `krrequirements` mediumtext,
  PRIMARY KEY  (`krid`)
) TYPE=MyISAM;

--
-- Table structure for table `linknotes`
--

CREATE TABLE `linknotes` (
  `gmnid` int(11) default '0',
  `linktable` varchar(80) default NULL,
  `linkid` int(11) default '0',
  KEY `gmnid` (`gmnid`,`linktable`,`linkid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `loggedin`
--

CREATE TABLE `loggedin` (
  `liplayerid` int(11) default NULL,
  `licookie` varchar(40) default NULL,
  `lidate`  date default NULL,
  PRIMARY KEY  (`liplayerid`)
) TYPE=MyISAM;

--
-- Table structure for table `menuheader`
--

CREATE TABLE `menuheader` (
  `mhid` int(11) NOT NULL auto_increment,
  `name` varchar(80) default NULL,
  `varexpr` varchar(80) default NULL,
  `parent` int(11) default '0',
  PRIMARY KEY  (`mhid`)
) TYPE=MyISAM;

--
-- Table structure for table `menuitem`
--

CREATE TABLE `menuitem` (
  `mid` int(11) NOT NULL auto_increment,
  `info` varchar(80) default NULL,
  `name` varchar(80) default NULL,
  `link` varchar(80) default NULL,
  `linkparams` varchar(80) default NULL,
  `varexpr` varchar(160) default NULL,
  `parent` int(11) default '0',
  PRIMARY KEY  (`mid`)
) TYPE=MyISAM;

--
-- Table structure for table `money`
--

CREATE TABLE `money` (
  `mid` int(11) NOT NULL auto_increment,
  `charid` int(11) default '0',
  `pounds` int(11) default '0',
  `entrydate` date default NULL,
  `notes` varchar(80) default NULL,
  PRIMARY KEY  (`mid`)
) TYPE=MyISAM;

--
-- Table structure for table `motiveforces`
--

CREATE TABLE `motiveforces` (
  `mfid` int(11) NOT NULL auto_increment,
  `mfname` varchar(30) default NULL,
  `mfdesc` text,
  `mfsecret` tinyint(1) default '0',
  PRIMARY KEY  (`mfid`)
) TYPE=MyISAM;

--
-- Table structure for table `news`
--

CREATE TABLE `news` (
  `newsid` int(11) NOT NULL auto_increment,
  `playerid` int(11) default '0',
  `title` varchar(80) default NULL,
  `article` text,
  `display` tinyint(1) default '0',
  `entrydate` date default NULL,
  PRIMARY KEY  (`newsid`)
) TYPE=MyISAM;

--
-- Table structure for table `npcsecrets`
--

CREATE TABLE `npcsecrets` (
  `npcsid` int(11) NOT NULL auto_increment,
  `charname` varchar(50) default NULL,
  `text` mediumtext,
  `level` int(11) default '0',
  `will` int(11) default '0',
  `status` int(11) default '0',
  PRIMARY KEY  (`npcsid`)
) TYPE=MyISAM;

--
-- Table structure for table `occupationabilities`
--

CREATE TABLE `occupationabilities` (
  `ocabid` int(11) NOT NULL auto_increment,
  `oid` int(11) default '0',
  `abid` int(11) default '0',
  `text` varchar(80) default NULL,
  `minlevel` int(11) default '0',
  PRIMARY KEY  (`ocabid`)
) TYPE=MyISAM;

--
-- Table structure for table `occupations`
--

CREATE TABLE `occupations` (
  `oid` int(11) NOT NULL auto_increment,
  `oname` varchar(80) default NULL,
  `odesc` mediumtext,
  `req_status` int(11) default '0',
  `base_income` int(11) default '0',
  `d10_base_income` int(11) default '0',
  `base_stigma_modifier` int(11) default '0',
  `d10_stigma_modifier` int(11) default '0',
  `base_bga_income` int(11) default '0',
  `d10_bga_income` int(11) default '0',
  `base_skill_bonus` int(11) default '0',
  `d10_skill_bonus` int(11) default '0',
  `skill_bonus_threshold` int(11) default '0',
  `stipend` tinyint(1) default NULL,
  `uses_weird_science` tinyint(1) default NULL,
  PRIMARY KEY  (`oid`)
) TYPE=MyISAM;

--
-- Table structure for table `pagedefaults`
--

CREATE TABLE `pagedefaults` (
  `pdid` int(11) NOT NULL auto_increment,
  `playerid` int(11) default '0',
  `pageid` varchar(80) default NULL,
  `defstring` varchar(160) default NULL,
  `tabnum` int(11) default '0',
  PRIMARY KEY  (`pdid`)
) TYPE=MyISAM;

--
-- Table structure for table `planapplications`
--

CREATE TABLE `planapplications` (
  `planid` int(11) NOT NULL default '0',
  `aid` int(11) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Table structure for table `planlevels`
--

CREATE TABLE `planlevels` (
  `levid` int(11) NOT NULL auto_increment,
  `levtext` varchar(80) default NULL,
  PRIMARY KEY  (`levid`)
) TYPE=MyISAM;

--
-- Table structure for table `planmfs`
--

CREATE TABLE `planmfs` (
  `planid` int(11) NOT NULL default '0',
  `mfid` int(11) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Table structure for table `planparts`
--

CREATE TABLE `planparts` (
  `planid` int(11) NOT NULL default '0',
  `wpid` int(11) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Table structure for table `planstates`
--

CREATE TABLE `planstates` (
  `stateid` int(11) NOT NULL auto_increment,
  `statetext` varchar(80) default NULL,
  PRIMARY KEY  (`stateid`)
) TYPE=MyISAM;

--
-- Table structure for table `playeractionitems`
--

CREATE TABLE `playeractionitems` (
  `acid` int(11) default '0',
  `playerid` int(11) default '0',
  `completed` tinyint(1) default '0',
  `datecompleted` datetime default NULL,
  `status` mediumtext
) TYPE=MyISAM;

--
-- Table structure for table `playerboxes`
--

CREATE TABLE `playerboxes` (
  `pbid` int(11) NOT NULL auto_increment,
  `pbbcid` int(11) NOT NULL default '0',
  `pbcharid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`pbid`)
) TYPE=MyISAM;

--
-- Table structure for table `playercharacters`
--

CREATE TABLE `playercharacters` (
  `pcplayerid` int(11) default NULL,
  `pccharid` int(11) default NULL,
  `pcdesc` mediumtext
) TYPE=MyISAM;

--
-- Table structure for table `playerquestionnaires`
--

CREATE TABLE `playerquestionnaires` (
  `pqplayerid` int(11) NOT NULL default '0',
  `pqlarpexp` varchar(100) default NULL,
  `pqsendpref` varchar(100) default NULL,
  `pqrtlb` varchar(100) default NULL,
  `pqfriends` varchar(100) default NULL,
  `pqnonfriends` varchar(100) default NULL,
  `pqfoodpref` varchar(100) default NULL,
  `pqemergcontactname` varchar(100) default NULL,
  `pqemergcontactphone` varchar(100) default NULL,
  `pqmedicalconditions` varchar(100) default NULL,
  `pqhowheard` varchar(100) default NULL,
  `pqdate` timestamp(6) NOT NULL,
  PRIMARY KEY  (`pqplayerid`)
) TYPE=MyISAM;

--
-- Table structure for table `players`
--

CREATE TABLE `players` (
  `playerid` int(11) NOT NULL auto_increment,
  `pfirst` varchar(20) default NULL,
  `plast` varchar(30) default NULL,
  `cmiddle` varchar(30) default NULL,
  `pemail` varchar(50) default NULL,
  `pcelphone` varchar(50) default NULL,
  `page` int(11) default NULL,
  `pgender` char(1) default NULL,
  `ppassword` varchar(20) default NULL,
  `psecurity` int(11) default NULL,
  `plogin` varchar(20) default NULL,
  `pXP` int(11) default NULL,
  `pXPspent` int(11) default '0',
  PRIMARY KEY  (`playerid`)
) TYPE=MyISAM;

--
-- Table structure for table `playerSC`
--

CREATE TABLE `playerSC` (
  `pscid` int(11) NOT NULL auto_increment,
  `playerid` int(11) NOT NULL default '0',
  `scid` int(11) NOT NULL default '0',
  `value` int(11) NOT NULL default '0',
  `eventid` int(11) NOT NULL default '0',
  `notes` mediumtext,
  `entrydate` datetime,  
  PRIMARY KEY  (`pscid`)
) TYPE=MyISAM;

--
-- Table structure for table `plotboxes`
--

CREATE TABLE `plotboxes` (
  `bcid` int(11) NOT NULL default '0',
  `plotid` int(11) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Table structure for table `plots`
--

CREATE TABLE `plots` (
  `plotid` int(11) NOT NULL auto_increment,
  `plstatus` int(11) default '0',
  `plname` varchar(100) default NULL,
  `plauthor` int(11) NOT NULL default '0',
  `pltypetext` varchar(40) default NULL,
  `ploverview` mediumtext,
  `plhistory` mediumtext,
  `plfx` mediumtext,
  `pltimeline` mediumtext,
  `pldetails` longtext,
  `plapproved` int(11) default '0',
  `plgmnotes` longtext,
  PRIMARY KEY  (`plotid`)
) TYPE=MyISAM;

--
-- Table structure for table `plotstatus`
--

CREATE TABLE `plotstatus` (
  `psid` int(11) NOT NULL auto_increment,
  `plstatustext` varchar(80) default NULL,
  PRIMARY KEY  (`psid`)
) TYPE=MyISAM;

--
-- Table structure for table `resourcetypelink`
--

CREATE TABLE `resourcetypelink` (
  `typeid` int(11) NOT NULL default '0',
  `abid` int(11) NOT NULL default '0',
  `level` int(11) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Table structure for table `resourcetypes`
--

CREATE TABLE `resourcetypes` (
  `typeid` int(11) NOT NULL auto_increment,
  `type` varchar(30) default NULL,
  `showplayer` tinyint(1) default '1',
  `isnumeric` tinyint(1) default '0',
  PRIMARY KEY  (`typeid`)
) TYPE=MyISAM;

--
-- Table structure for table `service_credits`
--

CREATE TABLE `service_credits` (
  `scid` int(11) NOT NULL auto_increment,
  `name` varchar(80) default NULL,
  `value` int(11) NOT NULL default '0',
  `notes` mediumtext,
  PRIMARY KEY  (`scid`)
) TYPE=MyISAM;


--
-- Table structure for table `speech`
--

CREATE TABLE `speech` (
  `spid` int(11) NOT NULL auto_increment,
  `charid` int(11) default '0',
  `did` int(11) default '0',
  `gvid` int(11) default '0',
  `result` int(11) default '0',
  PRIMARY KEY  (`spid`)
) TYPE=MyISAM;

--
-- Table structure for table `spellcomponents`
--

CREATE TABLE `spellcomponents` (
  `scid` int(11) NOT NULL auto_increment,
  `scname` varchar(80) default NULL,
  `scdesc` mediumtext,
  `scorigin` varchar(80) default NULL,
  `sccost` int(11) NOT NULL default '0',
  `sccanpurchase` tinyint(1) default '0',
  PRIMARY KEY  (`scid`)
) TYPE=MyISAM;

--
-- Table structure for table `spellcomponentscharacterlink`
--

CREATE TABLE `spellcomponentscharacterlink` (
  `sclid` int(11) default '0',
  `charid` int(11) default '0'
) TYPE=MyISAM;

--
-- Table structure for table `spellcomponentslink`
--

CREATE TABLE `spellcomponentslink` (
  `sclid` int(11) NOT NULL auto_increment,
  `scid` int(11) default '0',
  `abid` int(11) default '0',
  `sideeffect` mediumtext,
  `manacostmod` int(11) default '0',
  `displaysideeffect` tinyint(1) default '0',
  `spellfails` tinyint(1) default '0',
  PRIMARY KEY  (`sclid`)
) TYPE=MyISAM;

--
-- Table structure for table `spellspecifics`
--

CREATE TABLE `spellspecifics` (
  `abid` int(11) default '0',
  `basemanacost` int(11) default '0',
  `manaperlevel` int(11) default '0',
  `manacostspecial` tinyint(1) default '0',
  `basetimetoprep` int(11) default '0',
  `timetopreplevel` int(11) default '0',
  `timetoprepspecial` tinyint(1) default '0'
) TYPE=MyISAM;

--
-- Table structure for table `substatus_freebies`
--

CREATE TABLE `substatus_freebies` (
  `sfid` int(11) NOT NULL auto_increment,
  `name` varchar(160) default NULL,
  `description` mediumtext,
  `cost` int(11) NOT NULL default '0',
  `minstatus` int(11) NOT NULL default '0',
  `maxstatus` int(11) NOT NULL default '0',
  `private` tinyint(1) default '0',
  PRIMARY KEY  (`sfid`)
) TYPE=MyISAM;


--
-- Table structure for table `templates`
--

CREATE TABLE `templates` (
  `tid` int(11) NOT NULL auto_increment,
  `templatefile` varchar(80) default NULL,
  `bgcolor` varchar(80) default NULL,
  `boxcolor` varchar(80) default NULL,
  `ul` varchar(80) default NULL,
  `top` varchar(80) default NULL,
  `ur` varchar(80) default NULL,
  `leftcol` varchar(80) default NULL,
  `rightcol` varchar(80) default NULL,
  `bl` varchar(80) default NULL,
  `bottom` varchar(80) default NULL,
  `br` varchar(80) default NULL,
  `templatename` varchar(80) default NULL,
  PRIMARY KEY  (`tid`)
) TYPE=MyISAM;

--
-- Table structure for table `timeline`
--

CREATE TABLE `timeline` (
  `tid` int(11) NOT NULL auto_increment,
  `year` int(11) default '0',
  `month` int(11) default '0',
  `day` int(11) default '0',
  `text` mediumtext,
  `public` tinyint(1) default '0',
  PRIMARY KEY  (`tid`)
) TYPE=MyISAM;

--
-- Table structure for table `venues`
--

CREATE TABLE `venues` (
  `venueid` int(11) NOT NULL auto_increment,
  `vname` varchar(30) default NULL,
  `vtype` varchar(20) default NULL,
  `vcontact` varchar(50) default NULL,
  `vcontactinfo` mediumtext,
  `vaddress1` varchar(100) default NULL,
  `vaddress2` varchar(100) default NULL,
  `vcity` varchar(100) default NULL,
  `vstate` char(2) default NULL,
  `vweb` varchar(100) default NULL,
  `vzip` varchar(10) default NULL,
  `vemail` varchar(100) default NULL,
  `vfrontdeskphone` varchar(100) default NULL,
  `vsalesphone` varchar(100) default NULL,
  `vfax` varchar(100) default NULL,
  `vdirections` mediumtext,
  `vaccomodations` mediumtext,
  `vhours` varchar(100) default NULL,
  `vseason` varchar(100) default NULL,
  `vfunctionrates` mediumtext,
  `vroomrates` mediumtext,
  `vspacedesc` mediumtext,
  `vrules` mediumtext,
  `vcontactonsite` varchar(100) default NULL,
  `vemergcontactnum` varchar(10) default NULL,
  `vfacilities` varchar(100) default NULL,
  `vinsurancereq` tinyint(1) default NULL,
  `vportajohnsreq` tinyint(1) default NULL,
  `vnotes` mediumtext,
  PRIMARY KEY  (`venueid`)
) TYPE=MyISAM;

--
-- Table structure for table `virtuallocations`
--

CREATE TABLE `virtuallocations` (
  `vlid` int(11) NOT NULL auto_increment,
  `vlname` varchar(50) default NULL,
  `vldesc` mediumtext,
  `vlowner` int(11) default '0',
  `vl_fancy` int(11) default '0',
  `vl_secure` int(11) default '0',
  `vl_location` int(11) default '0',
  `vl_inventory` int(11) default '0',
  PRIMARY KEY  (`vlid`)
) TYPE=MyISAM;

--
-- Table structure for table `xp`
--

CREATE TABLE `xp` (
  `xid` int(11) NOT NULL auto_increment,
  `charid` int(11) default '0',
  `xp` int(11) default '0',
  `entrydate` date default NULL,
  `notes` varchar(80) default NULL,
  PRIMARY KEY  (`xid`)
) TYPE=MyISAM;

