#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "docket.pl";
$table = "docket";
$heading = "a Bill";
$keyfield = "did";
$keyvalue = $CGI->param($keyfield);
$namefield = "dname";
$tplfile = "docket.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("docketforplayers.pl");
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $heading</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">";
	if ($tplfile eq "")
	{
		local($dbvar) = dbconnect();
		local($query) = $dbvar->prepare("explain $table");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $dbvar->prepare("select * from $table where $keyfield = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$dbvar->disconnect;
		print "</table>";
	}
	else
	{
	     fillvars();
	     ParseForm($tplfile);
	}
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$SQL = "delete from charactergroupmembers where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Deleted"));
}
elsif ($action eq "dump")
{
	print $CGI->header(-type  =>  'application/msword', -filename  =>  'docket.doc');
        #print $CGI->header;
        print "<html><head>\n";
        print "<link href=\"../brassy.css\" rel=\"stylesheet\" type=\"text/css\">\n";
        print "</head>\n";
   	local($db) = dbconnect();
	local ($sql) = "select $keyfield from $table where eventid > 0 and submittor > 0 order by $namefield;";
   	#print"$sql<BR>";
   	local ($query) = $db->prepare($sql);
   	$query->execute;
   	local (@array);
        while (@array = $query->fetchrow_array)
        {
           $keyvalue = $array[0];
	   fillvars();
	   $ddesc =~ s/\n/<BR>/g;
	   $for_reasons =~ s/\n/<BR>/g;
	   $against_reasons =~ s/\n/<BR>/g;
	   ParseForm("docketforplayers.tpl");
   	   print "<BR><BR>[pb]<BR><BR>\n";
   	}
   	$query->finish;
   	$db->disconnect;
        print "</html>\n";
}
elsif ($action eq "upload")
{
	print $CGI->header();
	ParseForm($header);
	print $CGI->start_multipart_form(-name => "form1");
	print "<br><table border=0 align=\"center\"><tr><td align=\"center\"><b>Upload A Bill For the Docket</b></td></tr>\n<tr><td>\n";
	ParseForm("upnodir.tpl");
	print "</td></tr>\n</table>\n";
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"putfile\">\n";
	print $CGI->end_form;
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($action eq "putfile")
{
    #print $CGI->header();
    $fn = $CGI->param('filename');
    $fh = $CGI->param('filename');
    
    #print "$fn<BR>";
    
    $fn =~ s!^.*(\\|\/)!!; 
    
    #print "$fn<BR>";

    #print "[$fh]<BR>";
    
    binmode $fh;
    chmod 0777, "docket/$fn";
    open (OUTFILE,">docket/$fn") || print $CGI->redirect("$thispage?error=" . encodeURL("Error creating $fn. Please try again."));
    binmode OUTFILE;
    binmode $fh;
    while (<$fh>)
    {
	   print OUTFILE $_;
    }
    close OUTFILE;
    close $fh;
    chmod 0777, "docket/$fn";
    
    local($dbvar) = dbconnect();
    $SQL = "update $table set doc='docket/$fn' where $keyfield = $keyvalue;";
    $dbvar->do($SQL);
    $dbvar->disconnect;
        
    print $CGI->redirect("$thispage?error=". encodeURL("$fn successfully uploaded.")); 
    exit 0;
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<table border = 0><tr>\n";
	print "<td width=131><img src=gavel.gif align=left></td>\n";
	print "<td><font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>Manage The Docket</h1>\n";

	print "<BR><a href=\"$thispage?action=new\">ADD a NEW Bill</a>\n";
	print "<BR><a href=\"$thispage?action=dump\" target=_new>Save Docket as Word Document</a></td>\n";
	print "</tr></table>\n";
	
	showdocket();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdocket()
{
    local($db) = dbconnect();
    local ($sql) = "select eventid, eventname from events order by eventid;"; 
    local ($query2) = $db->prepare($sql);
    $query2->execute;
    local (@array);
    while (@array = $query2->fetchrow_array())
    {
        print "<H2>$array[1]</H2>\n";
	local ($sql) = "select * from $table where eventid=$array[0] order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Bill Name</b></td>\n";
	print "<td><b>Submittor</b></td>\n";
	print "<td><b>Link</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "<tr>\n";
	   print "<td>".$resptr->{"dname"}."</td>\n";
	   print "<td>".getCharPlayerStr($resptr->{"submittor"})."</td>\n";
	   print "<td><a href=\"".$resptr->{"url"}."\" target=_new>Click</a></td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield=".$resptr->{"$keyfield"}."\">Edit</a>\n";
	   print " -- <a href=\"javascript:deleteConfirm('".$resptr->{"$namefield"}."',".$resptr->{"$keyfield"}.");\">Delete</a>\n";
	   print " -- <a href=\"".$resptr->{"doc"}."\" target=_new>View Doc</a>\n";
	   print " -- <a href=\"$thispage?action=upload&$keyfield=".$resptr->{"$keyfield"}."\">Upload Doc</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
    }
    $query2->finish;
    $db->disconnect;
}

sub fillvars()
{
	filltable();
	
	$weight = $weight + 0;
	$eventid = $eventid + 0;
	$submittor = $submittor + 0;
	$eventselect = makeDropDown("events", "eventid", "eventname", "", "", "$eventid");
	$charselect = makeCharDropDown("submittor", $submittor);

	$subchar = getCharName($submittor);
	
	$weightofhistory = "Strongly in Favor";
	if ($weight < -60)
	{
	   $weightofhistory = "Strongly Against";
	}
	elsif ($weight < -15)
	{
	   $weightofhistory = "Generally Against";
	}
	elsif ($weight < 15)
	{
	   $weightofhistory = "Generally Neutral";
	}
	elsif ($weight < 60)
	{
	   $weightofhistory = "Generally in Favor";
	}

}

# ********************
# * makeCharDropDown *
# ********************
# * makeCharDropDown makes a drop down field from characters.
sub makeCharDropDown
{
local($selectname) = $_[0];
local($value) = $_[1];
local ($db) = dbconnect();
$SQL = "select a.charid, concat(b.pfirst, ' ', b.plast) from characters a, players b, playercharacters c where c.pccharid=a.charid and b.playerid=c.pcplayerid order by a.clast";
    
local($query) = $db->prepare($SQL);
$query->execute;

local ($retVal) = "";

#Check to make sure $query is not empty
    if ($query->rows > 0)
    {
        $retVal = "<select name=\"$selectname\">\n";
        local (@array);
        while (@array = $query->fetchrow_array)
        {
          if ("$array[0]" eq "$value")
          {
            $retVal .= "<option value=\"$array[0]\" SELECTED>".getCharName($array[0])." ($array[1])</option>\n";
          }
          else
          {
            $retVal .= "<option value=\"$array[0]\">".getCharName($array[0])." ($array[1])</option>\n";
          }
        }
        $retVal .= "</select>\n";
    }
$query->finish;
$db->disconnect;
return $retVal;
}