#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "editmenu.pl";
$table = "menuheader";
$heading = "Menu Heading";
$keyfield = "mhid";
$keyvalue = $CGI->param($keyfield);
$namefield = "name";
$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
$tplfile = "editmenu.tpl";
$errstr = $CGI->param("error");

if ($al < $developer_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	if ($keyvalue eq "")
	{
		$doctitle = "Add $heading";
	}
	else
	{
        	$doctitle = "Edit $namevalue";
	}
	ParseForm($header);
     	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";

	fillvars();
	ParseForm($tplfile);
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Deleted"));
}
elsif ($action eq "newItem" || $action eq "editItem")
{
	$table = "menuitem";
	$heading = "Menu Item";
	$keyfield = "mid";
	$keyvalue = $CGI->param($keyfield);
	$namefield = "name";
	$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
	$tplfile = "edititem.tpl";
	print $CGI->header();
	if ($keyvalue eq "")
	{
		$doctitle = "Add $heading";
	}
	else
	{
        	$doctitle = "Edit $namevalue";
	}
	ParseForm($header);
     	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";

	fillvars();
	ParseForm($tplfile);
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add Item\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change Item\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add Item")
{
	# Insert and Redirect
	$table = "menuitem";
	$heading = "Menu Item";
	$keyfield = "mid";
	$keyvalue = $CGI->param($keyfield);
	$namefield = "name";
	$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change Item")
{
	#print $CGI->header();
	# Update and Redirect
	$table = "menuitem";
	$heading = "Menu Item";
	$keyfield = "mid";
	$keyvalue = $CGI->param($keyfield);
	$namefield = "name";
	$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Updated"));
}
elsif ($action eq "deleteItem")
{
	# delete and Redirect
	#print "$SQL<BR>";
	$table = "menuitem";
	$heading = "Menu Item";
	$keyfield = "mid";
	$keyvalue = $CGI->param($keyfield);
	$namefield = "name";
	$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
	local($db) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Deleted"));
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s";
	ParseForm($header);
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle</h1>\n";

	print "<b><a href=\"$thispage?action=new\">ADD a NEW $heading</a></b><BR>\n";
	print "<a href=\"$thispage?action=newItem\">ADD a NEW Menu Item</a><BR><BR>\n";
	
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Eval</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	showdata(1,0);
	showdata(0,0);
	print "</table>\n";

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "function deleteConfirmItem(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=deleteItem&mid=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local $curparent = $_[0];
	local $recurlevel = $_[1];
	local($db) = dbconnect();
	local ($sql) = "select * from $table where parent = $curparent order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $key = $resptr->{"$keyfield"};
	   print "<tr>\n";
	   print "<td>";
	   for ($i = 0; $i < $recurlevel; $i++)
	   {
	      print "&nbsp;-&nbsp;";
	   }
	   print "$name</td>\n";
	   print "<td>".$resptr->{"varexpr"}."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('$name',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	   showitems($key);
	   showdata($key,$recurlevel+1);
	}
	$query->finish;
	$db->disconnect;
}

sub showitems()
{
	local $curparent = $_[0];
	local($db) = dbconnect();
	local ($sql) = "select * from menuitem where parent = $curparent order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
   	local $resptr;
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   local ($name) = $resptr->{"$namefield"};
	   local ($key) = $resptr->{"mid"};
	   print "<tr>\n";
	   print "<td><li>$name</li></td>\n";
	   print "<td>".$resptr->{"varexpr"}."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=editItem&mid=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirmItem('$name',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	filltable();

	if ("$varexpr" eq "")
	{
	   $varexpr = "true";
	}
	
	$parentselect = makeDropDown("menuheader", "mhid", "name", "", "", $parent);
	$parentselect =~ s/mhid/parent/;
}

