#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "freebies.pl";
$table = "substatus_freebies";
$heading = "Substatus Freebie";
$keyfield = "sfid";
$keyvalue = $CGI->param($keyfield);
$namefield = "name";
$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
$tplfile = "freebies.tpl";
$errstr = $CGI->param("error");


if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $namevalue</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">";
	if ($tplfile eq "")
	{
		local($dbvar) = dbconnect();
		local($query) = $dbvar->prepare("explain $table");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $dbvar->prepare("select * from $table where $keyfield = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$dbvar->disconnect;
		print "</table>";
	}
	else
	{
	     fillvars();
	     ParseForm($tplfile);
	}
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Deleted"));
}
elsif ($action eq "chars")
{
	print $CGI->header();
	$doctitle = "Give Characters Access to $namevalue";
	ParseForm($header);
        fillvars();
        print "<H1>$doctitle</H1>\n";
	print "<table border = 1 width=100%>\n";
	print "<tr>\n";
	print "<td><b>Character Name</b></td>\n";
	print "<td><b>Type</b></td>\n";
	print "<td><b>Access?</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	local($db) = dbconnect();
	local($query) = $db->prepare("select a.charid, b.ctypedesc from characters a, chartypes b where a.chartype=b.ctypeid order by a.chartype, a.clast");
	$query->execute;
	local (@array);
	while (@array = $query->fetchrow_array)
	{
	  print "<tr>\n";
	  local ($charid) = $array[0];
	  print "<td width=60%>".getCharPlayerStr($charid)."</td>\n";
	  print "<td>$array[1]</td>\n";
	  $sql = "select count(charid) from charactersubfree where $keyfield=$keyvalue and charid=$charid";
	  #print "$sql<BR>";
	  $hasacces = dosql($sql) + 0;
	  if ($hasacces > 0)
	  {
		print "<td><b>Yes</b></td>\n";
		print "<td><a href=\"$thispage?action=remaccess&charid=$charid&$keyfield=$keyvalue\">Remove Access</a></td>\n";
		print "</tr>\n";
	  }
	  else
	  {
		print "<td>No</td>\n";
		print "<td><a href=\"$thispage?action=addaccess&charid=$charid&$keyfield=$keyvalue\">Give Access</a></td>\n";
		print "</tr>\n";
	  }
	}
	$query->finish;
	print "</table>\n";
	print "<a href=\"$thispage\">Return to Substatus Freebies</a>\n";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "addaccess")
{
	# add and Redirect
	local ($charid) = $CGI->param("charid");
	$SQL = "insert into charactersubfree (charid,$keyfield) values ($charid, $keyvalue);";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?action=chars&$keyfield=$keyvalue");
}
elsif ($action eq "remaccess")
{
	# Remove and Redirect
	local ($charid) = $CGI->param("charid");
	$SQL = "delete from charactersubfree where charid=$charid and $keyfield=$keyvalue;";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?action=chars&$keyfield=$keyvalue");
}
elsif ($action eq "handle")
{
	# Remove and Redirect
	local ($csspid) = $CGI->param("csspid");
	$SQL = "update charactersubstatpoints set handled=1 where csspid=$csspid;";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Handled"));
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s";
	ParseForm($header);
	
	print "<table border = 0 width=100%><tr>\n";
	print "<td width=120><img align=left border=0 width=118 height=144 src=\"doclib/Clip Art/squidhat.jpg\">";
	
	print "</td><td><font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle</h1>\n";

	print "<a href=\"$thispage?action=new\">ADD a NEW $heading</a><BR>\n";
	print "<a href=\"$thispage#Handle2\">Handle Character Substatus Freebies</a><BR>\n";
	
	print "</td></tr></table><BR>\n";
	
	showdata();

	print "<A NAME=\"Handle2\"></A>\n";	
	print "<H1>Handle Character Substatus Freebies</h1>\n";
	showcharfreebies();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table order by minstatus, maxstatus, $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Description</b></td>\n";
	print "<td><b>Minimum Status</b></td>\n";
	print "<td><b>Maximum Status</b></td>\n";
	print "<td><b>Cost</b></td>\n";
	print "<td><b>Private</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $key = $resptr->{"$keyfield"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>".$resptr->{"description"}."</td>\n";
	   print "<td>".$resptr->{"minstatus"}."</td>\n";
	   print "<td>".$resptr->{"maxstatus"}."</td>\n";
	   print "<td>".$resptr->{"cost"}."</td>\n";
	   print "<td>".$yesno[$resptr->{"private"}]."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield=$key\">Edit</a>\n";
	   if ($resptr->{"private"} > 0)
	   {
	      print " -- <a href=\"$thispage?action=chars&$keyfield=$key\">Manage Characters</a>\n";
	   }
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('$name',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub showcharfreebies()
{
	local($db) = dbconnect();
	local ($sql) = "select * from charactersubstatpoints a, substatus_freebies b where a.points < 0 and a.notes=b.name order by handled, charid;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Character</b></td>\n";
	print "<td><b>Freebie</b></td>\n";
	print "<td><b>Description</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $handled = $resptr->{"handled"};
	   $charid = $resptr->{"charid"};
	   $charname = getCharPlayerStr($charid);
	   $key = $resptr->{"csspid"};
	   $descr = $resptr->{"description"};
	   if ($handled == 0)
	   {
	   	print "<tr bgcolor=#FFFFFF>\n";
	   }
	   else
	   {
	   	print "<tr bgcolor=#EEEEEE>\n";
	   }
	   print "<td>$charname</td>\n";
	   print "<td>".$resptr->{"notes"}."</td>\n";
	   print "<td>$descr</td>\n";
	   print "<td>";
	   if ($handled == 0)
	   {
	      print "<a href=\"$thispage?action=handle&csspid=$key&$keyfield=".$resptr->{"$keyfield"}."\">Mark as Handled</a>\n";
	   }
	   else
	   {
	   	print "Handled\n";
	   }
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}


sub fillvars()
{
	filltable();
}

