#!/usr/bin/perl

require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "freespend.pl";
$table = "substatus_freebies";
$heading = "Substatus Freebie";
$keyfield = "sfid";
$keyvalue = $CGI->param($keyfield);
$namefield = "name";
$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
$tplfile = "freebies.tpl";
$errstr = $CGI->param("error");
$charid = $CGI->param("charid");

$sql = "select sum(points) from charactersubstatpoints where charid=$charid;";
$points = dosql($sql) + 0;


if ($pid != getPIDFromCharID($charid) && $al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to spend SubStatus Freebie Points for that character!"));
}
elsif ($action eq "buy")
{
   filltable();
   if ($cost > $points)
   {
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("You do not have enough points to buy ".$namevalue));	
	exit(0);
   }
   
   buyfreebie();
   
   print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("Purchased ".$namevalue));	
   
}
else
{
	print $CGI->header;
	$doctitle = "Buy ".$heading."s";
	ParseForm($header);
	
	print "<table border = 0 width=100%><tr>\n";
	print "<td width=120><img align=left border=0 width=118 height=144 src=\"doclib/Clip Art/squidhat.jpg\">";
	
	print "</td><td><font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle</h1>\n";

	print "You have $points points available to spend<BR><BR>\n";
	
	print "<i>Note:  SubStatus Freebies processing is done manually by the GMs.  Feel free to drop us an e-mail when you spend your points.  We'll send you an e-mail when we've processed them.</i><BR><BR>\n";

	print "</td></tr></table><BR>\n";
	
	setSTATvars($charid);
	
	showdata();
	
	print "<BR>Do you have an in-character goal that you feel would be appropriate to purchase with your SubStatus Freebie Points?   <a href=\"mailto:$contact\">Mail the GMs</a>.<BR><BR>\n";

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
		
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Description</b></td>\n";
	print "<td><b>Cost</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";

	local($db) = dbconnect();

	local ($sql) = "select * from $table a, charactersubfree b where a.sfid=b.sfid and b.charid=$charid order by a.cost,  $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $key = $resptr->{"$keyfield"};
	   print "<tr bgcolor=\"#EEEEEE\">\n";
	   print "<td>$name</td>\n";
	   print "<td>".$resptr->{"description"}."</td>\n";
	   print "<td>".$resptr->{"cost"}."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=buy&$keyfield=$key&charid=$charid\">Buy</a>\n";
	   print "</td></tr>\n";
	}
	$query->finish;

	$sql = "select * from $table where private = 0 and $status >= minstatus and $status <= maxstatus order by cost,  $namefield;";
	#print "$sql<BR>";  
	$query = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $key = $resptr->{"$keyfield"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>".$resptr->{"description"}."</td>\n";
	   print "<td>".$resptr->{"cost"}."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=buy&$keyfield=$key&charid=$charid\">Buy</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	filltable();
}


sub buyfreebie()
{
   $handled = 0;
   if ($sfid == 1) #buy a point of XP
   {
      updateXP($charid,1,"SubStatus Freebie");
      $handled = 1;
   }
   elsif ($sfid == 4) #buy a point High Society Influence
   {
      $sql = " insert into characterabilities (charid, abid, level, text, difficulty, cost) values ($charid,30,1,'From SubStatus Freebie','Easy',1);";
   }
   else #email a notification to the GMs.
   {
   }

   $name =~ s/'/''/g;
   $thedate = getDBDate();
   $sql = "insert into charactersubstatpoints (charid, points, entrydate, notes, handled) values ($charid, -$cost, '$thedate', '$name', $handled);";
   dosql($sql);
}

