#!perl

#Globals for gmnotes
$gmnotestatus[0] = "Suggested";
$gmnotestatus[1] = "Approved";
$gmnotestatus[2] = "Important";

$gmn_suggested = 0;
$gmn_approved = 1;
$gmn_important = 2;
$gmn_numstatus = 3;

$gmnopen[0] = "<i>";
$gmnopen[1] = "";
$gmnopen[2] = "<font color=#DD0000>";
$gmnclose[0] = "</i>";
$gmnclose[1] = "";
$gmnclose[2] = "</font>";

$gmnoteheadercolor[0] = "#FFFFEE";
$gmnoteheadercolor[1] = "#EEEEEE";
$gmnoteheadercolor[2] = "#FFEEEE";

sub shownotefromid()
{
	local ($gmnid) = $_[0];	   
	local($retStr) = "";
	local ($resptr);
	local($db) = dbconnect();
	local($sql) = "select * from gmnotes where gmnid=$gmnid;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	  $retStr .=  shownote($resptr, "Transparent");
	}
	
	$query->finish;
	$db->disconnect;
	return ($retStr);
}


sub shownote()
{
	   local ($resptr) = $_[0];	   
	   local ($bgcolor) = "white";	   
	   local($name) = $resptr->{"summary"};
	   local($key) = $resptr->{"gmnid"};
	   local($status) = $resptr->{"status"};
	   local ($hdcolor) = $gmnoteheadercolor[$status];
	   local @toggler = ("[-]","[+]");
	   local @inline = ("inline","none");
	   local($retVal) = "";
	   $retVal .=  "<table width=100% border=0 cellspacing=0 style=\"border: thin solid Black;\">\n";
	   $retVal .=  "<tr>\n";
	   $retVal .=  "<td style=\"font-weight: bold; background-color: $hdcolor;\">";
	   $retVal .= "<input type=hidden id=\"show_$key\" value=\"".$summarize."\">";
	   $retVal .= "<a href=\"javascript:toggleGMNote('$key')\" id=\"toggle_$key\">$toggler[$summarize]</a> ";
	   $retVal .=  "$gmnopen[$status]".myFormatDate($resptr->{"entrydate"});
	   $retVal .=  "&nbsp;&nbsp;".$gmnotestatus[$status]."$gmnclose[$status]</td>\n";
	   $retVal .=  "<td style=\"font-weight: bold; background-color: $hdcolor;\" align=right>";
	   $retVal .=  "$gmnopen[$status]".getFullNameFromID($resptr->{"playerid"})."$gmnclose[$status]</td>\n";
	   $retVal .=  "</tr>\n";
	   $retVal .=  "<tr>\n";
	   $retVal .=  "<td style=\"border-bottom: thin dashed Black; font-weight: bold; background-color: $hdcolor;\">$gmnopen[$status]$name$gmnclose[$status]</td>\n";
	   $retVal .=  "<td colspan=2 align=right style=\"border-bottom: thin dashed Black; background-color: $hdcolor;\">$gmnopen[$status]\n";
	   if ($al >= $gmnotelevel)
	   {
		   if ($status == $gmn_suggested)
		   {
			$retVal .=  "<a href=\"gmnotes.pl?action=approve&gmnid=$key&linkid=$linkid&linktable=$linktable\">Approve</a> -- \n";
		   }
		   $retVal .=  "<a href=\"gmnotes.pl?action=edit&gmnid=$key&linkid=$linkid&linktable=$linktable\">Edit</a>\n";
		   $name =~ s/'//g;
		   $retVal .=  " -- <a href=\"javascript:deleteGMNConfirm('$name',$key);\">Delete</a>\n";
	   }
	   $retVal .=  "$gmnclose[$status]</td>\n";
	   $retVal .=  "</tr><tr>\n";
	   $retVal .=  "<td colspan=2 style=\"border-bottom: thin dashed Black; background-color: $bgcolor;\">";
	   $retVal .=  "<div id=\"gmnote_$key\" style=\"display: $inline[$summarize];\">\n";
	   $notes = $resptr->{"notes"};
	   $notes =~ s/\n/<BR>\n/g;
	   $retVal .=  "$gmnopen[$status]$notes$gmnclose[$status]\n";
	   $retVal .=  "</div>\n";
	   $retVal .=  "</td></tr>\n";
	   $retVal .= showlinks($key,$bgcolor);
	   $retVal .=  "</table>\n";
	   
	   return $retVal;
}

sub showlinks()
{
	local ($keyID) = $_[0];
	local ($bgcolor) = $_[1];	   
	local($db) = dbconnect();
	local ($sql) = "select * from gmlinktables order by tablename;";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local ($resptr);
	local($retVal) = "";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $sql = "select * from linknotes where gmnid=$keyID and linktable='".$resptr->{"linktable"}."';";
	   #print "$sql<BR>\n";
	   local ($query2) = $db->prepare($sql);
	   $query2->execute;
	   if ($query2->rows > 0)
	   {
	   	   $retVal .=   "<tr>\n";
	           $retVal .=   "<td colspan=2 style=\"border-bottom: thin dashed Black; font-style: italic; background-color: $bgcolor;\">$gmnopen[$status]\n";
	           $retVal .=   "<b>".$resptr->{"tablename"}.":</b> ";
		   local ($resptr2);
		   while ($resptr2 = $query2->fetchrow_hashref())
		   {
		      $sql = "select ".$resptr->{"linknamefield"}." from ".$resptr->{"linktable"}." where ".$resptr->{"linkfield"}." = '".$resptr2->{"linkid"}."';";
	   	      #print "$sql<BR>\n";
	   	      $name = dosql($sql);
	   	      if ($al >= $gmnotelevel)
	   	      {
		      	   $retVal .=   "<a href=\"".$resptr->{"editpage"}.$resptr2->{"linkid"}."\" target=_new>$name</a>; ";
		      }
		      else
	   	      {
		      	   $retVal .=   "$name; ";
		      }
		   }	
	   	   $retVal .=   "$gmnclose[$status]</td></tr>\n";
	   }
	   $query2->finish;
	}
	$query->finish;
	$db->disconnect;
	
	return ($retVal);
}

sub showGMNconfirm()
{
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteGMNConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"gmnotes.pl?action=delete&linkid=$linkid&linktable=$linktable&gmnid=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	
	print "function toggleGMNote(id)\n";
	print "{\n";
	print "	   var show = document.getElementById('show_' + id);\n";
	print "	   var toggle = document.getElementById('toggle_' + id);\n";
	print "	   show.value = 1 - show.value;\n";
	print "	   var element = document.getElementById('gmnote_' + id);\n";
	print "	   if (show.value == 0)\n";
	print "    {\n";
	print "		element.style[\"display\"] = \"inline\";\n";
	print "	 	toggle.innerHTML=\"[-]\";\n";
	print "    }\n";
	print "	   else\n";
	print "    {\n";
	print "		element.style[\"display\"] = \"none\";\n";
	print "	 	toggle.innerHTML=\"[+]\";\n";
	print "    }\n";
	print "}\n";

	print "</script>\n";

}

# ***************
# * Return True *
# ***************
# * A Perl Library must always return a true value,
# * or it doesn't compile in the require statement.
1;b