#!/usr/bin/perl

require 'gmnote_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "gmnotes.pl";
$table = "gmnotes";
$heading = "GM Note";
$keyfield = "gmnid";
$keyvalue = $CGI->param($keyfield);
$namefield = "summary";
$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
$tplfile = "gmnotes.tpl";
$errstr = $CGI->param("error");

$linkid = $CGI->param("linkid") + 0;
$linktable = $CGI->param("linktable");

$hidebox = $CGI->param("hidebox") + 0;
$sortby = $CGI->param("sortby") + 0;
$summarize = $CGI->param("summarize") + 0;

$sortbydate = 0;
$sortbyevent = 1;
$sortbyeventreversed = 2;
$numsorts = 3;

$showallnotes = 0;
$showapprovednotes = 1;
$showpendingnotes = 2;
$showchargroupsnotes = 3;
$showrecentnotes = 4;
$numnotetypes = 5;

$ctntot = 0;
for ($i = 0; $i < $numnotetypes; $i++)
{
   $charchecked[$i] = $CGI->param("chartype_$i") + 0;
   if ($i != $showrecentnotes)
   {
   	$ctntot += $charchecked[$i];
   }
}
if ($ctntot == 0)
{
   $charchecked[$showallnotes] = 1;
}


if ($linktable eq "characters")
{
    $linkname = getCharName($linkid);
}

if ($linktable eq "plots")
{
    $linkname = dosql("select plname from plots where plotid=$linkid;");
}

$sql = "select defstring from pagedefaults where playerid=$pid and pageid='gmnotes.pl';";
$defstr = dosql($sql);
if ("$defstr" eq "0")
{
	$defstr = "$thispage?linktable=$linktable&linkid=$linkid"
}
else
{
	$defstr = "$thispage".$defstr."&linktable=$linktable&linkid=$linkid"
}

if ($al < $gmnotelevel)
{
	print $CGI->redirect("main.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq 'makedef')
{

   #print $CGI->header();
   $myline = makeline();
   local($db) = dbconnect();
   $db->do("delete from pagedefaults where playerid=$pid and pageid='$thispage';");
   $db->do("insert into pagedefaults (playerid, pageid, defstring) values($pid,'$thispage','$myline');");
   $db->disconnect;
   print $CGI->redirect("$thispage".$myline."&linkid=$linkid&linktable=$linktable");
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	if ($keyvalue eq "")
	{
		$doctitle = "Add $heading";
	}
	else
	{
		$doctitle = "Edit $namevalue";
	}
	ParseForm($header);
     	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";

	fillvars();
	ParseForm($tplfile);
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"hidden\" name=\"linkid\" value=\"$linkid\">\n";
	print "<input type=\"hidden\" name=\"linktable\" value=\"$linktable\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$defstr\">Return/Cancel</a>.";
	if ($linktable eq "plots")
	{
	   print "<br><a href=\"plots.pl?submit=Update&plotid=$linkid\">Return to $linkname</a>.";
	}
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	#print $CGI->header();
	$sql = filltablefromCGI($table, 1);
	#print "$sql<BR>";
	local($db) = dbconnect();
	local ($query) = $db->prepare($sql);
	$query->execute;
	$keyvalue = $db->{'mysql_insertid'};
	#print "$keyvalue<BR>\n";
	$query->finish;
	$db->disconnect;
        updatelinks();
	print $CGI->redirect("$defstr&error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($db) = dbconnect();
	$db->do($SQL);
	$db->disconnect;
        updatelinks();
	print $CGI->redirect("$defstr&error=" . encodeURL("$namevalue Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print $CGI->header();
	local($db) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	#print "$SQL<BR>";
	$db->do($SQL);
	local ($sql) = "delete from linknotes where $keyfield=$keyvalue;";
        $db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$defstr&error=" . encodeURL("$namevalue Deleted"));
}
elsif ($action eq "approve")
{
	# delete and Redirect
	#print $CGI->header();
	local($db) = dbconnect();
	$sql = "update $table set status=$gmn_approved where $keyfield = $keyvalue;";
	#print "$sql<BR>";
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$defstr&error=" . encodeURL("$namevalue Approved"));
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s";
	if ($linktable eq "characters")
	{
	  $doctitle .= " for $linkname";
	  $line = dosql("select defstring from pagedefaults where playerid=$pid and pageid='gmchars.pl';");
	}
	if ($linktable eq "plots")
	{
	  $doctitle .= " for $linkname";
	}
	ParseForm($header);
	
	showGMNconfirm();
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle </h1>\n";

	print "<a href=\"$thispage?action=new&linkid=$linkid&linktable=$linktable\">ADD a NEW $heading</a><BR><BR>\n";
	
	if ("$hidebox" eq "1")
	{
	   local ($str) = "$thispage".makeline()."&linkid=$linkid&linktable=$linktable";
	   $str =~ s/hidebox=1/hidebox=0/;

	   print "<a href=\"$str\">Show Control Panel</a><BR>\n";
	}
	else
	{
	   showcontrolpanel();
	   print "<br><br>\n"; 
	}

	showdata();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	if ($linktable eq "characters")
	{
	    print "<br><a href=\"gmchars.pl$line#$linkid\">Return to $linkname</a>."; 
	}	
	if ($linktable eq "plots")
	{
	    print "<br><a href=\"plots.pl?action=edit&plotid=$linkid\">Return to $linkname</a>."; 
	}	
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
   if ($sortby == $sortbyevent || $sortby == $sortbyeventreversed)
   {
	showdataevent($sortby - 1);
   }
   else
   {
	local($db) = dbconnect();
	
	if ($charchecked[$showrecentnotes])
	{
	   $wherestr = "DATE_SUB(CURDATE(),INTERVAL 7 DAY) <= a.entrydate";
	}
	else
	{
	   $wherestr = "5=5";
	}
		
	if ("$linktable" ne "")
	{
		$sql = "select * from $table a join linknotes b on a.$keyfield = b.$keyfield where b.linktable='$linktable' and b.linkid=$linkid and $wherestr order by a.entrydate desc, a.gmnid desc;";
	}
	else
	{
		$sql = "select * from $table a where $wherestr order by a.entrydate desc, a.gmnid desc;";
	}
	#print "$sql<BR>";  
    	local (@gmnids);
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	        local($status) = $resptr->{"status"};
	        if ($gmnid[$resptr->{"gmnid"}] == 0 && ($charchecked[$showallnotes] || ($charchecked[$showapprovednotes] && $status == $gmn_approved) || ($charchecked[$showpendingnotes] && $status == $gmn_suggested) || $status == $gmn_important))
	        {
	         	print shownote($resptr, "Transparent");
	         	$gmnid[$resptr->{"gmnid"}] = 1;
	        }
	}
	
	$query->finish;
	if ($linktable eq "characters" && ($charchecked[$showallnotes] || $charchecked[$showchargroupsnotes]))
	{
		$sql = "select * from $table a join linknotes b on a.$keyfield = b.$keyfield where b.linktable='charactergroups' order by a.entrydate;";
		#print "$sql<BR>";  
		$query = $db->prepare($sql);
		$query->execute;
		while ($resptr = $query->fetchrow_hashref())
		{
		   local($groupid) = $resptr->{"linkid"};
		   $sql = "select count(charid) from charactergroupmembers where groupid=$groupid and charid=$linkid;";
		   #print "$sql<BR>"; 
		   local($ismember) = dosql($sql) + 0;
		   $sql = "select count(linkid) from linknotes where gmnid=".$resptr->{"gmnid"}." and linktable='characters' and linkid=$linkid;";
		   local($includechar) = dosql($sql) + 0;
		   if ($ismember > 0 && $includechar == 0 && $gmnid[$resptr->{"gmnid"}] == 0)
		   {
			local($status) = $resptr->{"status"};
			if ($charchecked[$showallnotes] || ($charchecked[$showapprovednotes] && $status == $gmn_approved) || ($charchecked[$showpendingnotes] && $status == $gmn_suggested) || $status == $gmn_important)
			{
				$resptr->{"summary"} .= " -- From Character Group";
				print shownote($resptr, "Transparent");
				$gmnid[$resptr->{"gmnid"}] = 1;
			}
		   }
		}
		$query->finish;
	}
	$db->disconnect;
   }
}

sub showdataevent()
{
    local ($reversed) = $_[0];
    local($db) = dbconnect();
    
    $revstr[0] = "";
    $revstr[1] = "DESC";
    
    $sql = "select eventid, eventname from events where eventid >= $current_episode order by eventstart $revstr[$reversed];"; 
    local ($query1) = $db->prepare($sql);
    $query1->execute;
    local (@array);
    while (@array = $query1->fetchrow_array)
    {   	
	showdataevent2($array[0],$array[1]);
    }
    $query1->finish;
	
    showdataevent2(0,'No Event');
    $db->disconnect;
}

sub showdataevent2()
{   	
	local ($myeventid) = $_[0];
	local ($myeventname) = $_[1];
	
	local (@gmnids);
   	@gmnids = ();

	print "<H2>$myeventname</H2>\n";
	
	if ("$linktable" ne "")
	{
	    if ($myeventid == 0)
	    {
		$sql = "select * from $table a, linknotes b where a.$keyfield = b.$keyfield and b.linktable='$linktable' and b.linkid=$linkid order by a.entrydate $revstr[$reversed];";
	    }
	    else
	    {
		$sql = "select * from $table a, linknotes b, linknotes c where a.$keyfield = b.$keyfield and b.linktable='$linktable' and b.linkid=$linkid and a.$keyfield=c.$keyfield and c.linktable='events' and c.linkid=$myeventid order by a.entrydate $revstr[$reversed];";
	    }
	}
	else
	{
		$sql = "select * from $table a join linknotes b on a.$keyfield = b.$keyfield where b.linktable='events' and b.linkid=$myeventid order by a.entrydate $revstr[$reversed];";
	}
	#print "sql1 -- $sql<BR>\n";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	  $key = $resptr->{"$keyfield"};
	  if ($myeventid == 0)
	  {
	     $sql = "select count(a.$keyfield) from $table a join linknotes b on a.$keyfield = b.$keyfield where a.$keyfield=$key and b.linktable='events';";
	     #print "sql2 -- $sql<BR>\n";  
	     $numevents = dosql($sql) + 0;
	     if ($numevents == 0)
	     {
	        local($status) = $resptr->{"status"};
	        if ($gmnid[$resptr->{"gmnid"}] == 0 && ($charchecked[$showallnotes] || ($charchecked[$showapprovednotes] && $status == $gmn_approved) || ($charchecked[$showpendingnotes] && $status == $gmn_suggested) || $status == $gmn_important))
	        {
	        	$gmnid[$resptr->{"gmnid"}] = 1;
	         	print shownote($resptr, "Transparent");
	        }
	     }
	  }
	  else
	  {
	     local($status) = $resptr->{"status"};
	     if ($gmnid[$resptr->{"gmnid"}] == 0 && ($charchecked[$showallnotes] || ($charchecked[$showapprovednotes] && $status == $gmn_approved) || ($charchecked[$showpendingnotes] && $status == $gmn_suggested) || $status == $gmn_important))
	     {
	        	$gmnid[$resptr->{"gmnid"}] = 1;
	         	print shownote($resptr, "Transparent");
	     }
	  }
	}
	
	$query->finish;
	if ($linktable eq "characters" && ($charchecked[$showallnotes] || $charchecked[$showchargroupsnotes]))
	{
		$sql = "select a.groupid from charactergroups a join charactergroupmembers b on a.groupid=b.groupid where b.charid=$linkid;";
		#print "$sql<BR>\n";  
		local($query) = $db->prepare($sql);
		$query->execute;
		local (@groupid);
		while (@groupid = $query->fetchrow_array)
		{
			$sql = "select a.* from gmnotes a join linknotes b on a.$keyfield = b.$keyfield where b.linktable='charactergroups' and b.linkid=$groupid[0] order by a.entrydate $revstr[$reversed];";
			#print "$sql<BR>\n";  
			local($query2) = $db->prepare($sql);
			$query2->execute;
			while ($resptr = $query2->fetchrow_hashref())
			{
		   	   local($gmnid) = $resptr->{"gmnid"};
			   if ($myeventid == 0)
			   {
			   	$sql = "select a.gmnid from gmnotes a join linknotes b on a.$keyfield = b.$keyfield where b.linktable='events' and a.$keyfield=$gmnid;";
			   }
			   else
			   {
			   	$sql = "select a.gmnid from gmnotes a join linknotes b on a.$keyfield = b.$keyfield where b.linktable='events' and b.linkid=$myeventid and a.$keyfield=$gmnid;";
			   }
			   #print "$sql<BR>\n";  
			   local($shownote) = dosql($sql) + 0;
			   if (($shownote > 0 && $myeventid > 0) || ($shownote == 0 && $myeventid == 0))
			   {
				local($status) = $resptr->{"status"};
				if ($gmnid[$resptr->{"gmnid"}] == 0 && ($charchecked[$showallnotes] || ($charchecked[$showapprovednotes] && $status == $gmn_approved) || ($charchecked[$showpendingnotes] && $status == $gmn_suggested) || $status == $gmn_important))
				{
					$resptr->{"summary"} .= " -- From Character Group";
					print shownote($resptr, "Transparent");
					$gmnid[$resptr->{"gmnid"}] = 1;
				}
			   }

			}
		}

	}

}

sub fillvars()
{
	filltable();
	$entrydate = getDBDate();
        $playerid = $pid;
        $playername = getFullNameFromID($playerid);

	$statusdrop = makeArrayDropDown(\@gmnotestatus,"status",[$gmnotestatus[$status]],"",1);

	$boxen = "";
	local($db) = dbconnect();
	local ($sql) = "select * from gmlinktables order by tablename;";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local ($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	  local(@selected) = getlinks($resptr->{"linktable"});
	  $boxen .= "<b>Link to ".$resptr->{"tablename"}.":</b><BR>\n";
	  $boxen .= makeMultipleBox($resptr->{"linktable"},$resptr->{"linkfield"},$resptr->{"linknamefield"},$resptr->{"wherefield"},@selected);
	  $boxen .= "<BR><BR>\n";
	}
	$query->finish;
	$db->disconnect;
}

sub getlinks()
{
	local ($tableID) = $_[0];
	local(@retVal);
	local($db) = dbconnect();
	local ($sql) = "select linkid from linknotes where $keyfield=$keyvalue and linktable='$tableID';";
	#print "$sql<BR>\n";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local(@array);
	local($i) = 0;
	while (@array = $query->fetchrow_array())
	{
	   $retVal[$i] = $array[0];
	   $i++;
	}
	$query->finish;
	$db->disconnect;
	if ("$tableID" eq "$linktable")
	{
	   $retVal[$i] = $linkid;
	   $i++;
	}
	return @retVal;
}

sub updatelinks()
{
	local($db) = dbconnect();
	local ($sql) = "delete from linknotes where $keyfield=$keyvalue;";
	$db->do($sql);
	
	local ($sql) = "select * from gmlinktables order by tablename;";
	local ($query) = $db->prepare($sql);
	local ($resptr);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   local(@array) = $CGI->param($resptr->{"linkfield"});
	   $size = @array;
	   #print $resptr->{"linktable"} . " -- size ($size) [@array]<BR>\n";
	   for ($k=0;$k<$size;$k++)
	   {
		$sql = "insert into linknotes (gmnid, linktable, linkid) values ($keyvalue, '".$resptr->{"linktable"}."', $array[$k]);";
		#print "$sql<BR>\n";
		$db->do($sql);
	   } 
	}
	$query->finish;
	$db->disconnect;
}

sub showcontrolpanel()
{
	for ($i = 0; $i < $numsorts; $i++)
	{
	  $sortchecked[$i] = "";
	}
	$sortchecked[$sortby] = "checked";

	$ctn = 0;

	print "<form action=\"$thispage\" method=\"post\">";
	print "<table border=0  cellspacing=0 cellpadding=1 align=center bgcolor=#eeeeee width=100%>\n";
	print "<tr><td><b>Control Panel</b></td></tr>\n";
	
	print "<tr>";
	print "<td style=\"font-size : xx-small;\" valign=middle><input type=radio name=sortby value=0 $sortchecked[0]>Sort By Entry Date Reversed</input></td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=checkbox name=chartype_0 value=\"1\" $ischecked[$charchecked[0]]>Show All Notes</input></td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=checkbox name=summarize value=\"1\" $ischecked[$summarize]><i>Summarize Notes</i></input></td>\n";
	$ctn++;
	print "</tr>";
	
	print "<tr>";
	print "<td style=\"font-size : xx-small;\" valign=middle><input type=radio name=sortby value=1 $sortchecked[1]>Sort By Event</input></td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=checkbox name=chartype_$ctn value=\"1\" $ischecked[$charchecked[$ctn]]>Show Approved Notes</input></td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=checkbox name=hidebox value=1><i>Hide Control Panel</i></input></td>\n";
	$ctn++;
	print "</tr>";
	
	print "<tr>";
	print "<td style=\"font-size : xx-small;\" valign=middle><input type=radio name=sortby value=2 $sortchecked[2]>Sort By Event Reversed</input></td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=checkbox name=chartype_$ctn value=\"1\" $ischecked[$charchecked[$ctn]]>Show Suggested Notes</input></td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=checkbox name=\"action\" value=\"makedef\"><i>Make Default</i></input></td>\n";
	$ctn++;
	print "</tr>";
	
	print "<tr>";
	print "<td style=\"font-size : xx-small;\" valign=middle></td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=checkbox name=chartype_$ctn value=\"1\" $ischecked[$charchecked[$ctn]]>Show Notes From Associated Character Groups</input></td>\n";
	$ctn++;
	print "</tr>";
			
	print "<tr>";
	print "<td style=\"font-size : xx-small;\"><i><input type=checkbox name=chartype_$ctn value=\"1\" $ischecked[$charchecked[$ctn]]>Show Only Notes From the Past Week</input></i></td>\n";
	print "<td style=\"font-size : xx-small;\" valign=middle></td>\n";
	$ctn++;
	print "<td style=\"font-size : xx-small;\"><input type=\"submit\" name=\"submit\" value=\"Submit\"></td>\n";
	print "</tr>";
			
	print "</table>\n";
	print "<input type=hidden name=linkid value=\"$linkid\"><input type=hidden name=linktable value=\"$linktable\"></form><BR>\n";
}

sub makeline()
{
	local($retVal) =  "?sortby=$sortby";
	$retVal .= "&hidebox=$hidebox";
	$retVal .= "&summarize=$summarize";
	for ($i = 0; $i < $numnotetypes; $i++)
	{
	   $retVal .= "&chartype_$i=$charchecked[$i]";
	}
	return $retVal;
}
