#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "inventory.pl";
$table = "inventory";
$heading = "Inventory Item";
$keyfield = "iid";
$keyvalue = $CGI->param($keyfield);
$namefield = "name";
$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
$tplfile = "inventory.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $namevalue</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">\n";
	fillvars();
	ParseForm($tplfile);
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"hidden\" name=\"action\" value=\"Add\">\n";
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"hidden\" name=\"action\" value=\"Change\">\n";
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "Add")
{
	# Insert and Redirect
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($action eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Deleted"));
}
elsif ($action eq "newspell" || $action eq "editspell")
{
	print $CGI->header();
	ParseForm($header);
	$keyfield = "iscid";
	$table = "inventory_sc";
	if ($keyvalue eq "")
	{
		print "<H1>Add Spell Component</H1>\n";
	}
	else
	{
        	print "<H1>Edit Spell Component</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">\n";
	fillvars_spell();
	ParseForm("inventory_sc.tpl");
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"hidden\" name=\"action\" value=\"AddSpell\">\n";
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"hidden\" name=\"action\" value=\"ChangeSpell\">\n";
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "AddSpell")
{
	# Insert and Redirect
	$keyfield = "iscid";
	$table = "inventory_sc";
	$keyvalue = $CGI->param($keyfield);
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("Spell Component Added"));
}
elsif ($action eq "ChangeSpell")
{
	#print $CGI->header();
	# Update and Redirect
	$keyfield = "iscid";
	$table = "inventory_sc";
	$keyvalue = $CGI->param($keyfield);
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("Spell Component Updated"));
}
elsif ($action eq "deletespell")
{
	# delete and Redirect
	#print "$SQL<BR>";
	$keyfield = "iscid";
	$table = "inventory_sc";
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("Spell Component Deleted"));
}
elsif ($action eq "newws" || $action eq "editws")
{
	print $CGI->header();
	ParseForm($header);
	$keyfield = "iwsid";
	$table = "inventory_ws";
	if ($keyvalue eq "")
	{
		print "<H1>Add Weird Science Part</H1>\n";
	}
	else
	{
        	print "<H1>Edit Weird Science Part</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">\n";
	fillvars_ws();
	ParseForm("inventory_sc.tpl");
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"hidden\" name=\"action\" value=\"AddWS\">\n";
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"hidden\" name=\"action\" value=\"ChangeWS\">\n";
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "AddWS")
{
	# Insert and Redirect
	$keyfield = "iwsid";
	$table = "inventory_ws";
	$keyvalue = $CGI->param($keyfield);
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("Weird Science Part Added"));
}
elsif ($action eq "ChangeWS")
{
	#print $CGI->header();
	# Update and Redirect
	$keyfield = "iwsid";
	$table = "inventory_ws";
	$keyvalue = $CGI->param($keyfield);
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("Weird Science Part Updated"));
}
elsif ($action eq "deletews")
{
	# delete and Redirect
	#print "$SQL<BR>";
	$keyfield = "iwsid";
	$table = "inventory_ws";
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("Weird Science Part Deleted"));
}
elsif ($action eq "newdev" || $action eq "editdev")
{
	print $CGI->header();
	ParseForm($header);
	$keyfield = "isdid";
	$table = "inventory_dev";
	if ($keyvalue eq "")
	{
		print "<H1>Add Weird Science Plan</H1>\n";
	}
	else
	{
        	print "<H1>Edit Weird Science Plan</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">\n";
	fillvars_dev();
	ParseForm("inventory_sc.tpl");
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"hidden\" name=\"action\" value=\"AddDev\">\n";
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"hidden\" name=\"action\" value=\"ChangeDev\">\n";
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "AddDev")
{
	# Insert and Redirect
	$keyfield = "isdid";
	$table = "inventory_dev";
	$keyvalue = $CGI->param($keyfield);
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("Weird Science Device Added"));
}
elsif ($action eq "ChangeDev")
{
	#print $CGI->header();
	# Update and Redirect
	$keyfield = "isdid";
	$table = "inventory_dev";
	$keyvalue = $CGI->param($keyfield);
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("Weird Science Device Added"));
}
elsif ($action eq "deletedev")
{
	# delete and Redirect
	#print "$SQL<BR>";
	$keyfield = "isdid";
	$table = "inventory_dev";
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("Weird Science Device Added"));
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s";
	ParseForm($header);
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle </h1>\n";

	print "<a href=\"$thispage?action=new\">ADD a NEW $heading</a><BR><BR>\n";
	
	showdata();
	
	print "<hr>\n";
	
	print "<h2>Spell Components</h2>\n";

	print "<a href=\"$thispage?action=newspell\">ADD a NEW Spell Component</a><BR><BR>\n";

	showspell();
	
	print "<hr>\n";
	
	print "<h2>Weird Science Parts</h2>\n";

	print "<a href=\"$thispage?action=newws\">ADD a NEW Weird Science Part</a><BR><BR>\n";

	showws();
	
	print "<hr>\n";
	
	print "<h2>Weird Science Devices</h2>\n";

	print "<a href=\"$thispage?action=newdev\">ADD a NEW Weird Science Device</a><BR><BR>\n";

	showdevs();
	
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var dothis, delName, jsid;\n";
	print "function deleteConfirm(dothis, delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=\"+dothis+\"&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Description</b></td>\n";
	print "<td><b>Owner</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $key = $resptr->{"$keyfield"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>".$resptr->{"description"}."</td>\n";
	   print "<td>".getCharPlayerStr($resptr->{"owner"})."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('delete','$name',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	filltable();
	
	$owner += 0;
	$chardrop = makeDropDown("characters", "charid", "concat(cfirst, ' ', clast)", "chartype < $test_character order by clast", "", $owner);
	$chardrop =~ s/charid/owner/;
}


sub showspell()
{
	local($db) = dbconnect();
	local ($sql) = "select * from inventory_sc a join spellcomponents b on a.scid=b.scid order by a.charid;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1 width=100%>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Owner</b></td>\n";
	print "<td><b>Quantity</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"scname"};
	   $key = $resptr->{"iscid"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>".getCharPlayerStr($resptr->{"charid"})."</td>\n";
	   print "<td>".$resptr->{"amount"}."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=editspell&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('deletespell','$name',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars_spell()
{
	filltable();
	
	$charid += 0;
	$chardrop = makeDropDown("characters", "charid", "concat(cfirst, ' ', clast)", "chartype < $test_character order by clast", "", $charid);
	
	$compdrop = makeDropDown("spellcomponents", "scid", "scname", "", "", $scid);

}


sub showws()
{
	local($db) = dbconnect();
	local ($sql) = "select * from inventory_ws a join WS_parts b on a.wpid=b.wpid order by a.charid;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1 width=100%>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Owner</b></td>\n";
	print "<td><b>Quantity</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"wpname"};
	   $key = $resptr->{"iwsid"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>".getCharPlayerStr($resptr->{"charid"})."</td>\n";
	   print "<td>".$resptr->{"amount"}."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=editws&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('deletews','$name',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars_ws()
{
	filltable();
	
	$charid += 0;
	$chardrop = makeDropDown("characters", "charid", "concat(cfirst, ' ', clast)", "chartype < $test_character order by clast", "", $charid);
	
	$compdrop = makeDropDown("WS_parts", "wpid", "wpname", "", "", $wpid);
}


sub showdevs()
{
	local($db) = dbconnect();
	local ($sql) = "select * from inventory_dev a join WS_plans b on a.planid=b.planid order by a.charid;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1 width=100%>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Owner</b></td>\n";
	print "<td><b>Quantity</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"name"};
	   $key = $resptr->{"isdid"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>".getCharPlayerStr($resptr->{"charid"})."</td>\n";
	   print "<td>".$resptr->{"amount"}."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=editdev&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('deletedev','$name',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars_dev()
{
	filltable();
	
	$charid += 0;
	$chardrop = makeDropDown("characters", "charid", "concat(cfirst, ' ', clast)", "chartype < $test_character order by clast", "", $charid);
	
	$compdrop = makeDropDown("WS_plans", "planid", "name", " planid>0 order by name", "", $planid);
	
}

