#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;
use CGI::Session;

$CGI = new CGI;

$pid = getPlayerID();


# ********************************************************
# * If they've gotten this far, either they haven't got  *
# * a session cookie or they're the wrong user. Either   *
# * way, we should let them log in now.                  *
# ********************************************************
if ($CGI->param("logout") == 1)
{
    $cookie1 = new CGI::Cookie(-name=>'temp',-value=>'',-domain=>'temp');    
    $cookie1->name($cookiename);
    $cookie1->domain($cookiesite);
    print $CGI->header(-cookie=>$cookie1);
    print "<html>\n";
    print "<head>\n";
    print "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-1\">\n";
    print "<META HTTP-EQUIV=\"refresh\" CONTENT=\"0; URL=login.pl\">\n"; 
    print "</head>\n";
    print "<body>\n";
    print "Logging Out...<BR>\n";
    print "</body>\n";
    print "</html>\n";
    exit 0;
}
elsif ($CGI->param("submit") eq "Submit")
{
    $pid = getPIDFromLogin($CGI->param('plogin'));
    if (($pid eq ""))
    {
    	print $CGI->redirect("login.pl?error=" . encodeURL("Invalid Login ID.  Please try again."));    
    }
    elsif (getAccessLevel($pid) == 0)
    {
    	print $CGI->redirect("login.pl?error=" . encodeURL("Your account has been deactivated.<br>\nPlease e-mail the GMs for more information.[$pid]"));    
    }
    elsif ((checkPassword($pid, $CGI->param('ppassword')) == 1))
    {
	    $session = new CGI::Session(undef, $CGI, {Directory=>"/tmp"});
	    $ckVal = $session->id();
	    doLogin($ckVal, $pid);
	    $cookie1 = new CGI::Cookie(-name=>'temp',-value=>$ckVal,-domain=>'.temp');    
    	    $cookie1->name($cookiename);
    	    $cookie1->domain($cookiesite);
	    print $CGI->header(-cookie=>$cookie1);
	    print "<html>\n";
	    print "<head>\n";
	    print "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-1\">\n";
	    print "<META HTTP-EQUIV=\"refresh\" CONTENT=\"0; URL=main.pl\">\n"; 
	    print "</head>\n";
	    print "<body>\n";
	#print "TRACE - PlayerID = $pid and Login = " . $CGI->param('plogin') . " and Password = " . $CGI->param('ppassword') . "<br>\n";
	    print "Logging In...";
	    print "</body>";
	    print "</html>";
	    exit 0;
    }
    else
    {
    print $CGI->redirect("login.pl?error=" . encodeURL("There was an error logging you onto the system.<br>\nPlease check your username and password and try again."));    
    }
}

if ($pid ne "")
{
	print $CGI->redirect("main.pl");
}
else
{
	print $CGI->header();
	ParseForm($header);
	if ($CGI->param("error") ne "")
	{
		print "<br><font color=\"red\">" . $CGI->param("error") . "</font><br>\n";
	}
	elsif ($CGI->param("emailerror") ne "")
	{
		print "<br><font color=\"red\">There was an error sending your password.<br>\nPlease check your email address and try again</font><br>\n";
		print "<!-- " . $CGI->param("emailerror") . " -->";
	}
	else
	{
		print "<br>";
	}

	ParseForm("login.tpl");

	ParseForm($footer);
}
