#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "loginas.pl";
$table = "players";
$keyfield = "playerid";
$keyvalue = $CGI->param($keyfield);
$namefield = "concat(pfirst, ' ', plast)";
$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
$errstr = $CGI->param("error");

if ($al < $developer_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to login as a different player!"));
}
elsif ($action eq "login")
{
	#print $CGI->header;
	$plogin = dosql("select plogin from players where $keyfield=$keyvalue;");
	$ppassword = dosql("select ppassword from players where $keyfield=$keyvalue;");
	print $CGI->redirect("login.pl?plogin=$plogin&submit=Submit&ppassword=$ppassword");
}
else
{
	print $CGI->header;
	$doctitle = "Log in as a Player";
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle</h1>\n";

	print "<p>This will let you log in as a different player.  Note that you will have to log out and log back in to get back to this account.</p>\n";
	
	print "<form action=\"$thispage\" method=\"post\">\n";
	print "Choose player: \n";
	
	$playerdrop = makeDropDown($table, $keyfield, $namefield, "psecurity > 0 order by plast");

	print "$playerdrop &nbsp;&nbsp;&nbsp;\n";

	print "<input type=\"submit\" name=\"submit\" value=\"Go\"><BR>\n";
	print "<input type=\"hidden\" name=\"action\" value=\"login\">\n";
	print "</form>";
	
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
		
	ParseForm($footer);
}

exit 0;
