#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "newchars.pl";
$table = "characters";
$heading = "your Character";
$keyfield = "charid";
$keyvalue = $CGI->param($keyfield);
$namefield = "clast";
$tplfile = "characters.tpl";
$errstr = $CGI->param("error");

if ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $heading</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">";
	if ($tplfile eq "")
	{
		local($dbvar) = dbconnect();
		local($query) = $dbvar->prepare("explain $table");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $dbvar->prepare("select * from $table where $keyfield = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$dbvar->disconnect;
		print "</table>";
	}
	else
	{
	     fillvars();
	     ParseForm($tplfile);
	}
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	#print $CGI->header();
	# Insert and Redirect
	@names = $CGI->param;
	$SQL = "INSERT into $table (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		$SQL .= "$i, ";
	    }

	}
	chop $SQL;
	chop $SQL;
	$SQL .= ") values (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		local($myCGI) = $CGI->param($i);
		$myCGI =~ s/'/''/g;
		$SQL .= "'" . $myCGI . "', ";
	    }
	 }
	chop $SQL;
	chop $SQL;
	$SQL .= ");";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
        $query = $dbvar->prepare("Select max(charid) from characters");
        $query->execute;
        @arrCharID = $query->fetchrow_array;
        $SQL = "insert into playercharacters (pcplayerid, pccharid) values ($pid, $arrCharID[0])";
        #print "TRACE-" . $SQL . "\n<br>\n";
        $dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	@names = $CGI->param;
	$SQL = "UPDATE $table set ";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		local($myCGI) = $CGI->param($i);
		$myCGI =~ s/'/''/g;
		$SQL .= "$i = '" . $myCGI . "', ";
	    }
	}
	chop $SQL;
	chop $SQL;
	$SQL .= " where $keyfield = $keyvalue;";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$SQL = "delete from charactergroupmembers where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Deleted"));
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<table border = 0><tr>\n";
	print "<td width=120><img src=book.jpg align=left></td>\n";
	print "<td><font color=red>$errstr</font><BR>\n";
	
	print "<H1>Manage Your Characters</h1>\n";

	print "<a href=\"$thispage?action=new\">ADD a NEW Character</a><BR></td>\n";
	print "</tr></table><BR>\n";
	
	showchars();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showchars()
{
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td align=\"center\"><b>Name</b></td>\n";
	print "<td align=\"center\"><b>Character Questionnaire</b></td>\n";
	print "<td align=\"center\"><b>Gender</b></td>\n";
	print "<td align=\"center\"><b>Stats</b></td>\n";
	print "<td align=\"center\"><b>Type</b></td>\n";
	print "<td align=\"center\"><b>Background<br>Approved</b></td>\n";
	print "<td align=\"center\"><b>STATs/Skills<br>Approved</b></td>\n";
	print "<td align=\"center\"><b>Contact GM(s)</b></td>\n";
	print "</tr>\n";
	
	local($dbvar) = dbconnect();
	local($query) = $dbvar->prepare("Select * from characters, playercharacters, chartypes where pccharid = charid and chartype = ctypeid and pcplayerid = $pid");
	$query->execute;

	while ($resptr = $query->fetchrow_hashref())
	{
	$sql = "select * from charquestionnaires where cqcharid = ".$resptr->{"charid"};
	local($query2) = $dbvar->prepare($sql);
	$query2->execute;
	$cq = 0;
	print "<tr>\n";
	    print "<td align=\"center\">".getCharName($resptr->{"charid"});
	    print " (<a href=\"$thispage?action=edit&charid=".$resptr->{"charid"}."\">Edit</a>)</td>";
	    if ($query2->rows > 0)
	    {
	       print "<td align=\"center\">Y (<a href=\"charquest.pl?mode=edit&cqcharid=".$resptr->{"charid"}."\">Edit</a>)</td>";
	       $cq = 1;
	    }
	    else
	    {
		print "<td align=\"center\">N (<a href=\"charquest.pl?mode=new&cqcharid=".$resptr->{"charid"}."\">Fill out</a>)</td>";
	    }
	    $query2->finish;
	    print "<td align=\"center\">".$resptr->{"charsex"}."</td>";
	    print"<td align=\"center\"><a href=\"stats.pl?charid=".$resptr->{"charid"}."\">Edit STATs</a></td>";
	    print"<td align=\"center\">\n";
	    local(@chartype) = { "", "PC", "Cast", "Test", "Secret" };
	    $chartype[0] = "";
	    $chartype[1] = "Player Character";
	    $chartype[2] = "Cast Character";
	    $chartype[3] = "Test Character";
	    $chartype[4] = "Secret Character";
	    print $chartype[$resptr->{"chartype"}];
	    print"</td>";
	    if ($resptr->{"charstoryapproved"} == 0)
	    {
	      print "<td align=\"center\">N";
	      if ($cq > 0)
	      {
		  print " -- <a href=\"alertGM.pl?mode=history&charid=".$resptr->{"charid"}."\">Alert GMs</a><sup>*</sup>";
	      }       
	      print "</td>\n";
	    }
	    if ($resptr->{"charstoryapproved"} == 1)
	    {
		print "<td align=\"center\">Pending</td>";
	    }
	    if ($resptr->{"charstoryapproved"} >= 2)
	    {
		print "<td align=\"center\">Y</td>";
	    }
	    if ($resptr->{"charstatsapproved"} > 0)
		{
		print "<td align=\"center\">Y</td>";
		}
	    else
		{
		print "<td align=\"center\">N</td>";
		}
	    $sql = "select gmcGMid from GMcharacters where gmccharid = ".$resptr->{"charid"}.";";
	    local($query2) = $dbvar->prepare($sql);
	    $query2->execute;
	    if ($query2->rows > 0)
	    {
		print"<td align=\"left\">";
		while (@array = $query2->fetchrow_array)
		{
		   print emailTagFromID($array[0])."<BR>";
		}
	    }
	    else
	    {
		print"<td align=\"center\">None</td>";
	    }
	    $query2->finish;
	print "</tr>\n";
	}
	print "</table>\n";
	print "<br>\n";
	if ($cq > 0)
	{
	  print("<sup>*</sup><i>Use this link to let the GMs know your character is ready for review.  Use it wisely.  If you change your character questionnaire after it is approved, it will have to go through review again.</i><BR><BR>\n");
	}
	else
	{
	  print("You must fill out a character questionnaire before your characters can be approved.<BR><BR>\n");
	}
}

sub fillvars()
{
	filltable();
	
	$chartypes = makeDropDown('chartypes','ctypeid','ctypedesc',"","",$chartype);
	$chartypes =~ s/ctypeid/chartype/g;
	
	$gender =  "<select name=\"charsex\">\n";
	$gender .= "<option value=\"M\" ";
	if ("$charsex" eq "M")
	{
	  $gender .= "SELECTED";
	}
	$gender .= ">Male</option>\n";
	$gender .= "<option value=\"F\" ";
	if ("$charsex" eq "F")
	{
	  $gender .= "SELECTED";
	}
	$gender .= ">Female</option>\n";
	$gender .= "</select><BR>";	
}

