#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "pcap.pl";

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to print political capital"));
}
elsif ($action eq "doc")
{
	print $CGI->header(-type  =>  'application/vnd.ms-excel', -filename  =>  'pcap.xls');
				
	$db = dbconnect();
	local ($sql) = "select c.pccharid from players a, eventplayers b, playercharacters c, characters d where a.playerid=b.playerid and b.eventid=$current_episode and b.reglevel > $not_attending and c.pcplayerid=a.playerid and c.pccharid > 0 and c.pccharid=d.charid and d.chartype <= $cast_character order by a.plast;";
	local ($query) = $db->prepare($sql);
	#print "$sql<BR>";
	$query->execute;
	local (@array);
	
	print "<table border=0>\n";
        print "<tr>\n";
        print "<td>CharName</td>\n";
        print "<td>PlayerName</td>\n";
        print "<td>Country</td>\n";
        print "</tr>\n";
	while (@array = $query->fetchrow_array())
	{
	   $charid = $array[0];
	   showpcap($charid);
	}
	print "</table>\n";
	
	$query->finish;
	
	$db->disconnect;
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<h1>Print Political Capital</H1>\n";
	
	print "1.  Step One.  Download the Microsoft XL Document.<BR>\n";
	print "Save this document as pcap.xls in your Brassy's folder:\n";
	print "<a href=\"$thispage?action=doc\" target=_new>Click me</a><BR><BR>\n";
		
	print "2.  Step Two.  Download the Microsoft Word Document.<BR>\n";
	print "Save this document as restok.doc in your Brassy's folder:\n";
	print "<a href=\"pcap.doc\" target=_new>Click me</a><BR><BR>\n";
		
	print "3.  Step Three.  Open and print the Microsoft Word Document.<BR>\n";
	print "Open pcap.doc in Microsoft Word.  Perform the mail merge.  Print.<BR>\n";
	print "<i>Note that pcap.doc has been formatted for business cards.</i><BR><BR>\n";

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}

exit 0;

sub showpcap()
{
   local($charid) = $_[0];
   
   $charname = getCharName($charid);
   $playername = getFullNameFromCharID($charid);

   $sql = "select c.level, c.text from characterabilities c where c.charid=$varID and c.abid=35;";
   #print "$sql<BR>\n";
   local($query) =$db->prepare($sql);
   $query->execute;
   local (@array);
   while (@array = $query->fetchrow_array)
   {
      for ($i = 0; $i < $array[0]; $i++)
      {
	print "<tr>\n";
	print "<td>$charname</td>\n";
	print "<td>$playername</td>\n";
	print "<td>$array[1]</td>\n";
	print "</tr>\n";
      }
   }
   $query->finish;
   
   $sql = "select c.level, c.text from keyroleabilities c, keyrolecharacters d where d.charid=$varID and c.krid=d.krid and c.abid=35;";
   #print "$sql<BR>\n";
   $query =$db->prepare($sql);
   $query->execute;
   while (@array = $query->fetchrow_array)
   {
      for ($i = 0; $i < $array[0]; $i++)
      {
	print "<tr>\n";
	print "<td>$charname</td>\n";
	print "<td>$playername</td>\n";
	print "<td>$array[1]</td>\n";
	print "</tr>\n";
      }
   }
   $query->finish;  
   
   return %myhash;
}
