#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "plans.pl";
$table = "WS_plans";
$heading = "Plan";
$keyfield = "planid";
$keyvalue = $CGI->param($keyfield);
$namefield = "name";
$tplfile = "plans.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	if ($keyvalue eq "")
	{
		$doctitle = "Add $heading\n";
	}
	else
	{
        	$doctitle = "Edit $heading\n";
	}
	ParseForm($header);
	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">";
	if ($tplfile eq "")
	{
		local($dbvar) = dbconnect();
		local($query) = $dbvar->prepare("explain $table");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $dbvar->prepare("select * from $table where $keyfield = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$dbvar->disconnect;
		print "</table>";
	}
	else
	{
	     fillvars();
	     ParseForm($tplfile);
	}
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	#print $CGI->header();
	# Insert and Redirect
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	dosql($SQL);
	$name = $CGI->param(name);
	$name =~ s/'/''/g;
	#print "[$name]<BR>";
	$SQL = "select max($keyfield) from $table where name='$name'";
	print "$SQL<BR>";
	$keyvalue = dosql($SQL);
	#print "$keyvalue<BR>";
	handlemfs();
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	handlemfs();
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	handlemfs();
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Deleted"));
}
elsif ($action eq "editchar")
{
	print $CGI->header;
	$planname = dosql("select $namefield from $table where $keyfield=$keyvalue;");
	$doctitle = "$planname -- Manage Characters";
	ParseForm($header);
	
	print "<center><img src=\"doclib/plans.jpg\" width=500 height=170></center>\n";
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle</H1>\n";

	print "<H2>Current Owners</H2>\n";
	print getplanowners($keyvalue). "<BR>";
	
	print "<a href=\"$thispage\">Return</a>.<BR><BR>";

	print "<H2>Add/Remove Characters</H2>\n";
	showChars();
	print "<br><hr><a href=\"$thispage\">Return</a>.";
	print "<br><a href=\"login.pl\">Main menu</a>."; 
		
	ParseForm($footer);
}
elsif ($action eq "addchar")
{
	#print $CGI->header();
	local ($charid) = $CGI->param("charid");
	local($db) = dbconnect();
	$SQL = "insert into characterplans (charid, $keyfield) values ($charid, $keyvalue);";
	#print "$SQL<BR>\n";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=editchar&$keyfield=$keyvalue");
}
elsif ($action eq "delchar")
{
	#print $CGI->header();
	local ($charid) = $CGI->param("charid");
	local($db) = dbconnect();
	$SQL = "delete from characterplans where charid=$charid and $keyfield=$keyvalue;";
	#print "$SQL<BR>\n";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=editchar&$keyfield=$keyvalue");
}
elsif ($action eq "editpart")
{
	print $CGI->header;
	$planname = dosql("select $namefield from $table where $keyfield=$keyvalue;");
	$doctitle = "$planname -- Manage Parts";
	ParseForm($header);
	
	print "<center><img src=\"doclib/plans.jpg\" width=500 height=170></center>\n";
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle</H1>\n";

	print "<H2>Current Parts</H2>\n";
	print getplanparts($keyvalue). "<BR>";
	
	print "<a href=\"$thispage\">Return</a>.<BR><BR>";

	print "<H2>Add/Remove Parts</H2>\n";
	showparts($keyvalue);
	print "<br><hr><a href=\"$thispage\">Return</a>.";
	print "<br><a href=\"login.pl\">Main menu</a>."; 
		
	ParseForm($footer);
}
elsif ($action eq "addpart")
{
	#print $CGI->header();
	local ($wpid) = $CGI->param("wpid");
	local($db) = dbconnect();
	$SQL = "insert into planparts (wpid, $keyfield) values ($wpid, $keyvalue);";
	#print "$SQL<BR>\n";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=editpart&$keyfield=$keyvalue");
}
elsif ($action eq "delpart")
{
	#print $CGI->header();
	local ($wpid) = $CGI->param("wpid");
	local($db) = dbconnect();
	$SQL = "delete from planparts where wpid=$wpid and $keyfield=$keyvalue;";
	#print "$SQL<BR>\n";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=editpart&$keyfield=$keyvalue");
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s";
	ParseForm($header);
	
	print "<center><img src=\"doclib/plans.jpg\" width=500 height=170></center>\n";
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle</H1>\n";

	print "<a href=\"$thispage?action=new\">ADD a NEW $heading</a><BR><BR>\n";
	
	showdata();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Owner(s)</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	local ($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $key = $resptr->{"$keyfield"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>".getplanowners($key)."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"$thispage?action=editchar&$keyfield=$key\">Owners</a>\n";
	   print " -- <a href=\"$thispage?action=editpart&$keyfield=$key\">Parts</a>\n";
	   print " -- <a href=\"javascript:deleteConfirm('$name',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	filltable();
	$entrydate = getDBDate();
	$leveldrop = makeDropDown("planlevels", "levid", "levtext", "", "", $level);
	$leveldrop =~ s/levid/level/;
	$statedrop = makeDropDown("planstates", "stateid", "statetext", "", "", $stateid);
	$mfs = makeCheckBoxes("motiveforces", "mfid", "mfname", "select mfid from planmfs where planid=$planid and mfid = \$array[0];");
	$aps = makeCheckBoxes("applications", "aid", "aname", "select aid from planapplications where planid=$planid and aid = \$array[0];");
	$owners = getplanowners($planid);
	$parts = getplanparts($planid);
}

sub handlemfs()
{
    $num = $CGI->param("mfid_total");
    $sql = "delete from planmfs where $keyfield=$keyvalue;";
    #print "$sql, $num<BR>";
    dosql($sql);
    for ($i = 0; $i < $num; $i++)
    {
        $mfid = $CGI->param("mfid_$i") + 0;
    	#print "$mfid<BR>";
        if ($mfid > 0)
        {
	    $sql = "insert into planmfs ($keyfield, mfid) values ($keyvalue,$mfid);";
	    #print "$sql<BR>";
	    dosql($sql);  
	}
    }
    $num = $CGI->param("aid_total");
    $sql = "delete from planapplications where $keyfield=$keyvalue;";
    #print "$sql, $num<BR>";
    dosql($sql);
    for ($i = 0; $i < $num; $i++)
    {
        $aid = $CGI->param("aid_$i") + 0;
    	#print "$aid<BR>";
        if ($aid > 0)
        {
	    $sql = "insert into planapplications ($keyfield, aid) values ($keyvalue,$aid);";
	    #print "$sql<BR>";
	    dosql($sql);  
	}
    }
}

# ******************
# * makeCheckBoxes *
# ******************
sub makeCheckBoxes
{
    local($table, $field1, $field2, $checksql) = @_;
    local ($db) = dbconnect();
    $SQL = "select $field1, $field2 from $table;";
    
    local($query) = $db->prepare($SQL);
    #print $CGI->header();
    #print "$SQL<BR>";
    $query->execute;

    local ($retVal) = "";
    #Check to make sure $query is not empty
    if ($query->rows > 0)
    {
        local ($num) = 0;
        local (@array);
        while (@array = $query->fetchrow_array)
        {        
           local ($csql) = eval qq/"$checksql"/;
           local ($checkval) = "";
           if (dosql($csql) + 0 > 0)
           {
             $checkval = "CHECKED";
           }
           $retVal .= "<input type=\"checkbox\" name=\"".$field1."_$num\" value=\"$array[0]\" $checkval>$array[1]</input>\n";
           $num++;
           if ($num % 5 == 0)
           {
               $retVal .=  "<BR>";
           }
        }
        $retVal .= "<input type=\"hidden\" name=\"".$field1."_total\" value=\"$num\">\n";
    }
    $query->finish;
    $db->disconnect;
    return $retVal;
}

sub showChars()
{
	local($db) = dbconnect();
	$SQL = "select charid from characters where chartype <= $cast_character order by clast;";
	#print "$SQL<BR>";
	local($query) = $db->prepare($SQL);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Character Name</b></td>\n";
	print "<td><b>Plan Owner</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	if ($query->rows > 0)
	{
	   local (@array);
	   while (@array = $query->fetchrow_array)
	   {
		   print "<tr>\n";
		   print "<td>".getCharPlayerStr($array[0])."</td>\n";
		   if (dosql("select count(charid) from characterplans where charid=$array[0] and $keyfield=$keyvalue;") > 0)
		   {
			print "<td><b>Yes</b></td>\n";
			print "<td><a href=\"$thispage?action=delchar&charid=$array[0]&$keyfield=$keyvalue\">Remove</a>\n";
		   }
		   else
		   {
			print "<td>No</td>\n";
			print "<td><a href=\"$thispage?action=addchar&charid=$array[0]&$keyfield=$keyvalue\">Add</a>\n";
		   }
		   print "</td></tr>\n";
	   }
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub getplanowners()
{
   	local($varID) = $_[0];
	local($db) = dbconnect();
	$SQL = "select charid from characterplans where $keyfield=$varID;";
	#print "$SQL<BR>";
	local($query) = $db->prepare($SQL);
	$query->execute;
	$retVal = "";
	if ($query->rows > 0)
	{
	   local (@array);
	   while (@array = $query->fetchrow_array)
	   {
	      $retVal .= getCharPlayerStr($array[0])."<BR>\n";
	   }
	}
	$query->finish;
	$db->disconnect;
	return $retVal;
}


sub showparts()
{
   	local($varID) = $_[0];
	local($db) = dbconnect();
	$SQL = "select * from planmfs a, WS_parts b, motiveforces c where b.wpmfid=a.mfid and a.planid=$varID and a.mfid=c.mfid order by c.mfname, b.wpname;";
	#print "$SQL<BR>";
	local($query) = $db->prepare($SQL);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Part Name</b></td>\n";
	print "<td><b>Motive Force</b></td>\n";
	print "<td><b>Cost</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	if ($query->rows > 0)
	{
	   local ($resptr);
	   while ($resptr = $query->fetchrow_hashref())
	   {
		   print "<tr>\n";
		   print "<td>".$resptr->{"wpname"}."</td>\n";
		   print "<td>".$resptr->{"mfname"}."</td>\n";
		   print "<td>".$resptr->{"wpcost"}."</td>\n";
		   if (dosql("select count(planid) from planparts where planid=$varID and wpid=".$resptr->{"wpid"}.";") > 0)
		   {
			print "<td><a href=\"$thispage?action=delpart&wpid=".$resptr->{"wpid"}."&$keyfield=$varID\">Remove</a>\n";
		   }
		   else
		   {
			print "<td><a href=\"$thispage?action=addpart&wpid=".$resptr->{"wpid"}."&$keyfield=$varID\">Add</a>\n";
		   }
		   print "</td></tr>\n";
	   }
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub getplanparts()
{
   	local($varID) = $_[0];
	local($db) = dbconnect();
	$SQL = "select * from planparts a, WS_parts b, motiveforces c where a.planid=$varID and b.wpmfid=c.mfid and a.wpid=b.wpid;";
	#print "$SQL<BR>";
	local($query) = $db->prepare($SQL);
	$query->execute;
	$retVal = "<table border=1>\n";
	$retVal .= "<tr>\n";
	$retVal .= "<td><b>Part Name</b></td>\n";
	$retVal .= "<td><b>Motive Force</b></td>\n";
	$retVal .= "<td><b>Cost</b></td>\n";
	$retVal .= "</tr>\n";
	local($cost) = 0;
	local($num) = 1;
	if ($query->rows > 0)
	{
	   local ($resptr);
	   while ($resptr = $query->fetchrow_hashref())
	   {
		$retVal .= "<tr>\n";
		$retVal .=  "<td>$num.".$resptr->{"wpname"}."</td>\n";
		$retVal .=  "<td>".$resptr->{"mfname"}."</td>\n";
		$retVal .=  "<td>".$resptr->{"wpcost"}."</td>\n";
		$retVal .= "</tr>\n";
		$cost += $resptr->{"wpcost"};
		$num++;
	   }
	}
	$query->finish;
	$db->disconnect;
	$retVal .= "<tr>\n";
	$retVal .= "<td colspan=2 align=right><i>Total Cost:</i></td>\n";
	$retVal .= "<td><i>$cost</i></td>\n";
	$retVal .= "</tr>\n";
	$retVal .= "</table>\n";
	return $retVal;
}
