#!/usr/bin/perl

require 'boxes.pl';
require 'gmnote_inc.pl';
require 'common.pl';
use DBI;
use CGI;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "plots.pl";
$table = "plots";
$heading = "Plot";
$keyfield = "plotid";
$keyvalue = $CGI->param($keyfield);
$namefield = "plname";
$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
$tplfile = "plots.tpl";
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$doctitle = "Edit/Display Plots -- $namevalue";
$errstr = $CGI->param("error");

$hidebox = $CGI->param("hidebox") + 0;
$showallplots = $CGI->param("showallplots") + 0;
$sortby = $CGI->param("sortby") + 0;
$sortbyevent = 0;
$sortbystatus = 1;
$sortbyname = 2;
$numsorts = 3;

$ctn = 0;
local($db) = dbconnect();
$sql = "select psid, plstatustext from plotstatus order by psid;";
local($query) = $db->prepare($sql);
$query->execute;
local (@array);
while (@array = $query->fetchrow_array)
{
	$psid[$ctn] = $array[0];
	$plotstatustext[$psid[$ctn]] = $array[1];
	$ctn++;
}
$query->finish;
$db->disconnect;
$numplotstatuses = $ctn;

$ctntot = 0;
for ($i = 0; $i < $numplotstatuses; $i++)
{
   $plotchecked[$psid[$i]] = $CGI->param("plotstatus_$psid[$i]") + 0;
   $ctntot += $plotchecked[$psid[$i]];
}
if ($ctntot == 0)
{
   $showallplots = 1;
}

if ($al < $plotlevel)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "Redirect")
{
	print $CGI->header();
	print "Submit: ".$CGI->param("submit")."<BR>";
	print "Target: ".$CGI->param("target")."<BR>";
}
elsif ($action eq "edit" || $action eq "new")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $namevalue</H1>\n";
	}
	print "<form action=\"$thispage?\" name=\"myform\" method=\"post\">";
        fillvars();
        ParseForm($tplfile);
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Return to the main menu</a>.";
	showGMNconfirm();
}
elsif ($submit eq "Delete")
{
	local($db) = dbconnect();
	local($sql) = "delete from $table where $keyfield = $keyvalue";
	$db->do($sql);
	local($sql) = "delete from plotboxes where $keyfield = $keyvalue";
	$db->do($sql);
	$sql = "select gmnid from linknotes where linktable='plots' and linkid=$keyvalue";
	local($query) =$db->prepare($sql);
	$query->execute;
	local (@gmnids);
	local($num) = 0;
   	local (@array);
        while (@array = $query->fetchrow_array)
        {
            $gmnids[$num] = $array[0];
            $num++;
	}	
	$query->finish;
	foreach $num (@gmnids)
	{
	    $sql = "delete from gmnotes where gmnid = $num";
	    $db->do($sql);
	    $sql = "delete from linknotes where gmnid = $num";
	    $db->do($sql);
	}
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Deleted"));
}
elsif ($submit eq "Change")
{
	    # Update and Redirect
	    #print $CGI->header();
	    $SQL = filltablefromCGI($table, 0);
	    local($db) = dbconnect();
	    $db->do($SQL);
	    $db->disconnect;
	    updateBoxes('plotboxes',$keyfield,$keyvalue);
	    if ($CGI->param("continue") eq "1")
	    {
	       print $CGI->redirect("$thispage?action=edit&$keyfield=$keyvalue");
	    }
	    else
	    {
	       $myline = fetchline($thispage,$pid);
	       if ($myline == '')
	       {
   	       		print $CGI->redirect("$thispage?error=" . encodeURL("$heading Modified"));
   	       }
   	       else
   	       {
   	       		print $CGI->redirect("$thispage$myline&error=" . encodeURL("$heading Modified"));
   	       }
	    }
}
elsif ($submit eq "Add")
{
	    # Insert and Redirect
	    #print $CGI->header();
	    $SQL = filltablefromCGI($table, 1);
	    local($db) = dbconnect();
	    $db->do($SQL);
	    $keyvalue = $db->{'mysql_insertid'};
	    $db->disconnect;
	    updateBoxes('plotboxes',$keyfield,$keyvalue);
	    if ($CGI->param("continue") eq "1")
	    {
	       print $CGI->redirect("$thispagel?action=edit&$keyfield=$keyvalue");
	    }
	    else
	    {
	       $myline = fetchline($thispage,$pid);
	       if ($myline == '')
	       {
   	       		print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
   	       }
   	       else
   	       {
   	       		print $CGI->redirect("$thispage$myline&error=" . encodeURL("$heading Added"));
   	       }
	    }
}
elsif ($action eq "dump")
{
	print $CGI->header(-type  =>  'application/msword', -filename  =>  'plots.doc');
        #print $CGI->header;
        print "<html><head>\n";
        print "<link href=\"../brassy.css\" rel=\"stylesheet\" type=\"text/css\">\n";
        print "</head>\n";
   	local($db) = dbconnect();
	local ($sql) = "select $keyfield from $table order by $namefield;";
   	#print"$sql<BR>";
   	local ($query) = $db->prepare($sql);
   	$query->execute;
   	local (@array);
        while (@array = $query->fetchrow_array)
        {
           $keyvalue = $array[0];
	   fillvars();
           $gmcomments =~ s/\n/<BR>/g;
           $ploverview =~ s/\n/<BR>/g;
           $plhistory =~ s/\n/<BR>/g;
           $plfx =~ s/\n/<BR>/g;
           $pltimeline =~ s/\n/<BR>/g;
           $pldetails =~ s/\n/<BR>/g;
           ParseForm("plotdump.tpl");
   	   print "<BR>[pb]<BR>\n";
   	}
   	$query->finish;
   	$db->disconnect;
        print "</html>\n";
}
elsif ($action eq 'makedef')
{

   #print $CGI->header();
   $myline = makeline();
   local($db) = dbconnect();
   $db->do("delete from pagedefaults where playerid=$pid and pageid='$thispage';");
   $db->do("insert into pagedefaults (playerid, pageid, defstring) values($pid,'$thispage','$myline');");
   $db->disconnect;
   print $CGI->redirect("$thispage".$myline);
}
else
{
	$pid = getPlayerID();
	print $CGI->header();
	$doctitle = "Edit/Display Plots";
	ParseForm($header);
	if ($CGI->param("error") ne "")
	{
	    print "<font color=\"red\">" . $CGI->param("error") . "</font><br><br>\n";
	}

	print "<a href=\"plotmatrix.pl\">Character/Plot Matrix</a>\n";
	print "<BR><a href=\"$thispage?action=dump\" target=_new>Save Plots for Episode 1 as Word Document</a><BR><BR>\n";
	
		if ("$hidebox" eq "1")
	{
	   $hidebox = 0;
	   print "<a href=\"$thispage".makeline()."\">Show Control Panel</a><BR>\n";
	}
	else
	{
	   showcontrolpanel();
	   print "<BR><BR>\n";
	}
	
	print "<H2><a href=\"$thispage?action=new\">New $heading</a></H2>\n";
	
	if ($sortby == $sortbyevent)
	{
	   sortplotsbyevent();
	}
	
	if ($sortby == $sortbystatus)
	{
	   sortplotsbystatus();
	}
	
	if ($sortby == $sortbyname)
	{
	   sortplotsbyname();
	}
	
	print "<br><hr><a href=\"login.pl\">Return to the main menu</a>.\n";
	showGMNconfirm();
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"plots.pl?submit=Delete&plotid=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
        ParseForm($footer);
}

# *********************************************************************************************8

sub sortplotsbyevent()
{
	print "\n<H1>Sort Plots By Event</H1>";
	local($db) = dbconnect();
	local ($sql) = "select eventid, eventname from events order by eventstart desc;";
	local($query) = $db->prepare($sql);
	$query->execute;
	while (@arrtemp = $query->fetchrow_array)
	{
	   print "\n<H2>$arrtemp[1]</H2>";
	   print "<table border=1><tr>";
	   print "<td><b>Plot Name</b></td>";
	   print "<td><b>Author</b></td>";
	   print "<td><b>Status</b></td>";
	   print "<td><b>Action</b></td>";
	   print "</tr>\n";
	   $sql = "select * from plots order by $namefield;";
	   local($query2) = $db->prepare($sql);
 	   $query2->execute;
	   local($resptr);
	   while ($resptr = $query2->fetchrow_hashref())
	   {
	   	$sql = "select a.gmnid from linknotes a, linknotes b where a.linktable='plots' and a.linkid=".$resptr->{"plotid"}." and a.gmnid=b.gmnid and b.linktable='events' and b.linkid=$arrtemp[0];";
	   	#print "$sql<BR>\n";
	        $gmnid = dosql($sql) + 0;
	        if ($gmnid > 0 && ($plotchecked[$resptr->{"plstatus"}] > 0 || $showallplots))
	        {
	   		showplot($resptr);
	   	}
	   }
	   print "</table>\n";
	   $query2->finish;
	}
	$query->finish;
	
	print "<H2>No Event</H2>\n";
	print "<table border=1><tr>";
	print "<td><b>Plot Name</b></td>";
	print "<td><b>Author</b></td>";
	print "<td><b>Status</b></td>";
	print "<td><b>Action</b></td>";
	print "</tr>\n";
	$sql = "select * from plots order by $namefield;";
	local($query2) = $db->prepare($sql);
	$query2->execute;
	local($resptr);
	while ($resptr = $query2->fetchrow_hashref())
	{
	   	$sql = "select a.gmnid from linknotes a, linknotes b where a.linktable='plots' and a.linkid=".$resptr->{"plotid"}." and a.gmnid=b.gmnid and b.linktable='events'";
		$gmnid = dosql($sql) + 0;
		if ($gmnid == 0 && ($plotchecked[$resptr->{"plstatus"}] > 0 || $showallplots))
		{
			showplot($resptr);
		}
	}
	print "</table>\n";
	$query2->finish;
	$db->disconnect;
}

sub sortplotsbystatus()
{
	print "\n<H1>Sort Plots By Status</H1>";
	local($db) = dbconnect();
	local ($sql) = "select psid, plstatustext from plotstatus order by psid;";
	local($query) = $db->prepare($sql);
	$query->execute;
	while (@arrtemp = $query->fetchrow_array)
	{
	   if ($plotchecked[$arrtemp[0]] > 0 || $showallplots)
	   {
		   print "\n<H2>$arrtemp[1]</H2>";
		   print "<table border=1><tr>";
		   print "<td><b>Plot Name</b></td>";
		   print "<td><b>Author</b></td>";
		   print "<td><b>Status</b></td>";
		   print "<td><b>Action</b></td>";
		   print "</tr>\n";
		   $sql = "select * from plots where plstatus=$arrtemp[0]"; # order by $namefield;";
		   local($query2) = $db->prepare($sql);
		   $query2->execute;
		   local($resptr);
		   while ($resptr = $query2->fetchrow_hashref())
		   {
			showplot($resptr);
		   }
		   print "</table>\n";
		   $query2->finish;
	    }
	}
	$query->finish;
	$db->disconnect;
}


sub sortplotsbyname()
{
	print "\n<H1>Sort Plots By Name</H1>";
	local($db) = dbconnect();
	print "<table border=1><tr>";
	print "<td><b>Plot Name</b></td>";
	print "<td><b>Author</b></td>";
	print "<td><b>Status</b></td>";
	print "<td><b>Action</b></td>";
	print "</tr>\n";
	$sql = "select * from plots order by $namefield;";
	local($query2) = $db->prepare($sql);
	$query2->execute;
	local($resptr);
	while ($resptr = $query2->fetchrow_hashref())
	{
		if ($plotchecked[$resptr->{"plstatus"}] > 0 || $showallplots)
		{
			showplot($resptr);
		}
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}


# ******************
# * showPlots *
# ******************
sub showplot()
{
	local($resptr) = $_[0];
	$name = $resptr->{"plname"};
	print "<tr>";
	print "<td>$name</td>\n";
	print "<td>".emailTagFromID($resptr->{"plauthor"})."</td>\n";
	print "<td>".$plotstatustext[$resptr->{"plstatus"}]."</td>\n";
	print "<td>";
	print "<a href=\"$thispage?action=edit&$keyfield=" .$resptr->{"plotid"}. "\">Edit</a> ";
	$name =~ s/'//g;
	print "-- <a href=\"javascript:deleteConfirm('$name','".$resptr->{"plotid"}."');\">Delete</a>";
	print "</td>\n";
	print "</tr>";
}

# **********************************************************************************************************************8
sub fillvars()
{
	filltable();

	if ($plauthor == 0)
	{
	  $plauthor = $pid;
	}
	$plauthorname = getFullNameFromID($plauthor);

	$plottype = makeArrayDropDown(['Scene/Event', 'Small', 'One Game Minor', 'One Game Major', 'Multi-game', 'Overarc'],"pltypetext",[$pltypetext]);

	$linkid = $plotid;
	$linktable = "plots";

	$linkednotes = getgmnotes();

	$statusboxes = createBoxes(1,'plotboxes','plotid',$plotid);

	$socialboxes = createBoxes(2,'plotboxes','plotid',$plotid);

	$plotboxes = createBoxes(3,'plotboxes','plotid',$plotid);
	
	$plstatustext = makeDropDown("plotstatus", "psid", "plstatustext", "", "", $plstatus);
	$plstatustext =~ s/psid/plstatus/;
	
	$plgmnotes =~ s/\n/<BR>\n/g;

}

sub getgmnotes()
{
	local ($ltb) = $_[0];
	local ($retstr) = "";
	local($db) = dbconnect();
	$sql = "select distinct b.* from linknotes a join gmnotes b on a.gmnid=b.gmnid where a.linktable='plots' and a.linkid=$plotid;";
	local($query) = $db->prepare($sql);
	#print "$sql<BR>\n";
	$query->execute;
	if ($query->rows > 0)
	{
	        local($resptr);
		while ($resptr = $query->fetchrow_hashref())
		{
		     $retstr .= shownote($resptr,'Transparent');
		}
	}
	else
	{
		$retstr .= "<BR>";
	}
	$query->finish;
	$db->disconnect;
	return $retstr;
}

# ******************
# * findminplotid *
# ******************

sub findminplotid()
{
	local($db) = dbconnect();
	local ($SQL) = "select max(plotid) from $table;";
	#print "$SQL<BR>";
	local($query) = $db->prepare($SQL);
	$query->execute;
	@array = $query->fetchrow_array;
	$query->finish;
	$db->disconnect;
	return $array[0] + 1;
}




# **************************************************************************************8

sub showcontrolpanel()
{
	for ($i = 0; $i < $numsorts; $i++)
	{
	  $sortchecked[$i] = "";
	}
	$sortchecked[$sortby] = "checked";

	for ($i = 0; $i < $numplayertypes; $i++)
	{
	  $playchecked[$i] = "";
	}
	$playchecked[$onlypaid] = "checked";
	
	$ctn = 0;
	
	print "<form action=\"$thispage\" method=\"post\">";
	print "<p><table border=1 cellspacing=0 cellpadding=0 align=left bgcolor=#eeeeee width=100%><tr><td>\n";
	print "<table border=0  cellspacing=1 cellpadding=1 align=center bgcolor=#eeeeee width=100%>\n";
	print "<tr><td><b>Control Panel</b></td></tr>\n";
	
	print "<tr>";
	print "<td style=\"font-size : xx-small;\" valign=middle><input type=radio name=sortby value=0 $sortchecked[0]>Sort By Event</input></td>\n";
	print "<td style=\"font-size : xx-small;\" valign=middle>\n";
	print "<input type=checkbox name=showallplots value=\"1\" $ischecked[$showallplots]>Show All Plots</input>";
	print "</td>\n";
	print "<td style=\"font-size : xx-small;\">";
	if ($numchartypes > $ctn)
	{
		print "<input type=checkbox name=plotstatus_$psid[$ctn] value=\"1\" $ischecked[$plotchecked[$psid[$ctn]]]>Show $plotstatustext[$psid[$ctn]] Plots</input>";
	}
	print "</td>\n";
	$ctn++;
	print "</tr>";
	
	print "<tr>";
	print "<td style=\"font-size : xx-small;\" valign=middle><input type=radio name=sortby value=1 $sortchecked[1]>Sort By Status</input></td>\n";
	print "<td style=\"font-size : xx-small;\" valign=middle></td>\n";
	print "<td style=\"font-size : xx-small;\">";
	if ($numchartypes > $ctn)
	{
		print "<input type=checkbox name=plotstatus_$psid[$ctn] value=\"1\" $ischecked[$plotchecked[$psid[$ctn]]]>Show $plotstatustext[$psid[$ctn]] Plots</input>";
	}
	print "</td>\n";
	$ctn++;
	print "</tr>";
	
	print "<tr>";
	print "<td style=\"font-size : xx-small;\" valign=middle><input type=radio name=sortby value=2 $sortchecked[2]>Sort By Name</input></td>\n";
	print "<td style=\"font-size : xx-small;\" valign=middle></td>\n";
	print "<td style=\"font-size : xx-small;\">";
	if ($numchartypes > $ctn)
	{
		print "<input type=checkbox name=plotstatus_$psid[$ctn] value=\"1\" $ischecked[$plotchecked[$psid[$ctn]]]>Show $plotstatustext[$psid[$ctn]] Plots</input>";
	}
	print "</td>\n";
	$ctn++;
	print "</tr>";
		
	for (;$ctn < $numplotstatuses; $ctn++)
	{
		print "<tr>";
		print "<td style=\"font-size : xx-small;\" valign=middle></td>\n";
		print "<td style=\"font-size : xx-small;\" valign=middle></td>\n";
		print "<td style=\"font-size : xx-small;\">";
		print "<input type=checkbox name=plotstatus_$psid[$ctn] value=\"1\" $ischecked[$plotchecked[$psid[$ctn]]]>Show $plotstatustext[$psid[$ctn]] Plots</input>";
		print "</td>\n";
		print "</tr>";
	}
		
	print "<tr><td style=\"font-size : xx-small;\"><input type=checkbox name=hidebox value=1><i>Hide Control Panel</i></input</td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=checkbox name=\"action\" value=\"makedef\"><i>Make Default</i></input</td>\n";
	print "<td style=\"font-size : xx-small;\"><input type=\"submit\" name=\"submit\" value=\"Submit\"></td>\n";
	print "</tr>";	
	print "</table>\n";
	print "</td></tr></table></p></form><BR>\n";
}

sub makeline()
{
	local($retVal) =  "?sortby=$sortby";
	$retVal .= "&hidebox=$hidebox";
	$retVal .= "&showallplots=$showallplots";
	for ($i = 0; $i < $numplotstatuses; $i++)
	{
	   $retVal .= "&plotstatus_$psid[$i]=$plotchecked[$psid[$i]]";
	}
	return $retVal;
}


