#!/usr/bin/perl

require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "prepspell.pl";
$table = "spellspecifics";
$heading = "A Spell";
$keyfield = "abid";
$keyvalue = $CGI->param($keyfield);
$namefield = "name";
$tplfile = "x.tpl";
$errstr = $CGI->param("error");

$step = $CGI->param("step") + 0;
$charid = $CGI->param("charid");
$charname = getCharName($charid);
$abid = $CGI->param("abid");
$abname = dosql("select name from abilities where abid=$abid;");
$scid = $CGI->param("scid");
$scname = dosql("select scname from spellcomponents where scid=$scid;");
$mymana = $CGI->param("mymana") + 0;
$mylevel = $CGI->param("mylevel") + 0;

$alive = $CGI->param("alive");
$casters = $CGI->param("casters");
$mana_special = $CGI->param("mana_special");

$submit = $CGI->param("submit");

if ($al < $writer_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to visit this page!"));
}
elsif ($submit eq "Create New Component")
{
   	print $CGI->header;
	ParseForm($header);
	
	print "<H1>Preparing Spells</h1>\n";
	
	print "<p><i>This page is for assistant/floor GMs to prep spells.  If you need help working this page, find a GM.</i></p>\n";
	
	print "<form action=\"$thispage\" method=\"post\">";

	print "<h2>Step 4a: Creating a New Component</h2><BR>\n";
	
	print "<p><i>Right now, you just need to create the component.  Later on, you'll determine what it does in the spell.</i></p>\n";
	
	print "<form action=\"$thispage\" method=\"post\">";

	print "<b>Component Name:</b> ";
	print "<input type=text name=scname size=80><BR><BR>\n";
	print "A Short Description:";
	print "<input type=text name=scdesc size=80><BR><BR>\n";
	print "General Location where it can be found:";
	print "<input type=text name=scorigin size=80><BR><BR>\n";
	
	print "<p><i>After this, you will be asked to select the component again.</i></p>\n";
	
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<input type=\"hidden\" name=\"abid\" value=\"$abid\">\n";
	print "<input type=\"hidden\" name=\"mymana\" value=\"$mymana\">\n";
	print "<input type=\"hidden\" name=\"step\" value=\"8\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Add Component\"><BR>";
	print "</form>";
	
}
elsif ($step == 8)
{
   	#print $CGI->header;
	$SQL = filltablefromCGI("spellcomponents", 1);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?step=4&charid=$charid&abid=$abid&mymana=$mymana");
}
elsif ($step == 7)
{
   	#print $CGI->header;
	$SQL = filltablefromCGI("spellcomponentslink", 1);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?step=6&mylevel=$mylevel&scid=$scid&alive=$alive&casters=$casters&charid=$charid&abid=$abid&mymana=$mymana&mana_special=$mana_special");
}
elsif ($step == 6)
{
   print $CGI->header;
   $num = dosql("select count(sideeffect) from spellcomponentslink where abid=$abid and scid=$scid;") + 0;
   if ($num == 0)
   {
	ParseForm($header);
	
	print "<H1>Preparing Spells</h1>\n";
	
	print "<p><i>This page is for assistant/floor GMs to prep spells.  If you need help working this page, find a GM.</i></p>\n";
	
	print "<form action=\"$thispage\" method=\"post\">";

	print "<h2>Step 6: Add Side Effect</h2><BR>\n";
	
	print "<p><b>$charname is casting $abname at level $mylevel with $mymana MANA</b></p>\n";
	
	print "<p><b>Spell component being used is $scname</b></p>\n";
	
	print "<p><i>I do not know what effect $scname has on the Spell.  Please enter a side effect.  If you aren't sure, call a GM.</i></p>\n";
	
	print "<p><i><b>Here is what the other components do for <a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=$abid','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">$abname</a>.</b></i></p>\n";
	
	print getmycomponents()."<BR>\n";
	
	print "<form action=\"$thispage\" method=\"post\">";

	print "<b>New Side Effect:</b> ";
	print "<input type=text name=sideeffect size=80><BR><BR>\n";
	print "If this side effect involves extra (or less) mana cost, enter the difference (+2; -1; etc) here:";
	print "<input type=text name=manacostmod size=5><BR><BR>\n";
	print "<input type=checkbox name=spellfails value=1> Check this box if this component causes the spell to fail.</input><BR><BR>\n";
	
	print "<i>No matter what, enter a textual description in the New Side Effect box.  If the component is not thematically correct for the spell, make the spell fail.</i><BR><BR>\n";
	print "<i>Please keep in mind that magic is subtle and side effect should be so too.</i><BR><BR>\n";
	
	print "<input type=\"hidden\" name=\"mana_special\" value=\"$mana_special\">\n";
	print "<input type=\"hidden\" name=\"displaysideeffect\" value=\"1\">\n";
	print "<input type=\"hidden\" name=\"mylevel\" value=\"$mylevel\">\n";
	print "<input type=\"hidden\" name=\"scid\" value=\"$scid\">\n";
	print "<input type=\"hidden\" name=\"alive\" value=\"$alive\">\n";
	print "<input type=\"hidden\" name=\"casters\" value=\"$casters\">\n";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<input type=\"hidden\" name=\"abid\" value=\"$abid\">\n";
	print "<input type=\"hidden\" name=\"mymana\" value=\"$mymana\">\n";
	print "<input type=\"hidden\" name=\"step\" value=\"7\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Add Side Effect\"><BR>";
	print "</form>";
   }
   else
   {
	$doctitle = "Prepare Spell";
	ParseForm("revheader.tpl");
	
	filltable();
	setSTATvars();
	
	print "<H1>Preparing Spells -- Results</h1>\n";
	
	print "<p><i>This page is for assistant/floor GMs to prep spells.  If you need help working this page, find a GM.</i></p>\n";
	
	print "<p><i>Find an envelope.  You should have plenty.  Either print and cut out this page or write it down on an index card.</i></p>\n";
	
	$ct = $basetimetoprep + ($timetopreplevel * $mylevel);
	
	$ct= handlepreptime($ct);
	
	print "<p><i>Hand the envelope to the player.  Remind them that they must spend <b><i>$ct minutes</i></b> preparing the spell, if they have not already done so.</i></p>\n";
	
	print "<h2>Inside of Envelope</h2><BR>\n";
	
	print "<p><i>Cut this out and put it in the envelope and seal it.</i></p>\n";
	
	print "<center><table border=2 width=80%><tr><td align=left>\n";
	print handlespell();
	print "</td></tr></table></center>\n";
	
	print "<h2>Outside of Envelope</h2><BR>\n";
	
	print "<p><i>Write this on the outside of the envelope.</i></p>\n";
	
	print "<p><b>$abname Results for Character ID \#$charid.  If found return to a GM.</b></p>\n";
	
	print "<p><b>You may hold a total of $mana Spells.  Open when cast.</b></p>\n";
   }	
   print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
   ParseForm($footer);
}
elsif ($step == 5)
{
	print $CGI->header;
	ParseForm($header);
	
	print "<H1>Preparing Spells</h1>\n";
	
	print "<p><i>This page is for assistant/floor GMs to prep spells.  If you need help working this page, find a GM.</i></p>\n";
	
	print "<form action=\"$thispage\" method=\"post\">";

	print "<h2>Step 5: Confirmation</h2><BR>\n";
	
	print "<p><b>$charname is casting $abname at level $mylevel with $mymana MANA</b></p>\n";
	
	print "<p><b>Spell component being used is $scname</b></p>\n";
	
	print "<p><i>Ask the player if they are sure?  If so, take the MANA chits and item card for the component, assign Blue Stars as needed, and press the \"Confirm\" Button.</i></p>\n";
	
	print "<input type=\"hidden\" name=\"mana_special\" value=\"$mana_special\">\n";
	print "<input type=\"hidden\" name=\"mylevel\" value=\"$mylevel\">\n";
	print "<input type=\"hidden\" name=\"scid\" value=\"$scid\">\n";
	print "<input type=\"hidden\" name=\"alive\" value=\"$alive\">\n";
	print "<input type=\"hidden\" name=\"casters\" value=\"$casters\">\n";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<input type=\"hidden\" name=\"abid\" value=\"$abid\">\n";
	print "<input type=\"hidden\" name=\"mymana\" value=\"$mymana\">\n";
	print "<input type=\"hidden\" name=\"step\" value=\"6\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Confirm\"><BR>";
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
elsif ($step == 4)
{
	print $CGI->header;
	ParseForm($header);
	
	print "<H1>Preparing Spells</h1>\n";
	
	print "<p><i>This page is for assistant/floor GMs to prep spells.  If you need help working this page, find a GM.</i></p>\n";

	print "<p><i>$charname is casting $abname</i></p>\n";
	
	print "<form action=\"$thispage\" method=\"post\">";

	print "<h2>Step 4</h2>\n";
	
	print "<p><i>Select the Spell Component they are using.  Indicate, via the checkboxes, if it is from a live creature, and if it is a human part if it is the caster's.</i></p>\n";
	
	print makeDropDown("spellcomponents", "scid", "scname", "scid=scid order by scname") ."<BR><BR>\n";
	
	print "<input type=checkbox name=alive value=1> This is from a live source.</input><BR>\n";
	print "<input type=checkbox name=casters value=1> The part being sacrificed is a body part of the caster.</input><BR><BR>\n";
	
	print "<p><i>If the component is not in the drop down list above, then click the \"New Component\" button below.</i></p>\n";
	
	$manaperlevel = dosql("select manaperlevel from spellspecifics where abid=$abid;") + 0;
	if ($manaperlevel > 0)
	{
	   print "<h2>Step 5</h2>\n";
	   	
	   $ablevel = getlevel($abname);
	   $ablevel = max($ablevel,1);
	   print "<p><i>This spell requires MANA per level.  The caster may prepare this spell up to level $ablevel.  Ask the player what level they want to cast the spell at.</i></p>\n";
	   	
	   print "<p>Enter Level Cast: <input type=text size=5 name=mylevel value=$ablevel></p>\n";
	   	
	}
	
	$manacostspecial = dosql("select manacostspecial from spellspecifics where abid=$abid;") + 0;
	if ($manacostspecial > 0)
	{
		if ($abid == 231)  #summon
		{
		   print "<h2>Step 5a</h2>\n";

		   print "<p><i>This spell requires more information about the MANA cost.</i></p>\n";

		   print "<p>Enter Type of Animal Being Summonned: \n";
		   print "<select name=\"mana_special\">\n";
		   print "<option value=\"2\">Small animal (cat or smaller)</option>\n";
		   print "<option value=\"4\">Medium animal (pig or sheep)</option>\n";
		   print "<option value=\"6\">Large animal (horse or larger)</option>\n";
		   print "</select><BR><BR>\n"
		}
	      
	      	if ($abid == 220) #infatuation
	      	{
		   print "<p><i><b>Note:</b> This spell requires a special component besides the base component: A lock of hair from the person the caster wishes the target to fall in love with (a lock of the loved one's hair).  Please make sure you get this component from the caster.</i></p>\n";	      	   
	      	}
	}
	
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<input type=\"hidden\" name=\"abid\" value=\"$abid\">\n";
	print "<input type=\"hidden\" name=\"mymana\" value=\"$mymana\">\n";
	print "<input type=\"hidden\" name=\"step\" value=\"5\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Create New Component\">   ";
	print "<input type=\"submit\" name=\"submit\" value=\"Go To Confirmation\"><BR>";
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<H1>Preparing Spells</h1>\n";
	
	print "<p><i>This page is for assistant/floor GMs to prep spells.  If you need help working this page, find a GM.</i></p>\n";

	print "<form action=\"$thispage\" method=\"post\">";

	print "<h2>Step 1</h2>\n";
	
	print "<p><i>Select the caster from the list below.  This is a list of all player characters with STATs.  If a group of players are working together to cast the spell, then have them choose one to be the caster.  If the caster isn't on this list, then fetch a GM.</i></p>\n";
	
	print createCharDrop() ."<BR>\n";

	print "<h2>Step 2</h2>\n";
	
	print "<p><i>Select the spell from the list below.  If the spell is not on the list, then it requires a GM to prep it.  Stop and fetch a GM.</i></p>\n";
	
	print createSpellDrop() ."<BR>\n";

	print "<h2>Step 3</h2>\n";
	
	print "<p><i>Enter the total MANA being spent on the spell.  This includes bonuses, enchanted items, bonuses from location, bonuses from time, and willpower conversions (players may take 2 blue stars of fatigue to add 1 MANA.  Blue stars of fatigue go away at the rate of one every 10 minutes).</i></p>\n";
	
	print "<p>Total MANA Spent: <input type=text size=5 name=mymana value=0></p>\n";
	
	print "<p><i>Keep in mind the following notes on MANA.</i></p>\n";
	print "<ul>\n";
	print "<li>  The caster <b>must</b> put one MANA into the spell, either from his/er own personal stash or by taking 2 Blue Stars of fatigue.\n";
	print "<li>  They get a +1 to MANA if it is between midnight at 1 AM. Do not mention this to the players; they might not know.\n";
	print "<li>  They get a bonus to MANA if casting in a Power Spot.  Do not mention power spots to the players.  If they say the are in a power spot, then give them the bonus.  They might not even know what a power spot is.\n";
	print "<li>  They get a bonus to MANA if casting in Unhallowed Ground.  Do not mention unhallowed ground to the players.  If they say the are in unhallowed ground, then give them the bonus.  They might not even know what unhallowed ground is.\n";
	print "<li>  Players may overspend on MANA.  This might help them.\n";
	print "<li>  Players may take 2 blue stars of fatigue to add 1 MANA.  Blue stars of fatigue go away at the rate of one every 10 minutes.\n";
	print "<li>  You do not need to know their stats.  The database takes care of that.\n";
	print "</ul>\n";

	print "<input type=\"hidden\" name=\"step\" value=\"4\"><BR>";
	print "<input type=\"submit\" name=\"submit\" value=\"Go To Step 4\"><BR>";
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
exit 0;

sub createCharDrop
{
    local ($db) = dbconnect();
    $SQL = "select a.charid, concat(a.cfirst, ' ', a.clast), a.ctitle from characters a,  characterSTATs b where a.charid=b.charid and a.chartype != $test_character and a.charid > 0 order by a.clast;";
 
    local($query) = $db->prepare($SQL);
    #print "$SQL<BR>";
    $query->execute;

    local ($retVal) = "";
    if ($query->rows > 0)
    {
        $retVal = "<select name=\"charid\">\n";
        while (@array = $query->fetchrow_array)
        {
            $retVal .= "<option value=\"$array[0]\">$array[1]";
            if ($array[2] ne "")
            {
            	$retVal .= ", $array[2]";
            }
            
            $retVal .= "</option>\n";
        }
        $retVal .= "</select>\n";
    }
    $query->finish;
    $db->disconnect;
    return "$retVal";
}

sub createSpellDrop
{
    local ($db) = dbconnect();
    $SQL = "select a.abid, a.name from abilities a, spellspecifics b where a.abid=b.abid order by a.name;";
 
    local($query) = $db->prepare($SQL);
    #print "$SQL<BR>";
    $query->execute;

    local ($retVal) = "";
    if ($query->rows > 0)
    {
        $retVal = "<select name=\"abid\">\n";
        while (@array = $query->fetchrow_array)
        {
            $retVal .= "<option value=\"$array[0]\">$array[1]</option>\n";
        }
        $retVal .= "</select>\n";
    }
    $query->finish;
    $db->disconnect;
    return "$retVal";
}

sub handlespell()
{
   local($resstr) = "<center><font size=+3><BR>Spell failed.<BR><BR>No effect.<BR><BR></font></center>";

   #did they meet the mana cost? 
   local ($cost) = $basemanacost + ($manaperlevel * $mylevel)+ dosql("select manacostmod from spellcomponentslink where abid=$abid and scid=$scid;");
   $cost = handlecost($cost);
   $cost = max($cost,1);
   
   if ($alive > 0)
   {
      $mymana += 5;
   }
   
   if ($casters > 0)
   {
      $mymana *= 3;
   }
   
   #print "cost = $cost; spent = $mymana<BR>";
   
   if ($mymana < $cost)
   {
      return ($resstr);
   }
   
   #5% chance of failure
   $num = int(rand(100)) + getlevel("RITUAL KNOWLEDGE") + ($mymana - $cost);
   
   if ($num < 5)
   {
      return ($resstr);
   }
   
   #if they don't know the spell, 80% chance of failure
   if (hasability($abname) == 0 && $num < 80)
   {
      return ($resstr);
   }
   
   #some components just cause failure.
   $val = dosql("select spellfails from spellcomponentslink where abid=$abid and scid=$scid;");
   if ($val > 0)
   {
      $num = dosql("select a.sclid from spellcomponentscharacterlink a, spellcomponentslink b where a.charid=$charid and b.scid=$scid and a.sclid=b.sclid and b.abid=$abid") + 0;
      if ($num == 0)
      {
      	$resstr .= "<b>Congratulations!</b>  You have learned what the component, $scname, does to this spell.</b><BR><BR>";
      	$num = dosql("select sclid from spellcomponentslink b where scid=$scid and abid=$abid") + 0;
      	dosql("insert into spellcomponentscharacterlink (charid,sclid) values ($charid,$num);");
      }
      return ($resstr);

   }
   
   $sideeffects = "";
   #handle side effects 
   $sideeffects = handlesideeffects();   
   
   #5% chance of additional problem.
   if ($num < 10)
   {
     $sideeffects .= randomeffects();
   }

   $table = "abilities";
   filltable();
   
   $resstr = "<H1>$abname</h1>\n";
   $resstr .= "<b>Effect:</b> $effect<BR><BR>\n";
   if ($challenge ne "Unchallenged")
   {
      $resstr .= "<b>This Spell Must be Challenged.  Roll:</b><BR>";
      $resstr .= displaychallenge();
      $resstr .= "<BR><BR>";
   }
   $resstr .= "<b>Other Constraints:</b> $other_constraints<BR><BR>\n";
   if ($sideeffects ne "")
   {
      $resstr .= "<i>This spell has side effects.  These side effects override anything said in effects or other constraints.  Side effects that modify your roll are cumultive and have not been added in.</i><BR>\n";
      $resstr .= "<b>Side Effects:</b> $sideeffects<BR><BR>\n";
   }
   
   if (hasability($abname) == 0)
   {
      $resstr .= "<b>Congratulations!</b>  You have learned to cast this spell.  You may spend XP to perfect it between games and drastically lower your chance of failure!</b><BR><BR>";
      $num = dosql("select abid from charabilityallowed where charid=$charid and abid=$abid;") + 0;
      if ($num == 0)
      {
         dosql("insert into charabilityallowed (charid,abid) values ($charid,$abid);");
      }
      
   }
   
   $num = dosql("select a.sclid from spellcomponentscharacterlink a, spellcomponentslink b where a.charid=$charid and b.scid=$scid and a.sclid=b.sclid and b.abid=$abid") + 0;
   if ($num == 0)
   {
      $resstr .= "<b>Congratulations!</b>  You have learned what the component, $scname, does to this spell.</b><BR><BR>";
      $num = dosql("select sclid from spellcomponentslink b where scid=$scid and abid=$abid") + 0;
      dosql("insert into spellcomponentscharacterlink (charid,sclid) values ($charid,$num);");
   }

      
   return ($resstr);
}


sub displaychallenge()
{
    local ($retstr) = "";
    local ($level) = getlevel($abname);
    $retstr .= $challenge . " vs. " . $challenge_defense;
    if ($challenge eq "5 + Ability Level")
    {
	$retstr .= "<BR>";
	$num = 5 + $level;
	$retstr .= "<i>$num vs. "  . $challenge_defense. "</i>";
    }
    if ($challenge eq "DEX + Ability Level")
    {
	$retstr .= "<BR>";
	$num = $dex + $level;
	$retstr .= "<i>$num vs. "  . $challenge_defense. "</i>";
    }
    if ($challenge eq "DEX - Ability Level")
    {
	$retstr .= "<BR>";
	$num = $dex - $level;
	$retstr .= "<i>$num vs. "  . $challenge_defense. "</i>";
    }
    if ($challenge eq "IQ - Ability Level")
    {
	$retstr .= "<BR>";
	$num = $iq - $level;
	$retstr .= "<i>$num vs. "  . $challenge_defense. "</i>";
    }
    if ($challenge eq "IQ + Ability Level")
    {
	$retstr .= "<BR>";
	$num = $iq + $level;
	$retstr .= "<i>$num vs. "  . $challenge_defense. "</i>";
    }
    if ($challenge eq "Library Use + Ability Level")
    {
	$retstr .= "<BR>";
	$num = $libuse + $level;
	$retstr .= "<i>$num vs. "  . $challenge_defense. "</i>";
    }
    if ($challenge eq "STR + Ability Level")
    {
	$retstr .= "<BR>";
	$num = $str + $level;
	$retstr .= "<i>$num vs. "  . $challenge_defense. "</i>";
    }
    if ($challenge eq "STR - Ability Level")
    {
	$retstr .= "<BR>";
	$num = $str - $level;
	$retstr .= "<i>$num vs. "  . $challenge_defense. "</i>";
    }
    if ($challenge eq "WILL - Ability Level")
    {
	$retstr .= "<BR>";
	$num = $will - $level;
	$retstr .= "<i>$num vs. "  . $challenge_defense. "</i>";
    }
    if ($challenge eq "WILL + Ability Level")
    {
	$retstr .= "<BR>";
	$num = $will + $level;
	$retstr .= "<i>$num vs. "  . $challenge_defense. "</i>";
    }
    if ($challenge eq "STR + Unarmed Combat")
    {
	$retstr .= "<BR>";
	$num = $str + getlevel("UNARMED/CLOSE WEAPONS");
	$retstr .= "<i>$num vs. "  . $challenge_defense. "</i>";
    }
    if ($challenge eq "DEX + Ranged Weapons")
    {
	$retstr .= "<BR>";
	$num = $dex + getlevel("RANGED/THROWN WEAPONS");
	$retstr .= "<i>$num vs. "  . $challenge_defense. "</i>";
    }
    if ($challenge eq "Status + Ability Level")
    {
	$retstr .= "<BR>";
	$num = $status + $level;
	$retstr .= "<i>$num vs. "  . $challenge_defense. "</i>";
    }
    
    return $retstr;
}

sub handlesideeffects()
{
   local($str) = "";
   
   $val = dosql("select displaysideeffect from spellcomponentslink where abid=$abid and scid=$scid;");
   if ($val == 0)
   {
      return ($str);
   }

   $sql = "select sideeffect from spellcomponentslink where abid=$abid and scid=$scid;";
   #print "$sql<BR>\n";
   
   $str = dosql($sql);

   return $str;
}

sub randomeffects()
{
   local($str) = "";
   
   
   return $str;
}

sub getmycomponents()
{
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select a.sclid, b.scname, a.sideeffect, a.scid from spellcomponentslink a, spellcomponents b where a.scid=b.scid and a.abid=$abid order by b.scname;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Name</b></td>\n";
	$retstr .= "<td><b>Side Effect</b></td>\n";
	$retstr .= "</tr>\n";
	local ($num) = 0;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $retstr .= "<tr>\n";
	   $retstr .= "<td>".$resptr->{"scname"}."</td>\n";
	   $retstr .= "<td>".$resptr->{"sideeffect"}."</td>\n";
	   $retstr .= "</tr>\n";
	   $num++;
	}
	$retstr .= "</table>\n";
	$retstr .= "<input type=hidden name=num_abs value=$num>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}

sub handlecost()
{
   local($hcost) = $_[0];

   #print "manacostspecial=$manacostspecial<BR>";
   if ($manacostspecial eq "CHECKED")
   {
      if ($abid == 190)  #power stat
      {
          $hcost = 0;
          for ($i = 1; $i <= $mylevel; $i++)
          {
             $hcost += $i;
          }
      }
      
      if ($abid == 231) #summon
      {
          $hcost = $mana_special;
      }
   
   }
   
   
   return $hcost;
}


sub handlepreptime()
{
   local($hct) = $_[0];

   if ($timetoprepspecial eq "CHECKED")
   {
      if ($abid == 190)  #power stat
      {
          $hct = $mymana * 10;
      }
      
      if ($abid == 220) #infatuation
      {
	   print "<p><i><b>Note:</b> This spell requires a special component besides the base component: A lock of hair from the person the caster wishes the target to fall in love with (a lock of the loved one's hair).  Please make sure you get this component from the caster and that you note on the paper to go in the envelope who the loved one is.</i></p>\n";	      	   
      }

   }
   
   
   return $hct;
}

