#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "servicecredits.pl";  	#Name of this web page
$tabnum = $CGI->param("tabnum");
if ("$tabnum" eq '' && $pid > 0)
{
	$tabnum = dosql("select tabnum from pagedefaults where playerid=$plid and pageid='$thispage';") + 0;
}
elsif ($pid > 0)
{
	setTabNum($thispage,$pid,$tabnum)
}
else
{
	$tabnum = 0;
}

$table[0] = "service_credits";  		#table you're editing
$table[1] = "playerSC";
$table[2] = "service_credits";  		#table you're editing
$heading[0] = "Service Credit";		#textual description, for example, "A parsnip"
$heading[1] = "Player/Service Credit";	#textual description, for example, "A parsnip"
$heading[2] = "Service Credit Report";	#textual description, for example, "A parsnip"
$keyfield[0] = "scid";	#name of the primary key field of the table.
$keyfield[1] = "pscid";	#name of the primary key field of the table.
$keyfield[2] = "scid";	#name of the primary key field of the table.
$keyvalue = $CGI->param($keyfield[$tabnum]);	
$namefield[0] = "name";	#the name of the name field for the table.
$namefield[1] = "";	#the name of the name field for the table.
$namefield[2] = "name";	#the name of the name field for the table.
$namevalue[0] = dosql("select $namefield[$tabnum] from $table[$tabnum] where $keyfield[$tabnum]=$keyvalue;");
$nv1 = getFullNameFromID(dosql("select playerid from $table[$tabnum] where $keyfield[$tabnum]=$keyvalue;"));
$nv2 = dosql("select b.name from playerSC a, service_credits b where a.scid=b.scid and a.$keyfield[$tabnum]=$keyvalue;");
$namevalue[1] = "$nv1/$nv2";
$namevalue[2] = dosql("select $namefield[$tabnum] from $table[$tabnum] where $keyfield[$tabnum]=$keyvalue;");
$tplfile[0] = "";	#File to make specfic editing look good.
$tplfile[1] = "servicecredits.tpl";	#File to make specfic editing look good.
$tplfile[2] = "";	#File to make specfic editing look good.
$showDataFunc[0]=\&showCredits;
$showDataFunc[1]=\&showPlayers;
$showDataFunc[2]=\&showReport;
$fillVarsFunc[0]=\&fillvars;
$fillVarsFunc[1]=\&fillvars;
$fillVarsFunc[2]=\&fillvars;
$errstr = $CGI->param("error");

@tabheadings = { "", "" };
$tabheadings[0] = "Manage Credits";
$tabheadings[1] = "Manage Players";
$tabheadings[2] = "Credit Report";
$numtabs = 3;

if ($al < $gm_access)
{
	$numtabs = 2;
	$tabheadings[0] = "Show All Credits";
	$tabheadings[1] = "Show Your Credits";
	$showDataFunc[1]=\&showYourCredits;

	print $CGI->header;
	$doctitle = $heading[$tabnum]."s";
	ParseForm($header);
	ParseForm("tabs.tpl");
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle </h1>\n";
	
	if ($pid > 0)
	{
		showTabs();
	}

	$tmpFunc = $showDataFunc[$tabnum];
	&$tmpFunc();
	
	if ($pid == 0)
	{
		print "<br><hr><a href=\"login.pl\">Log In</a>.";
	}
	else
	{
		print "<br><hr><a href=\"main.pl\">Main Menu</a>.";
	}
		
	ParseForm($footer);
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	if ($keyvalue eq "")
	{
		$doctitle = "Add $heading[$tabnum]";
	}
	else
	{
        	$doctitle = "Edit $namevalue[$tabnum]";
	}
	ParseForm($header);
     	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";
	if ($tplfile[$tabnum] eq "")
	{
		local($db) = dbconnect();
		local($query) = $db->prepare("explain $table[$tabnum]");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $db->prepare("select * from $table[$tabnum] where $keyfield[$tabnum] = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$db->disconnect;
		print "</table>";
	}
	else
	{
	     $tmpFunc = $fillVarsFunc[$tabnum];
	     &$tmpFunc();
	     ParseForm($tplfile[$tabnum]);
	}
	print "<input type=\"hidden\" name=\"tabnum\" value=\"$tabnum\">\n";
	print "<input type=\"hidden\" name=\"$keyfield[$tabnum]\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	$sql = filltablefromCGI($table[$tabnum], 1, $keyfield[$tabnum], $keyvalue[$tabnum]);
	#print "$sql<BR>";
	local($db) = dbconnect();
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading[$tabnum] Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$sql = filltablefromCGI($table[$tabnum], 0, $keyfield[$tabnum], $keyvalue[$tabnum]);
	#print "$sql<BR>";
	local($db) = dbconnect();
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue[$tabnum] Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$sql<BR>";
	local($db) = dbconnect();
	$sql = "delete from $table[$tabnum] where $keyfield[$tabnum] = $keyvalue;";
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue[$tabnum] Deleted"));
}
elsif ($action eq "doc")
{
	print $CGI->header(-type  =>  'application/msword', -filename  =>  'chargroups.doc');
	$db = dbconnect();
	local ($sql) = "select a.playerid from players a join eventplayers b on a.playerid=b.playerid where b.reglevel >= $registered and eventid=$current_episode order by a.plast;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);

	while (@array = $query->fetchrow_array())
	{
	   $playerid = $array[0];
	   getServiceCredits($playerid);
	   print "<BR>[PB]<BR>\n";
	}

	$query->finish;
	$db->disconnect;
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading[$tabnum]."s";
	
	if ($tabnum == 2)
	{
		$doctitle = "Service Credit Report";
	}
	
	ParseForm($header);
	ParseForm("tabs.tpl");
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle </h1>\n";
	
	showTabs();

	if ($tabnum != 2)
	{
		print "<a href=\"$thispage?action=new\">ADD a NEW $heading[$tabnum]</a><BR><BR>\n";
	}
	else
	{
		print "<a href=\"$thispage?action=doc\">Get this report as a Word Document</a><BR><BR>\n";
	}
	
	$tmpFunc = $showDataFunc[$tabnum];
	&$tmpFunc();
	
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield[$tabnum]=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showTabs()
{
	local ($tottabs) = 1;
	print "<table>\n";
	print "<tr>\n";
	
	for ($i = 0; $i < $numtabs; $i++)
	{
	      if ($tabnum == $i)
	      {
		   print "<td class=\"blacktab\">$tabheadings[$i]</td>\n";
	      }
	      else
	      {
		   print "<td class=\"greytab\" OnClick=\"document.location ='$thispage?tabnum=$i'\">$tabheadings[$i]</td>\n";
	      }
	      $tottabs = $tottabs + 1;
	      if ($tottabs % 7 == 0)
	      {
	    	print "</tr><tr>\n";
	      }
	}
	print "</tr>\n";
	print "</table>\n";
}

sub showCredits()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table[$tabnum] order by $namefield[$tabnum];";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Value</b></td>\n";
	print "<td><b>Notes</b></td>\n";
	if ($al >= $gm_access)
	{
		print "<td><b>Action</b></td>\n";
	}
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield[$tabnum]"};
	   $key = $resptr->{"$keyfield[$tabnum]"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>\$".$resptr->{"value"}.".00</td>\n";
	   print "<td>".$resptr->{"notes"}."</td>\n";
	   if ($al >= $gm_access)
	   {
		   print "<td>";
		   print "<a href=\"$thispage?action=edit&$keyfield[$tabnum]=$key\">Edit</a>\n";
		   $name =~ s/'//g;
		   print " -- <a href=\"javascript:deleteConfirm('$name',$key);\">Delete</a>\n";
		   print "</td></tr>\n";
	   }
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}


sub showPlayers()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table[$tabnum] where eventid=$current_episode order by playerid, entrydate;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Player</b></td>\n";
	print "<td><b>Credit</b></td>\n";
	print "<td><b>Value</b></td>\n";
	print "<td><b>Event</b></td>\n";
	print "<td><b>Notes</b></td>\n";
	print "<td><b>Date</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $key = $resptr->{"$keyfield[$tabnum]"};
	   $playername = getFullNameFromID($resptr->{"playerid"});
	   if ($resptr->{"scid"} > 0)
	   {
		   $credit = dosql("select name from service_credits where scid=".$resptr->{"scid"}.";");
		   $value = dosql("select value from service_credits where scid=".$resptr->{"scid"}.";");
	   }
	   else
	   {
		   $credit = "Other";
		   $value = $resptr->{"value"};
	   }
	   $notes = $resptr->{"notes"};
	   $entrydate = $resptr->{"entrydate"};
	   $eventname = dosql("select eventname from events where eventid = ".$resptr->{"eventid"}.";");
	   print "<tr>\n";
	   print "<td>$playername</td>\n";
	   print "<td>$credit</td>\n";
	   print "<td>\$$value.00</td>\n";
	   print "<td>$eventname</td>\n";
	   print "<td>$notes</td>\n";
	   print "<td>$entrydate</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield[$tabnum]=$key\">Edit</a>\n";
	   $name = "$playername/$credit";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('$name',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub showYourCredits()
{
	local($db) = dbconnect();
	local (%sum);
	local ($smallsum) = 0;
	
	local ($sql) = "select * from $table[$tabnum] where playerid=$pid and eventid=$current_episode order by eventid, entrydate;";
	$playername = getFullNameFromID($pid);
	$eventname = dosql("select eventname from events where eventid=$current_episode;");
	print "<H2>Service Credits for $playername for $eventname</H2>\n";
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Credit</b></td>\n";
	print "<td><b>Value</b></td>\n";
	print "<td><b>Notes</b></td>\n";
	print "<td><b>Date</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $key = $resptr->{"$keyfield[$tabnum]"};
	   if ($resptr->{"scid"} > 0)
	   {
		   $credit = dosql("select name from service_credits where scid=".$resptr->{"scid"}.";");
		   $value = dosql("select value from service_credits where scid=".$resptr->{"scid"}.";");
	   }
	   else
	   {
		   $credit = "Other";
		   $value = $resptr->{"value"};
	   }
	   $notes = $resptr->{"notes"};
	   $entrydate = $resptr->{"entrydate"};
	   print "<tr>\n";
	   print "<td>$credit</td>\n";
	   print "<td>\$$value.00</td>\n";
	   print "<td>$notes</td>\n";
	   print "<td>$entrydate</td>\n";
	   print "</tr>\n";
	   $smallsum += $value;
	}
	print "<tr>\n";
	print "<td><i>Sum</i></td>\n";
	print "<td><i>\$".$smallsum.".00</i></td>\n";
	print "<td colspan=3><i>$eventname</i></td>\n";
	print "</tr>\n";
	print "</table>\n";
	$query->finish;

	
	$sql = "select * from $table[$tabnum] where playerid=$pid order by eventid, entrydate;";
	#print "$sql<BR>";  
	$query = $db->prepare($sql);
	$query->execute;
	print "<H2>Service Credits for $playername for all episodes</H2>\n";
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Credit</b></td>\n";
	print "<td><b>Value</b></td>\n";
	print "<td><b>Event</b></td>\n";
	print "<td><b>Notes</b></td>\n";
	print "<td><b>Date</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $key = $resptr->{"$keyfield[$tabnum]"};
	   if ($resptr->{"scid"} > 0)
	   {
		   $credit = dosql("select name from service_credits where scid=".$resptr->{"scid"}.";");
		   $value = dosql("select value from service_credits where scid=".$resptr->{"scid"}.";");
	   }
	   else
	   {
		   $credit = "Other";
		   $value = $resptr->{"value"};
	   }
	   $notes = $resptr->{"notes"};
	   $entrydate = $resptr->{"entrydate"};
	   $eventname = dosql("select eventname from events where eventid = ".$resptr->{"eventid"}.";");
	   print "<tr>\n";
	   print "<td>$credit</td>\n";
	   print "<td>\$$value.00</td>\n";
	   print "<td>$eventname</td>\n";
	   print "<td>$notes</td>\n";
	   print "<td>$entrydate</td>\n";
	   print "</tr>\n";
	   $sum{$eventname} += $value;
	}
	
	foreach $eventname (sort keys %sum)
	{
	   print "<tr>\n";
	   print "<td><i>Sum</i></td>\n";
	   print "<td><i>\$".$sum{$eventname}.".00</i></td>\n";
	   print "<td colspan=3><i>$eventname</i></td>\n";
	   print "</tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub showReport()
{
	$db = dbconnect();
	local ($sql) = "select a.playerid from players a join eventplayers b on a.playerid=b.playerid where b.reglevel >= $registered and eventid=$current_episode order by a.plast;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);

	while (@array = $query->fetchrow_array())
	{
	   $playerid = $array[0];
	   getServiceCredits($playerid);
	}

	$query->finish;
	$db->disconnect;
}

sub getServiceCredits()
{
	local ($pid) = $_[0];
   	
	local ($sum) = 0;
	local ($sql) = "select * from playerSC where playerid=$pid and eventid=$current_episode order by entrydate;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;

	local ($playername) = getFullNameFromID($pid);
	print "<H2>Service Credits for $playername</H2>\n";
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Credit</b></td>\n";
	print "<td><b>Value</b></td>\n";
	print "<td><b>Notes</b></td>\n";
	print "<td><b>Date</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $key = $resptr->{"scid"};
	   if ($resptr->{"scid"} > 0)
	   {
		   $credit = dosql("select name from service_credits where scid=".$resptr->{"scid"}.";");
		   $value = dosql("select value from service_credits where scid=".$resptr->{"scid"}.";");
	   }
	   else
	   {
		   $credit = "Other";
		   $value = $resptr->{"value"};
	   }
	   $notes = $resptr->{"notes"};
	   $entrydate = $resptr->{"entrydate"};
	   print "<tr>\n";
	   print "<td>$credit</td>\n";
	   print "<td>\$$value.00</td>\n";
	   print "<td>$notes</td>\n";
	   print "<td>$entrydate</td>\n";
	   print "</tr>\n";
	   $sum += $value;
	}

	$eventname = dosql("select eventname from events where eventid = $current_episode;");
	print "<tr>\n";
	print "<td><i>Sum</i></td>\n";
	print "<td><i>\$".$sum.".00</i></td>\n";
	print "<td colspan=3><i>$eventname</i></td>\n";
	print "</tr>\n";
	print "<tr>\n";

	$balance = dosql("select balance from eventplayers where playerid=$playerid and eventid=$current_episode;");
	print "<td><i>Pre-Balance</i></td>\n";
	print "<td><i>\$".$balance.".00</i></td>\n";
	print "<td colspan=3><i>This is your balance without service credits.</i></td>\n";
	print "</tr>\n";

	$total = $balance - $sum;
	if ($total < 0) {
		$total = 0;
	}
	print "<td><i>Final Balance</i></td>\n";
	print "<td><i>\$".$total.".00</i></td>\n";
	print "<td colspan=3><i>This is how much you owe.  Please pay at the door.</i></td>\n";
	print "</tr>\n";

	print "</table>\n";

	$query->finish;
}

sub fillvars()
{
	goodfilltable($table[$tabnum], $keyfield[$tabnum], $keyvalue);
	$entrydate = dosql("select now();");
	$playerdrop = makeDropDown("players order by plast", "playerid", "concat(pfirst, \" \", plast) as playerid", "", "", $playerid);
	$scdrop = makeDropDown("service_credits order by name", "scid", "name", "", "", $scid);
	if ($scid == 0)
	{
		$scdrop =~ s|</select>|<option value="0" SELECTED>Other</option>\n</select>|g;
	}
	else
	{
		$scdrop =~ s|</select>|<option value="0">Other</option>\n</select>|g;
	}
	
	$scdrop =~ s|name="scid">|name="scid" onchange="setValue(this.value)">|g;
	
	$eventdrop = makeDropDown("events order by eventname", "eventid", "eventname", "", "", $eventid);

	print "<script language=\"javascript\">\n";
	print "var myvalues = new Array();\n";
	
	local($db) = dbconnect();
	local($sql) = "select scid, value from service_credits order by scid";
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
		print "myvalues[".$resptr->{"scid"}."] = \"\$".$resptr->{"value"}.".00\";\n";
	}
	$query->finish;
	$db->disconnect;
	
	print "</script>\n";

}

