#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$pid = getPlayerID();
$al = getAccessLevel($pid);
$plid = $CGI->param("plid");
$action = $CGI->param("action");

#globals for this file
$thispage = "showreg.pl";
$table = "eventplayers";
$keyfield = "epid";
$keyvalue = $CGI->param($keyfield);
$namefield = dosql("select playerid from $table where $keyfield=$keyvalue;");
$namevalue = getFullNameFromID($namefield);
$errstr = $CGI->param("error");

$tabnum = $CGI->param("tabnum") + 0;
if ($tabnum == 0)
{
	$tabnum = dosql("select tabnum from pagedefaults where playerid=$plid and pageid='$thispage';") + 0;
	if ($tabnum == 0)
	{
		$tabnum = dosql("select eventid from events order by eventstart desc;") + 0;
		setTabNum($thispage,$pid,$tabnum)
	}
}
else
{
	setTabNum($thispage,$pid,$tabnum)
}
	

$numpriority = 5;

$prioritytext[0] = "GMs and Tech.";
$prioritytext[1] = "Those who played or cast in the previous episode.";
$prioritytext[2] = "Those who paid for the previous episode but could not attend.";
$prioritytext[3] = "Those who had approved characters in the database prior to this episode, did not pay or attend.";
$prioritytext[4] = "All others.";
$prioritytext[5] = "Cast.";
	
if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to view player registration!"));
}
if ($action eq "confirm")
{
	print $CGI->header();
	ParseForm($header);
	local($eventid) = $CGI->param("eventid");
	$eventname = dosql("select eventname from events where eventid=$eventid");
	print "<H1>Confirm ".getFullNameFromID($plid)." for $eventname</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"plid\" value=\"$plid\">\n";
	print "<input type=\"hidden\" name=\"eventid\" value=\"$eventid\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"doconfirm\">\n";
	print "<input type=\"hidden\" name=\"tabnum\" value=\"$tabnum\">\n";
	print "<p>Set Balance: \$<input type=\"text\" name=\"balance\" value=\"0.0\" size=10><br>\n";
	print "<i>Balance is the amount they still owe.</i><BR><BR>\n";
	print "Set Priority: <input type=\"text\" name=\"priority\" value=\"1\" size=10><br>\n";
	for ($i = 0; $i <= $numpriority ; $i++)
	{
	  print "<i>Priority $i: $prioritytext[$i]</i><BR>\n";
	}
	print "</p><input type=\"submit\" name=\"submit\" value=\"Confirm\">\n";
	print "</form>\n";
	print "<br><br><a href=\"login.pl\">Database Main Menu</a><hr><br>";
	ParseForm($footer);
}
elsif ($action eq "update")
{

	print $CGI->header();
	ParseForm($header);
	filltable();
	$eventname = dosql("select eventname from events where eventid=$tabnum");
	print "<H1>Update ".getFullNameFromID($playerid)." for $eventname</H1>\n";
	print "<form action=\"showreg.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"epid\" value=\"$epid\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"setbalance\">\n";
	print "<input type=\"hidden\" name=\"tabnum\" value=\"$tabnum\">\n";
	print "Set Balance: \$<input type=\"text\" name=\"balance\" value=\"$balance\" size=10><br>\n";
	print "<i>Balance is the amount they still owe.</i><BR><BR>\n";
	$pridrop = makeArrayDropDown(\@prioritytext, "priority", [$prioritytext[$priority]], "", 1);
	print "Set Priority: $pridrop<BR><BR>\n";		
	$reglevdrop = makeArrayDropDown(\@player_registration, "reglevel", [$player_registration[$reglevel]], "", 1);
	print "<BR>Set Registration Level: $reglevdrop<BR><BR>";
	print "<input type=\"submit\" name=\"submit\" value=\"Update\">\n";
	print "</form>\n";
	print "<br><br><a href=\"login.pl\">Database Main Menu</a><hr><br>";
	ParseForm($footer);
}
elsif ($action eq "regevent")
{
	print $CGI->header();
	ParseForm($header);
	print "<H1>Register For Event: ".getFullNameFromID($plid)."</H1>\n";
	print "<form action=\"showreg.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"plid\" value=\"$plid\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"doreg\">\n";
	print "Choose Event: ";
	print 	makeDropDown("events", "eventid", "eventname");
	print "<input type=\"submit\" name=\"submit\" value=\"Register\">\n";
	print "</form>\n";
	print "<br><br><a href=\"login.pl\">Database Main Menu</a><hr><br>";
	ParseForm($footer);
}
elsif ($action eq "setbalance")
{
	 $balance = $CGI->param("balance");
	 $priority = $CGI->param("priority");
	 $reglevel = $CGI->param("reglevel");
	 $tabnum = $CGI->param("tabnum");
	 local($sql) = "update eventplayers set balance=$balance, priority=$priority, reglevel=$reglevel where $keyfield=$keyvalue";
	 dosql($sql);

	 print $CGI->redirect("$thispage?tabnum=$tabnum&error=" . encodeURL("$namevalue updated"));
}
elsif ($action eq "doconfirm")
{
	$pid = getPlayerID();
	$plid = $CGI->param("plid");
	$fullname = getFullNameFromID($plid);
	$email = getEmailFromID($plid);
	$eventid = $CGI->param("eventid");
	$balance = $CGI->param("balance");
	$priority = $CGI->param("priority");
	$tabnum = $CGI->param("tabnum");

	local($SQL) = "update eventplayers set reglevel=$confirmed, priority=$priority, balance=$balance where playerid=$plid and eventid=$eventid;";
	dosql($SQL);
	$eventname = dosql("select eventname from events where eventid=$eventid");

	#print $CGI->header();
	#print "pid=$pid<BR>";
	#print "fullname=$fullname<BR>";

	# Retrieve Date
	$date = getDate();
	print "$date<BR>";

	# Send E-Mail
	open(MAIL, "| /usr/sbin/sendmail -oi -t") or print "couldn't send mail: $!<BR>";
	print MAIL "From: $contact\n";
	print MAIL "To: $gmlist\n";
	print MAIL "Cc: $email\n";
	print MAIL "Subject: $fullname is confirmed for $campaign\n";
	print MAIL "\n";
	print MAIL "$fullname has been confimed for the $campaign Event: $eventname.\n";
	if ($balance > 0)
	{
	print MAIL "\n";
	print MAIL "You still owe a balance of: \$$balance.\n";
	print MAIL "Balance due by three months before the start of the event.\n";
	print MAIL "\n";
	}
	print MAIL "Congratulations.\n";
	print MAIL "Today's date: $date\n";
	print MAIL "---------------------------------------------------------------------------\n";
	close(MAIL);

	#print "done<br>";

	# Return HTML Page or Redirect User
	print $CGI->redirect("$thispage?tabnum=$eventid&error=" . encodeURL(getFullNameFromID($plid)." registered."));
}
elsif ($action eq "doreg")
{
	#print $CGI->header();
	 local($eventid) = $CGI->param("eventid");
	 local($SQL) = "insert into eventplayers (eventid, playerid, reglevel) values ($eventid, $plid, 2);";
	 #print "$SQL<BR>\n";
	 dosql($SQL);
	 print $CGI->redirect("$thispage?tabnum=$eventid&error=" . encodeURL(getFullNameFromID($plid)." registered."));
}
elsif ($action eq "setroom")
{
	local($eventid) = $CGI->param("eventid");
	local($SQL) = "update eventplayers set hasroom=".$CGI->param("room")." where playerid=$plid and eventid=$eventid";
	#print "$SQL<BR>\n";
	$db->do($SQL);
	print $CGI->redirect("$thispage?tabnum=$eventid&error=" . encodeURL(getFullNameFromID($plid)." update."));
}
elsif ($action eq "dumpemail")
{
	local($resptr);
	local($eventid) = $CGI->param("eventid");
	print $CGI->header();
	ParseForm($header);
        $db = dbconnect();
	local($sql) = "select * from events where eventid = $eventid";
        local($query) = $db->prepare($sql);
        $query->execute;
        $resptr = $query->fetchrow_hashref();
	print "<H1>Emails for ".$resptr->{"eventname"}."</H1>\n";
        $query->finish;
        
	local($sql) = "select b.pemail, b.pfirst, b.plast from eventplayers a, players b where a.eventid=$eventid and (a.reglevel=$confirmed or a.reglevel=$registered) and a.playerid=b.playerid;";
	#print "$sql<BR>\n";
	$query = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
		print '"'.$resptr->{"pfirst"}.' '.$resptr->{"plast"}.'" &lt;'.$resptr->{"pemail"}.'&gt;, ';
	}
        print "<br><br><br><a href=\"login.pl\">Database Main Menu</a><hr><br>";
        $query->finish;
        $db->disconnect;	
 	ParseForm($footer);
}
else
{
       print $CGI->header();
       ParseForm($header);
       ParseForm("tabs.tpl");
	
       print "<H1>Event Registration Summary</H1>\n";
       
       $db = dbconnect();

       if ("$errstr" ne "")
       {
	  print "<font color=red><i>$errstr</i></font><BR><BR>\n";
       }
       
       showTabs();
       
       $myemail = dosql("select pemail from players where playerid=$pid;");

       local($sql) = "select * from events where eventid=$tabnum;";
       local($query) = $db->prepare($sql);
       $query->execute;
       while ($resptr = $query->fetchrow_hashref())
       {
	 if ($resptr->{"eventid"} + 0 > 0)
	 {
	     #print ($resptr->{"paypalemail"} . " vs $myemail<BR>\n");
	     $authorized = ($resptr->{"paypalemail"} eq $myemail);
	     if ($al >= $writer_access || $authorized)
   	     {
		   print "<H2>".$resptr->{"eventname"}."</H2>";

		   if ($resptr->{"eventregavailable"} == 0)
		   {
			print "This event is not open for registration.<BR>";
		   }
		   print "<a href=\"$thispage?action=dumpemail&eventid=".$resptr->{"eventid"}."\">Dump E-mails</a><BR>";

		   for (local($i) = $num_registered - 1; $i >= 0; $i -= 1)
		   {
 		   	print "<BR><b>".$player_registration[$i]." Players -- ".$resptr->{"eventname"}."</b>";          
		   	showPlayers($resptr->{"eventid"}, $i);        
		   }
	     }
	}
       }
       $query->finish;
       print "<br><br><a href=\"login.pl\">Main Menu</a><hr><br>";
       $db->disconnect;	
       ParseForm($footer);
}

#########################################################################################

sub showTabs()
{
	local ($tottabs) = 1;
	print "<table>\n";
	print "<tr>\n";
	
       	local($sql) = "select * from events order by eventstart desc;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	      local($eventid) = $resptr->{"eventid"} + 0;
	      if ($tabnum == $eventid)
	      {
		   print "<td class=\"blacktab\">".$resptr->{"eventname"}."</td>\n";
	      }
	      elsif ($resptr->{"eventregavailable"} == 0)
	      {
		   print "<td class=\"greytab\" OnClick=\"document.location ='$thispage?tabnum=$eventid'\">".$resptr->{"eventname"}."</td>\n";
	      }
	      else
	      {
		   print "<td class=\"yellowtab\" OnClick=\"document.location ='$thispage?tabnum=$eventid'\">".$resptr->{"eventname"}."</td>\n";
	      }
	      $tottabs = $tottabs + 1;
	      if ($tottabs % 7 == 0)
	      {
	    	print "</tr><tr>\n";
	      }
	}
	print "</tr>\n";
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub showPlayers()
{
   $eid = $_[0];
   $lev = $_[1];
   print "<table border=1><tr>\n";
   print "<td><b>Player</b></td>\n";
   print "<td><b>Has Hotel Room</b></td>\n";
   print "<td><b>Priority</b></td>\n";
   if ($lev == $confirmed)
   {
   	print "<td><b>Balance</b></td>\n";
   }
   if ($al >= $gm_access || $authorized)
   {
      print "<td><b>Action</b></td>\n";
   }
   print "</tr>";
   local($SQL) = "select a.* from eventplayers a, players b where a.eventid=$eid and a.reglevel=$lev and a.playerid=b.playerid order by a.priority, b.plast";
   local($query2) = $db->prepare($SQL);
   $query2->execute;
   for (local($i) = 0; $i <= $numpriority; $i++)
   {
      $pnum[$i] = 0;
   }
   local($resptr);
   while ($resptr = $query2->fetchrow_hashref())
   {
      local($plid)=$resptr->{"playerid"};
      local($hasroom)=$resptr->{"hasroom"};
      local($balance)=$resptr->{"balance"};
      local($priority)=$resptr->{"priority"};
      local($key) = $resptr->{"$keyfield"};
      print "<tr>\n";
      print "<td>".emailTagFromID($plid)."</td>\n";
      print "<td>".$yesno[$hasroom]."</td>\n";
      print "<td>$priority</td>\n";
      $pnum[$priority]++;
      if ($lev == $confirmed)
      {
        if ($balance > 0)
        {
	   print "<td>\$$balance</td>\n";
	}
	else
        {
	   print "<td>\Paid in Full</td>\n";
	}
	
      }
      print "<td>";
      if ($al >= $gm_access || $authorized)
      {
	print "<a href=\"$thispage?action=update&$keyfield=$key&tabnum=$tabnum\">Update</a>";
	if ($lev != $confirmed)
	{
	   print " -- <a href=\"showreg.pl?action=confirm&plid=$plid&eventid=$eid\">Confirm Player</a>";
	}
	if ($charcreatelevel > $player_access)
	{
	   $pqexists = dosql("select pqplayerid from playerquestionnaires where pqplayerid=$plid;") + 0;
	   if ($pqexists > 0)
	   {
	   	print " -- <a href=\"playquest.pl?mode=edit&pqplayerid=$plid\">Player Questionnaire</a>";
	   }
	   else
	   {
	   	print " -- No Player Questionnaire";
	   }
	}
      }
      print "</tr>";
   }
    print "</table>";
   $query2->finish;
   
   $ptot = 0;
   print "<p>\n";
   for (local($i) = 0; $i <= $numpriority; $i++)
   {
     print "Priority $i: $pnum[$i] players -- <i>$prioritytext[$i]</i><BR>\n";
     $ptot += $pnum[$i];
   }
   
   $ptot = $ptot - $pnum[0];
   $ptot = $ptot - $pnum[5];
   print "Total players:  $ptot<BR>\n";
   print "Total cast:  $pnum[5]</p>\n";
}

