#!/usr/bin/perl

# Require and Use
# * These statements alert perl.exe that
# * you are going to be using functions, 
# * subroutines, and methods from other
# * perl programs. "require" is used for a
# * perl library, and the "use" statement 
# * is usually used to reference a perl
# * object (usually referred to as a 
# * module).
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$pid = getPlayerID();
$charid = $CGI->param("charid");
$fullname = getFullNameFromID($pid);
$email = getEmailFromID($pid);
$charname = getCharName($charid);
$mode = $CGI->param("mode");

#print $CGI->header();
#print "$pid<BR>";
#print "$charid<BR>";
#print "$fullname<BR>";
#print "$charname<BR>";

# Retrieve Date
$date = getDate();
#print "$date<BR>";

# Send E-Mail
open(MAIL, "| /usr/sbin/sendmail  -oi -t") or die "couldn't send mail: $!";
print MAIL "From: $contact\n";
print MAIL "To: $gmlist\n";
print MAIL "Cc: $email\n";

if ($mode eq "history")
{
     print MAIL "Subject: Character history review for $charname\n";
     print MAIL "\n";
     print MAIL "$fullname is ready for a character review for $charname.\n";
     print MAIL "Today's date: $date\n";
     print MAIL "---------------------------------------------------------------------------\n";
   
     #print "done<br>";

     #update charstory
     $SQL = "update characters set charstoryapproved=1 where charid=$charid";
     local($db) = dbconnect();
     $db->do($SQL);
     $db->disconnect;
     
     $redir = "characters.pl?error=" . encodeURL("The GMs have been alerted");
}

if ($mode eq "docket")
{
     $did = $CGI->param("did");
     $dname = dosql("select dname from docket where did=$did;");
     print MAIL "Subject: Docket submission from $fullname for $dname\n";
     print MAIL "\n";
     print MAIL "$fullname (as $charname) has submitted an item for the docket entitled $dname.\n";
     print MAIL "Today's date: $date\n";
     print MAIL "---------------------------------------------------------------------------\n";

     $redir = "docketforplayers.pl?charid=$charid&error=" . encodeURL("The GMs have been alerted");

}

close(MAIL);

# Return HTML Page or Redirect User
print $CGI->redirect($redir);
