#!/usr/bin/perl

require 'stat_inc.pl';
require 'g_invest.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;
$CGI = new CGI;
	
$thispage = "bgincome.pl";
$pid = getPlayerID();
$al = getAccessLevel($pid);
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$charid = $CGI->param("charid") + 0;
   
if ($pid != getPIDFromCharID($CGI->param("charid")) && $al < $gm_access)
{
   print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to perform Between Games Income Calculations"));
}
elsif ($submit eq "Skip")
{
	$sql = "update characterSTATs set lastBGincome = -1 where charid=$charid;";
	dosql($sql);	   	
	
	$sql = "select a.charid from characterSTATs a, characters b where a.lastBGincome < $current_bgp and a.lastBGincome >= 0 and a.charid=b.charid and b.chartype<=$cast_character and a.charid > 0";
	#print "$sql<BR>\n";
	$newcharid = dosql($sql) + 0;
	print $CGI->redirect("$thispage?charid=$newcharid");
}
elsif ($action eq "update")
{
	#print $CGI->header;

	$occ_income =  $CGI->param("occ_income") + 0;
	$invest_income =  $CGI->param("invest_income") + 0;
	$taxes_income =  $CGI->param("taxes_income") * -1;
	$expense_income =  $CGI->param("expense_income") * -1;
	$vl_income =  $CGI->param("vl_income") * -1;
	$mail_str =  $CGI->param("mail_str");

	$sql = "insert into money (charid, pounds, notes, entrydate) values ($charid,$occ_income,'BG Occupation Income','";
	$sql .= getDBDate() . "');";
	dosql($sql);
	$sql = "insert into money (charid, pounds, notes, entrydate) values ($charid,$invest_income,'BG Investments Income','";
	$sql .= getDBDate() . "');";
	dosql($sql);
	$sql = "insert into money (charid, pounds, notes, entrydate) values ($charid,$taxes_income,'BG Taxes','";
	$sql .= getDBDate() . "');";
	dosql($sql);
	$sql = "insert into money (charid, pounds, notes, entrydate) values ($charid,$expense_income,'BG Expenses','";
	$sql .= getDBDate() . "');";
	dosql($sql);
	$sql = "insert into money (charid, pounds, notes, entrydate) values ($charid,$vl_income,'BG VL Cost','";
	$sql .= getDBDate() . "');";
	dosql($sql);
	
	$taxes_income =  $CGI->param("taxes_income") + 0;
	$sql = "update global_variables set level = level + $taxes_income where name='The Treasury'";
	dosql($sql);
	
	if (dosql("select a.stipend from occupations a, characteroccupations b where a.oid=b.oid and b.charid=$charid") + 0 > 0)
	{
	   $sql = "update global_variables set level = level - $occ_income where name='The Treasury'";
	   dosql($sql);
	}

	$tot =  $CGI->param("lower_tot") + 0;
	for ($i = 0; $i < $tot; $i++)
	{
	   $caid = $CGI->param("lower_$i");
	   $level = dosql("select level from characterresourcetypelink where abid=$caid and typeid=5;") + 0;
	   if ($level > 1)
	   {
	      $sql = "update characterresourcetypelink set level = level - 1 where abid=$caid and typeid=5;";
	   }
	   else
	   {
	      $sql = "update characterresourcetypelink set level = 5 where abid=$caid and typeid=5;";
	   }
	   dosql($sql);	   	   
	}

	$tot =  $CGI->param("raise_tot") + 0;
	for ($i = 0; $i < $tot; $i++)
	{
	   $caid = $CGI->param("raise_$i");
	   
	   $sql = "update characterresourcetypelink set level = level + 1 where abid=$caid and typeid=5;";
	   dosql($sql);	   	   
	}

	$tot =  $CGI->param("elminate_tot") + 0;
	for ($i = 0; $i < $tot; $i++)
	{
	   $caid = $CGI->param("eliminate_$i");
	   
	   $level = dosql("select level from characterabilities where caid=$caid;") + 0;
	   $cost = dosql("select c.diffid from characterabilities a, abilities b, abilitydifficulty c where a.caid=$caid and a.abid=b.abid and b.difficulty=c.difficulty;") - 2;
	   $cost = getcost($level, $cost);
	   
	   $sql = "delete from characterabilities where caid=$caid;";
           dosql($sql);
	   updateXP($charid,0 - $cost,"Lost a Resource");
	}


	$tot =  $CGI->param("krlower_tot") + 0;
	for ($i = 0; $i < $tot; $i++)
	{
	   $caid = $CGI->param("krlower_$i");
	   $level = dosql("select level from keyrolerresourcetypelink where abid=$caid and typeid=5;") + 0;
	   if ($level > 1)
	   {
	      $sql = "update keyrolerresourcetypelink set level = level - 1 where abid=$caid and typeid=5;";
	   }
	   else
	   {
	      $sql = "update keyrolerresourcetypelink set level = 5 where abid=$caid and typeid=5;";
	   }
	   dosql($sql);	   	   
	}

	$tot =  $CGI->param("krraise_tot") + 0;
	for ($i = 0; $i < $tot; $i++)
	{
	   $caid = $CGI->param("krraise_$i");
	   
	   $sql = "update keyrolerresourcetypelink set level = level + 1 where abid=$caid and typeid=5;";
	   dosql($sql);	   	   
	}

	$tot =  $CGI->param("vlcount") + 0;
	$vlpoints = 0;
	for ($i = 0; $i < $tot; $i++)
	{
	   $vlid = $CGI->param("vlid_$i");
	   $vltype = $CGI->param("vltype_$i");
	   
	   $sql = "update virtuallocations set $vltype = $vltype - 1 where vlid=$vlid;";
	   dosql($sql);	   	
	   $vlpoints++;
	   $sql = "select $vltype from virtuallocations where vlid=$vlid;";
	   $vllev = dosql($sql) + 0;
	   if ($vllev < 1)
	   {
	     $sql = "select vl_fancy + vl_location + vl_inventory + vl_secure from virtuallocations where vlid=$vlid;";
	     $vlpoints += dosql($sql);
	     deleteVL($vlid);
	   }
	}
	
	$tot =  $CGI->param("vlcount2") + 0;
	for ($i = 0; $i < $tot; $i++)
	{
	   $vlid = $CGI->param("vlid2_$i");
	   $vlsid = $CGI->param("vlsid_$i");
	   
	   $sql = "update VLstatlink set vlslevel = vlslevel - 1 where vlid=$vlid and charid=$charid and vlsid=$vlsid;";
	   print "$sql<BR>";
	   dosql($sql);	   	
	   $vlpoints++;
	}
   	dosql("delete from VLstatlink where vlslevel < 1;");
	
	$tot =  $CGI->param("vlcount3") + 0;
	for ($i = 0; $i < $tot; $i++)
	{
	   $vlid = $CGI->param("vlid3_$i");
	   $vla_fancy = dosql("select vla_fancy from VLaccess where vlid=$vlid and charid=$charid");
	   $vla_secure = dosql("select vla_secure from VLaccess where vlid=$vlid and charid=$charid");
	   $vla_location = dosql("select vla_location from VLaccess where vlid=$vlid and charid=$charid");
	   $vla_inventory = dosql("select vla_inventory from VLaccess where vlid=$vlid and charid=$charid");
	   $vlname = dosql("select vlname from virtuallocations where vlid=$vlid");
	   
	   $max_vla = max(max($vla_secure,$vla_fancy), max($vla_location, $vla_inventory));
	   
	   if ($vla_fancy == $max_vla)
	   {
	     $sql = "update VLaccess set vla_fancy = vla_fancy - 1 where vlid=$vlid and charid=$charid";
	     $mail_str =~ s/Replace $vlid/Reducing the level of fancy of $vlname by 1/;
	   }
	   elsif ($vla_location == $max_vla)
	   {
	     $sql = "update VLaccess set vla_location = vla_location - 1 where vlid=$vlid and charid=$charid";
	     $mail_str =~ s/Replace $vlid/Reducing the level of location of $vlname by 1/;
	   }
	   elsif ($vla_inventory == $max_vla)
	   {
	     $sql = "update VLaccess set vla_inventory = vla_inventory - 1 where vlid=$vlid and charid=$charid";
	     $mail_str =~ s/Replace $vlid/Reducing the level of inventory of $vlname by 1/;
	   }
	   elsif ($vla_secure == $max_vla)
	   {
	     $sql = "update VLaccess set vla_secure = vla_secure - 1 where vlid=$vlid and charid=$charid";
	     $mail_str =~ s/Replace $vlid/Reducing the level of inventory of $vlname by 1/;
	   }
	   
	   dosql($sql);	   	
	   $vlpoints++;
	}
   	dosql("delete from VLaccess where vla_fancy < 1 and vla_secure < 1 and vla_location < 1 and vla_inventory < 1;");

	$sql = "update characterSTATs set vlspecialpoints = vlspecialpoints + $vlpoints, lastBGincome = $current_bgp where charid=$charid;";
	dosql($sql);	   
	
	mailplayer();
	
	$sql = "select a.charid from characterSTATs a, characters b where a.lastBGincome < $current_bgp and a.lastBGincome >= 0 and a.charid=b.charid and b.chartype<=$cast_character and a.charid > 0";
	#print "$sql<BR>\n";
	$newcharid = dosql($sql) + 0;
	print $CGI->redirect("$thispage?charid=$newcharid");
	
}
else
{
   
   if ($charid > 0)
   {
      print $CGI->header;
      $charname = getCharName($charid);
      $doctitle = "Between Game Income Calculations for $charname"; 
      ParseForm($header);
      print "<H1>$doctitle</h1>\n";
      
      if (dosql("select lastBGincome from characterSTATs where charid=$charid") >= $current_bgp)
      {
         print "<font color=red>This person has already been processed for this BGP</font><BR><BR>\n";
      }
         
      print "<form action=\"$thispage\" method=\"post\">\n";
      print "<input type=hidden name=\"action\" value=\"update\">\n";
      print "<input type=hidden name=\"charid\" value=\"$charid\">\n";
      print dispall();
      print "<i>If these values are acceptable, click Accept.  Otherwise, press F5 to refresh this page.</i><BR><BR>\n";
      print "<input type=submit name=submit value=\"Accept\">&nbsp;&nbsp;&nbsp; \n";
      print "<input type=submit name=submit value=\"Skip\"><BR> \n";
      print "</form>\n";

      print "<br><a href=\"login.pl\">Main menu</a>."; 
      print "<br><a href=\"$thispage\">Return</a>."; 
      ParseForm($footer);
   }
   else
   {
	print $CGI->header;
        $doctitle = "Perform Between Game Income Calculations"; 
	ParseForm($header);
	print "<H1>$doctitle</h1>\n";
	
	print "<a href=\"$thispage?action=dac\">Do <i>all</i> characters</a><BR><BR>\n";
	
	print "<form action=\"$thispage\" method=\"post\">\n";
	
	print "Choose Character: ";
	print makeCharDropDown("charid",0);
	print "<input type=\"submit\" name=\"submit\" value=\"Go For It\"><BR>";

	print "</form>\n";
      	print "<br><a href=\"login.pl\">Main menu</a>."; 
      	ParseForm($footer);
   }
   
}

exit(0);

sub dispall()
{
   setSTATvars();

   local ($db) = dbconnect();
   
   $pounds = getMoney($charid);
   local($retStr) = "<i>What follows is your results of investments, expenses, and occupation from this BGP.  It does not include the results of your BGAs.</i><BR><BR>\n";
   $retStr .= "You start with $pounds.<BR><BR>\n";   
   $retStr .= "<b>Step One: Occupations</b><BR><BR>\n";
   
   #occupation first
   $tot = 0;
   $sql = "select * from occupations a join characteroccupations b on a.oid=b.oid where charid=$charid order by a.oname;";
   local($query) = $db->prepare($sql);
   $query->execute;
   while ($resptr = $query->fetchrow_hashref())
   {
      $oid = $resptr->{"oid"};
      $oname = $resptr->{"oname"};
      $req_status = $resptr->{"req_status"};
      $err_val = 0;
      $retStr .= "<i>$oname</i><BR><BR>\n";
      if ($status < $req_status)
      {
   	   $err_val++;
   	   $retStr .= "<font color=red> Your Base Status of $status is not enough to perform the duties of a $oname.  Base Status of at least $req_status is required.<BR><BR>\n";
      }
      else
      {
        $d10_base_income = $resptr->{"d10_base_income"};
        $base_income = $resptr->{"base_income"};
    	$num = $base_income + d11($d10_base_income);
     	$tot += $num;
    	$retStr .= $charname." receives a base income of between $base_income and ".($base_income  + ($d10_base_income * 10))." each BGP.  This BGP, the income is $num.<BR><BR>\n";
    	
    	$effstatus = $status + geteffectivestatus($charid);
    
        $base_stigma_modifier = $resptr->{"base_stigma_modifier"};
        $d10_stigma_modifier = $resptr->{"d10_stigma_modifier"};
	if ($effstatus < $req_status)
	{
		$amt = $req_status - $effstatus;
		$num = ($base_stigma_modifier * $amt) + d11($d10_stigma_modifier * amt);
		$tot -= $num;

		$retStr .= "Because $charname has an Effective Status of $effstatus, which is less than $req_status, $charname lost $num this BGP.<BR><BR>\n";
	}
	
	$ab_diff = min($ab_diff,3);
	if ($ab_diff > 0)
	{
	  $num = ($base_skill_bonus * $ab_diff) + d11($d10_skill_bonus * $ab_diff);
	  $tot += $num;

	  $retStr .= "$charname is very skilled as a $oname and receives a bonus $num this BGP.<BR><BR>\n";
	}

	$retStr .= "Total money earned this BGP in Occupation is $tot.<BR><BR>\n";
	print "<input type=\"hidden\" name=\"occ_income\" value=\"$tot\">\n";
	$pounds += $tot;
	$bigtot += $tot;
   	$retStr .= "You now have $pounds.<BR><BR>\n";   
      }
      $retStr .= checkoccabilities();   
   }
   $query->finish;
      
   #resources/economics 
   
   $tot = 0;
   $bigtot = 0;
   
   $retStr .= "<b>Step Two: Investments</b><BR>\n";
   $retStr .= "<i>Note: Your non-Agricultural investments have been processed manually.</i><BR><BR>\n";
   #$sql = "select b.name, a.text, a.level, c.level, a.caid from characterabilities a, abilities b, characterresourcetypelink c where a.charid=$charid and a.abid=b.abid and b.type='Resource' and c.charid=$charid and c.abid=a.caid and c.typeid=5 order by b.name;";    
   $sql = "select b.name, a.text, a.level, c.level, a.caid from characterabilities a, abilities b, characterresourcetypelink c where a.charid=$charid and a.abid=b.abid and b.type='Resource' and c.charid=$charid and c.abid=a.caid and a.abid=32 order by b.name;"; #5 is income
   #32 is is Agricultural
   #print "$sql<BR>";
   #$retStr .= "$sql<BR>";
   $query = $db->prepare($sql);
   $query->execute;
   $tot = 0;
   $lnum = 0;
   $lowerstr = "lower";
   $rnum = 0;
   $raisestr = "raise";
   $enum = 0;
   $eliminatestr = "eliminate";
   local(@array);
   while (@array = $query->fetchrow_array())
   {
        $name = $array[0];
        $name =~ s/_//g;
        $text = $array[1];
        $mylev = $array[2];
        $reslev = $array[3];
        $caid = $array[4];
        $imod = dosql("select level from characterresourcetypelink where typeid=6 and abid=$caid") + 2; #6 is income modifier
        $retStr .= handleinvestment();       
   }
   print "<input type=hidden name=\"lower_tot\" value=\"$lnum\">\n";
   print "<input type=hidden name=\"raise_tot\" value=\"$rnum\">\n";
   print "<input type=hidden name=\"elminate_tot\" value=\"$enum\">\n";
   $query->finish;
   
   #$sql = "select b.name, d.text, d.level, c.level, d.kraid from keyrolecharacters a, abilities b, keyrolerresourcetypelink c, keyroleabilities d where a.charid=$charid and a.krid=d.krid and d.abid=b.abid and b.type='Resource' and c.krid=a.krid and c.abid=d.kraid and c.typeid=5 order by b.name;"; #5 is income
   $sql = "select b.name, d.text, d.level, c.level, d.kraid from keyrolecharacters a, abilities b, keyrolerresourcetypelink c, keyroleabilities d where a.charid=$charid and a.krid=d.krid and d.abid=b.abid and b.type='Resource' and c.krid=a.krid and c.abid=d.kraid and d.krid=32 order by b.name;"; #5 is income
   #$retStr .= "$sql<BR>";
   $query = $db->prepare($sql);
   $query->execute;
   $lnum = 0;
   $lowerstr = "krlower";
   $rnum = 0;
   $raisestr = "krraise";
   $enum = 0;
   $eliminatestr = "kreliminate";
   while (@array = $query->fetchrow_array())
   {
        $name = $array[0];
        $name =~ s/_//g;
        $text = $array[1];
        $mylev = $array[2];
        $reslev = $array[3];
        $caid = $array[4];
        $imod = dosql("select level from characterresourcetypelink where typeid=6 and abid=$caid") + 2; #6 is income modifier
        $retStr .= handleinvestment();       
   }
   $query->finish;
   print "<input type=hidden name=\"krlower_tot\" value=\"$lnum\">\n";
   print "<input type=hidden name=\"krraise_tot\" value=\"$rnum\">\n";
   print "<input type=hidden name=\"kreliminate_tot\" value=\"$enum\">\n";

   $retStr .= "<BR>You made $tot in Investments.<BR>\n";
   print "<input type=\"hidden\" name=\"invest_income\" value=\"$tot\">\n";
   $pounds += $tot;
   $bigtot += $tot;
   $retStr .= "<BR>You now have $pounds.<BR><BR>\n";   
   
   $retStr .= "<b>Step Three: Taxes</b><BR><BR>\n";

   $taxes_income = 0;
   if (hasability("TAX EXEMPT") > 0)
   {
   	$retStr .= "You are exempt from Taxes.<BR><BR>\n";   
   }
   else
   {
	   $tax = int($bigtot * 0.05);
	   $tax = max($tax,0);
	   $retStr .= "You paid $tax in Taxes.<BR><BR>\n";
	   $pounds -= $tax;
   	   print "<input type=\"hidden\" name=\"taxes_income\" value=\"$tax\">\n";
   }
   $retStr .= "You now have $pounds.<BR><BR>\n";   
   
   $retStr .= "<b>Step Four: Expenses</b><BR><BR>\n";

   $num = getlevel("EXPENSES");
   $expense_income = 0;
   if ($num == 0)
   {
   	$retStr .= "You have no expenses.<BR><BR>\n";   
   }
   else
   {
	   $tot = $num * $status * 10;
	   $retStr .= "You owe $tot in Expenses.<BR><BR>\n";
	   $pounds -= $tot;
   	   print "<input type=\"hidden\" name=\"expense_income\" value=\"$tot\">\n";
   }
   $retStr .= "You now have $pounds.<BR><BR>\n";   
   
   $retStr .= "<b>Step Five: Virtual Locations</b><BR><BR>\n";
   
   $sql = "select sum(vl_fancy) + sum(vl_location) + sum(vl_inventory) + sum(vl_secure) from virtuallocations where vlowner=$charid";
   
   $vl_tot = dosql($sql);

   $sql = "select sum(a.vla_fancy) + sum(a.vla_secure) + sum(a.vla_location) + sum(a.vla_inventory) from VLaccess a where a.charid=$charid;";

   $vl_tot += dosql($sql);

   $tot = $vl_tot * $status;
   $retStr .= "You put $vl_tot points into Virtual Locations, costing you $tot<BR><BR>\n";
   
   #$pounds = 2 * $tot / 3;   
   #$retStr .= "pounds = $pounds; tot = $tot<BR>\n";
   
   if ($tot > $pounds)
   {
   	$retStr .= "<font color=red>You cannot afford the upkeep on all of your Virtual Locations.</font><BR><BR>";
   }
   
   $vl_res[0] = "vl_fancy";
   $vl_res[1] = "vl_location";
   $vl_res[2] = "vl_inventory";
   $vl_res[3] = "vl_secure";
   $vl_res[4] = "vla_fancy";
   $vl_res[5] = "vla_location";
   $vl_res[6] = "vla_inventory";
   $vl_res[7] = "vla_secure";
   $vl_rname[0] = "fancy";
   $vl_rname[1] = "location";
   $vl_rname[2] = "inventory";
   $vl_rname[3] = "secure";
   
   $vlcount = 0;
   $vlcount2 = 0;
   $vlcount3 = 0;
   dosql("delete from VLstatlink where vlslevel < 1;");
   dosql("delete from VLaccess where vla_fancy < 1 and vla_secure < 1 and vla_location < 1 and vla_inventory < 1;");
   while ($tot > $pounds && $pounds > 0)
   {
   	$num = int(rand(6));
   	$count_vls = dosql("select count(vlid) from virtuallocations where vlowner=$charid;") + 0;
   	$count_vllinks = dosql("select count(vlid) from VLstatlink where charid=$charid;") + 0;
   	$count_vlas = dosql("select count(vlid) from VLaccess where charid=$charid;") + 0;
   	
   	if ($num < 4 && $count_vls > 0)
   	{
   	   $sql = "select vlid, vlname, $vl_res[$num] from virtuallocations where vlowner=$charid";
   	   #$retStr .= "$sql<BR>";
   	   $query = $db->prepare($sql);
	   $query->execute;
	   $testnum = int(rand($count_vls)) + 1;
	   while ((@array = $query->fetchrow_array()) && $testnum > 0)
	   {
	     $testnum -= 1;
	     $vlid = $array[0];
	     $vlname = $array[1];
	     $vllev = $array[2];
	   }
	   $query->finish();
      	   $retStr .= "Reducing the level of $vl_rname[$num] of $vlname by 1.<BR>\n";
           print "<input type=\"hidden\" name=\"vlid_$vlcount\" value=\"$vlid\">\n";
           print "<input type=\"hidden\" name=\"vltype_$vlcount\" value=\"$vl_res[$num]\">\n";
           $vlcount++;
           $tot -= $status;
           if ($vllev <= 1)
           {
      	      $retStr .= "<i>The $vl_rname[$num] of $vlname has dropped to 0 (or below).  This Virtual Location will be eliminated.  You will not get the points back for it.</i><BR>\n";
           }
   	}
   	elsif ($num == 4 && $count_vllinks > 0) #from vllinks
   	{
   	   $sql = "select a.vlid, b.vlname, a.vlslevel, c.vlsname, a.vlsid from VLstatlink a, virtuallocations b, VLstats c where a.charid=$charid and a.vlid=b.vlid and a.vlsid = c.vlsid;";
   	   #$retStr .= "$sql<BR>";
   	   $query = $db->prepare($sql);
	   $query->execute;
	   $testnum = int(rand($count_vllinks)) + 1;
	   while ((@array = $query->fetchrow_array()) && $testnum > 0)
	   {
	     $testnum -= 1;
	     $vlid = $array[0];
	     $vlname = $array[1];
	     $vllev = $array[2];
	     $vlsname = $array[3];
	     $vlsid = $array[4];
	     #$retStr .=  "$vlname --";
	   }
	   $query->finish();
   	   $retStr .= "Reducing the level of $vlsname of $vlname by 1.<BR>\n";
   	   $tot -= $status;
           print "<input type=\"hidden\" name=\"vlid2_$vlcount2\" value=\"$vlid\">\n";
           print "<input type=\"hidden\" name=\"vlsid_$vlcount2\" value=\"$vlsid\">\n";
           $vlcount2++;
   	}
   	elsif ($count_vlas > 0) #from vlaccess
   	{
   	   $sql = "select a.vlid, b.vlname from VLaccess a, virtuallocations b where a.charid=$charid and a.vlid=b.vlid;";
   	   #$retStr .= "$sql<BR>";
   	   $query = $db->prepare($sql);
	   $query->execute;
	   $testnum = int(rand($count_vllinks)) + 1;
	   while ((@array = $query->fetchrow_array()) && $testnum > 0)
	   {
	     $testnum -= 1;
	     $vlid = $array[0];
	     $vlname = $array[1];
	   }
	   $query->finish();
   	   $retStr .= "Replace $vlid.<BR>\n";
   	   $tot -= $status;
           print "<input type=\"hidden\" name=\"vlid3_$vlcount3\" value=\"$vlid\">\n";
           $vlcount3++;
   	}
   	elsif ($count_vls == 0 &&  $count_vllinks == 0) #nothing left
   	{
   	   $tot = $pounds;
   	}
   	#$retStr .= "pounds = $pounds; tot = $tot<BR>\n";
   }
   
   print "<input type=\"hidden\" name=\"vlcount\" value=\"$vlcount\">\n";
   print "<input type=\"hidden\" name=\"vlcount2\" value=\"$vlcount2\">\n";
   print "<input type=\"hidden\" name=\"vlcount3\" value=\"$vlcount3\">\n";
   $pounds -= $tot;
   print "<input type=\"hidden\" name=\"vl_income\" value=\"$tot\">\n";
   $retStr .= "<BR><H3>You end up with $pounds.</H3><BR><BR>\n";
   
   $db->disconnect;
   
   print "<input type=\"hidden\" name=\"mail_str\" value=\"$retStr\">\n";
   
   return $retStr;
}


sub checkoccabilities()
{
        $levtot = 0;
        $mylev = 0;
        local($retStr) = "";
	local($db) = dbconnect();
	local ($sql) = "select a.abid, a.minlevel, a.text, b.name, b.req_text from occupationabilities a, abilities b where a.$keyfield=$keyvalue and a.abid=b.abid order by b.name, a.text;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"name"};
	   $text = $resptr->{"text"};
	   $num = getlevel($name, $text) + 0;
	   $name =~ s/_//g;
	   if ($resptr->{"req_text"} > 0)
	   {
	     $name .= " $text";
	   }
	   
	   if ($num == 0 && $resptr->{"minlevel"} > 0)
	   {
	      $retStr .= "<font color=red>Error: You need at least a ".$resptr->{"minlevel"}." in $name.  $charname does not even have this Ability.</font><BR>\n";
   	      $err_val++;
	   }
	   elsif ($num < $resptr->{"minlevel"})
	   {
	      $retStr .= "<font color=red>Error: You need at least a ".$resptr->{"minlevel"}." in $name.  $charname only has a $num.</font><BR>\n";
   	      $err_val++;
	   }
	   $levtot += $resptr->{"minlevel"};
	   $mylev += $num;
	}
	$query->finish;
	$db->disconnect;
	
	if ($uses_weird_science ne "")
	{
	   setSTATvars();
	   $num = $weirdscience;
	   if ($num == 0)
	   {
	      $retStr .= "<font color=red>Error: You need at least a 1 in Weird Science.  $charname does not even have this Ability.</font><BR>\n";
   	      $err_val++;
	   }
	   $levtot += 1;
	   $mylev += $num;
	}
	
	$ab_diff = 0;
	if ($mylev >= $levtot + $skill_bonus_threshold)
	{
	  $ab_diff = $mylev + 1 - ($levtot + $skill_bonus_threshold);
	}	
	
	return $retStr;
}

sub handleinvestment()
{
    	$amt = int(rand(10)) + int(rand(10)) + 2 + $imod;
    	$showres = 1;
    	$newpo = 0;
    	$mult = int($mylev * $mylev * ($status / 2) * ($status /2));
    	local ($retStr) = "";
    	
    	if ($name eq "AGRICULTURAL INVESTMENTS: ")
    	{
	  $lowered = 0;
    	  do 
    	  {
    	     $amt = int(rand(10)) + int(rand(10)) + 2 + $imod;
    	     #$retStr .= "Rolled a $amt<BR>\n";
	     $amt = $inv_ag[$amt];
	     $amt = $res[$reslev][$amt];
	     if ($amt < $eliminate)
	     {
	        $newpo = $amt * $mult;
	     }
	     elsif ($amt == $eliminate)
	     {
	        $retStr .= "$name $text produced so poorly that it was eliminated<BR>\n";
      		print "<input type=hidden name=\"".$eliminatestr."_".$enum."\" value=\"$caid\">\n";
	        $enum++;
	        return $retStr;
	     }
	     elsif ($amt == $raiselev && $levels[$reslev] eq "Average" )
	     {
		$amt = 3;
	        $newpo = $amt * $mult;
	     }
	     elsif ($amt == $lowerlev && ($levels[$reslev] eq "Low" || $lowered > 0))
	     {
		$amt = -2;
	        $newpo = $amt * $mult;
	     }
	     elsif ($amt == $lowerlev)
	     {
	        $retStr .= "Lowering Profitability of $name $text from $levels[$reslev]";
	        $reslev = $reslev - 1;
	        if ($reslev == 0)
	        {
	           $reslev = 5;
	        }
	        $retStr .= " to $levels[$reslev]<BR>\n";
      		print "<input type=hidden name=\"".$lowerstr."_".$lnum."\" value=\"$caid\">\n";
	        $lnum++;
	        $lowered= 1;
	     }
	     elsif ($amt == $raiselev)
	     {
	        $retStr .= "Raising Profitability of $name $text from $levels[$reslev]";
	        $reslev = $reslev + 1;
	        if ($reslev == 6)
	        {
	           $reslev = 1;
	        }
	        $retStr .= " to $levels[$reslev]<BR>\n";
      		print "<input type=hidden name=\"".$raisestr."_".$rnum."\" value=\"$caid\">\n";
	        $rnum++;
	     }
	  } while ($amt == $lowerlev || $amt == $raiselev);
    	}
    	
    	if ($name eq "INDUSTRIAL INVESTMENTS: ")
    	{
	  $lowered = 0;
    	  do 
    	  {
    	     $amt = int(rand(10)) + int(rand(10)) + 2 + $imod;
    	     $amt += getlevel("BUSINESS");
    	     if ($amt > 20)
    	     {
    	       $amt = 20;
    	     }
    	     #$retStr .= "Rolled a $amt<BR>\n";
	     $amt = $inv_in[$amt];
	     $amt = $res[$reslev][$amt];
	     if ($amt < $eliminate)
	     {
	        $newpo = $amt * $mult;
	     }
	     elsif ($amt == $eliminate)
	     {
	        $retStr .= "$name $text produced so poorly that it was eliminated<BR>\n";
      		print "<input type=hidden name=\"".$eliminatestr."_".$enum."\" value=\"$caid\">\n";
	        $enum++;
	        return $retStr;
	     }
	     elsif ($amt == $raiselev && $levels[$reslev] eq "High" )
	     {
		$amt = 3;
	        $newpo = $amt * $mult;
	     }
	     elsif ($amt == $lowerlev && $lowered > 0)
	     {
		#reroll
	        $lowered += 1;
	     }
	     elsif ($amt == $lowerlev)
	     {
	        $retStr .= "Lowering Profitability of $name $text from $levels[$reslev]";
	        $reslev = $reslev - 1;
	        if ($reslev == 0)
	        {
	           $reslev = 5;
	        }
	        $retStr .= " to $levels[$reslev]<BR>\n";
      		print "<input type=hidden name=\"".$lowerstr."_".$lnum."\" value=\"$caid\">\n";
	        $lnum++;
	        $lowered = 10;
	     }
	     elsif ($amt == $raiselev)
	     {
	        $retStr .= "Raising Profitability of $name $text from $levels[$reslev]";
	        $reslev = $reslev + 1;
	        if ($reslev == 6)
	        {
	           $reslev = 1;
	        }
      		print "<input type=hidden name=\"".$raisestr."_".$rnum."\" value=\"$caid\">\n";
	        $rnum++;
	        $retStr .= " to $levels[$reslev]<BR>\n";
	     }
	  } while ($amt == $lowerlev || $amt == $raiselev);
    	}
    	
    	if ($name eq "TRADE INVESTMENTS: ")
    	{
	  $lowered = 0;
    	  do 
    	  {
    	     $amt = int(rand(10)) + int(rand(10)) + 2  + $imod;
    	     $amt += getlevel("HAGGLE");
    	     if ($amt > 20)
    	     {
    	       $amt = 20;
    	     }
    	     #$retStr .= "Rolled a $amt<BR>\n";
	     $amt = $inv_tr[$amt];
	     $amt = $res[$reslev][$amt];
	     if ($amt < $eliminate)
	     {
	        $newpo = $amt * $mult;
	     }
	     elsif ($amt == $eliminate)
	     {
	        $retStr .= "$name $text produced so poorly that it was eliminated<BR>\n";
      		print "<input type=hidden name=\"".$eliminatestr."_".$enum."\" value=\"$caid\">\n";
	        $enum++;
	        return $retStr;
	     }
	     elsif ($amt == $lowerlev && $lowered > 0)
	     {
	        $lowered++;
	     }
	     elsif ($amt == $lowerlev)
	     {
	        $retStr .= "Lowering Profitability of $name $text from $levels[$reslev]";
	        $reslev = $reslev - 1;
	        if ($reslev == 0)
	        {
	           $reslev = 5;
	        }
	        $retStr .= " to $levels[$reslev]<BR>\n";
      		print "<input type=hidden name=\"".$lowerstr."_".$lnum."\" value=\"$caid\">\n";
	        $lnum++;
	        $lowered++;
	     }
	     elsif ($amt == $raiselev)
	     {
	        $retStr .= "Raising Profitability of $name $text from $levels[$reslev]";
	        $reslev = $reslev + 1;
	        if ($reslev == 6)
	        {
	           $reslev = 1;
	        }
	        $retStr .= " to $levels[$reslev]<BR>\n";
      		print "<input type=hidden name=\"".$raisestr."_".$rnum."\" value=\"$caid\">\n";
	        $rnum++;
	     }
	  } while ($amt == $lowerlev || $amt == $raiselev);
	}
        
        if ($showres == 1)
        {
           $retStr .= "$name $text at level $mylev, $levels[$reslev] produces $newpo<BR>\n";
           $tot += $newpo;
        }
        
        return $retStr;
}

# ********************
# * makeCharDropDown *
# ********************
# * makeCharDropDown makes a drop down field from characters.
sub makeCharDropDown
{
local($selectname) = $_[0];
local($value) = $_[1];
local ($db) = dbconnect();
$SQL = "select a.charid, concat(b.pfirst, ' ', b.plast) from characters a, players b, playercharacters c, characterSTATs d where c.pccharid=a.charid and b.playerid=c.pcplayerid and a.chartype != $test_character and d.charid=a.charid and a.charid > 0 order by a.clast";
    
local($query) = $db->prepare($SQL);
$query->execute;

local ($retVal) = "";

#Check to make sure $query is not empty
    if ($query->rows > 0)
    {
        $retVal = "<select name=\"$selectname\">\n";
        local (@array);
        while (@array = $query->fetchrow_array)
        {
          if ("$array[0]" eq "$value")
          {
            $retVal .= "<option value=\"$array[0]\" SELECTED>".getCharName($array[0])." ($array[1])</option>\n";
          }
          else
          {
            $retVal .= "<option value=\"$array[0]\">".getCharName($array[0])." ($array[1])</option>\n";
          }
        }
        $retVal .= "</select>\n";
    }
$query->finish;
$db->disconnect;
return $retVal;
}

sub mailplayer()
{	
	$toemail = getEmailFromID(getPIDFromCharID($charid));
	
	$ccmail = dosql("select gmcGMid from GMcharacters where gmccharid=$charid");
	$ccmail = getEmailFromID($ccmail);

	#print $CGI->header();

	# Retrieve Date
	$date = getDate();
	#print "$date<BR>";

	# Send E-Mail
	open(MAIL, "| /usr/sbin/sendmail  -oi -t") or die "couldn't send mail: $!";
	print MAIL "From: \"$campaign GMs\" <$contact>\n";
	print MAIL "To: $toemail\n";
	#print "[$toemail]<BR>\n";
	print MAIL "Cc: economy\@$cookiesite\n";
	#print MAIL "Bcc: $ccmail\n";
	print MAIL "Subject: Between Games Economy Results For ".getCharName($charid)."\n";
	print MAIL "MIME-Version: 1.0\n";
	print MAIL "Content-Type: text/html;\n";
	print MAIL "\n";
	print MAIL "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2//EN\">";
	print MAIL "<html><body>\n";
	print MAIL "This email contains your between games economic results.<BR>\n"; 
	print MAIL "This is different from your BGA results.  BGAs have not yet been processed.<BR>\n"; 
	print MAIL "You will get your BGA results at the game.<BR>\n"; 
	print MAIL "These results were automatically generated by the database using your STATs and skills.<BR>\n"; 
	print MAIL "Sometimes bad things happen.  These are random.  Nothing so bad that it cannot be overcome will occur.<BR>\n"; 
	print MAIL "We suggest that if your investments didn't do well, or your virtual locations cost too much that you try to find in-game ways around these problems.<BR>\n"; 
	print MAIL "For example, you could try to get Parliament to pass laws that would benefit your resources, or give subsidies to homeowners.<BR>\n"; 
	print MAIL "<BR>\n"; 
	print MAIL "We'd also like to take this opportunity to remind you of the following:<BR>\n"; 
	print MAIL "If you have not yet made a reservation for the hotel for Episode 4, now is the time.<BR>\n"; 
	print MAIL "To reserve your room, call the Clarion Antietam in Hagerstown, MD at 1.301.733.5100.<BR>\n"; 
	print MAIL "<BR>\n"; 
	print MAIL "We will have character sheets for Episode 4 available one week before the game.<BR>\n"; 
	print MAIL "<BR>\n"; 
	print MAIL "Note that you can veiw important game documents at:  $siteURL and selecting the Document Library.<BR>\n"; 
	print MAIL "<BR>\n"; 
	print MAIL "Thanks for playing!<BR>\n"; 
	print MAIL "<BR>\n"; 
	print MAIL "$mail_str\n";
	print MAIL "--\n";
	print MAIL "This e-mail sent via the $campaign database.\n";
	print MAIL "$siteURL\n";
	print MAIL "E-mail $contact for questions/comments.\n";
	print MAIL "</body></html>\n";
	close(MAIL);
}