#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$pid = getPlayerID();
$al = getAccessLevel($pid);

if ($al >= 3)
{
$cqcharid = $CGI->param("cqcharid");
$mode = $CGI->param("mode");
if ($mode eq "edit")
{
$mode = "approve";
print $CGI->header();
ParseForm($header);
fillvars($cqcharid);
ParseForm("gmcharquest.tpl");
ParseForm($footer);
}
elsif (($mode eq "approve") and ($al >= 3))
{
local($dbvar) = dbconnect();
$dbvar->do("Update characters SET charstoryapproved = 1 where charid = " . $CGI->param("cqcharid"));
$dbvar->disconnect;
print $CGI->redirect("gmchars.pl?error=" . encodeURL("Character Approved"))
}
else
{
print $CGI->redirect("gmchars.pl?error=" . encodeURL("Unrecognized function"))
}
}
else
{
print $CGI->redirect("login.pl?error=" . encodeURL("You do not have access to that function"));
}

sub fillvars()
{
local($p) = @_;
local($db) = dbconnect();
local($tab) = $db->prepare("explain charquestionnaires");

if ($al >= 3)
{
$submitbutton = "<input type=\"submit\" name=\"submit\" value=\"Approve Character\">";
}
$tab->execute;
$i = 0;
while (@arrtemp = $tab->fetchrow_array)
{
$arr[$i] = $arrtemp[0];
$arrTypes[$i] = $arrtemp[1];
#print "$arr[$i]<br>\n";
$i++;
}
$tab->finish;
local($query) = $db->prepare("select * from charquestionnaires where cqcharid = $p");
$query->execute;
@cqquery = $query->fetchrow_array;
for ($k=0;$k<$tab->rows;$k++)
{
#print "\$$arr[$k] = $cqquery[$k]<br>\n";
$cqquery[$k] =~ s/'/\\'/g;
$cqquery[$k] =~ s/"/\"/g;
    if ($arrTypes[$k] eq 'tinyint(1)')
    {
        if ($cqquery[$k] > 0)
        {
            eval("\$$arr[$k] = 'CHECKED'");
        }
        else
        {
            eval("\$$arr[$k] = ''");
        }
    }
    else
    {
        eval("\$$arr[$k] = '$cqquery[$k]'");
    }
}
$query->finish;
$hairselect = makeArrayDropDown(['brwn','blck','red','blnd','grey','bald'],"cqcharhair",[$cqcharhair]);

$eyesselect = makeArrayDropDown(['brwn','blck','blue','grn','hazl','grey'],"cqchareyes",[$cqchareyes]);

$ethnicselect = makeArrayDropDown(['White','Negro','Oriental','Mexican','American Indian','Other'],"cqcharethnic",[$cqcharethnic]);

$religpracselect = makeArrayDropDown(['No Selection ','actively irreligious ','not at all religious','vague childhood memories, not actively religious ','actively religious but never attend services ','"Easter and Christmas" participation ','Go to regular services ','Active participant in church/temple, etc. ','Devoutly Religious ','Extremely Devout ','I have an irregular religious practice (witchcraft, etc.) and maintain another religion as a "front"','I have an irregular religious practice'],"cqrelpractice",[$cqrelpractice]);

$relbirthselect = makeArrayDropDown(['No Selection','Roman Catholic','Orthodox Catholic','Protestant Baptist','Protestant Methodist','Protestant Presbyterian','Protestant Episcopalian','Protestant Lutheran','Protestant Congregationalist','Protestant Unitarian','Protestant Christian Scientist','Protestant Mormon','Protestant','Misc. Jewish Orthodox','Jewish Reformed','Jewish Conservative','Other Mohammedan','Buddhist','Hindu','Confucian/Taoist','Animist','Shintoist','Evil Cultist'],"cqrelraised",[$cqrelraised]);

$relcurrentselect = makeArrayDropDown(['No Selection','Roman Catholic','Orthodox Catholic','Protestant Baptist','Protestant Methodist','Protestant Presbyterian','Protestant Episcopalian','Protestant Lutheran','Protestant Congregationalist','Protestant Unitarian','Protestant Christian Scientist','Protestant Mormon','Protestant','Misc. Jewish Orthodox','Jewish Reformed','Jewish Conservative','Other Mohammedan','Buddhist','Hindu','Confucian/Taoist','Animist','Shintoist','Evil Cultist'],"cqrelcurrent",[$cqrelcurrent]);

$wealthtypeselect = makeArrayDropDown(['Income','Salary','Mixed'],"cqwealthtype",[$cqwealthtype]);

$wealthlevelselect = makeArrayDropDown(['No Selection','Bum','Impoverished','Lower middle class/Blue collar','Middle Class','Upper Middle Class','Wealthy *','Very Wealthy *'],"cqwealthlevel",[$cqwealthlevel]);

$workposselect = makeArrayDropDown(['No Selection','Flunky','Office boy','low man on the totem pole','Worker Drone','Regular guy, one of the workers','A top worker','Supervisor','Middle Management','Upper Management','Exec, or VP President, Owner, Chief...'],"cqworkposition",[$cqworkposition]);

$edulevelselect = makeArrayDropDown(['No Selection','Uneducated','Elementary','Self or home schooled','Elementary, plus Military Training','High School Graduate','High School, plus Military Training','Trade School, or Apprenticeship','British Public School Education','British Public School Education and College','Junior College or Finishing School','College','Prestigious University','Master\'s Degree Doctoral Degree'],"cqedulevel",[$cqedulevel]);

$eduprimaryselect = makeArrayDropDown(['No Selection','Lived in the Country Mostly rural schools (one room schoolhouse)','Lived in the City or Suburbs - Mostly Urban schools (PS 132)','Wealthy - Military School','Wealthy - Boarding School','Wealthy - Private Academy','Lived abroad or unconventional upbringing outside a city or town - Home Schooled'],"cqprimarytype",[$cqprimarytype]);

$sxquery = $db->prepare('select charsex from characters where charid = ' . $CGI->param("cqcharid"));
$sxquery->execute;
@cqarray = $sxquery->fetchrow_array;
$sxquery->finish;
if ($cqarray[0] eq 'F')
{
$warservicebranchselect = makeArrayDropDown(['US WAVES (Navy)','US SPARS (Coast Guard )','US WAAC [WAC c.1943] (Army, Air Corps)','British ATS (Army)','British WREN (Navy)','British WAAF (RAF)','Allied Regular forces (Canada, Australia, Greece)','Allied Irregular forces (Partisans, Resistance, etc.)'],"cqwarwwiiservicebranch",[$cqwarwwiiservicebranch]);
}
else
{
$warservicebranchselect = makeArrayDropDown(['U.S. Navy','U.S. Coast Guard','U.S. Marines','U.S. Army','U.S. Army Air Corps','U.S. Merchant Marine','Royal Army','Royal Navy','Royal Marines','Royal Air Force','Merchant Navy','Allied Regular forces (Canada, Australia, Greece, Soviet Union)','Allied Irregular forces (Partisans, Resistance, etc.)','German forces','Other Axis forces (Japanese, Italian, etc.)'],"cqwarwwiiservicebranch",[$cqwarwwiiservicebranch]);
}

$momrelselect = makeArrayDropDown(['No Selection','Died before I can remember','Distant relationship - brought up by someone else','Distant relationship - we were never close','About average - keep in contact or remember him/her well','Fairly close - good memories or visit on a regular basis','Very close - major influence past or present','Extremely close relationship - one of the most important people in my life'],"cqfammotherrelationship",[$cqfammotherrelationship]);

$momaliveselect = makeArrayDropDown(['No Selection','Alive','Deceased','Don\'t Know'],"cqfammotheralive",[$cqfammotheralive]);

$dadrelselect = makeArrayDropDown(['No Selection','Died before I can remember','Distant relationship - brought up by someone else','Distant relationship - we were never close','About average - keep in contact or remember him/her well','Fairly close - good memories or visit on a regular basis','Very close - major influence past or present','Extremely close relationship - one of the most important people in my life'],"cqfamfatherrelationship",[$cqfamfatherrelationship]);

$dadaliveselect = makeArrayDropDown(['No Selection','Alive','Deceased','Don\'t Know'],"cqfamfatheralive",[$cqfamfatheralive]);

$rentorownselect = makeArrayDropDown(['No Selection','Rent cheap digs weekly','Boarding House','Rent or Lease an Apartment or house','Live with family','Own a house'],"cqpersrentorown",[$cqpersrentorown]);

$housetypeselect = makeArrayDropDown(['A cheap flop-house','Dirty brownstone apartment','Run down Residence Hotel','Respectable apartment','Respctable Residence Hotel','Room or bungalow rental','Pleasant, upper class, apartment','Small urban house','Small suburban house or cottage','Small rural house or cottage','Large Urban house','Large suburban house','Large rural farmhouse','Wealthy Town House','Suburban Estate','Country Manor House','Other'],"cqpershousetype",[$cqpershousetype]);

$arrestselect = makeArrayDropDown(['No Selection','Never in trouble with the law','A few scrapes, nothing unusual','Up on charges more than once, but got off','Served time in jail for minor offenses','Served hard time in the pen for major offenses','A wanted man in my home country'],"cqdarkarrests",[$cqdarkarrests]);

$cqmysticgroups = makeArrayDropDown(['Yes','No'],"cqmysticgroups",[$cqmysticgroups]);
$cqweirdevents = makeArrayDropDown(['Yes','No'],"cqweirdevents",[$cqweirdevents]);
$cqhamop = makeArrayDropDown(['Yes','No'],"cqhamop",[$cqhamop]);

$db->disconnect;
}

