#!/usr/bin/perl

require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "charinfo.pl";
$table = "charinfo";
$heading = "Your Character Information ";
$keyfield = "charid";
$keyvalue = $CGI->param($keyfield);
$namevalue = getCharName($keyvalue);
$tplfile = "charinfo.tpl";
$errstr = $CGI->param("error");

$pid2 = getPIDFromCharID($keyvalue);
if ($pid != getPIDFromCharID($keyvalue) && $al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit information for this character.$pid, $pid2"));
}
elsif ($submit eq "Update")
{
	#print $CGI->header();
	# Update and Redirect
	$ciid = $CGI->param("ciid") + 0;
	$cqchardob = $CGI->param("birthday");
	$cqcharnationality = $CGI->param("nationality");
	$cqmarried = $CGI->param("married");
	$cqspouse = $CGI->param("spouse");
	$cqcharaddress = $CGI->param("address");
	$cqrelcurrent = $CGI->param("religion");
	$cpiclink =  $CGI->param("picurl");
	if ($ciid > 0)
	{
		$sql = filltablefromCGI($table, 0);
	}
	else
	{
		$sql = filltablefromCGI($table, 1);
	}
	#print "$sql<BR>";
	dosql($sql);
	
	$cqcharid = dosql("select cqcharid from charquestionnaires where cqcharid=$keyvalue") + 0;
	if ($cqcharid == $keyvalue)
	{
	  $sql = "update charquestionnaires set cqchardob='$cqchardob', cqcharnationality='$cqcharnationality', cqmarried='$cqmarried', cqspouse='$cqspouse', cqcharaddress='$cqcharaddress', cqrelcurrent='$cqrelcurrent' where cqcharid=$cqcharid;";
	}
	else
	{
	   $sql = "insert into charquestionnaires (cqchardob, cqcharnationality, cqmarried, cqspouse, cqcharaddress, cqrelcurrent, cqcharid) values ('$cqchardob', '$cqcharnationality', '$cqmarried', '$cqspouse', '$cqcharaddress', '$cqrelcurrent', '$keyvalue');";
	}
	
	#print "$sql<BR>\n";
	dosql($sql);
	$sql = "update characters set cpiclink='$cpiclink' where charid=$keyvalue;";
	dosql($sql);
	
	print $CGI->redirect("$thispage?$keyfield=$keyvalue&error=" . encodeURL("$namevalue Updated"));
}
else
{
	print $CGI->header;
	$doctitle = "Manage $heading: $namevalue";
	ParseForm($header);
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle</h1>\n";

	print "<h2>This page will let you edit the information the shows up in the public characters pages.</h2>\n";
	
	showdata();

	print "<br><hr><a href=\"login.pl\">Main Menu</a>.\n"; 
	print "<br><a href=\"characters.pl\">Manage Characters</a>.\n"; 
		
	print"<SCRIPT LANGUAGE=\"Javascript\">\n";
	print"function openwindow()\n";
	print"{\n";
	print"	win=window.open(\"showplayer.pl?charid=$charid\");\n";
	print"	win.focus();\n";
	print"}\n";
	print"</SCRIPT>\n";
	ParseForm($footer);
}

exit 0;

sub showdata()
{
 	fillvars();
	print "<form action=\"$thispage\" method=\"post\">\n";
	ParseForm($tplfile);
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Update\">&nbsp;&nbsp;&nbsp;&nbsp;";
	print "<input type=\"button\" name=\"display\" value=\"Display\" onClick=\"javascript:openwindow()\";><BR>";
	print "<i>Update then Display....</i><BR>\n";
	print "</form>\n";

}

sub fillvars()
{
	filltable();
	$charid = $CGI->param("charid");
	$player = getFullNameFromID(getPIDFromCharID($charid));
	$status = dosql("select status from characterSTATs where charid=$charid") + 0;
	$birthday = dosql("select cqchardob from charquestionnaires where cqcharid=$charid");
	$nationality = dosql("select cqcharnationality from charquestionnaires where cqcharid=$charid");  $married = dosql("select cqmarried from charquestionnaires where cqcharid=$charid") + 0;
	$marstat[0] = "Single";
	$marstat[1] = "Married";
	$mardrop = makeArrayDropDown(\@marstat, "married", [$marstat[$married]], "", 1);
	$spouse .= dosql("select cqspouse from charquestionnaires where cqcharid=$charid");
	$address .= dosql("select cqcharaddress from charquestionnaires where cqcharid=$charid");
	$religion .= dosql("select cqrelcurrent from charquestionnaires where cqcharid=$charid");
	$occupation .= dosql("select a.oname from occupations a join characteroccupations b on a.oid=b.oid where b.charid=$charid");
	$keyroles .= dosql("select a.krname from keyroles a join keyrolecharacters b on a.krid=b.krid where b.charid=$charid");
	$picurl = dosql("select cpiclink from characters where charid=$charid;");
	$templdrop = makeDropDown("templates", "tid", "templatename", "tid > 0 order by templatename", "", $template);
	$templdrop =~ s/tid/template/;

}

