<H1>$campaign Character Questionnaire for $charname</b></H1>
This questionnaire will be available here for review and editing. Each time you make changes, the GMs will need to approve them again.  Note that this information is a general outline of your character.  You will have the opportunity to insert more detailed information later. 
<br><br>
In the Questionnaire below, we'll ask you a number of questions.  You are not obligated to answer any of the questions, but we may make the answers up if you do not.
<br><br>
<form action="charquest.pl?table=charquestionnaires" method="post">
<input type="hidden" name="cqcharid" value="$cqcharid">
<h2>Character Creation STATS Overview</h2>

<BR>How much of the actual character creation do you want to be responsible
for? 

$rtlbselect<BR>

<i>Note: Character background and plots shall be created jointly with the GMs for <b>all</b> characters.  If you have a clear idea for the character that you wish to play, please choose, "I will create the entire character," but realize that the GMs will still have substantial input into the process.</i><BR><BR>

<h1>Character Information</h1>
<h2>Address</h2>
Your street address <i>"Apt 4, 143 S. Oak St. not "London."</i>
<input type="text" name="cqcharaddress" value="$cqcharaddress" size=50><br>

City/State (if applicable):<input type="text" name="cqcharcitystate" value="$cqcharcitystate" size=50><BR>

Nationality:<input type="text" name="cqcharnationality" value="$cqcharnationality" size=50><br>
<i>We strongly encourage characters to originate from England.  Other good choices are: America, France, Prussia, Russia, or an English Colony.  Characters from other places may find themselves limited in social or politcal opportunities.  See <a href="http://www.interactivitiesink.com/larps/brassy/empire.shtml">this page</a> for more details.</i>

<h2>Vital Statistics</h2>
Date of Birth: (<i>yyyy-mm-dd</i>)<input type="text" name="cqchardob" value="$cqchardob" size=50><BR>

<i>Note: Our campaign begins in the year 1874.</i><BR><BR>

Ethnic Background:$ethnicselect

<H2>Religion</center></H2>
<br>
Birth Religion - I was raised:$relbirthselect<BR>
I am currently:$relcurrentselect<BR>
Religious Habits: $religpracselect<BR>
<i>Again, we strongly urge you to choose an acceptible religion.  Characters who are not 
Anglican will be discriminated against.  Characters who are not Christian of some flavor
will be discriminated against further.  And as you get further down the list, the worse it
gets.</i> <BR>


<H2>Education</center></H2><br><i>
Obviously characters from the lower classes wouldn't get much of an education, but for
you higher class characters out there, we'd like to know where you went to school<br></i>

How Educated are you?$edulevelselect<br>

If you attended College, where?<input type="text" name="cqcollegename" value="$cqcollegename" size=50>
<br>

What was your graduating class?<input type="text" name="cqcollegeclass" value="$cqcollegeclass" size=50><br>

<h2>Personal Information</h2>
<br>

Are you married?<br>
<input type="radio" name=cqmarried value=1 $ismarried> Yes I am</input><br>   
<input type="radio" name=cqmarried value=0 $notmarried> No I am not</input>   

<br>
Spouse/Current Girlfriend Boyfriend(s):<input type="text" name="cqspouse" value="$cqspouse" size=50>
<br><br>
Tell us a bit about your family.  List any relatives, and if you would like to see them in game,
and especially if you believe that someone else will be playing them as player characters (tell
us the player).<br>
<textarea name="cqfamily" COLS=50 ROWS=7>$cqfamily</textarea><br>
<br>
Tell us a bit about your friends.  List any close friends, and if you would like to see them in game,
and especially if you believe that someone else will be playing them as player characters (tell
us the player).<br>
<textarea name="cqsofriends" COLS=50 ROWS=7>$cqsofriends</textarea><br>
<br>

<h2>Occupation and Hobbies</h2>
<br>
<i>Your occupation and hobbies tell a great deal about you.  Your occupation brings you in money
and your hobbies bring you things to do.  Check <a href="../occupation.shtml">this page</a> to take a look at Occupations in $campaign.</i><br><br>

Tell us a bit about your occupation:<br>
<textarea name="cqcharoccupation" COLS=50 ROWS=7>$cqcharoccupation</textarea><br>
<br>
Tell us a bit about your hobbies:<br>
<textarea name="cqcharhobbies" COLS=50 ROWS=7>$cqcharhobbies</textarea><br>
<br>

$statusboxes
$socialboxes

<H2>Summary</center></H2><i>
It may be some time before we are ready for you to select skills for your character.  However, you should probably have some idea of the general sorts of activities that you want your character to take part in.  We cannot recommend too strongly that your character emphasize two to three areas of activity, no more, no less.  </i><br><br>

Your Character History<br>
<textarea name="cqcharstory" COLS=80 ROWS=20>$cqcharstory</textarea>
<br><br>

$plotboxes
<br>

Any plot hooks you especially want to call attention to?<br>
<textarea name="cqplothooks" COLS=50 ROWS=7>$cqplothooks</textarea>
<br><br>

<input type="hidden" name="mode" value="$mode">
<input type="hidden" name="table" value="charquestionnaires">
<input type="submit" name="submit" value="Submit">


</form>
<br><br><br>