#!/usr/bin/perl

# Require and Use
# * These statements alert perl.exe that
# * you are going to be using functions, 
# * subroutines, and methods from other
# * perl programs. "require" is used for a
# * perl library, and the "use" statement 
# * is usually used to reference a perl
# * object (usually referred to as a 
# * module).
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$pid = getPlayerID();

if ($CGI->param("submit") ne "Submit" and $CGI->param("mode") eq "")
{
#Print Out The Creation Menu
print $CGI->header();
ParseForm($header);
print "<br><font size=+1>Create A Group Menu</font><br><br>\n";
print "<a href=\"creategroups.pl?mode=1\">Pick Players Individually</a><br>\n";
#print "<a href=\"creategroups.pl?mode=2\">Pick Characters Individually</a><br>\n";
#print "<a href=\"creategroups.pl?mode=3\">Copy An Existing Group</a><br>\n";
#print "<a href=\"creategroups.pl?mode=4\">Select All Players With A Skill</a><br>\n";
#print "<a href=\"creategroups.pl?mode=5\">Select All Players With An Item</a><br>\n";
print "<br><hr>You can <a href=\"login.pl\">Click Here</a> to return to the main menu page.";
ParseForm($footer);
}
elsif ($CGI->param("submit") ne "Submit" and $CGI->param("mode") == 1)
{
print $CGI->header();
ParseForm($header);
print "<br><font size=+1>Create a Player Group</font><br><br>\n";
print "<form name=\"frmCreate\" action=\"creategroups.pl\" method=\"post\">\n<table border=0 align=\"center\">\n<tr align=\"center\">\n";
print "<td align=\"center\">Group Name<br><input type=\"text\" name=\"groupname\" maxsize=30></td>\n</tr>\n<tr align=\"center\">\n";
print "<td align=\"center\">Group Description<br><input type=\"hidden\" value=\"1\" name=\"mode\"><textarea name=\"groupdesc\" cols=50 rows=5></textarea></td>\n</tr>\n<tr align=\"center\">\n";
print "<td>Players In This Group*</td>\n</tr>\n<tr align=\"center\">\n";
print "<td>\n";
print makeDropDown("players", "playerid", "concat(pfirst, \" \", plast) as playername", "", "MULTIPLE size=10");
print "</td>\n</tr>\n<tr align=\"center\">\n";
print "<td><input type=\"submit\" name=\"submit\" value=\"Submit\"></td>\n</tr>\n</table>\n</form>\n";
print "*You can choose multiple players by using Ctrl + click or Shift + click.";
print "<br><hr>You can <a href=\"login.pl\">Click Here</a> to return to the main menu page.";
ParseForm($footer);
}
else
{
#Create the group and redirect them to the login page.
    if ($CGI->param("submit") eq "Submit" and $CGI->param("mode") == 1)
    {
     $db = dbconnect();
     @players = $CGI->param("playerid");
     $groupDesc = $CGI->param("groupdesc");
     $groupDesc =~ s/\'/\\'/g;
     $groupDesc =~ s/\n/\n<br>\n/g;
     $groupName = $CGI->param("groupname");
     $groupName =~ s/\'/\\'/g;
     $groupName =~ s/\n/\n<br>\n/g;
     #print $CGI->header;
     #print "insert into playergroups(groupname, groupdesc, groupowner) values('" . $CGI->param("groupname") . "', '$groupDesc', $pid" . "\n<br><br>\n";
     $query = $db->prepare("insert into playergroups (groupname, groupdesc, groupowner) values ('$groupName', '$groupDesc', $pid)");
     $query->execute;
     $query->finish;
     $query = $db->prepare("select max(groupid) from playergroups");
     $query->execute;
     $groupid = $query->fetchrow_array;
     $query->finish;
         foreach $i (@players)
         {
     #    print "insert into playergroupmembers (playerid, groupid) values($pid, $groupid)\n<br>\n";
         $query = $db->prepare("insert into playergroupmembers (playerid, groupid) values ($pid, $groupid)");
         $query->execute;
         $query->finish;
     }
     #$db->disconnect;
    }
print $CGI->redirect("login.pl");
}