#!/usr/bin/perl

require 'stat_inc.pl';
require 'g_invest.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;
$CGI = new CGI;

$thispage = "dispnumblack.pl";
$pid = getPlayerID();
$al = getAccessLevel($pid);
$action = $CGI->param("action");
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
   print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to display blackmail material."));
}
elsif ($action eq "assign")
{
	#print $CGI->header;
   	local($db) = dbconnect();
	$sql = "select charid, level from characterabilities where abid=25";
   	#print"$sql<BR>";
   	$query = $db->prepare($sql);
   	$query->execute;
	
   	while (@array = $query->fetchrow_array())
        {
           $charid = $array[0];
           $level = $array[1];
       	   #print "for charid $charid<BR>\n";
    	   for ($i = 1; $i <= $level; $i++)
     	   {
	   	$sql = "SELECT a.bid FROM blackmail a JOIN blackmailcharacters b ON a.bid != b.bid WHERE b.charid=$charid or b.charid is NULL ORDER BY RAND() LIMIT 1;";
       		$bid = dosql($sql) + 0;
       		if ($bid == 0)
       		{
		   $sql = "SELECT a.bid FROM blackmail a ORDER BY RAND() LIMIT 1;";
		   $bid = dosql($sql) + 0;
       		}
       		#print "$bid<BR>\n";
       		$sql = "insert into blackmailcharacters (bid,charid,entrydate) values ($bid, $charid, CURDATE());";
       		$db->do($sql);
       		
    	   }
   	}
   	$query->finish;
   	$db->disconnect;
   	print $CGI->redirect("$thispage?error=" . encodeURL("Blackmail snippets updated."));
}

elsif ($action eq "doc")

{
	#print $CGI->header(-type  =>  'application/msword', -filename  =>  'blackmail.doc');
        print $CGI->header;
	print"<HTML>\n";
	print"<HEAD>\n";
	print"<link href=\"../brassy.css\" rel=\"stylesheet\" type=\"text/css\">\n";
	print"</HEAD>\n";
	print"<body topmargin=0 leftmargin=0 marginheight=0 marginwidth=0 bgcolor=#ffffff>\n";

   	local($db) = dbconnect();
  	
	$pcnpc[0] = "[NPC]";
	$pcnpc[1] = "[PC]";
	
	$sql = "SELECT a.text, a.isplayersecret, a.bid, b.charid FROM blackmail a JOIN blackmailcharacters b ON a.bid = b.bid order by b.charid, b.entrydate;";
   	#print"$sql<BR>";
   	$query = $db->prepare($sql);
   	$query->execute;
   	$oldcharid = -1;
   	while (@array = $query->fetchrow_array())
        {
           $charid = $array[3];
           if ($charid != $oldcharid)
           {
                if ($oldcharid > -1)
                {
   	   		print "</p>\n";
   	   		ParseForm("dispblack.tpl");
	   		print "<BR>[pb]<BR>\n";
                }
    	   	$charname = getCharName($charid);
    	   	print "<h1>Blackmail snippets for $charname</h1><p>\n";
    	   }
       	
       	   print "#$array[2]. $array[0] $pcnpc[$array[1]]<BR>\n";
       	   $oldcharid = $charid;
   	}
	print "</p>\n";
	ParseForm("dispblack.tpl");
	print "<BR>[pb]<BR>\n";
    	$query->finish;
   	$db->disconnect;
	print "</BODY>\n</HTML>\n";
}
elsif ($action eq "print")
{
	#print $CGI->header(-type  =>  'application/msword', -filename  =>  'blackmail.doc');
        print $CGI->header;
	print"<HTML>\n";
	print"<HEAD>\n";
	print"<link href=\"../brassy.css\" rel=\"stylesheet\" type=\"text/css\">\n";
	print"</HEAD>\n";
	print"<body topmargin=0 leftmargin=0 marginheight=0 marginwidth=0 bgcolor=#ffffff>\n";

	$makeperm = $CGI->param("makeperm") + 0;
	$level = $CGI->param("numsnip") + 0;
	$charid = $CGI->param("charid") + 0;

	$charname = getCharName($charid);
	print "<h1>Blackmail snippets for $charname</h1>\n";

	$pcnpc[0] = "[NPC]";
	$pcnpc[1] = "[PC]";

	$num = dosql("select count(bid) from blackmailcharacters where charid=$charid;") + 0;

   	local($db) = dbconnect();
	if ($num == 0)
	{
	   $sql = "SELECT a.text, a.isplayersecret, a.bid FROM blackmail a ORDER BY RAND() LIMIT $level;";
	}
	else
	{
	   $sql = "SELECT a.text, a.isplayersecret, a.bid FROM blackmail a JOIN blackmailcharacters b ON a.bid != b.bid WHERE b.charid=$charid or b.charid is NULL ORDER BY RAND() LIMIT $level;";
	}
   	#print"$sql<BR>";
   	local ($query) = $db->prepare($sql);
   	$query->execute;
	local (@array);
   	while (@array = $query->fetchrow_array())
        {
	   print "#$array[2]. $array[0] $pcnpc[$array[1]]<BR>\n";
	   if ($makeperm > 0)
	   {
       		$sql = "insert into blackmailcharacters (bid,charid,entrydate) values ($array[2], $charid, CURDATE());";
       		$db->do($sql);
	   }
	}
	
   	print "<BR>\n";
   	ParseForm("dispblack.tpl");

	print "</BODY>\n</HTML>\n";
}
else
{ 
	print $CGI->header;
	
	$doctitle = "Print Blackmail Snippets";
	ParseForm($header);

	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	print "<H1>$doctitle</h1>\n";
	
	print "<a href=\"javascript:assignConfirm();\">Assign Blackmail Snippets to Players.</a><BR><BR>\n";
	print "<a href=\"$thispage?action=doc\">Print Blackmail Snippets for Players.</a><BR><BR>\n";
	
	print "<hr width=75% color=gray><br><form action=\"$thispage\" method=\"post\">\n";
	
	print "<b>Number of Snippets:</b> ";
	print "<input type=\"text\" name=\"numsnip\" size=\"3\"><BR><BR>\n";

	print "<b>Is this for a specific character?:</b> ";
	print makeCharDropDown("charid",0);
	print "<BR><BR>\n";
	
	print "<input type=\"checkbox\" name=\"makeperm\" value=\"1\">\n";
	print "<b>Assign the snippets to the character permanently</b></input><BR><BR>\n ";
	
	print "<input type=\"hidden\" name=\"action\" value=\"print\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Do it\"><BR>\n";

	print "</form>\n";
      	print "<hr><a href=\"login.pl\">Main menu</a>.\n"; 
      	
	print "<script language=\"javascript\">\n";
	print "function assignConfirm()\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"This will make a permanent change to the database and should only be done once before each event.  Are you sure?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=assign\"\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
     	ParseForm($footer);   
}

exit(0);


# ********************
# * makeCharDropDown *
# ********************
# * makeCharDropDown makes a drop down field from characters.
sub makeCharDropDown
{
local($selectname) = $_[0];
local($value) = $_[1];
local ($db) = dbconnect();
$SQL = "select a.charid, concat(b.pfirst, ' ', b.plast) from characters a, players b, playercharacters c, characterSTATs d where c.pccharid=a.charid and b.playerid=c.pcplayerid and a.chartype != $test_character and d.charid=a.charid order by a.clast";
    
local($query) = $db->prepare($SQL);
$query->execute;

local ($retVal) = "";
local ($oldcharid) = -1;

#Check to make sure $query is not empty
    if ($query->rows > 0)
    {
        $retVal = "<select name=\"$selectname\">\n";
        local (@array);
        while (@array = $query->fetchrow_array)
        {
          if ($oldcharid != $array[0])
          {
	     if ($array[0] == $value)
	     {
		$retVal .= "<option value=\"$array[0]\" SELECTED>".getCharName($array[0])." ($array[1])</option>\n";
	     }
	     else
	     {
		$retVal .= "<option value=\"$array[0]\">".getCharName($array[0])." ($array[1])</option>\n";
	     }
          }
          $oldcharid = $array[0];
        }
        $retVal .= "</select>\n";
    }
$query->finish;
$db->disconnect;
return $retVal;
}

