#!/usr/bin/perl

require 'stat_inc.pl';
require 'g_invest.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;
$CGI = new CGI;
	
$statusText[0] = "Enemy of Crown and Country";
$statusText[1] = "Criminal";
$statusText[2] = "Low Class";
$statusText[3] = "Higher Lower Class";
$statusText[4] = "Lower Middle Class";
$statusText[5] = "Middle Class";
$statusText[6] = "Upper Middle Class";
$statusText[7] = "Minor Noble";
$statusText[8] = "Nobility";
$statusText[9] = "Lower Royalty";
$statusText[10] = "Royalty";

$thispage = "dispstats.pl";
$pid = getPlayerID();
$al = getAccessLevel($pid);
$action = $CGI->param("action");
$curchar = $CGI->param("charid") + 0;
   
if ($pid != getPIDFromCharID($CGI->param("charid")) && $al < $gm_access)
{
   print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to display stats for that character."));
}
elsif ($action eq "doc")
{
	$amount = $CGI->param("amount");

	print $CGI->header(-type  =>  'application/msword', -filename  =>  'stats.doc');
        #print $CGI->header;
   	local($db) = dbconnect();
   	if ($amount eq "next")
   	{
		$sql = "select c.pccharid from players a, eventplayers b, playercharacters c, characters d where a.playerid=b.playerid and b.eventid=$current_episode and b.reglevel > $not_attending and a.playerid=c.pcplayerid and d.charid=c.pccharid and (d.chartype=1 or d.chartype=2) and d.charid > 0 order by a.plast;";
	}
	else
   	{
		$sql = "select a.charid from characters a join characterSTATs b on a.charid=b.charid order by a.clast;";
	}
	
   	#print"$sql<BR>";
   	local ($query) = $db->prepare($sql);
   	$query->execute;
	local (@array);
   	while (@array = $query->fetchrow_array())
        {
           $curchar = $array[0];
   	   dispall();
   	   print "[pb]";
   	}
   	$query->finish;
   	$db->disconnect;
}
else
{
   
   if ($curchar > 0)
   {
      print $CGI->header;
      $doctitle = "Display Skills"; 
      ParseForm("revheader.tpl");
      dispall();
      print "<br><a href=\"login.pl\">Main menu</a>."; 
      ParseForm($footer);
   }
   else
   {
	print $CGI->header;
	ParseForm($header);
	print "<H1>Display STATs</h1>\n";
	
	print "<a href=\"$thispage?action=doc&amount=all\">Display STATs for all characters in database</a><BR><BR>\n";
	
	print "<a href=\"$thispage?action=doc&amount=next\">Display STATs for characters attending the next event.</a><BR><BR>\n";
	
	print "<form action=\"$thispage\" method=\"post\">\n";
	
	print "Choose Character:";
	print makeCharDropDown("charid",0);
	print "<input type=\"submit\" name=\"submit\" value=\"View Stats\"><BR>";

	print "</form>\n";
      	print "<br><a href=\"login.pl\">Main menu</a>."; 
      	ParseForm($footer);
   }
   
}

exit(0);

sub dispall()
{
   dispstats($curchar);
   $num = dosql("select dcid from damagechart where charid=$curchar;") + 0;
   if ($num == 0)
   {
   	$num = dosql("select dcid from damagechart where charid=0 and itemid=0;") + 0;
   }
   dispdamchart($num);
   dispskills("Handicap",$curchar);
   dispskills("Resource",$curchar);
   dispskills("Skill",$curchar);
   dispskills("Combat Manuever",$curchar);
   dispskills("Aptitude",$curchar);
   dispskills("Spell",$curchar);
   dispskills("Celestial",$curchar);
   if ($unholyallowed == 1)
   {
      dispskills("Infernal",$curchar);
   }
   dispWS($curchar);
   dispKR($curchar);
   dispVL($curchar);
}

sub dispstats()
{
   $charid = $_[0];
   $charname = getCharName($charid);
   $playername = getFullNameFromCharID($charid);
   setSTATvars();
   $libuse = $iq + getlevel("Library Use");
   
   print "<h1 style=\"font-family : Arial, Helvetica, sans-serif; font-size: 16;\"><b>Stats/Skills for $charname -- <i>$playername</i></b></h1>\n";
   
   print "<h2 style=\"font-family : Arial, Helvetica, sans-serif; font-size: 14;\">STATs</h2>\n";
   print "<table border=1>\n";
   print "<tr>";
   print "$midtd";
   print "STR: $str";
   print "</td>";
   print "$midtd";
   print "DEX: $dex";
   print "</td>";
   print "$midtd";
   print "IQ: $iq";
   print "</td>";
   print "$midtd";
   print "WILL: $will";
   print "</td>";
   print "$midtd";
   print "STATUS: $status ($statusText[$status])";
   print "</td>";
   print "</tr>\n";
   print "<tr>";
   print "$midtd";
   $hp = $str + $will + getlevel("HEALTHY");
   print "Hit Points: $hp";
   print "</td>";
   if ($holy > 0)
   {
      print "$midtd";
      print "Celestial: $holy";
      print "</td>";
   }
   if ($unholy > 0)
   {
      print "$midtd";
      print "Infernal: $unholy";
      print "</td>";
   }
   if ($mana > 0)
   {
      print "$midtd";
      print "MANA: $mana";
      print "</td>";
   }
   if ($inspiration > 0)
   {
      print "$midtd";
      print "Inspiration: $inspiration";
      print "</td>";
   }
   print "$midtd";
   $effstat = $status + getlevel("GENUINE CURIOUSITY/FAMOUS") - getlevel("SOCIAL STIGMA ______________");
   print "Effective Status: $effstat";
   print "</td>";
   print "</tr>\n";
   print "<tr>";
   print "$midtd";
   $uc = $str + getlevel("UNARMED/CLOSE WEAPONS");
   print "Unarmed/Close Weapons: $uc";
   print "</td>";
   print "$midtd";
   $ranged = $dex + getlevel("RANGED/THROWN WEAPONS");
   print "Ranged/Thrown Weapons: $ranged";
   print "</td>";
   print "$midtd";
   $dodge = $dex + getlevel("DODGE");
   print "Dodge: $dodge";
   print "</td>";
   print "$midtd";
   $libuse = $iq + getlevel("LIBRARY USE");
   print "Library Use: $libuse";
   print "</td>";
   print "</tr>\n";
   print "</table>";

}

sub dispskills()
{
   $curtabtext = $_[0];
   $charid = $_[1];
   $tabshow = 0;
   
   local($db) = dbconnect();
   $sql = "select * from characterabilities a, abilities b where a.charid=$charid and a.abid=b.abid and b.type='$curtabtext' order by b.name;";
   #print "$sql<BR>";  
   local ($query) = $db->prepare($sql);
   $query->execute;
   local ($resptr);
   local($numSkills) = $query->rows;
   if ($query->rows > 0)
   {
        local ($prev_resptr);
        $prev_resptr->{"abid"} = 0;
        $tabshow = 1;
   	print "<h2 style=\"font-family : Arial, Helvetica, sans-serif; font-size: 14;\">".$curtabtext."s</H2>\n";
   	print "<table border=0 width=100%>";
	while ($resptr = $query->fetchrow_hashref())
	{
	  if ($prev_resptr->{"abid"} == 0)
	  {
	  }
	  elsif ($resptr->{"abid"} == $prev_resptr->{"abid"})
	  {
	     showskillheader($prev_resptr);
	  }
	  else
	  {
      	     $effect = $prev_resptr->{"effect"};
   	     $constr = $prev_resptr->{"other_constraints"};
	     showskill($prev_resptr);
	  }
	  $prev_resptr = $resptr;
	}
      	$effect = $prev_resptr->{"effect"};
   	$constr = $prev_resptr->{"other_constraints"};
	showskill($prev_resptr);
   }
   $query->finish;
   if ($curtabtext eq "Celestial")
   {
      dispasholy($curchar);
   }
   
   dispkeyroleskills();
   
   if ($tabshow == 1)
   {
     print "</table>";
   }
	
   $db->disconnect;
   return $numSkills;
}

sub dispkeyroleskills()
{
   $sql = "select * from keyroleabilities a, abilities b, keyrolecharacters c, keyroles d where a.abid=b.abid and b.type='$curtabtext' and c.charid=$charid and c.krid=a.krid and a.krid=d.krid order by b.name;";
   #print "$sql<BR>";  
   local ($query2) = $db->prepare($sql);
   $query2->execute;
   if ($query2->rows > 0)
   {
        if ($tabshow == 0)
        {
   	   print "<table border=0 bgcolor=#eeeeee>";
        }
        $tabshow = 1;
  	$smalltd1 = "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"  bgcolor=#eeeeee>";
   	$smalltd2 = "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\" colspan=2  bgcolor=#eeeeee>";
   	$midtd = "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 12;\" bgcolor=#eeeeee>";
   	$midtd2 = "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 12;\" bgcolor=#eeeeee align=right>";
        local ($resptr);
        local ($prev_resptr);
        $prev_resptr->{"abid"} = 0;
	while ($resptr = $query2->fetchrow_hashref())
	{
	  if ($prev_resptr->{"abid"} == 0)
	  {
	  }
	  elsif ($resptr->{"abid"} == $prev_resptr->{"abid"})
	  {
	     showskillheader($prev_resptr);
	  }
	  else
	  {
	     $effect = $prev_resptr->{"effect"};
	     $constr = $prev_resptr->{"other_constraints"};
	     showskill($prev_resptr);
	  }
	  $prev_resptr = $resptr;
	}
      	$effect = $prev_resptr->{"effect"};
   	$constr = $prev_resptr->{"other_constraints"};
	showskill($prev_resptr);
  	$smalltd1 = "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\" >";
   	$smalltd2 = "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\" colspan=2>";
   	$midtd = "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 12;\">";
   	$midtd2 = "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 12;\" align=right>";
	$query2->finish;
   }
}

sub dispasholy()
{
   $charid = $_[0];
   
   local($db) = dbconnect();
   $sql = "select * from characterabilities a, abilities b, charabilityallowed c where a.charid=$charid and a.abid=b.abid and b.type='Infernal' and c.abid=a.abid and c.charid=$charid and c.asholy = 1 order by b.name;";
   #print "$sql<BR>";  
   local ($query) = $db->prepare($sql);
   $query->execute;
   local ($resptr);
   if ($query->rows > 0)
   {
        if ($tabshow == 0)
        {
   	   print "<h2 style=\"font-family : Arial, Helvetica, sans-serif; font-size: 14;\">Celestials</H2>\n";
   	   print "<table border=0 bgcolor=#eeeeee>";
   	   $tabshow = 1;
        }
	while ($resptr = $query->fetchrow_hashref())
	{
	  $effect = $resptr->{"effect"};
	  $constr = $resptr->{"other_constraints"};
	  $effect =~ s/Infernal/Celestial/g;
	  $constr =~ s/Infernal/Celestial/g;
	  showskill($resptr);
	}
   }
   $query->finish;
	
   $db->disconnect;
}

sub showskill()
{
   local ($resptr) = $_[0];
   showskillheader($resptr);
   print "<tr>";
   print "$smalltd2<u>Effect:</u> $effect</td>";
   print "</tr><tr>";
   if ($curtabtext eq "Spell")
   {
       print "$smalltd1<u>Time to Prepare</u>: ".$resptr->{"time"}."</td>";
   }
   else
   {
       print "$smalltd1<u>Time to Use</u>: ".$resptr->{"time"}."</td>";
   }
   print "$smalltd1<u>Number of Uses</u>: ".$resptr->{"uses"}."</td>";
   print "</tr><tr>";
   $constr =~ s|<table(.*)</table>|<i>Table deleted.</i>|i;	   
   $constr =~ s|\n|<BR>|g;	   
   print "$smalltd2<u>Other Constraints</u>: $constr<BR>";
   if ($curtabtext eq "Resource")
   {
      print showResourceLinks($resptr->{"caid"});
   }
   if ($curtabtext eq "Spell")
   {
      showComponents($charid, $resptr->{"abid"});
   }
   print "<hr></td>";
   print "</tr>";
}

sub showskillheader()
{
   local ($resptr) = $_[0];
   $myname = $resptr->{"name"};
   $myname =~ s/_//g;
   $myname = $myname . " " . $resptr->{"text"};
   print "<tr>";
   print "$midtd<b>$myname</b></td>";
   print "$midtd2<b>";
   if ($resptr->{"difficulty"} ne "Cost")
   {
	print "Level:   ".$resptr->{"level"};
   }
   if ($resptr->{"challenge"} ne "Unchallenged")
   {
      displaychallenge($resptr);
   }
   print "</b></td>";
   print "</tr>";
}

sub displaychallenge()
{
    local ($resptr) = $_[0];
    print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    print $resptr->{"challenge"} . " vs. " . $resptr->{"challenge_defense"};
    if ($resptr->{"challenge"} eq "5 + Ability Level")
    {
	print "<BR>";
	$num = 5 + $resptr->{"level"};
	print "<i>$num vs. "  . $resptr->{"challenge_defense"}. "</i>";
    }
    if ($resptr->{"challenge"} eq "DEX + Ability Level")
    {
	print "<BR>";
	$num = $dex + $resptr->{"level"};
	print "<i>$num vs. "  . $resptr->{"challenge_defense"}. "</i>";
    }
    if ($resptr->{"challenge"} eq "DEX - Ability Level")
    {
	print "<BR>";
	$num = $dex - $resptr->{"level"};
	print "<i>$num vs. "  . $resptr->{"challenge_defense"}. "</i>";
    }
    if ($resptr->{"challenge"} eq "IQ - Ability Level")
    {
	print "<BR>";
	$num = $iq - $resptr->{"level"};
	print "<i>$num vs. "  . $resptr->{"challenge_defense"}. "</i>";
    }
    if ($resptr->{"challenge"} eq "IQ + Ability Level")
    {
	print "<BR>";
	$num = $iq + $resptr->{"level"};
	print "<i>$num vs. "  . $resptr->{"challenge_defense"}. "</i>";
    }
    if ($resptr->{"challenge"} eq "Library Use + Ability Level")
    {
	print "<BR>";
	$num = $libuse + $resptr->{"level"};
	print "<i>$num vs. "  . $resptr->{"challenge_defense"}. "</i>";
    }
    if ($resptr->{"challenge"} eq "STR + Ability Level")
    {
	print "<BR>";
	$num = $str + $resptr->{"level"};
	print "<i>$num vs. "  . $resptr->{"challenge_defense"}. "</i>";
    }
    if ($resptr->{"challenge"} eq "STR - Ability Level")
    {
	print "<BR>";
	$num = $str - $resptr->{"level"};
	print "<i>$num vs. "  . $resptr->{"challenge_defense"}. "</i>";
    }
    if ($resptr->{"challenge"} eq "WILL - Ability Level")
    {
	print "<BR>";
	$num = $will - $resptr->{"level"};
	print "<i>$num vs. "  . $resptr->{"challenge_defense"}. "</i>";
    }
    if ($resptr->{"challenge"} eq "WILL + Ability Level")
    {
	print "<BR>";
	$num = $will + $resptr->{"level"};
	print "<i>$num vs. "  . $resptr->{"challenge_defense"}. "</i>";
    }
    if ($resptr->{"challenge"} eq "STR + Unarmed Combat")
    {
	print "<BR>";
	$num = $str + getlevel("UNARMED/CLOSE WEAPONS");
	print "<i>$num vs. "  . $resptr->{"challenge_defense"}. "</i>";
    }
    if ($resptr->{"challenge"} eq "DEX + Ranged Weapons")
    {
	print "<BR>";
	$num = $dex + getlevel("RANGED/THROWN WEAPONS");
	print "<i>$num vs. "  . $resptr->{"challenge_defense"}. "</i>";
    }
    if ($resptr->{"challenge"} eq "Status + Ability Level")
    {
	print "<BR>";
	$num = $status + $resptr->{"level"};
	print "<i>$num vs. "  . $resptr->{"challenge_defense"}. "</i>";
    }

}

sub showResourceLinks()
{
  	local ($caid) = $_[0];
	local($db) = dbconnect();
	local ($sql) = "select * from resourcetypes a, characterresourcetypelink b where a.typeid=b.typeid and b.abid=$caid order by a.type;";
	#print "$sql<BR>";
	local($query) = $db->prepare($sql);
	$query->execute;
	local ($resptr);
	$rlretstr = "<table border = 0 width=100% cellspacing=0 cellpadding=0><tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   if ($resptr->{"showplayer"} == 0)
	   {
	   }
	   elsif ($resptr->{"isnumeric"} == 0)
	   {
	     $rlretstr .= "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><u>".$resptr->{"type"}.":</u>  ".$levels[$resptr->{"level"}]."</td>";
	   }
	   else
	   {
	     $rlretstr .= "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><u>".$resptr->{"type"}.":</u>  ".$resptr->{"level"}."</td>";
	   }
	}
	$rlretstr .= "</tr></table>\n";
	$query->finish;
	$db->disconnect;
	return $rlretstr;
}

sub showComponents()
{
	local($charid) = $_[0];
	local($abid) = $_[1];
	local($db) = dbconnect();
	$sql = "select b.scname, a.sideeffect, b.scorigin from spellcomponentslink a, spellcomponents b, spellcomponentscharacterlink c where a.scid=b.scid and a.abid=$abid and a.sclid=c.sclid and c.charid= $charid order by b.scname;";
	#print "$sql<BR>";
	local($query) = $db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
	   print "<u>Known Spell Components</u>\n";
	   print "<table border=1 width=100%>\n";
	   print "<tr>\n";
	   print "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><u>Name</u></td>\n";
	   print "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><u>Effect</u></td>\n";
	   print "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><u>Found In</u></td>\n";
	   print "</tr>\n";
	   while (@array = $query->fetchrow_array())
	   {
	     print "<tr>\n";
	     print "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\">$array[0]</td>\n";
	     print "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\">$array[1]</td>\n";
	     print "<td style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\">$array[2]</td>\n";
	     print "</tr>\n";
	   }
	   print "</table>\n";
	   print "</p>\n";
	}
	$query->finish;
	$db->disconnect;
}

sub dispWS()
{
   local ($charid) = $_[0];
   
   $alchemylevel = getlevel("ALCHEMY","");
   
   if ($inspiration > 0 || $alchemylevel > 0)
   {
	local($db) = dbconnect();
	$ws_level = $weirdscience;
	
	$ws_points = $ws_level * $ws_mult;
	$ws_cost = getcost($ws_level,2);
	$totalcost = $ws_cost;
	
	#that was the easy part.
	$num_applications = 0;
	$sql = "select * from applications where amfid=0 order by aname";
	local($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $aid[$num_applications] = $resptr->{"aid"};
	   $applications[$num_applications] = $resptr->{"aname"};
	   $application_text[$num_applications] = $resptr->{"adesc"};
	   $num_applications += 1;
	}
	$query->finish;
	
	$num_motives = 0;
	$sql = "select * from motiveforces order by mfsecret, mfname desc";
	local($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $mfid[$num_motives] = $resptr->{"mfid"};
	   $mfsecret[$num_motives] = $resptr->{"mfsecret"} + 0;
	   $motives[$num_motives] = $resptr->{"mfname"};
	   $motive_text[$num_motives] = $resptr->{"mfdesc"};
	   $num_motives += 1;
	}
	$query->finish;
	
	$spent = 0;
	$ws_chart = "<table border=1 cellspacing=0 cellpadding=1 align=center>\n";
	$ws_chart .= "<tr><td colspan=2 rowspan=2 style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\">&nbsp;</td><td colspan=$num_applications align=center style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><b>Applications</b></td></tr>\n";
	$ws_chart .= "<tr>";
	for ($k=0; $k < $num_applications; $k++)
	{
	   if ($inspiration > 0)
	   {
	   	$ws_chart .= "$smalltd3 $applications[$k] </td>";
	   }
	   else
	   {
	   	$ws_chart .= "&nbsp; </td>";
	   }
	}
	$ws_chart .= "</tr>\n";
	$ws_chart .= "<tr><td colspan=2 align=center style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><b>Motive Forces</b></td>";
	for ($k=0; $k < $num_applications; $k++)
	{
	   if ($inspiration > 0)
	   {
		   $apvals[$k] = getapplication($aid[$k]);
		   $ws_chart .= "$smalltd3";
		   $ws_chart .= "$apvals[$k]</td>";
	   }
	   else
	   {
	   	$ws_chart .= "&nbsp; </td>";
	   }
	}
	$ws_chart .= "</tr>\n";
	$num_shown_motives = 0;
	for ($k=0; $k < $num_motives; $k++)
	{
	   local ($mfval) = getmotiveforce($mfid[$k]);
	   if ("$mfsecret[$k]" eq "0" && $inspiration > 0)
	   {
		$ws_chart .= "<tr>$smalltd1 $motives[$k]</td>\n";
		$ws_chart .= "$smalltd3 $mfval</td>";
		for ($j=0; $j < $num_applications; $j++)
		{
		   $ws_chart .= "$smalltd3". min($mfval,$apvals[$j]);
		   
		   $sql = "select aname from applications where amfid=$mfid[$k] and abaseid=$aid[$j];";
		   local($mystr) = dosql($sql);
		   #print "$sql<BR>";		   
		   if ($mystr ne "0")
		   {
		     $ws_chart .= "<BR><i>($mystr)</i>";
		   }
		   $ws_chart .= "</td>";
		}
		$ws_chart .= "</tr>\n";
		$num_shown_motives++;
	   }
	   elsif (canshowmotiveforce($mfid[$k]) && $inspiration > 0)
	   {
		$ws_chart .= "<tr><td bgcolor=#eeeeee style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\">$motives[$k]</td>\n";
		$ws_chart .= "$smalltd1 $mfval</td>";
		for ($j=0; $j < $num_applications; $j++)
		{
		   $ws_chart .= "<td align=center bgcolor=#eeeeee style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\">". min($mfval,$apvals[$j]);
		    
		   $sql = "select aname from applications where amfid=$mfid[$k] and abaseid=$aid[$j];";
		   local($str) = dosql($sql);
		   #print "$sql<BR>";		   
		   if ($str ne "0")
		   {
		     $ws_chart .= "<BR><i>($str)</i>";
		   }
		   $ws_chart .= "</td>";
		}
		$ws_chart .= "</tr>\n";
		$num_shown_motives++;
	   }
	   elsif ($alchemylevel > 0 && $motives[$k] eq "Alchemy")
	   {
	   	$mfval = $alchemylevel;
		$ws_chart .= "<tr><td bgcolor=#eeeeee style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\">$motives[$k]</td>\n";
		$ws_chart .= "$smalltd1 $mfval</td>";
		for ($j=0; $j < $num_applications; $j++)
		{
		   $ws_chart .= "<td align=center bgcolor=#eeeeee style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\">". min($mfval+$apvals[$j],6);
		    
		   $sql = "select aname from applications where amfid=$mfid[$k] and abaseid=$aid[$j];";
		   local($str) = dosql($sql);
		   #print "$sql<BR>";		   
		   if ($str ne "0")
		   {
		     $ws_chart .= "<BR><i>($str)</i>";
		   }
		   $ws_chart .= "</td>";
		}
		$ws_chart .= "</tr>\n";
		$num_shown_motives++;
	   }
	}
	$ws_chart .= "</table>\n";
	$db->disconnect;	

	if ($inspiration > 0 && $alchemylevel > 0)
	{
		print "<h2 style=\"font-family : Arial, Helvetica, sans-serif; font-size: 14;\">Weird Science/Alchemy</H2><BR>\n";
		print "<B>Weird Science Skill Level: $weirdscience</b><BR>\n";
	}
	elsif ($inspiration > 0)
	{
		print "<h2 style=\"font-family : Arial, Helvetica, sans-serif; font-size: 14;\">Weird Science</H2><BR>\n";
		print "<p style=\"font-family : Arial, Helvetica, sans-serif; font-size: 12;\"><B>Weird Science Skill Level: $weirdscience</b></p>\n";
	}
	else 
	{
		print "<h2 style=\"font-family : Arial, Helvetica, sans-serif; font-size: 14;\">Alchemy</H2><BR>\n";
	}
 	print $ws_chart;
   	print "<BR><hr>\n";
   }
}

sub dispKR()
{
  	local($charid) = $_[0];
   	local($db) = dbconnect();
   	local $sql = "select * from keyroles a, keyrolecharacters b where b.charid=$charid and a.krid=b.krid order by a.krname;";
   	#print"$sql<BR>";
   	local ($query) = $db->prepare($sql);
   	$query->execute;
   	if ($query->rows > 0)
   	{
   	  print "<h2 style=\"font-family : Arial, Helvetica, sans-serif; font-size: 14;\">Key Roles</H2><BR>\n";
   	  while ($resptr = $query->fetchrow_hashref())
   	  {
   		print "<h3 style=\"font-family : Arial, Helvetica, sans-serif; font-size: 12;\"><b>".$resptr->{"krname"}."</b></h3>\n";
   		print "<p style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><u>Description:</u> ".$resptr->{"krdescription"}."<BR>\n";
   		print "<p style=\"font-family : Arial, Helvetica, sans-serif; font-size: 10;\"><u>Requirements:</u> ".$resptr->{"krrequirements"}."</p>\n";
   	  }
   	  print "<hr>\n";
   	}
   	$query->finish;
   	$db->disconnect;
}

sub dispVL()
{
  	local($charid) = $_[0];
   	local($db) = dbconnect();
   	print "<h2 style=\"font-family : Arial, Helvetica, sans-serif; font-size: 14;\">Virtual Locations</H2><BR>\n";
	print "<table width=100% border = 1>";
	print "<tr>";
	print "$midtd <b>Name</b></td>";
	print "$midtd <b>Description</b></td>";
	print "</tr>";
	$num_vls = 0;
	$spent = 0;
	
	$sql = "select * from virtuallocations where vlowner = $charid";
	local($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	    print "<tr>";
	    print "$midtd ".$resptr->{"vlname"}."</td>";
	    print "$midtd ".$resptr->{"vldesc"}."</td>";
	    print "</tr>\n";
	    print "<tr>";
	    print "<td colspan=2>";
	        $val = 0;
		print "<table border=1 width=100%>";
		print "<tr> ";
		$val = getVLtotal($resptr->{"vlid"},"vl_fancy", "vla_fancy");
		print "$smalltd1 Fancy: $val </td>";
		$val = getVLtotal($resptr->{"vlid"},"vl_secure", "vla_secure");
		print "$smalltd1 Secure: $val </td>";
		$val = getVLtotal($resptr->{"vlid"},"vl_location", "vla_location");
		print "$smalltd1 Location: $val </td>";
		$val = getVLtotal($resptr->{"vlid"},"vl_inventory", "vla_inventory");
		print "$smalltd1 Inventory: $val </td>";
		print "</tr>\n";	
		print showspecialVLstats($resptr->{"vlid"}, $num_vls, "vl");
		print "</table>\n";
	    print "</td>";
	    print "</tr>\n";
	    $num_vls++;
	}
	$query->finish;
	$num_vlas = 0;
	$sql = "select * from virtuallocations a, VLaccess b where a.vlid=b.vlid and b.charid = $charid";
	local($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	    print "<tr bgcolor=#EEEEEE>";
	    print "$midtd ".$resptr->{"vlname"}."</td>";
	    print "$midtd ".$resptr->{"vldesc"}."</td>";
	    print "</tr>\n";
	    print "<tr bgcolor=#EEEEEE>";
	    print "<td colspan=2>";
		print "<table border=1 width=100%>";
		print "<tr bgcolor=#EEEEEE> ";
		$val = getVLtotal($resptr->{"vlid"},"vl_fancy", "vla_fancy");
		print "$smalltd1 Fancy: $val </td>";
		$val = getVLtotal($resptr->{"vlid"},"vl_secure", "vla_secure");
		print "$smalltd1 Secure: $val </td>";
		$val = getVLtotal($resptr->{"vlid"},"vl_location", "vla_location");
		print "$smalltd1 Location: $val </td>";
		$val = getVLtotal($resptr->{"vlid"},"vl_inventory", "vla_inventory");
		print "$smalltd1 Inventory: $val </td>";
		print "</tr>\n";		
		print showspecialVLstats($resptr->{"vlid"}, $num_vlas, "vla");
		print "</table>\n";
	    print "</td>";
	    print "</tr>\n";
	    $num_vlas++;
	}
	$query->finish;
	print "</table>\n";
	$query->finish;
   	$db->disconnect;
}

sub showspecialVLstats()
{
  local ($vlid) = $_[0];
  local ($nums) = $_[1];
  local ($jssub) = $_[2];
  local($db) = dbconnect();
  local ($sql) = "select b.vlsname, a.vlsid, b.vlsdesc from VLstatlink a, VLstats b, virtuallocations c where a.vlid=$vlid and a.vlsid=b.vlsid and a.charid=c.vlowner and c.vlid=$vlid;";
  #print "$sql<BR>";
  local($query) = $db->prepare($sql);
  $query->execute;
  local($retstr)= "";
  local ($sub) = 0;
  if ($query->rows > 0)
  {
     $retstr .= "<tr>\n";
     local ($resptr);
     while ($resptr = $query->fetchrow_hashref())
     {
        $sql = "select vlslevel from VLstatlink where vlid=$vlid and vlsid=".$resptr->{"vlsid"}." and charid=$charid;";
   	#print "$sql<BR>";
  	local($query2) = $db->prepare($sql);
  	$query2->execute;
  	local (@myval);
  	$myval[0] = 0;
  	if ($query2->rows > 0)
  	{
  		@myval = $query2->fetchrow_array();
  	}
	$query2->finish;
        $sql = "select sum(vlslevel) from VLstatlink where vlid=$vlid and vlsid=".$resptr->{"vlsid"}.";";
   	#print "$sql<BR>";
  	$query2 = $db->prepare($sql);
  	$query2->execute;
  	local (@mysum);
  	$mysum[0] = 0;
  	if ($query2->rows > 0)
  	{
  		@mysum = $query2->fetchrow_array();
  	}
	$query2->finish;
        local ($name) = $resptr->{"vlsname"};
     	$retstr .= "$smalltd1 ";
     	$retstr .= "<i>$name: ";
     	$retstr .= $mysum[0];
     	$retstr .= "</i></td>\n";
     }
     $retstr .= "</tr>\n";
  }
  $query->finish;
  $db->disconnect;
  return $retstr;
}

sub dispdamchart()
{
   $dcid = $_[0];
   
   local ($mystr);
   $nummsg = 6;
   $msgstr[0] = "";
   $msgstr[1] = "\\(A:";
   $msgstr[2] = "Reroll";
   $msgstr[3] = "Fierce";
   $msgstr[4] = "Stun";
   $msgstr[5] = "P";
   $msgshow[0] = 0;
   $msgshow[1] = 0;
   $msgshow[2] = 0;
   $msgshow[3] = 0;
   $msgshow[4] = 0;
   $msgshow[5] = 0;
   $msgmsg[0] = ": Target takes no damage.";
   $msgmsg[1] = "(A:): Attacker takes damage in Parentheses.";
   $msgmsg[2] = "Reroll: Target takes damage listed, plus attacker may roll the die again to do additional damage in this attack.";
   $msgmsg[3] = "Fierce: Roll STR vs. WILL. If successful, target gains a Blue Star of Fear that lasts for the rest of the combat.";
   $msgmsg[4] = "Stun: Target is stunned and cannot do anything except evade the next round of combat.";
   $msgmsg[5] = "P: Poison.  This damage cannot be healed with surgery.  It requires anti-venoms, or physician.  Damage may be healed by magic, alchemy, or celestials.";
   
   local($db) = dbconnect();
   $sql = "select * from damagechart where dcid=$dcid;";
   #print "$sql<BR>";  
   local ($query) = $db->prepare($sql);
   $query->execute;
   local ($resptr);
   if ($query->rows > 0)
   {
	print "<h2 style=\"font-family : Arial, Helvetica, sans-serif; font-size: 14;\">Damage Chart for Unarmed Combat</h2>";
	print "<table border=1>\n";
	print "<tr>\n";
	print "$midtd<b>Roll</b></td>";
	for ($i = 1; $i < 10; $i++)
	{
	  print "$midtd<b>$i</b></td>";
	}
	print "$midtd<b>0</b></td>";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "<tr>\n";
	   print "$midtd<b>Result</b></td>";
	   for ($i = 1; $i < 10; $i++)
	   {
	        $mystr = $resptr->{"roll$i"};
	  	print "$midtd$mystr</td>";
	  	for ($j = 0; $j < $nummsg; $j++)
	  	{
	  	    #print "$j $msgshow[$j] --";
	  	    $msgshow[$j] += int($mystr =~ m/$msgstr[$j]/);
	  	    #print " ($mystr) vs. ($msgstr[$j]) is (".int($mystr =~ m/$msgstr[$j]/).")($msgshow[$j])<BR>\n";
	  	}
	   }
	   $mystr = $resptr->{"roll0"};
	   print "$midtd $mystr</td>";
	   for ($j = 0; $j < $nummsg; $j++)
	   {
	    #print "$j $msgshow[$j] --";
	    $msgshow[$j] += int($mystr =~ m/$msgstr[$j]/);
	    #print " ($mystr) vs. ($msgstr[$j]) is (".int($mystr =~ m/$msgstr[$j]/).")($msgshow[$j])<BR>\n";
	   }
	   print "</tr>\n";
	}
	print "</table>\n";
	$query->finish;
   }
   $query->finish;
   
   for ($j = 0; $j < $nummsg; $j++)
   {
     if ($msgshow[$j])
     {
     	 print "<p style=\"font-family : Arial, Helvetica, sans-serif; font-size: 12;\">";
         print "<i>$msgmsg[$j]</i></p>\n";
     }
   }
	
   $db->disconnect;
}



# ********************
# * makeCharDropDown *
# ********************
# * makeCharDropDown makes a drop down field from characters.
sub makeCharDropDown
{
local($selectname) = $_[0];
local($value) = $_[1];
local ($db) = dbconnect();
$SQL = "select a.charid, concat(b.pfirst, ' ', b.plast) from characters a, players b, playercharacters c, characterSTATs d where c.pccharid=a.charid and b.playerid=c.pcplayerid and a.chartype != $test_character and d.charid=a.charid and a.charid > 0 order by a.clast";
    
local($query) = $db->prepare($SQL);
$query->execute;

local ($retVal) = "";

#Check to make sure $query is not empty
    if ($query->rows > 0)
    {
        $retVal = "<select name=\"$selectname\">\n";
        local (@array);
        while (@array = $query->fetchrow_array)
        {
          if ("$array[0]" eq "$value")
          {
            $retVal .= "<option value=\"$array[0]\" SELECTED>".getCharName($array[0])." ($array[1])</option>\n";
          }
          else
          {
            $retVal .= "<option value=\"$array[0]\">".getCharName($array[0])." ($array[1])</option>\n";
          }
        }
        $retVal .= "</select>\n";
    }
$query->finish;
$db->disconnect;
return $retVal;
}

