#!/usr/bin/perl

require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "doblack.pl";
$table = "npcsecrets";
$heading = "Blackmail";
$keyfield = "npcsid";
$keyvalue = $CGI->param($keyfield);
$namefield = "concat(charname, ' -- ', text)";
$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
$errstr = $CGI->param("error");

$step = $CGI->param("step") + 0;
$charid = $CGI->param("charid");
$charname = getCharName($charid);

$wantmoney = $CGI->param("wantmoney") + 0;
$wantvotes = $CGI->param("wantvotes") + 0;
$wantsubfree = $CGI->param("wantsubfree") + 0;
$wantbga = $CGI->param("wantbga") + 0;

if ($al < $writer_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to visit this page!"));
}
elsif ($action eq "addsub")
{
	#print $CGI->header;
   	$thedate = getDBDate();
   	$val = $CGI->param("points");
   	$namevalue =~ s/'/''/g;
	$sql = "insert into charactersubstatpoints (charid,points,entrydate,notes) values ($charid, $val, '$thedate', 'From Blackmail: $namevalue');";
	#print "$sql<BR>\n";
	dosql($sql);
	print $CGI->redirect("$thispage?error=" . encodeURL("SubStatus for $charname updated"));
}

elsif ($step == 6)
{
	print $CGI->header;
	$doctitle = "Perform Blackmail: Results";
	ParseForm($header);
	
	print "<H1>$doctitle</h1>\n";
	
	$brid = $CGI->param("brid");
	$sql = "select * from blackres where brid=$brid;";
	
	local($db) = dbconnect();
	local ($query) = $db->prepare($sql);
	$query->execute;
	local ($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
		$charid = $resptr->{"charid"};
		$keyvalue = $resptr->{$keyfield};
		$wantmoney = $resptr->{"money"} + 0;
		$wantvotes = $resptr->{"votes"} + 0;
		$wantsubfree = $resptr->{"subfree"} + 0;
		$wantbga = $resptr->{"bga"} + 0;
		$result = $resptr->{"result"} + 0;
	}
	$query->finish;
	$db->disconnect;

	$namevalue = dosql("select $namefield from $table where $keyfield=$keyvalue;");
	$charname = getCharName($charid);
		
	print "<H2>Results for $charname blackmailing $namevalue</H2><BR>\n";
	
	$status = dosql("select status from $table where $keyfield=$keyvalue;");
	$level = dosql("select level from $table where $keyfield=$keyvalue;");
	$money = d11($status * $level);
	$votes = min($status,$level);
	$subfree = min($status,$level);
	$bga = 0;
	
	if ($result > 5)
	{
	   print "<p><b>Super Success!</b>  The NPC is terrified that the secret might leak out.  You get all that you asked for and more.</p>\n";
	   $money = int($money * 1.5);
	   $votes += 1;
	   $subfree += 1;
	   $bga = 1;
	}
	elsif ($result > 1)
	{
	   print "<p><b>Full Success</b>  You have convinced the NPC to give you what you asked for.</p>\n";
	   $bga = 1;
	}
	elsif ($result > -2)
	{
	   print "<p><b>Partial Success</b>  The NPC hedges or allows for a partial payment.</p>\n";
	   $money = int($money / 2);
	   $votes = max(0,$votes-1);
	   $subfree = max(0,$subfree-1);
	}
	elsif ($result > -6)
	{
	   print "<p><b>Failure</b>  The NPC refuses to pay, but does nothing special to reveal your blackmail attempt.</p>\n";
	   $money = 0;
	   $votes = 0;
	   $subfree = 0;
	}
	else
	{
	   print "<p><b>Catastrophic Failure</b>  The NPC not only doesnt pay, but attempts to have you arrested or scandalized.  In general, we will not screw over your character with this.  We dont want to discourage people from blackmailing.  The NPCs attempts may fail.<BR><BR>\n";
	   
	   print "<i>Please alert a GM of the results of this Blackmail attempt after it is resolved.  We may wish to take action.</i></p>\n";
	   $money = 0;
	   $votes = 0;
	   $subfree = 0;
	   $bga = 0;
	}

	print "<p>Please feel free to roleplay out the blackmail attempt.  It is fine if it is an artifice for letters being sent back and forth or whatever paranoid contrivance the player attempts to perform.</p>\n";
	
	if ($wantmoney > 0)
	{
	   print "<p><b>Money:</b>  NPC is willing to part with $money and not a farthing more.  Add the money to the player character's Ledger.</p>\n";
	}
	
	if ($wantvotes > 0)
	{
	   print "<p><b>Votes:</b>  NPC is willing to part with $votes Vote Token(s).  Find the blank vote tokens, write the NPC's name on them and hand them to the player.</p>\n";
	}
	
	if ($wantsubfree > 0)
	{
	   print "<p><b>Substatus Freebie Points:</b>  You gain $subfree Substatus Freebie Point(s).  ";
	   if ($subfree > 0)
	   {
	   	print "Click <a href=\"$thispage?action=addsub&charid=$charid&points=$subfree&$keyfield=$keyvalue\">here</a> to add them automatically after the attempt is resolved.";
	   }
	   print "</p>\n";
	}
	
	if ($wantbga > 0)
	{
	   print "<p><b>Between Games Action:</b>  ";
	   if ($bga > 0)
	   {
	   	print "The NPC will perform a BGA for you during the next BGP.  This will show up as an option on your BGA list.";
	   }
	   else
	   {
	   	print "The NPC will not perform an action for you between games.";
	   }
	   print "</p>\n";
	}
	
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
elsif ($step == 5)
{
	#just process and redirect results
	#print $CGI->header;
	
	$numclues = $CGI->param("numclues") + 0;
	$clues = 0;
	
	for ($i = 0; $i < $numclues; $i++)
	{
	  $clues += $CGI->param("clue_$i");
	}
	
	#print "$clues out of $numclues<BR>\n";
	
	#handle blackmail
	
	#player roll
	#base player iq
	$sql = "select iq from characterSTATs where charid=$charid;";
	$roll1 = dosql($sql) + 0;
	
	#plus higher of pursuade or fast talk
	$roll1 += max(getlevel("FAST TALK"),getlevel("PERSUADE"));
	
	#plus the number of pieces of information the player has
	$roll1 += $clues;
	
	#vs. npc roll
	#the npc's will.
	$sql = "select will from npcsecrets where $keyfield=$keyvalue;";
	$roll2 = dosql($sql) + 0;
	
	#plus the previous number of blackmail attempts on the NPC
	$count = dosql("select count(brid) from blackres where npcsid=$keyvalue;");
	$roll2 += $count;
	
	#plus the number of pieces of information the player is missing
	$roll2 += $numclues - $clues;
	
	#plus the number of things the player has asked for
	$roll2 += $wantmoney + $wantvotes + $wantsubfree + $wantbga;
	
	$roll1 += d11(1);
	$roll2 += d11(1);
	
	#print "$roll1 vs. $roll2<BR>\n";
	
	$num = $roll2 - $roll1;
	
	if ($count > 3)
	{
	  $num = -3; #failure
	}
	
	$sql = "insert into blackres (npcsid, charid, result, money, votes, subfree, bga) values ($keyvalue, $charid, $num, $wantmoney, $wantvotes, $wantsubfree, $wantbga);";
	
	#print "$sql<BR>\n";
	
	local($db) = dbconnect();
	$db->do($sql);
	$num = $db->{'mysql_insertid'};
	#print "$num<BR>\n";
	$db->disconnect;
	
	print $CGI->redirect("$thispage?step=6&brid=$num&charid=$charid&npcsid=$keyvalue");
}
elsif ($step == 4)
{
	print $CGI->header;
	$doctitle = "Perform Blackmail";
	ParseForm($header);
	
	print "<H1>$doctitle</h1>\n";
		
	print "<p><i>This page is for assistant/floor GMs to handle Blackmail.  If you need help working this page, find a GM.</i></p>\n";

	print "<H2>$charname is blackmailing $namevalue</H2>\n";
	
	print "<form action=\"$thispage\" method=\"post\">";

	print "<h2>Step 4</h2>\n";
	
	print "<p><i>Ask the player to read you the list of clues for the blackmail attempt.  Check off the ones below as they read them.  Ignore any clues the player gives you that are not on the list.  It is possible when the player is done, that the player has some, all, or none of the correct clues.</i></p>\n";
	
	$sql = "select bid, text from blackmail where linkid=$keyvalue and isplayersecret=0;";
	#print "$sql<BR>\n";
	
	local($db) = dbconnect();
	local ($query) = $db->prepare($sql);
	$query->execute;
	$num = 0;
	while (@array = $query->fetchrow_array())
	{
	   print "<input type=checkbox name=clue_$num value=1> $array[1]</input><BR>\n";
	   print "<input type=\"hidden\" name=\"bid_$num\" value=\"$array[0]\">\n";
	   $num++;
	}
	$query->finish;
	$db->disconnect;
	
	print "<input type=\"hidden\" name=\"numclues\" value=\"$num\">\n";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"hidden\" name=\"wantmoney\" value=\"$wantmoney\">\n";
	print "<input type=\"hidden\" name=\"wantvotes\" value=\"$wantvotes\">\n";
	print "<input type=\"hidden\" name=\"wantsubfree\" value=\"$wantsubfree\">\n";
	print "<input type=\"hidden\" name=\"wantbga\" value=\"$wantbga\">\n";
	print "<input type=\"hidden\" name=\"step\" value=\"5\">\n";
	print "<BR><input type=\"submit\" name=\"submit\" value=\"Display Results \"><BR>";
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
else
{
	print $CGI->header;
	$doctitle = "Perform Blackmail";
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle</h1>\n";
	
	print "<p><i>This page is for assistant/floor GMs to perform blackmail on NPCs.  If you need help working this page, find a GM.</i></p>\n";

	print "<form action=\"$thispage\" method=\"post\">";

	print "<h2>Step 1</h2>\n";
	
	print "<p><i>Select the blackmailer from the drop down list.  This is a list of all player characters with STATs.  If a group of players are working together to cast the spell, then have them choose one to be the blackmailer.  If the blackmailer isn't on this list, then fetch a GM.</i></p>\n";
	
	print createCharDrop() ."<BR>\n";

	print "<h2>Step 2</h2>\n";
	
	print "<p><i>Ask the players which NPC they wish to blackmail, and what secret they are trying to blackmail for.<BR><BR>\n";
	print "Select that NPC Blackmail combination from the dropdown list.  If the combination does not exist, check the box below.</i></p>\n";
	
	print createBlackDrop() ."<BR>\n";

	print "<h2>Step 3</h2>\n";
	
	print "<p><i>Ask the player what s/he wants to get out of the Blackmail attempt.  The player can choose as much as s/he wants, but being too greedy increases a chance of failure.</i></p>\n";
	
	print "<p><input type=checkbox name=wantmoney value=1> Money</input><BR>\n";
	print "<input type=checkbox name=wantvotes value=1> Vote Tokens</input><BR>\n";
	print "<input type=checkbox name=wantsubfree value=1> A Substatus Freebie Point</input><BR>\n";
	print "<input type=checkbox name=wantbga value=1> A Between Game Task</input></p>\n";
	
	print "<p><i>Keep in mind the following things:</i></p>\n";
	print "<ul>\n";
	print "<li>  You do not need to know their stats.  The database takes care of that.\n";
	print "</ul>\n";

	print "<input type=\"hidden\" name=\"step\" value=\"4\"><BR>";
	print "<input type=\"submit\" name=\"submit\" value=\"Go To Step 4\"><BR>";
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
exit 0;

sub createCharDrop
{
    local ($db) = dbconnect();
    $SQL = "select a.charid, concat(a.cfirst, ' ', a.clast), a.ctitle from characters a,  characterSTATs b where a.charid=b.charid and a.chartype = $player_character and a.charid > 0 order by a.clast;";
 
    local($query) = $db->prepare($SQL);
    #print "$SQL<BR>";
    $query->execute;

    local ($retVal) = "";
    if ($query->rows > 0)
    {
        $retVal = "<select name=\"charid\">\n";
        while (@array = $query->fetchrow_array)
        {
            $retVal .= "<option value=\"$array[0]\">$array[1]";
            if ($array[2] ne "")
            {
            	$retVal .= ", $array[2]";
            }
            
            $retVal .= "</option>\n";
        }
        $retVal .= "</select>\n";
    }
    $query->finish;
    $db->disconnect;
    return "$retVal";
}

sub createBlackDrop
{
    local ($db) = dbconnect();
    $SQL = "select $keyfield, $namefield from $table order by charname;";
 
    local($query) = $db->prepare($SQL);
    #print "$SQL<BR>";
    $query->execute;

    local ($retVal) = "";
    if ($query->rows > 0)
    {
        $retVal = "<select name=\"$keyfield\">\n";
        while (@array = $query->fetchrow_array)
        {
            $retVal .= "<option value=\"$array[0]\">$array[1]</option>\n";
        }
        $retVal .= "</select>\n";
    }
    $query->finish;
    $db->disconnect;
    return "$retVal";
}
