#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "docketforplayers.pl";
$table = "docket";
$heading = "a Bill";
$keyfield = "did";
$keyvalue = $CGI->param($keyfield);
$namefield = "dname";
$tplfile = "docketforplayers.tpl";
$errstr = $CGI->param("error");
$charid = $CGI->param("charid") + 0;

if ($action eq "display")
{
	print $CGI->header();
	ParseForm($header);

	fillvars();
	ParseForm($tplfile);
	print "<br><br><a href=\"$thispage\">Return to Docket</a>.";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "new")
{
	print $CGI->header();
	$doctitle = "Add $heading";
	ParseForm($header);
	print "<H1>Add $heading</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">";
	fillvars();
	ParseForm("editdocketforplayers.tpl");
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<input type=\"hidden\" name=\"submittor\" value=\"$charid\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>\n";
	print "</form>\n";
	print "<br><hr><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}

elsif ($action eq "edit")
{
	fillvars();
	checkdocket();
	$doctitle = "Edit $dname";
	print $CGI->header();
	ParseForm($header);
        print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">";
	ParseForm("editdocketforplayers.tpl");
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"hidden\" name=\"charid\" value=\"$charid\">\n";
	print "<input type=\"hidden\" name=\"submittor\" value=\"$charid\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>\n";
	print "</form>\n";
	print "<br><hr><a href=\"bga.pl?charid=$charid\">Return to BGAs</a>.";
	print "<br><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}

elsif ($submit eq "Add")
{
	# Insert and Redirect
	$SQL = filltablefromCGI($table, 1);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	fillvars();
	checkdocket();
	#print $CGI->header();
	# Update and Redirect
	$SQL = filltablefromCGI($table, 0);
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	fillvars();
	checkdocket();
	# delete and Redirect
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$SQL = "delete from charactergroupmembers where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading Deleted"));
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<table border = 0><tr>\n";
	print "<td width=131><img src=gavel.gif align=left></td>\n";
	print "<td><font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>The Docket</h1>\n";
	print "<i>This is a list of all bills and proposals to be voted on in Parliament in the next episode  ";
	print "Characters may sponsor additional legislation before (but not during) the next game.  Said legislation ";
	print "will be added to this list.<i><BR>\n";

	print "</tr></table>\n";
	
	showdocket();
	
	if ($charid > 0)
	{
	   showyourdocket();
	}

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&charid=$charid&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdocket()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table where eventid = $current_episode and submittor > 0;";		 
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Bill Name</b></td>\n";
	print "<td><b>Submitted By</b></td>\n";
	print "<td><b>Display</b></td>\n";
	print "<td><b>Link to Text</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $submittor = $resptr->{"submittor"};
	   print "<tr>\n";
	   print "<td>".$resptr->{"dname"}."</td>\n";
	   print "<td>".getCharPlayerStr($submittor)."</td>\n";
	   print "<td align=center><a href=\"$thispage?action=display&$keyfield=".$resptr->{"$keyfield"}."\">Display</a></td>\n";
	   print "<td align=center><a href=\"".$resptr->{"url"}."\" target=_new>View Link</a></td>\n";
	   print "</tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub showyourdocket()
{
	print "<H1>Your Docket</h1>\n";
	print "<i>This is a list of the bills and proposals you have proposed for the Docket.  You must alert the GMs that you are ready to add it to the Docket and they will add it for the next game.  Once it has been added to the Docket, you will be unable to edit it.</i><BR><BR>\n";

	local($db) = dbconnect();
	local ($sql) = "select * from $table where submittor = $charid and eventid = 0 order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Bill Name</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "<tr>\n";
	   print "<td>".$resptr->{"dname"}."</td>\n";
	   print "<td> <a href=\"$thispage?charid=$charid&action=edit&$keyfield=".$resptr->{"$keyfield"}."\">Edit</a> -- \n";
	   print "<a href=\"javascript:deleteConfirm('".$resptr->{"$namefield"}."',".$resptr->{"$keyfield"}.");\">Delete</a> -- ";
	   print "<a href=\"alertGM.pl?mode=docket&charid=$charid&$keyfield=".$resptr->{"$keyfield"}."\">Alert GMs</a><sup>*</sup></td>\n";
	   print "</tr>\n";
	}
	print "</table><BR>\n";
	$query->finish;
	$db->disconnect;
	
	print "<a href=\"$thispage?action=new&charid=$charid\">Add a new bill to the Docket</a><BR><br>\n";
	print "<SUP>*</SUP>You must alert the GMs when you want the bill added to the Docket.  Once it is added to the docket, you may no longer edit it.<BR>\n";
	
}


sub fillvars()
{
	filltable();
	
	$weight = $weight + 0;
	$eventid = $eventid + 0;
	$submittor = $submittor + 0;
	$ddesc =~ s/\n/<BR>/g;
	$for_reasons =~ s/\n/<BR>/g;
	$against_reasons =~ s/\n/<BR>/g;
	$subchar = getCharName($submittor)." <i>(".emailTagFromID(getPIDFromCharID($submittor)).")</i>";
	
	$weightofhistory = "Strongly in Favor";
	if ($weight < -60)
	{
	   $weightofhistory = "Strongly Against";
	}
	elsif ($weight < -15)
	{
	   $weightofhistory = "Generally Against";
	}
	elsif ($weight < 15)
	{
	   $weightofhistory = "Generally Neutral";
	}
	elsif ($weight < 60)
	{
	   $weightofhistory = "Generally in Favor";
	}
}

#assumes fillvars has been called
sub checkdocket()
{
  if ($submittor == $charid || $al >= $gm_access)
  {
     return;
  }
  
  print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("You may not edit $dname"));
  exit 0;
}