#!/usr/bin/perl 

require 'common.pl';
use DBI;
use CGI::Session;
use CGI::Cookie;
use CGI qw/:standard/;
use File::Copy;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

$accessarray[$player_access] = "Player Access";
$accessarray[$writer_access] = "Staff Access";
$accessarray[$gm_access] = "GM Access";
$accessarray[$developer_access] = "Database Developer Access";

$document_locked = 1;
$document_unlocked = 0;

#globals for this file
$thispage = "doclib.pl";
$table = "doclib2";
$heading = "Document";
$keyfield = "docid";
$keyvalue = $CGI->param($keyfield);
$namefield = "filename";
$tplfile = "doclib.tpl";
$errstr = $CGI->param("error");

if ($action eq "new" || $action eq "checkin")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	elsif ($action eq "checkin")
	{
        	print "<H1>Check In $heading</H1>\n";
	}
	else
	{
        	print "<H1>Checkout $heading</H1>\n";
        	$tplfile = "doclibcheckout.tpl";
	}
	print $CGI->start_multipart_form(-name => "form1");

	fillvars();
	ParseForm($tplfile);

	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	elsif ($action eq "checkin")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Check In\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Check Out\"><BR>";
	}
	print $CGI->end_form;
	print "<br><a href=\"$thispage\">Return</a>.";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "info")
{
	print $CGI->header();
	fillvars();
	$doctitle = "$filename - Edit Info";
	ParseForm($header);
        print "<H1>$doctitle</H1>\n";

	print $CGI->start_multipart_form(-name => "form1");

	ParseForm("doclibinfo.tpl");

	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"updateinfo\">\n";

	print "<input type=\"submit\" name=\"submit\" value=\"Update\"><BR>";

	print $CGI->end_form;
	print "<br><a href=\"$thispage\">Return</a>.";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "infofolder")
{
	print $CGI->header();
	fillfoldervars();
	$doctitle = "$foldername - Edit Info";
	ParseForm($header);
        print "<H1>$doctitle</H1>\n";

	print $CGI->start_multipart_form(-name => "form1");

	ParseForm("doclibfolderinfo.tpl");

	print "<input type=\"hidden\" name=\"action\" value=\"updatefolderinfo\">\n";

	print "<input type=\"submit\" name=\"submit\" value=\"Update\"><BR>";

	print $CGI->end_form;
	print "<br><a href=\"$thispage\">Return</a>.";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "newfolder")
{
	print $CGI->header();
	$doctitle = "Document Library -- Add Folder";
	ParseForm($header);
	print $CGI->start_multipart_form(-name => "form1");
	fillfoldervars();
	print "<h1>$doctitle</h1>\n";
	ParseForm("doclibfolder.tpl");
	print "<input type=\"submit\" name=\"submit\" value=\"Add Folder\"><BR>";
	print $CGI->end_form;
	print "<br><a href=\"$thispage\">Return</a>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>";
	ParseForm($footer);
}
elsif ($submit eq "Add Folder")
{
	# Insert and Redirect
	#print $CGI->header();
	$table = "doclibfolders";
	$sql = filltablefromCGI($table, 1);
	#print "$sql<BR>";
	$db = dbconnect();
	$db->do($sql);
	$path = "doclib/" . makepath($CGI->param("parent"),"");
	$path .= $CGI->param("foldername");
	$db->disconnect;
	#print "$path<BR>";
	mkdir $path;
	chmod 0777, $path;
	
	print $CGI->redirect("$thispage?error=" . encodeURL($CGI->param(foldername) . " Created"));
}
elsif ($action eq "deletefolder")
{
	# delete and Redirect
	#print $CGI->header();
	$dfid = $CGI->param("dfid");
	$db = dbconnect();
	deletefolder($dfid);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("Folder Deleted"));
}
elsif ($action eq "updatefolderinfo")
{
	# Insert and Redirect
	#print $CGI->header();
	$table = "doclibfolders";
	$keyfield = "dfid";
	$keyvalue = $CGI->param("dfid");
	$sql = filltablefromCGI($table, 0);
	#print "$sql<BR>";
	$db = dbconnect();
	$db->do($sql);
	$db->disconnect;
	
	print $CGI->redirect("$thispage?error=" . encodeURL($CGI->param(foldername) . " Updated"));
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	#print $CGI->header();
	$db = dbconnect();
	$db->do($sql);
	$path = "doclib/" . makepath($CGI->param("dfid"),"");
	$db->disconnect;
	#print "$path<BR>";
	uploaddoc();
	$sql = filltablefromCGI($table, 1);
	#print "$fh<BR>\n";
	#print "$path$fn<BR>\n";
	$sql =~ s!fnord!$fn!;
	#print "$sql<BR>\n";
	dosql($sql);
	print $CGI->redirect("$thispage?error=" . encodeURL($fn . " Added"));
}
elsif ($action eq "checkout")
{
	#print $CGI->header();
	# Update and Redirect
	$SQL = "update $table set status=$document_locked, creator=$pid where $keyfield=$keyvalue;";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL($CGI->param("filename") . " Locked"));
}
elsif ($submit eq "Check In")
{
	# Insert and Redirect
	#print $CGI->header();
	$db = dbconnect();
	$path = "doclib/" . makepath($CGI->param("dfid"),"");
	$db->disconnect;
	#print "$path<BR>";
	uploaddoc();
	$sql = filltablefromCGI($table, 0);
	#print "$fh<BR>\n";
	#print "$path$fn<BR>\n";
	$sql =~ s!fnord!$fn!;
	#print "$sql<BR>\n";
	dosql($sql);
	print $CGI->redirect("$thispage?error=" . encodeURL($fn . " Checked In"));
}
elsif ($action eq "updateinfo")
{
	# Insert and Redirect
	#print $CGI->header();
	$sql = filltablefromCGI($table, 0);
	dosql($sql);
	print $CGI->redirect("$thispage?error=" . encodeURL("File Info Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Deleted"));
}
elsif ($action eq "movefile")
{
	# move and redirect
	#print $CGI->header();
        $dfid = $CGI->param("dfid");
	$sql = "select dfid from $table where $keyfield=$keyvalue;";
	$sql2 = "select filename from $table where $keyfield=$keyvalue;";
	$olddfid = dosql($sql);
	$fn = dosql($sql2);
	#print "$sql<BR>\n";
	local($db) = dbconnect();
	$topath = "doclib/" . makepath($dfid,"") . "$fn";
	$frompath = "doclib/" . makepath($olddfid,"") . "$fn";
	$sql = "update $table set dfid=$dfid where $keyfield=$keyvalue;";
	#print "$sql<BR>";
	$db->do($sql);
	$db->disconnect;
	#print "moving from $frompath ($olddfid) to $topath<BR>\n";
	move($frompath, $topath);
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Moved"));
}
else
{
	print $CGI->header;
	$sid = $CGI->cookie($cookiename) || undef;
        #print "[$sid]<BR>\n";
	$session = new CGI::Session(undef, $sid, {Directory=>"/tmp"});
        #print $session->id()."<BR>\n";

	$doctitle = "$campaign Document Library";
	ParseForm($header);

	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle</h1>\n";
	
	$searchtext = $CGI->param("searchtext");
	$searchtype = $CGI->param("searchtype") + 0;
	
        print "<table border = 0>\n";
        print "<tr><td width=65%  valign=top>\n";
	if ($action eq "search" && $al >= gm_access)
	{
	   print "<div width=100% style=\"background: #FFFFDD\">\n";
	   $db = dbconnect();
	   print "<a href=\"$thispage?searchtext=$searchtext\">";
	   print "<img src=\"icons/close8.png\" alt=\"Click to Close Search Results\" align=right border=0></a>\n";
	   print "<h2>Search Results</h2>\n";
	   print "<h3>Files whose filename or notes contain \"$searchtext\".</h3>\n";
	   searchfiles();
	   if ($searchtype > 0)
	   {
	      print "<h3>Files whose contents contain \"$searchtext\".</h3>\n";
	      fullsearchfiles();
	   }	   
	   $db->disconnect;
	   print "<BR></div>\n";
	}
	
	$db = dbconnect();
	showdata(0,0);
	$db->disconnect;
	print "</td><td valign=top>\n";
	print "<div width=100% style=\"background: #DDDDDD\">\n";
	print "<form action=\"$thispage\" method=\"post\">\n";
	print "<h2>Search:</h2>\n";
	print "Search for: <input name=searchtext type=text size=20 value=\"$searchtext\"><BR>\n";
	print "<input type=radio name=searchtype value=0 checked>";
	print "Basic Search</input><BR>\n";
	print "<i>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(searches filename and notes)</i><BR>\n";
	print "<input type=radio name=searchtype value=1>";
	print "Full Search</input><BR>\n";
	print "<i>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(searches inside the files)</i><BR>\n";
	print "<input type=\"hidden\" name=\"action\" value=\"search\">\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type=IMAGE src=\"icons/search8.png\" alt=\"Click to Search\" align=\"center\">\n";
	print "</form></div>\n";
	print "</td></tr></table>\n";

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "var delName, jsid;\n";
	print "function deleteFolderConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete folder \"+delName+\" and all files and folders it contains?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=deletefolder&dfid=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "var myid,yourid,isFolder;\n";
        print "function drop(myid) {\n";
        if ($al >= $gm_access)
        {
        	print "    window.location = \"$thispage?action=movefile&isfolder=\"+isFolder+\"&dfid=\"+myid+\"&docid=\"+yourid;\n";
        }
        print "}\n";
        print "function cancelEvent() {\n";
        print "    window.event.returnValue = false;\n";
        print "}\n";	
        print "function StartDrag(myid) \n";
        print "{   \n";
        print "    yourid = myid;\n";
        print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
        local($parent) = $_[0];
        local($reclev) = $_[1];
	local ($sql) = "select * from doclibfolders where access <= $al and parent=$parent order by foldername;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"foldername"};
	   $key = $resptr->{"dfid"};
	   if ($CGI->param("folder$key") eq "open")
	   {
	      $session->param("folder$key", "open");
	   }
	   if ($CGI->param("folder$key") eq "close")
	   {
	      $session->param("folder$key", "closed");
	   }
	   for ($i = 0; $i < $reclev; $i++)
	   {
	      print "<img src = \"icons/line8.png\" border=0 align=left>\n";
	   }
	   
	   if ($session->param("folder$key") eq "open")
	   {
	      print "<a href=\"$thispage?folder$key=close\"><img src = \"icons/openfolder8.png\" alt=\"Click to Close Folder\" border=0  align=left ondrop=\"javascript:drop($key)\" ondragenter=\"cancelEvent()\" ondragover=\"cancelEvent()\"></a>\n";
	   }
	   else
	   {
	      print "<a href=\"$thispage?folder$key=open\"><img src = \"icons/folder8.png\" alt=\"Click to Open Folder\" border=0 align=left ondrop=\"javascript:drop($key)\" ondragenter=\"cancelEvent()\" ondragover=\"cancelEvent()\"></a>\n";
	   }
	   if ($al >= $gm_access)
	   {
	      print "<a href=\"javascript:deleteFolderConfirm('$name',$key);\"><img src = \"icons/delfolder8.png\" alt=\"Click to Delete Folder $name\" border=0 align=left></a>\n";
	      $playername = getFullNameFromID($resptr->{"creator"});
	      $info = "Info -- $name -- Click to Edit\n";
	      $info .= "Creator: $playername\n";
	      $info .= "Notes: ".$resptr->{"description"}."\n";
	      $info .= $accessarray[$resptr->{"access"}];
	      print "<a href=\"$thispage?action=infofolder&dfid=$key\"><img src =   \"icons/info8.png\" alt=\"$info\" border=0 align=left></a>\n";
	   }
	   print "<span title=\"".$resptr->{"description"}."\">$name</span>\n";
	   print "<BR>\n";
	   if ($session->param("folder$key") eq "open")
	   {
	      showdata($key,$reclev+1);
	   }
	}
	$query->finish;
	if ($al >= $gm_access)
	{
	   for ($i = 0; $i < $reclev; $i++)
	   {
	      print "<img src = \"icons/line8.png\" border=0  align=left>\n";
	   }
	   print "<a href=\"$thispage?action=newfolder&parent=$parent\" title=\"Click to add new folder\"><img src = \"icons/newfolder8.png\" alt=\"New Folder\" border=0>\n";
	   print "<i>New Folder</a></i><BR>\n";
	}
	showfiles($parent,$reclev);
}

sub showfiles()
{
        local($parent) = $_[0];
        local($reclev) = $_[1];
	local ($sql) = "select * from $table where access <= $al and dfid=$parent order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $key = $resptr->{"$keyfield"};
	   $access = $resptr->{"access"};
	   for ($i = 0; $i < $reclev; $i++)
	   {
	      print "<img src = \"icons/line8.png\" border=0  align=left>\n";
	   }
	   displayfile($resptr);
	}
	$query->finish;
	if ($al >= $gm_access)
	{
	   for ($i = 0; $i < $reclev; $i++)
	   {
	      print "<img src = \"icons/line8.png\" border=0  align=left>\n";
	   }
	   print "<a href=\"$thispage?action=new&parent=$parent\" title=\"Upload New Document\"><img src = \"icons/newdocument8.png\" alt=\"New Document\" border=0>\n";
	   print "<i>Upload New Document</a></i><BR>\n";
	}
}

sub searchfiles()
{
	local ($sql) = "select * from $table where access <= $al and (filename like '%$searchtext%' or notes like '%$searchtext%') order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	      displayfile($resptr);
	}
	$query->finish;
}

sub fullsearchfiles()
{
	local ($sql) = "select * from $table where access <= $al order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local($resptr);
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $path = "doclib/" . makepath($resptr->{"dfid"},"") . $name;
	   open(MYSEARCH, $path);
	     $filetext = <MYSEARCH>;
	     if ($filetext =~ /$searchtext/)
	     {
	   	displayfile($resptr);
	     }
	   close (MYSEARCH);
	}
	$query->finish;
}

sub displayfile()
{
	local ($resptr) = $_[0];
	$name = $resptr->{"$namefield"};
	$notes = $resptr->{"notes"};
	$key = $resptr->{"$keyfield"};
	$access = $resptr->{"access"};
	print "<img src = \"icons/document8.png\" alt=\"".$resptr->{"notes"}." -- $accessarray[$access]\" border=0 align=left ondragstart=\"StartDrag($key)\">\n";
	if ($al >= $gm_access)
	{
	   $playername = getFullNameFromID($resptr->{"creator"});
	   print "<a href=\"javascript:deleteConfirm('$name',$key);\"><img src = \"icons/deldoc8.png\" alt=\"Click to Delete $name\" border=0 align=left></a>\n";
	   if ($resptr->{"status"} == $document_unlocked)
	   {
	   	print "<a href=\"$thispage?action=checkout&$keyfield=$key\"><img src = \"icons/unlocked8.png\" alt=\"Click to Lock $name\" border=0 align=left></a>\n";
	   }
	   elsif ($pid == $resptr->{"creator"})
	   {
	   	print "<a href=\"$thispage?action=checkin&$keyfield=$key\"><img src =   \"icons/yellowlock8.png\" alt=\"Click to Check In $name\" border=0 align=left></a>\n";
	   }
	   else
	   {
	   	print "<img src = \"icons/locked8.png\" alt=\"$name is locked by $playername\" border=0 align=left>\n";
	   }
	   $info = "Info -- $name -- Click to Edit\n";
	   $info .= "Creator: $playername\n";
	   $info .= "Notes: $notes\n";
	   $info .= "$accessarray[$access]";
	   print "<a href=\"$thispage?action=info&$keyfield=$key\"><img src =   \"icons/info8.png\" alt=\"$info\" border=0 align=left></a>\n";
	}
	$path = "doclib/" . makepath($resptr->{"dfid"},"") . $name;
	print "<a href=\"$path\" title=\"".$resptr->{"notes"}." -- $accessarray[$access]\" target=_new>$name</a>\n";
	print "<BR>\n";
}


sub fillvars()
{
   filltable();
   $accesssel[$access] = "selected";
   $accessdrop = "<select name=\"access\">\n";
   for ($i = 1; $i <= min($al,$developer_access); $i++)
   {
     $accessdrop .= "<option value=\"$i\" $accesssel[$i]>$accessarray[$i]</option>\n";
   }
   $accessdrop .= "</select>\n";
   
   if ($creator == 0)
   {
     $creator = $pid;
   }
   
   $creatorname = getFullNameFromID($creator);
   
   $statusstr[1] = $ischecked[$status];
   $statusstr[0] = $ischecked[1 - $status];
   
   if ($dfid == 0)
   {
      $dfid = $CGI->param("parent");
   }
   $parentname = dosql("select foldername from doclibfolders where dfid=$dfid");

   $entrydate = getDBDate();
}

sub fillfoldervars()
{
   $table = "doclibfolders";
   $keyfield = "dfid";
   $keyvalue = $CGI->param($keyfield);

   filltable();

   $accesssel[$access] = "selected";
   $accessdrop = "<select name=\"access\">\n";
   for ($i = 1; $i <= min($al,$developer_access); $i++)
   {
     $accessdrop .= "<option value=\"$i\" $accesssel[$i]>$accessarray[$i]</option>\n"
   }
   $accessdrop .= "</select>\n";
   
   if ($creator == 0)
   {
     $creator = $pid;
   }
   
   $creatorname = getFullNameFromID($creator);
   if ($parent == 0)
   {
   	$parent = $CGI->param("parent");
   }
   $parentname = dosql("select foldername from doclibfolders where dfid=$parent");
   
   $entrydate = getDBDate();
}

sub uploaddoc()
{
	$fn = $CGI->param('filething');
	$fh = $CGI->param('filething');

	#print "$fn<BR>";

	$fn =~ s!^.*(\\|\/)!!; 

	#print "$fn<BR>";

	#print "[$fh]<BR>";

	binmode $fh;
	open (OUTFILE,">$path/$fn") || print $CGI->redirect("$thispage?error=" . encodeURL("Error creating $fn. Please try again."));
	binmode OUTFILE;
	binmode $fh;
	while (<$fh>)
	{
	   print OUTFILE $_;
	}
	close OUTFILE;
	close $fh;
	chmod 0777, "$path/$fn";
	return "$path\$fn";
}

sub deletefolder()
{
        local($dfid) = $_[0];
	local ($sql) = "select dfid from doclibfolders where parent=$dfid;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local(@array);
	while (@array = $query->fetchrow_array())
	{
	      deletefolder($array[0]);
	}
	$query->finish;
	$sql = "delete from doclibfolders where dfid=$dfid;";
	$db->do($sql);
	$sql = "delete from doclib2 where dfid=$dfid;";
	$db->do($sql);
}

sub makepath()
{
        local($dfid) = $_[0];
        local($curpath) = $_[1];
	local ($sql) = "select parent, foldername from doclibfolders where dfid=$dfid;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local(@array);
	@array = $query->fetchrow_array();
	$query->finish;
	#print "$dfid, $curpath, $array[0], $array[1]<BR>\n";
	if ($array[0] > 0)
	{
	  $curpath = makepath($array[0],$curpath);
	}
	return $curpath . $array[1] . "/";
}
