#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$sortby = $CGI->param("sortby");
$pid = getPlayerID();
$al = getAccessLevel($pid);

if ("$sortby" eq "level")
{
   $sortby = 'psecurity';
}
else
{
   $sortby = 'plast';
}

#globals for this file
$thispage = "editplayeraccess.pl";  	#Name of this web page
$table = "players";  		#table you're editing
$heading = "Player";		#textual description, for example, "A parsnip"
$keyfield = "playerid";	#name of the primary key field of the table.
$keyvalue = $CGI->param($keyfield) + 0;	
$namevalue = dosql("select concat(pfirst,' ',plast) from $table where $keyfield=$keyvalue;");
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
else
{
    if ($action eq "edit")
    {
        print $CGI->header();
        ParseForm($header);
        # We are fetching the player's information for editing
        $subjectaccess = getAccessLevel($keyvalue);
    
        # Connect To Database
        $db = dbconnect();
        $sql = "SELECT * FROM players where playerid = $keyvalue;";
        $query = $db->prepare($sql);
        $query->execute;
	$resptr = $query->fetchrow_hashref();
        $query->finish;
        $db->disconnect;
        $mselected = "";
        $fselected = "";
        $pselected = "";
        $wselected = "";
        $gselected = "";
        if ($resptr->{"pgender"} eq "F")
        {
           $fselected = " SELECTED";
        }
        else
        {
           $mselected = " SELECTED";
        }
        if ($subjectaccess == $writer_access)
        {
           $wselected = " SELECTED";
        }
        elsif ($subjectaccess == $gm_access)
        {
           $gselected = " SELECTED";
        }
        elsif ($subjectaccess >= $developer_access)
        {
           $dselected = " SELECTED";
        }
        else
        {
           $pselected = " SELECTED";
        }

        print "<br><br><font size=+1><b>Edit Player: " . $resptr->{"plast"}. ", ". $resptr->{"pfirst"} ." ".substr($resptr->{"cmiddle"},0,1).".</b></font><br><br>";
        print "<form action=\"editplayeraccess.pl\" method=\"post\">\n";
        print "<table border=0>\n";
        print "<tr>\n<td>PlayerID</td><td><input type=\"hidden\" name=\"playerid\" value=\"".$resptr->{"playerid"}."\">".$resptr->{"playerid"}."</td>\n</tr>\n";
	print "<tr>\n<td>Login ID</td><td><input type=\"text\" name=\"plog\" value=\"".$resptr->{"plogin"}."\"></td>\n</tr>\n";
	print "<tr>\n<td>First Name</td><td><input type=\"text\" value=\"" . $resptr->{"pfirst"} . "\" name=\"pfirst\"></td>\n</tr>\n";
	print "<tr>\n<td>Middle Name</td><td><input type=\"text\" value=\"" . $resptr->{"cmiddle"} . "\" name=\"cmiddle\"></td>\n</tr>\n";
	print "<tr>\n<td>Last Name</td><td><input type=\"text\" value=\"" . $resptr->{"plast"} . "\" name=\"plast\"></td>\n</tr>\n";
	print "<tr>\n<td>Email Address</td><td><input type=\"text\" value=\"" . $resptr->{"pemail"} . "\" name=\"pemail\"></td>\n</tr>\n";
	print "<tr>\n<td>Phone Number</td><td><input type=\"text\" value=\"" . $resptr->{"pcelphone"} . "\" name=\"pcelphone\"></td>\n</tr>\n";
	print "<tr>\n<td>Age</td><td><input type=\"text\" value=\"" . $resptr->{"page"} . "\" name=\"page\"></td>\n</tr>\n";
	print "<tr>\n<td>Password</td><td><input type=\"text\" name=\"ppass\" value=\"" . $resptr->{"ppassword"} . "\"></td>\n</tr>\n";
	print "<tr>\n<td>Gender</td><td><select name=\"pgender\">\n<option value=\"M\"$mselected>Male</option>\n<option value=\"F\"$fselected>Female</option>\n</select></td>\n</tr>\n";
        print "<tr>\n<td>Access</td><td><select name=\"psecurity\">\n";
        print "<option value=\"0\">Deactivate Player</option>\n";
        print "<option value=\"1\"$pselected>Player (basic) Access Only</option>\n";
        print "<option value=\"2\"$wselected>Writer-level (expanded) Access</option>\n";
        print "<option value=\"3\"$gselected>GM-level (full) Access</option>\n";
            if ($al >= $developer_access)
            {
            print "<option value=\"4\"$dselected>Developer-level (full) Access</option>\n";
            }
        print "</select></td>\n</tr>\n";
        print "<tr>\n<td colspan=2 align=\"center\"><input type=\"submit\" name=\"submit\" value=\"Submit\"></td>\n</tr>\n";
        print "</table>\n</form>\n";
        print "<a href=\"editplayeraccess.pl\">Return to player list</a>.<br>";
        print "<a href=\"login.pl\">Return to main menu</a>.";
        ParseForm($footer);
    }
    elsif ($action eq "delete")
    {
	# delete and Redirect
	#print "$sql<BR>";
	local($db) = dbconnect();
	delPlayer($keyvalue);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Deleted"));
    }
    elsif ($action eq "delslackers")
    {
	# delete and Redirect
	#print $CGI->header;
	local($retStr) = "";
	local($db) = dbconnect();
	local ($sql) = "select * from $table order by $sortby, plast;";
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"pfirst"} . " " . $resptr->{"plast"};
	   $key = $resptr->{"$keyfield"};
	   $sql = "select count(epid) from eventplayers where playerid=$key;";
	   local ($num) = dosql($sql) + 0;
	   if ($num == 0)
	   {
	      $retStr = $retStr . "$name<BR>";
	      delPlayer($key);
	   }
	   
	}	
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("Deleted: $retStr"));
    }
    elsif ($keyvalue > 0 and $submit eq "Submit")
    {
        # Execute the update Query
	# print $CGI->header;
        local($sql) = "UPDATE players set pfirst ='" . $CGI->param("pfirst") .  "', plast ='" . $CGI->param("plast") ."', cmiddle ='" . $CGI->param("cmiddle") .  "', pemail ='" . $CGI->param("pemail") .  "', pcelphone ='" . $CGI->param("pcelphone") .  "', page =" . $CGI->param("page") .  ", pgender ='" . $CGI->param("pgender") .  "', ppassword ='" . $CGI->param("ppass") . "', plogin = '" . $CGI->param("plog") . "', psecurity = '" . $CGI->param("psecurity") . "' where playerid=$keyvalue;";

        #print "$sql<BR>\n";
	dosql($sql);
	print $CGI->redirect("$thispage?error=" . encodeURL("Edited: ".$CGI->param("pfirst") .  " " . $CGI->param("plast") .""));
        exit 0;
    }
    else
    {
	print $CGI->header;
	$doctitle = "Manage ".$heading."s";
	ParseForm("revheader.tpl");
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle </h1>\n";

	print "<p><a href=\"javascript:deleteSlackers();\">Delete ALL slackers.</a> -- \n";
	print "<i>This will delete all players who have <b>never</b> resgistered for an event.</i></p>\n";
	
        showdata();

	print "<br><hr><a href=\"login.pl\">Main menu</a>.\n"; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "\n";
	print "function deleteSlackers()\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Are you sure?  This may delete many players.\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delslackers;\"\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
    }
}

sub delPlayer()
{
	local $playerid = $_[0];
	local $sql = "delete from players where playerid = $playerid;";
	$db->do($sql);
	local $sql = "update announcement set playerd=$pid where playerid = $playerid;";
	$db->do($sql);
	local $sql = "delete from eventplayers where playerid = $playerid;";
	$db->do($sql);
	local $sql = "update gmnotes set playerd=$pid where playerid = $playerid;";
	$db->do($sql);
	local $sql = "delete from loggedin where liplayerid = $playerid;";
	$db->do($sql);
	local $sql = "update news set playerd=$pid where playerid = $playerid;";
	$db->do($sql);
	local $sql = "delete from pagedefaults where playerid = $playerid;";
	$db->do($sql);
	local $sql = "update playeractionitems set playerd=$pid where playerid = $playerid;";
	$db->do($sql);
	local $sql = "update playercharacters set pcplayerid=$pid where pcplayerid = $playerid;";
	$db->do($sql);
	local $sql = "delete from playerquestionnaires where pqplayerid = $playerid;";
	$db->do($sql);
	local $sql = "delete from playerSC where playerid = $playerid;";
	$db->do($sql);
	local $sql = "delete from playershows where playerid = $playerid;";
	$db->do($sql);
}

sub showdata()
{
	local($db) = dbconnect();
	
	local ($sql) = "select * from $table order by $sortby, plast;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td width=5% valign=top><b>User ID</b></td>\n";
	print "<td width=20%><a href=\"$thispage?sortby=last\"><b>Name</b></a></td>\n";
	print "<td width=5%><a href=\"$thispage?sortby=level\"><b>Level</b></a></td>\n";
	print "<td width=40%><b>Events</b></td>\n";
	print "<td width=30%><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"pfirst"} . " " . $resptr->{"plast"};
	   $key = $resptr->{"$keyfield"};
	   print "<tr>\n";
	   print "<td>".$resptr->{"plogin"}."</td>\n";
	   print "<td>$name</td>\n";
	   print "<td>".$playertype[$resptr->{"psecurity"}]."</td>\n";
	   print "<td>\n";
	   $sql = "select eventname from events a join eventplayers b on a.eventid=b.eventid where b.playerid=$key;";
	   local ($query2) = $db->prepare($sql);
	   $query2->execute;
	   while ($resptr2 = $query2->fetchrow_hashref())
	   {
	      print $resptr2->{"eventname"}."<BR>\n";
	   }
	   $query2->finish;
	   print "</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('$name',$key);\">Delete</a>\n";
	   print " -- <a href=\"emailPlayer.pl?topid=$key\">Email</a>";
	   print " -- <a href=\"showreg.pl?plid=$key&action=regevent\">Register</a>";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}
