#!/usr/bin/perl

# Require and Use
# * These statements alert perl.exe that
# * you are going to be using functions, 
# * subroutines, and methods from other
# * perl programs. "require" is used for a
# * perl library, and the "use" statement 
# * is usually used to reference a perl
# * object (usually referred to as a 
# * module).
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$pid = getPlayerID();
$al = getAccessLevel($pid);

if ($action eq "send")
{
	#print $CGI->header();
	$playerid = $CGI->param("charid");
	$playerid = getPIDFromCharID($playerid);
	$subject = $CGI->param("subject");
	$text = $CGI->param("text");
	$ccGMs = $CGI->param("ccGMs");
	$ccsender = $CGI->param("ccsender");

    	print $CGI->redirect("emailPlayer.pl?action=send&playerid=$playerid&subject=" .encodeURL("$subject"). "&text=" .encodeURL("$text"). "&ccGMs=$ccGMs&ccsender=$ccsender");
}
else
{
	$doctitle = "E-mail a Character";
	print $CGI->header();
	ParseForm($header);
	print "<H1>$doctitle</h1>";
	print "<p><i>Note: This will send a private e-mail revealing your e-mail address to your recipient.</i></p>\n";
	print "<form action=\"emailCharacter.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"send\">\n";
	print "<b>Recipient</b>: ";
	print makeCharDropDown();
	print "<BR><BR>\n";
	print "<b>Subject</b>: <input type=text name=\"subject\"  size=60>\n";
	print "<BR><BR>";
	print "<b>CC the $campaign GMs</b>: <input type=checkbox name=ccGMs value=1><BR>\n";
	print "<b>CC yourself</b>: <input type=checkbox name=ccsender value=1>\n";
	print "<BR><BR>";
	print "<b>Text</b>:<BR> <textarea name=\"text\" COLS=80 ROWS=12></textarea><BR><BR>\n";
	print "<input type=submit name=send value=Send>\n";
	print "</form><BR>\n";
	print "<br><br><a href=\"login.pl\">Database Main Menu</a><hr><br>";
	ParseForm($footer);
}

sub makeCharDropDown
{
	local ($db) = dbconnect();
	$sql = "select charid, chartype from characters order by clast;";

	local($query) = $db->prepare($sql);
	#print $CGI->header();
	#print "$SQL<BR>[$value]<BR>";
	$query->execute;

	#Check to make sure $query is not empty
	if ($query->rows > 0)
	{
		$retVal = "<select name=\"charid\">\n";
		local (@array);
		while (@array = $query->fetchrow_array)
		{
		   $issecret = 0;
		   if ($al < $gm_access)
		   {
		   	$issecret = dosql("select b.value from chartypetraits a join chartypetraitlink b on a.cttid=b.cttid where b.ctypeid=$array[1] and a.traitname='secret'") + 0; 
		   }
		   if ($issecret == 0 || $al >= $gm_access)
		   {
		   	$retVal .= "<option value=\"$array[0]\">".getCharName($array[0])."</option>\n";
		   }
		}
		$retVal .= "</select>\n";
		$query->finish;
		$db->disconnect;
		return $retVal;
	}
	$query->finish;
	$db->disconnect;
	return "";
}




























