#!/usr/bin/perl

# Require and Use
# * These statements alert perl.exe that
# * you are going to be using functions, 
# * subroutines, and methods from other
# * perl programs. "require" is used for a
# * perl library, and the "use" statement 
# * is usually used to reference a perl
# * object (usually referred to as a 
# * module).
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$frompid = getPlayerID();
$tempstr = $CGI->param("topid");
$action = $CGI->param("action");
$numpid = $CGI->param("numpid") + 0;
$numbcc = $CGI->param("numbcc") + 0;

if ($numpid > 1)
{
  @topid = split(/ /, $tempstr);
}
else
{
  $topid[0] = $tempstr + 0;
  $numpid = 1;
}

if ("$topid[0]" eq "" or $topid[0] == 0)
{
   $topid[0] = $CGI->param("playerid");
}
	
$toname = "";
for ($k = 0; $k < $numpid; $k++)
{
   $toname .= getFullNameFromID($topid[$k]) . ", ";
}
chop($toname);
chop($toname);

if ($numbcc > 0)
{
	if ($numbcc > 1)
	{
	   $tempstr2 = $CGI->param("bccpid");
	   @bccpid = split(/ /, $tempstr2);
	}
	else
	{
	   $bccpid[0] = $CGI->param("bccpid") + 0;
	   $numbcc = 1;
	}
}

if ($action eq "send")
{
	$fromemail = getEmailFromID($frompid);
	$fromname = getFullNameFromID($frompid);
	
	$toemail = "";
	for ($k = 0; $k < $numpid; $k++)
	{
	   $toemail .= getEmailFromID($topid[$k]) . ", ";
	}
	chop($toemail);
	chop($toemail);


	$subject = $CGI->param("subject");
	$text = $CGI->param("text");
	$ccGMs = $CGI->param("ccGMs");
	$ccsender = $CGI->param("ccsender");


	#print $CGI->header();
	#print "$topid<BR>";
	#print "$frompid - $fromname<BR>";

	# Retrieve Date
	$date = getDate();
	#print "$date<BR>";

	# Send E-Mail
	open(MAIL, "| /usr/sbin/sendmail  -oi -t") or die "couldn't send mail: $!";
	print MAIL "From: \"$fromname\" <$fromemail>\n";
	print MAIL "To: $toemail\n";
	#print "[$toemail]<BR>\n";
	if ($ccGMs)
	{
	   print MAIL "Cc: $contact\n";
	}
	if ($ccsender)
	{
	   print MAIL "Cc: $fromemail\n";
	}
	if ($numbcc > 0)
	{
	   $bccemail = "";
	   for ($k = 0; $k < $numbcc; $k++)
	   {
	      $bccemail .= getEmailFromID($bccpid[$k]) . ", ";
	   }
	   chop($bccemail);
	   chop($bccemail);
	   print MAIL "Bcc: $bccemail ($numbcc, $tempstr2)\n";
	}
	print MAIL "Subject: $subject\n";
	print MAIL "\n";
	print MAIL "$text\n";
	print MAIL "--\n";
	print MAIL "This e-mail sent via the $campaign database.\n";
	print MAIL "$siteURL\n";
	print MAIL "E-mail $contact for questions/comments.\n";
	close(MAIL);

	#print "done<br>";

	# Return 
    	print $CGI->redirect("login.pl?error=" . encodeURL("E-mail sent to $toname"));
}
else
{
	print $CGI->header();
	ParseForm($header);
	print "<H1>E-mail: $toname</h1>";
	print "<p><i>Note: This will send a private e-mail revealing your e-mail address to your recipient(s)</i></p>";
	print "<form action=\"emailPlayer.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"send\">\n";
	if ("$topid[0]" eq "" or "$topid[0]" eq "0")
	{
	   print "<b>Recipient</b>: ";
	   print makeDropDown("players order by plast", "playerid", "concat(pfirst, \" \", plast) as playername");
	   print "<BR><BR>\n";
	}
	else
	{
	   print "<input type=\"hidden\" name=\"topid\" value=\"@topid\">\n";
	   print "<input type=\"hidden\" name=\"numpid\" value=$numpid>\n";
	   print "<input type=\"hidden\" name=\"bccpid\" value=\"@bccpid\">\n";
	   print "<input type=\"hidden\" name=\"numbcc\" value=$numbcc>\n";
	}
	print "<b>Subject</b>: <input type=text name=\"subject\"  size=60>\n";
	print "<BR><BR>";
	print "<b>CC the $campaign GMs</b>: <input type=checkbox name=ccGMs value=1><BR>\n";
	print "<b>CC yourself</b>: <input type=checkbox name=ccsender value=1>\n";
	print "<BR><BR>";
	print "<b>Text</b>:<BR> <textarea name=\"text\" COLS=80 ROWS=12></textarea><BR><BR>\n";
	print "<input type=submit name=send value=Send>\n";
	print "<br><hr><a href=\"login.pl\">Main Menu</a><br>";
	ParseForm($footer);
}






























