#!/usr/bin/perl

require 'stat_inc.pl';
require 'g_invest.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "restok.pl";
$table = "character";
$heading = "x";
$keyfield = "x";
$keyvalue = $CGI->param($keyfield);
$namefield = "x";
$tplfile = "x.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to visit this page!"));
}
elsif ($CGI->param("xl") ne "")
{
	print $CGI->header(-type  =>  'application/vnd.ms-excel', -filename  =>  'envelopes.xls');
				
	$db = dbconnect();
	local ($sql) = "select c.pccharid from players a, eventplayers b, playercharacters c, characters d, chartypetraitlink e, chartypetraits f where a.playerid=b.playerid and b.eventid=$current_episode and b.reglevel > $not_attending and c.pcplayerid=a.playerid and c.pccharid > 0 and d.charid=c.pccharid and d.chartype=e.ctypeid and e.cttid = f.cttid and f.traitname = 'pack' and e.value=1 order by a.plast;";
	#print "$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	
	print "<table border=0>\n";
        print "<tr>\n";
        print "<td>CharName</td>\n";
        print "<td>PlayerName</td>\n";
        print "</tr>\n";
	while (@array = $query->fetchrow_array())
	{
	   $charid = $array[0];
	   print "<tr>\n";
	   print "<td>".getCharName($charid)."</td>\n";
	   print "<td>".getFullNameFromCharID($charid)."</td>\n";
	   print "</tr>\n";
	}
	print "</table>\n";
	
	$query->finish;
	
	$db->disconnect;
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<h1>Print Envelopes</H1>\n";
	print "<p><i>This will only show character types whose pack trait is 1.  <a href=\"chartypes.pl\">Manage character types</a></i></p>\n";
	
	print "1.  Step One.  Download the Microsoft XL Document.<BR>\n";
	print "Save this document as envelopes.xls in your Brassy's folder:\n";
	print "<a href=\"envelopes.pl?xl=1\" target=_new>Click me</a><BR><BR>\n";
		
	print "2.  Step Two.  Download the Microsoft Word Document.<BR>\n";
	print "Save this document as envelopes.doc in your Brassy's folder:\n";
	print "<a href=\"envelopes.doc\" target=_new>Click me</a><BR><BR>\n";
		
	print "3.  Step Three.  Open and print the Microsoft Word Document.<BR>\n";
	print "Open envelopes.doc in Microsoft Word.  Perform the mail merge.  Print.<BR>\n";
	print "<i>Note that envelopes.doc has been formatted for the small labels.</i><BR><BR>\n";

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
exit 0;
