#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "events.pl";
$numtabs = 2;

$tabnum = $CGI->param("tabnum");
if ("$tabnum" eq '')
{
	$tabnum = dosql("select tabnum from pagedefaults where playerid=$plid and pageid='$thispage';") + 0;
}
else
{
	setTabNum($thispage,$pid,$tabnum)
}

$table[0] = "events";
$table[1] = "eventreglevels";
$heading[0] = "Event";
$heading[1] = "Event Registration Level";
$keyfield[0] = "eventid";
$keyfield[1] = "erlid";
$keyvalue = $CGI->param($keyfield[$tabnum]);
$namefield[0] = "eventname";
$namefield[1] = "name";
$namevalue = dosql("select $namefield[$tabnum] from $table[$tabnum] where $keyfield[$tabnum]=$keyvalue;");
$tplfile[0] = "events.tpl";
$tplfile[1] = "";
$showDataFunc[0]=\&showdata;
$showDataFunc[1]=\&showerl;
$fillVarsFunc[0]=\&fillvars;
$fillVarsFunc[1]=\&fillvars;
$errstr = $CGI->param("error");

@tabheadings = { "", "" };
$tabheadings[0] = "Manage $heading[0]s";
$tabheadings[1] = "Manage $heading[1]s";


if ($al < $gm_access)
{
	print $CGI->redirect("main.pl?error=" . encodeURL("You are not authorized to edit $heading[$tabnum](s)!"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	if ($keyvalue eq "")
	{
		$doctitle = "Add $heading[$tabnum]";
	}
	else
	{
        	$doctitle = "Edit $namevalue";
	}
	ParseForm($header);
     	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";
	if ($tplfile[$tabnum] eq "")
	{
		local($db) = dbconnect();
		local($query) = $db->prepare("explain $table[$tabnum]");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $db->prepare("select * from $table[$tabnum] where $keyfield[$tabnum] = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$db->disconnect;
		print "</table>";
	}
	else
	{
	     $tmpFunc = $fillVarsFunc[$tabnum];
	     &$tmpFunc();
	     ParseForm($tplfile[$tabnum]);
	}
	print "<input type=\"hidden\" name=\"tabnum\" value=\"$tabnum\">\n";
	print "<input type=\"hidden\" name=\"$keyfield[$tabnum]\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"main.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	$sql = filltablefromCGI($table[$tabnum], 1, $keyfield[$tabnum], $keyvalue[$tabnum]);
	#print "$sql<BR>";
	local($db) = dbconnect();
	$db->do($sql);
	updatereglevels();
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading[$tabnum] Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$sql = filltablefromCGI($table[$tabnum], 0, $keyfield[$tabnum], $keyvalue[$tabnum]);
	#print "$sql<BR>";
	local($db) = dbconnect();
	$db->do($sql);
	updatereglevels();
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$sql<BR>";
	local($db) = dbconnect();
	$sql = "delete from $table[$tabnum] where $keyfield[$tabnum] = $keyvalue;";
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Deleted"));
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading[$tabnum]."s";
	ParseForm($header);
	ParseForm("tabs.tpl");
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle </h1>\n";

	showTabs();

	print "<a href=\"$thispage?action=new\">ADD a NEW $heading[$tabnum]</a><BR><BR>\n";
	$tmpFunc = $showDataFunc[$tabnum];
	&$tmpFunc();

	print "<br><hr><a href=\"main.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield[$tabnum]=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}


sub showTabs()
{
	local ($tottabs) = 1;
	
	if ($numtabs < 2)
	{
		return;
	}
	
	print "<table>\n";
	print "<tr>\n";
	
	for ($i = 0; $i < $numtabs; $i++)
	{
	      if ($tabnum == $i)
	      {
		   print "<td class=\"blacktab\">$tabheadings[$i]</td>\n";
	      }
	      else
	      {
		   print "<td class=\"greytab\" OnClick=\"document.location ='$thispage?tabnum=$i'\">$tabheadings[$i]</td>\n";
	      }
	      $tottabs = $tottabs + 1;
	      if ($tottabs % 7 == 0)
	      {
	    	print "</tr><tr>\n";
	      }
	}
	print "</tr>\n";
	print "</table>\n";
}

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table[$tabnum] order by $namefield[$tabnum];";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Location</b></td>\n";
	print "<td><b>Date</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   local($name) = $resptr->{"$namefield[$tabnum]"};
	   local($key) = $resptr->{"$keyfield[$tabnum]"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   local($venue) = dosql("select vname from venues where venueid=".$resptr->{"venueid"});
	   print "<td>$venue</td>\n";
	   print "<td>".myFormatDate($resptr->{"eventstart"})."(".$resptr->{"eventstarttime"}.") - ".myFormatDate($resptr->{"eventend"})."(".$resptr->{"eventendtime"}.")</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield[$tabnum]=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('$name',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub showerl()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table[$tabnum] order by $namefield[$tabnum];";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Description</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield[$tabnum]"};
	   $key = $resptr->{"$keyfield[$tabnum]"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>".$resptr->{"description"}."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield[$tabnum]=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('$name',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	goodfilltable($table[$tabnum], $keyfield[$tabnum], $keyvalue);

	$typeselect = makeDropDown("eventtypes", "etid", "ettext", "", "", $etid);
	$venueselect = makeDropDown("venues", "venueid", "vname", "", "", $venueid);
	
	$regtypeselect = "";
	local($db) = dbconnect();
	local ($sql) = "select * from eventreglevels order by name;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$regtypeselect .= "<table border=1>\n";
	$regtypeselect .= "<tr>\n";
	$regtypeselect .= "<td><b>Available</b></td>\n";
	$regtypeselect .= "<td><b>Name</b></td>\n";
	$regtypeselect .= "<td><b>Description</b></td>\n";
	$regtypeselect .= "<td><b>Cost (Textual)</b></td>\n";
	$regtypeselect .= "<td><b>Cost (Numeric)</b></td>\n";
	$regtypeselect .= "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   local($name) = $resptr->{"name"};
	   local($key) = $resptr->{"erlid"};
	   $sql = "select count(erlid) from eventsreglevelslink where erlid=$key and eventid=$eventid";
	   #print "$sql<BR>\n";
	   local($val) = dosql($sql) + 0;
	   $sql = "select cost from eventsreglevelslink where erlid=$key and eventid=$eventid";
	   #print "$sql<BR>\n";
	   local($mycost) = dosql($sql); 
	   $sql = "select realcost from eventsreglevelslink where erlid=$key and eventid=$eventid";
	   #print "$sql<BR>\n";
	   local($myrealcost) = dosql($sql) + 0; 
	   $regtypeselect .= "<tr>\n";
	   $regtypeselect .= "<td><input type=checkbox value=\"1\" name=\"rts_$key\" $ischecked[$val]></input></td>\n";
	   $regtypeselect .= "<td>$name</td>\n";
	   $regtypeselect .= "<td>".$resptr->{"description"}."</td>\n";
	   $regtypeselect .= "<td><input type=\"text\" name=\"cost_$key\" value=\"$mycost\" size=\"5\"></td>\n";
	   $regtypeselect .= "<td>&#36;<input type=\"text\" name=\"realcost_$key\" value=\"$myrealcost\" size=\"5\"></td>\n";
	   $regtypeselect .= "</tr>\n";
	}
	$regtypeselect .= "</table>\n";
	$query->finish;
	$db->disconnect;
}

#this assumes the db is open
sub updatereglevels()
{
	$sql = "delete from eventsreglevelslink where $keyfield[$tabnum] = $keyvalue;";
	#print "$sql<BR>";  
	$db->do($sql);
	$sql = "select erlid from eventreglevels;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	while (@array = $query->fetchrow_array)
	{
	   #print "$array[0]<BR>\n";
	   local($rts) = $CGI->param("rts_$array[0]") + 0;
	   local($cost) = $CGI->param("cost_$array[0]");
	   local($realcost) = $CGI->param("realcost_$array[0]");
	   #print "$array[0] $rts $cost $realcost<BR>\n";
	   if ($rts > 0)
	   {
	   	$sql = "insert into eventsreglevelslink (erlid,eventid,cost,realcost) values ($array[0],$keyvalue,'$cost',$realcost);";	   	
		#print "$sql<BR>";
		$db->do($sql);
	   }
	}
	$query->execute;
	$query->finish;
}