#!/usr/bin/perl

# Require and Use
# * These statements alert perl.exe that
# * you are going to be using functions, 
# * subroutines, and methods from other
# * perl programs. "require" is used for a
# * perl library, and the "use" statement 
# * is usually used to reference a perl
# * object (usually referred to as a 
# * module).
require 'common.pl';
use DBI;
use CGI;
use CGI::Cookie;

$CGI = new CGI;
$pid = getPlayerID();
$gameid = $CGI->param("gameid");

if (getAccessLevel($pid) >= 3)
{
    if ($CGI->param("submit") eq "Update")
    {
    #Print the Game page for adding/updating
    print $CGI->header();
    ParseForm($header);
    local($dbvar) = dbconnect();
    $selquery = $dbvar->prepare("select * from games where gameid = $gameid");
    $selquery->execute;
        if ($selquery->rows > 0)
        {
        @array = $selquery->fetchrow_array;
        $gamenum = $array[1];
        $gamename = $array[2];
        $gamestart = $array[3];
        $gameend = $array[4];
        $gametype = $array[5];
        $gamelocation = $array[6];
        $gamegmnotes = $array[7];
        $gameevite = $array[8];
        $gamecost = $array[9];
        $gamecastarrival = $array[10];
        $gameplayerarrival = $array[11];
        $gamefridayshutdown = $array[12];
        $gamesaturdaycheckin = $array[13];
        $gamesaturdaystart = $array[14];
        $gamesaturdayshutdown = $array[15];
        $gamesundaystart = $array[16];
        $gamenotes = $array[17];
        }
    $selquery->finish;
    $dbvar->disconnect;
    $venuedropdown = makeDropDown('venues','venueid','vname');
    ParseForm("game.tpl");               
    ParseForm($footer);
    }
    elsif ($CGI->param("submit") eq "Delete")
    {
        if ($venueid ne "")
        {
        local($dbvar) = dbconnect();
        local($query) = $dbvar->prepare("delete from games where gameid = $gameid");
        $query->execute;
        $query->finish;
        $dbvar->disconnect;
        print $CGI->redirect("login.pl?error=" . encodeURL("Game Deleted"));
        }
    }
    elsif (($CGI->param("submit") eq "Submit") && ($gameid ne ""))
    {
    # Update The Game and Redirect To Main Menu
    @names = $CGI->param;
    $SQL = "UPDATE games set";
        foreach $i(@names)
        {
            if (($i ne "gameid") && ($i ne "submit"))
            {
             if (($i eq "gamenum") || ($i eq "gamelocation") || ($i eq "gamecost"))
             {
              $SQL .= "$i = " . $CGI->param($i) . ", ";
             }
             else
             {
              $SQL .= "$i = '" . $CGI->param($i) . "', ";
             }
            }
        }
        chop $SQL;
        chop $SQL;
        $SQL .= "where gameid = $gameid";
    local($dbvar) = dbconnect();
    local($query) = $dbvar->prepare($SQL);
    $query->execute;
    $query->finish;
    $dbvar->disconnect;
    print $CGI->redirect("login.pl?error=" . encodeURL("Venue Updated"));
    }
    elsif (($CGI->param("submit") eq "Submit") && ($gameid eq ""))
    {
    # Insert The New Game and Redirect to Main Menu
    @names = $CGI->param;
    $SQL = "INSERT into games (";
        foreach $i(@names)
        {
            if (($i ne "gameid") && ($i ne "submit") && ($CGI->param($i) ne "") && ($i ne "venueid"))
            {
                $SQL .= "$i, ";
            }
            elsif ($i eq "venueid")
            {
                $SQL .= "gamelocation, ";
            }
            
        }
        chop $SQL;
        chop $SQL;
        $SQL .= ") values (";
        foreach $i(@names)
        {
            if (($i ne "gameid") && ($i ne "submit") && ($CGI->param($i) ne ""))
            {
                if (($i eq "gamenum") || ($i eq "venueid"))
                {
                $SQL .= $CGI->param($i) . ", ";
                }                
                else
                {
                $SQL .= "'" . $CGI->param($i) . "', ";
                }
            }
         }
        chop $SQL;
        chop $SQL;
        $SQL .= ")";
    local($dbvar) = dbconnect();
    local($query) = $dbvar->prepare($SQL);
    $query->execute;
    $query->finish;
    $dbvar->disconnect;
    #print $CGI->redirect("login.pl?error=" . encodeURL("New Game Added"));
    print $CGI->redirect("login.pl?error=" . encodeURL($SQL));
    }
    else
    {
    # Select a Game
    local($dbvar) = dbconnect();
    local($query) = $dbvar->prepare("select gameid, gamename from games");
    $query->execute;
    local($strHTML) = "";
    if ($query->rows > 0)
    {
        while(@array = $query->fetchrow_array)
        {
        $strHTML .= "<a href=\"games.pl?submit=Update&gameid=" . $array[0] . "\">" . $array[1] . "</a><br>\n";
        }
    }
    $query->finish;
    $dbvar->disconnect;
    print $CGI->header();
    ParseForm($header);
    print "\n<br><br><font size=+1><b>Select A Game</b></font></br><hr>";
    print $strHTML;
    print "<a href=\"games.pl?submit=Update\">Add A New Game</a><br>\n";
    print "<form action=\"games.pl\" method=\"post\"><br>\n";
    print "<center><font size=+1><b>Delete a Game</b></font><br>\n";
    print makeDropDown("games", "gameid", "gamename");
    if ($strHTML ne "") {
    print "\n<br>\n<input type=\"submit\" name=\"submit\" value=\"Delete\"></center></form>";
    }
    print "<br><hr>You can <a href=\"login.pl\">Click Here</a> to return to the main menu page.";
    $dbvar->disconnect;
    ParseForm($footer);
    }
}
else
{
print $CGI->redirect("login.pl?error=" . encodeURL("You don't have access to that function"));
}