#!/usr/bin/perl

require 'bga_inc.pl';
require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "gmbga.pl";
$table = "bgas";
$heading = "Between Game Action";
$keyfield = "bgaid";
$keyvalue = $CGI->param($keyfield);
$tplfile = "bga.tpl";
$errstr = $CGI->param("error");

$charid = $CGI->param("charid") + 0;
$charname = getCharName($charid);

$approved = dosql("select charstatsapproved from characters where charid=$charid;") + 0;

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to adjudicate BGAs!"));
}
elsif ($action eq "next")
{
	#print $CGI->header();
	$sql = "select a.charid from characterSTATs a, characters b where a.charid=b.charid  and b.chartype<=$cast_character and a.charid > 0";
	#print "$sql<BR>\n";
	local ($db) = dbconnect();
	local($query) = $db->prepare($sql);
	$query->execute;
        local (@array);
        while (@array = $query->fetchrow_array)
        {
           $charid = $array[0];
	   $num_bgas = dosql("select count(btid) from bgas where charid=$charid and handled > 0 and period=$current_bgp;") + 0;
	   #remove this line
	   $num_bgas = dosql("select count(btid) from bgas where charid=$charid and period=$current_bgp;") + 0;

           $num_allowed = $base_num_allowed + getlevel("SPARE TIME"); 
	   $num_allowed -= getlevel("RESPONSIBILITIES"); 
	   $num_allowed = max($num_allowed,1);

	   if ($num_bgas < $num_allowed)
	   {    
	   	$query->finish;
		$db->disconnect;
		print $CGI->redirect("$thispage?charid=$charid");
		exit(0);
	   }
	}
	$query->finish;
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("All BGAs Processed"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	if ($keyvalue eq "")
	{
		$doctitle = "New $heading for $charname";
	}
	else
	{
        	$doctitle = "Edit $heading for $charname";
	}
	ParseForm($header);
	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">";
	if ($tplfile eq "")
	{
		local($dbvar) = dbconnect();
		local($query) = $dbvar->prepare("explain $table");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $dbvar->prepare("select * from $table where $keyfield = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$dbvar->disconnect;
		print "</table>";
	}
	else
	{
	     fillvars();
	     ParseForm($tplfile);
	}
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"submit\" name=\"submit\" value=\"Go To Step 2\"><BR>";
	
	print "<b>Types of BGAs</b>:<BR>";
	print "<i>Here is an explanation of BGAs that you may perform:</i><BR><BR>";
	
	print "$bga_list<BR>";

	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Go To Step 2")
{
	handlebgastep2();
}
elsif ($action eq "fame")
{
	# Insert and Redirect
	#print $CGI->header();
	$num_bgas = dosql("select count(btid) from bgas where charid=$charid and period=$current_bgp;") + 1;
	$SQL = "insert into bgas (charid, btid, data, priority, period, money) values ($charid, 18, 'Stay in the Public Eye', $num_bgas, $current_bgp, 0);";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("Fame Added"));
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	#print $CGI->header();
	$SQL = createAddBGAsql();
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	$SQL = createChangeBGAsql();
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	#print $CGI->header();
	# delete and Redirect
	$SQL = "select priority from $table where $keyfield = $keyvalue;";
	#print "$SQL<BR>";
	$priority = dosql($SQL);
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$SQL = "update $table set priority = (priority-1) where charid=$charid and priority>$priority;";
	#print "$SQL<BR>";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading Deleted"));
}
elsif ($action eq "down")
{
	#print $CGI->header();
	$max = dosql("select max(priority) from $table where charid=$charid;");
	$priority = dosql("select priority from $table where $keyfield=$keyvalue;");
	if ($priority < $max)
	{
		local($dbvar) = dbconnect();
		$SQL = "update $table set priority = (priority-1) where charid=$charid and priority=".($priority+1).";";
		#print "$SQL<BR>";
		$dbvar->do($SQL);
		$SQL = "update $table set priority = (priority+1) where $keyfield=$keyvalue;";
		#print "$SQL<BR>";
		$dbvar->do($SQL);
		$dbvar->disconnect;
	}
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading moved"));
}
elsif ($action eq "up")
{
	#print $CGI->header();
	$priority = dosql("select priority from $table where $keyfield=$keyvalue;");
	if ($priority > 1)
	{
		local($dbvar) = dbconnect();
		$SQL = "update $table set priority = (priority+1) where charid=$charid and priority=".($priority-1).";";
		#print "$SQL<BR>";
		$dbvar->do($SQL);
		$SQL = "update $table set priority = (priority-1) where $keyfield=$keyvalue;";
		#print "$SQL<BR>";
		$dbvar->do($SQL);
		$dbvar->disconnect;
	}
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading moved"));
}
elsif ($action eq "process")
{
	print $CGI->header();
	$doctitle = "Process ".$heading." for $charname";
	ParseForm($header);
	
	print "<H1>$doctitle</h1>\n";
	
	print processBGA();
	
	print "<br><hr><a href=\"$thispage?charid=$charid\">Return to $charname</a>."; 
	print "<br><a href=\"$thispage\">Return to BGA List</a>."; 
	print "<br><a href=\"$thispage?action=pautoall\">Next</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($action eq "pautoall")
{
	print $CGI->header();
	$doctitle = "Process Multiple BGAs";
	ParseForm($header);
	print "<H1>$doctitle</h1>\n";
	
	$sql = "select a.bgaid,a.charid from $table a join bgatypes b on a.btid=b.btid where a.handled=0 and a.period=$current_bgp and b.auto=1 and a.conspirators is NULL LIMIT 25";
	#print "$sql<BR>\n";
	local($db) = dbconnect();
	local($query) =$db->prepare($sql);
	$query->execute;
	local(@array);
	while (@array = $query->fetchrow_array)
	{
		$bgaid = $array[0];
		$charid = $array[1];
		$keyvalue = $bgaid;
		$charname = getCharName($charid);
		
		print "<h2>Process ".$heading." for $charname</h2>";
		print processBGA();
		print "<HR>\n";
	}
	$query->finish;
	$db->disconnect;

	print "<br><a href=\"$thispage\">Return to BGA List</a>."; 
	print "<br><a href=\"$thispage?action=pautoall\">Next</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($action eq "manual")
{
	print $CGI->header();
	$doctitle = "Process ".$heading." for $charname";
	
	ParseForm($header);
	
	print "<H1>$doctitle</h1>\n";
	
	print "<a target=_new href=\"charquest.pl?mode=review&cqcharid=$charid\">Show History</a> &nbsp;&nbsp;&nbsp;\n";
	print "<a target=_new href=\"stats.pl?charid=$charid\">Show Stats</a>\n";

	print "<form action=\"$thispage\" method=\"post\">";
        fillvars();
        $bgatitle = dosql("select text from bgatypes where btid=$btid;");
        $charmoney = getMoney($charid);
        $minmoney = min($money,$charmoney);
        ParseForm("gmbga.tpl");

	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"processmanual\"><BR>";
	print "<input type=\"submit\" name=\"submit\" value=\"Process\"><BR>";
	
	print "</form>";
	
	print "<br><hr><a href=\"$thispage?charid=$charid\">Return</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
elsif ($action eq "processmanual")
{
	#print $CGI->header();
	$money = $CGI->param("money") * -1;
	$result = $CGI->param("result");
	$result =~ s/'/''/g;
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$SQL = "update bgas set handled=1, result='$result' where $keyfield=$keyvalue;";
	$dbvar->do($SQL);
   	$SQL = "insert into money (charid, pounds, entrydate, notes) values ($charid,$money,'";
   	$SQL .= getDBDate() . "', 'BGA Result');";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "fill")
{
	#print $CGI->header;
	local(@array) = getoccupations($charid);
	$numoccs = dosql("select count(oid) from characteroccupations where charid=$charid;") + 0;
        $btid = $CGI->param("btid");
        if ($numoccs == 0 && $btid == 3)
        {
      		$btid = 24;
   	}
	$num_bgas = dosql("select count(btid) from bgas where charid=$charid and period=$current_bgp;") + 0;

        $num_allowed = $base_num_allowed + getlevel("SPARE TIME"); 
	$num_allowed -= getlevel("RESPONSIBILITIES"); 
	$num_allowed = max($num_allowed,1);
		
	#print "$num_allowed, $num_bgas<BR>\n";
	
	local($dbvar) = dbconnect();
	for ($i = 0; $i < $num_allowed - $num_bgas; $i++)
	{
   	   $num = int(rand($numoccs));
           $oid = $array[$num];
           $cur_btid = $btid;
	   if ($oid > 0 && $btid == 3)
	   {
	      $occname = dosql("select oname from occupations where oid=$oid;");
	      $occname =~ s/'/''/g;
	      $str = "Perform Occupation: $occname";
	   }
	   else
	   {
	      $cur_btid = 24;
	      $str = "Do Nothing";
	   }
	  $num = $num_bgas + $i + 1;
	  $SQL = "insert into bgas (charid, btid, data, priority, period, money) values ($charid, $cur_btid, '$str', $num, $current_bgp, $oid);";
	  #print "$SQL<BR>\n";
	  $dbvar->do($SQL);
	}
	$dbvar->disconnect;
        print $CGI->redirect("$thispage?charid=$charid&error=" . encodeURL("$heading Added"));
}
elsif ($action eq "mailGMs")
{
	# Mail and Redirect
	#print $CGI->header;
	local($dbvar) = dbconnect();
	$sql = "select playerid from players where psecurity >= $gm_access";
	local ($query) = $dbvar->prepare($sql);
	$query->execute;
	local @array;
	while (@array = $query->fetchrow_array())
	{
	   $sql = "select * from $table a, bgatypes b where (a.btid = 1 or a.btid = 6) and a.charid > 0 and a.handled = 1 and a.btid=b.btid order by a.charid;";
	   local ($query2) = $dbvar->prepare($sql);
	   $query2->execute;
	   if ($query2->rows > 0)
	   {
	      $email = getEmailFromID($array[0]);
	      local ($resptr);
	      $message = "This is a list of all the completed exploration and research BGAs.\n\n";
	      $message .= "Please approve them by Sunday.  No replies means that you are ok with them.\n\n";
	      while ($resptr = $query2->fetchrow_hashref())
	      {
	   	$message .= getCharName($resptr->{"charid"}) . " (";
	   	$message .= getFullNameFromCharID($resptr->{"charid"}) . "): ";
	   	$message .= $resptr->{"text"} . "\n";
	   	$message .= "Description: " . $resptr->{"data"} ."\n";
	   	$message .= "Results: " . $resptr->{"result"} ."\n\n";
	   	$message .= "----------------------------------------------------------------------\n\n";
	      }
	      $query2->finish;
	      #print "============================================<BR>\n;";
	      #print "$message<BR>\n;";
	      #print "============================================<BR>\n;";
	      sendDBMail($email, "$campaign BGA Results Checklist", $message); 
	   }
	}
	$query->finish;
	
	$dbvar->disconnect;	
	print $CGI->redirect("$thispage?error=" . encodeURL("Mailed Status Reminders"));
}
elsif ($action eq "mailPlayers")
{
	# Mail and Redirect
	#print $CGI->header;
	local($dbvar) = dbconnect();
	$sql = "select c.pccharid, a.playerid from players a, characters b, playercharacters c where a.playerid=c.pcplayerid and c.pccharid=b.charid and b.chartype=$player_character;";
	#print "$sql<BR>\n";
	local ($query) = $dbvar->prepare($sql);
	$query->execute;
	local @array;
	while (@array = $query->fetchrow_array())
	{
	   $curplayer = $array[1];
	   $charid = $array[0];
	   $registered = dosql("select count(playerid) from eventplayers where playerid = $curplayer and eventid = $current_episode;") + 0;
	   $numresults = dosql("select count(a.btid) from $table a, bgatypes b where a.charid = $charid and a.btid=b.btid;") + 0;
	   if ($numresults > 0 && $registered > 0)
	   {
	      $email = getEmailFromID($curplayer);
	      $message = "BGA Results for " . getCharName($charid) . ":\n\n";
	      $message .= "Here are your BGA results.\n\n";
	      $message .= "You may view your BGA results online at $siteURL and then selecting \"Manage Your Characters\" and then \"Between Games Actions\".\n\n";

	      $message .= "BGA Results For BGP $current_bgp: $bgpstring[$current_bgp]\n\n";
	      $message .= getmailresults($current_bgp,1);
	      $message .= "===============================================================\n\n";

              for ($i = 1; $i < $current_bgp; $i++)
	      {
			$message .= "BGA Results For BGP $i: $bgpstring[$i]\n\n";
			$message .= getmailresults($i,1);
	   	        $message .= "===============================================================\n\n";
	      }
	      #$message =~ s/\n/<BR>\n/g;
	      #print "$message<BR><BR>\n";
	      sendDBMail($email, "$campaign BGA Results", $message);
	   }
	}
	$query->finish;
	
	$dbvar->disconnect;	
	print $CGI->redirect("$thispage?error=" . encodeURL("Mailed BGA Results"));
}
elsif ($action eq "makePrint")
{
	print $CGI->header(-type  =>  'application/msword', -filename  =>  'bgas.doc');
	#print $CGI->header;
	ParseForm("noheader.tpl");
	local($dbvar) = dbconnect();
	$sql = "select c.pccharid, a.playerid from players a, characters b, playercharacters c where a.playerid=c.pcplayerid and c.pccharid=b.charid and b.chartype=$player_character;";
	#print "$sql<BR>\n";
	local ($query) = $dbvar->prepare($sql);
	$query->execute;
	local @array;
	while (@array = $query->fetchrow_array())
	{
	   $curplayer = $array[1];
	   $charid = $array[0];
	   
	   $sql = "select count(playerid) from eventplayers where playerid = $curplayer and eventid = $current_episode;";
	   #print "$sql<BR>\n";
	   $registered = dosql($sql) + 0;
	   $sql = "select count(a.btid) from $table a, bgatypes b where a.charid = $charid and a.btid=b.btid;";
	   #print "$sql<BR><BR>\n";
	   $numresults = dosql($sql) + 0;
	   if ($numresults > 0 && $registered > 0)
	   {
		   print "<h1>BGA Results for " . getCharName($charid) . ":</H1>\n";
		   showdata($current_bgp,1);
	   	   print "[pb]<BR>\n";
	   }
	      

	}
	$query->finish;
	
	$dbvar->disconnect;
	print "</body></html>\n";
}
elsif ($charid > 0)
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s for $charname";
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle</h1>\n";
	
	$isfamous = dosql("select sum(level) from characterabilities where charid=$charid and abid=140;") + 0;
	
	if ($isfamous > 0)
	{
	  print "<b>This character is famous and must maintain fame.</b><BR><BR>";
	  print "<a href=\"$thispage?action=fame&charid=$charid\">Add Maintain Fame</a><BR><BR>\n";	
	}
	
	$num_allowed = $base_num_allowed + getlevel("SPARE TIME"); 
	$num_allowed -= getlevel("RESPONSIBILITIES"); 
	$num_allowed = max($num_allowed,1);

	showdata($current_bgp,0);

	print "Character is allowed $num_allowed $heading(s) this Between Games Period.<BR>";
	if ($num_bgas < $num_allowed)
	{
	   print "<a href=\"$thispage?action=fill&charid=$charid&btid=3\">Fill with Occupation</a><BR><BR>\n";	
	   print "<a href=\"$thispage?action=fill&charid=$charid&btid=24\">Fill with Do Nothing</a><BR><BR>\n";	
	}

	for ($i = 1; $i < $current_bgp; $i++)
	{
	  print "<H2>BGA Results For BGP $i: $bgpstring[$i]</h2>\n";
	  showdata($i,0);
	}

	print "<br><a href=\"$thispage\">Skip</a>."; 
	print "&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"$thispage?action=next\">Next</a>."; 
	print "&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"$thispage\">Return</a>."; 
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?charid=$charid&action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}
elsif ($action eq "showall")
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s";
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle</h1>\n";
	
	print "<a href=\"$thispage\">Return</a>."; 
	print "&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"$thispage?action=showall\">Show ALL Unhandled BGAs</a>\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"$thispage?action=showall&sort=2\">Show ALL Research/Explore BGAs</a>\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"$thispage?action=pautoall\">Process ALL Automatic BGAs</a><BR><BR>\n";

	$sortby = $CGI->param("sort") + 0;

	if ($sortby == 2)
	{
	   print "<h2>Show ALL Research/Explore BGAs</h2>\n";
	}
	elsif ($sortby == 1)
	{
	   print "<h2>Sort by BGA Type</h2>\n";
	}
	else
	{
	   print "<h2>Sort by Character</h2>\n";
	}
	
	for ($i = $current_bgp; $i >= 1; $i--)
	{
	  print "<H2>BGA Results For BGP $i: $bgpstring[$i]</h2>\n";
	  showall($i);
	}

	print "<a href=\"$thispage?action=next\">First</a>."; 
	print "&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"$thispage?action=showall\">Show ALL Unhandled BGAs</a>\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"$thispage?action=showall&sort=2\">Show ALL Research/Explore BGAs</a><BR>\n";
	print "<br><a href=\"login.pl\">Main menu</a>."; 

	ParseForm($footer);
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s";
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>$doctitle</h1>\n";
	
	print "<H2>Show Unhandled BGAs</H2>\n";
	
	print "<form action=\"$thispage\" method=\"post\">\n";

	print "Choose Character: ";
	print makeCharDropDown("charid",0);
	print "<input type=\"submit\" name=\"submit\" value=\"Go For It\"><BR>";

	print "</form>\n";
	
	print "<a href=\"$thispage?action=next\">First</a>."; 
	print "&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"$thispage?action=showall\">Show ALL Unhandled BGAs</a>\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"$thispage?action=showall&sort=2\">Show ALL Research/Explore BGAs</a>\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"$thispage?action=pautoall\">Process ALL Automatic BGAs</a>\n";
	print "<BR><BR><a href=\"$thispage?action=mailGMs\">Mail BGA Results to GMs</a>\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"$thispage?action=mailPlayers\">Mail BGA Results to Players</a><BR><BR>\n";
	print "<a href=\"$thispage?action=makePrint\" target=_new>Make Printable BGA Results List</a><BR>\n";
	print "<br><a href=\"login.pl\">Main menu</a>."; 

	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local ($period) = $_[0];
	local ($printable) = $_[1];
	$num_bgas = 0;
	$max = dosql("select max(priority) from $table where charid=$charid;");
	local($db) = dbconnect();
	local ($sql) = "select * from $table where charid=$charid and period=$period order by priority;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Notes</b></td>\n";
	print "<td><b>Priority</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	  showrow($resptr,$printable);
	}
	print "</table><BR>\n";
	$query->finish;
	$db->disconnect;
}

sub showall()
{
	local ($period) = $_[0];
	$num_bgas = 0;
	local($db) = dbconnect();
	local ($sql) = "select * from $table where handled=0 and btid != 24 and charid > 0 and period=$period order by charid;";
	if ($sortby == 1)
	{
	   $sql = "select * from $table where handled=0 and btid != 24 and charid > 0 and period=$period order by btid;";
	}
	if ($sortby == 2)
	{
	   $sql = "select * from $table where (btid = 1 or btid = 6) and charid > 0 and period=$period order by charid;";
	}
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name -- <a href=\"$thispage?action=showall&sort=1\">Sort</a></b></td>\n";
	print "<td><b>Notes</b></td>\n";
	print "<td><b>Character -- <a href=\"$thispage?action=showall&sort=0\">Sort</a></b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   showrow($resptr,0);
	}
	print "</table><BR>\n";
	
	print "$num_bgas unhandled BGAs<BR>\n";
	$query->finish;
	$db->disconnect;
}

sub showrow()
{
   local($resptr) = $_[0]; 
   local($printable) = $_[1]; 
   $name = dosql("select text from bgatypes where btid = ".$resptr->{"btid"}.";");
   $key = $resptr->{"$keyfield"};
   print "<tr>\n";
   print "<td>$name</td>\n";
   print "<td>".$resptr->{"data"}."</td>\n";
   print "<td align=center>";
   if ($action eq "showall")
   {
      print getCharPlayerStr($resptr->{"charid"});
   }
   else
   {
	   if ($resptr->{"priority"} > 1 && $printable == 0)
	   {
	       print "<a href=\"$thispage?charid=$charid&action=up&$keyfield=$key\"><img src=\"up_arrow.gif\" alt=\"Move up\" border=0></a>";
	   }
	   elsif ($printable == 0)
	   {
	       print "<img src=\"empty.gif\">";
	   }	   
	   print "&nbsp;&nbsp;".$resptr->{"priority"}."&nbsp;&nbsp;";
	   if ($resptr->{"priority"} < $max && $resptr->{"priority"} > 0  && $printable == 0)
	   {
	       print "<a href=\"$thispage?charid=$charid&action=down&$keyfield=$key\"><img src=\"down_arrow.gif\" alt=\"Move down\" border=0></a>";
	   }
	   elsif ($printable == 0)
	   {
	       print "<img src=\"empty.gif\">";
	   }	 
   }
   print "</td>\n";
   print "<td>";
   if ($resptr->{"handled"} + 0 == 0  && $printable == 0)
   {
	   print "<a href=\"$thispage?charid=".$resptr->{"charid"}."&action=edit&$keyfield=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('$name',$key);\">Delete</a>\n";
	   $isauto = dosql("select auto from bgatypes where btid=".$resptr->{"btid"}.";") + 0;
	   if ($isauto > 0 && $resptr->{"conspirators"} eq "")
	   {
	      print " -- <a href=\"$thispage?charid=".$resptr->{"charid"}."&action=process&$keyfield=$key\">Process</a><sup>*</sup>\n";
	   }
	   if ($al >= $gm_access)
	   {
	      print " -- <a href=\"$thispage?charid=".$resptr->{"charid"}."&action=manual&$keyfield=$key\">Process Manually</a>\n";
	   }
   }
   else
   {
        $results = $resptr->{"result"};
        $results =~ s/\n/<BR>\n/g;
	print "Processed: $results";
	if ($al >= $gm_access  && $printable == 0)
        {
	      print " -- <a href=\"$thispage?charid=".$resptr->{"charid"}."&action=manual&$keyfield=$key\">Edit Results</a>\n";
	}
   }
   print "</td></tr>\n";
   $num_bgas++;
}

sub getmailresults()
{
	local ($period) = $_[0];
	local ($printable) = $_[1];
	local $retStr = "";
	$num_bgas = 0;
	local($db) = dbconnect();
	local ($sql) = "select * from $table where charid=$charid and period=$period order by priority;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   	$retStr .= $resptr->{"text"} . "\n";
	   	$retStr .= "Description: " . $resptr->{"data"} ."\n";
	   	$retStr .= "Results: " . $resptr->{"result"} ."\n\n";
	   	$retStr .= "----------------------------------------------------------------------\n\n";
	}
	$query->finish;
	$db->disconnect;
	return $retStr;
}

sub handlebgastep2()
{
   fillvars();
   $btid = $CGI->param("btid") + 0;
   $priority = $CGI->param("priority") + 0;
   $tplfile = "bga2.tpl";
   if ($btid == 1) #research/investigate
   {
	$tatext= "Enter a description of what you are researching or the character you are investigating.  You do not need to mention your skills or what you have learned already.  We can get that information from the database and from your journal.  \n";
	$tatext .= "<i>Keep in mind that the GMs have to go through <i>hundreds</i> of BGAs.  Please be brief.  We may deduct from your roll if you are overly verbose.</i><BR><BR>\n";
	
	$moneytext = "You may spend money to assist in your research.  Spending money will add to your chance of success.  For every 15 you spend, we'll give you a +1 to your roll (up to a +6).<BR>";
	
	showbgaform2();
   }
   elsif ($btid == 3) #occupation
   {
	$sql = "select a.oname from occupations a, characteroccupations b where b.charid=$charid and a.oid=b.oid;";
	$data = dosql($sql);
	
	#print $CGI->header;
	#print "$sql<BR>\n";
	#print "$data<BR>\n";

	print $CGI->redirect("$thispage?submit=Add&charid=$charid&data=$data&priority=$priority&$keyfield=$keyvalue&btid=$btid");
   }
   elsif ($btid == 4) #gamble
   {
	$moneytext = "Enter the amount you wish to gamble.<BR>";
	$tplfile = "bga3.tpl";
	
	showbgaform2();
   }
   elsif ($btid == 5) #theft
   {
	$data = "From random NPC";
	
	#print $CGI->header;
	#print "$sql<BR>\n";
	#print "$data<BR>\n";

	print $CGI->redirect("$thispage?submit=Add&charid=$charid&data=$data&priority=$priority&$keyfield=$keyvalue&btid=$btid");
   }
   elsif ($btid == 6) #explore
   {
	$tatext= "Enter a description or name of the location you wish to explore.  You do not need to mention your skills or what you have learned already.  We can get that information from the database and from your journal.  Do mention anyone you believe is accompanying you.  If you do not know where the location is, then your result may just give you clies\n";
	$tatext .= "<i>Keep in mind that the GMs have to go through <i>hundreds</i> of BGAs.  Please be brief.  We may deduct from your results if you are overly verbose.</i><BR><BR>\n";
	
	$moneytext = "Enter the maximum amount of money you're willing to spend to explore this area.  It may cost less.<BR>";
	
	showbgaform2();
   }
   elsif ($btid == 7) #weird science build
   {
	$tplfile = "bgahost.tpl";
	$tatext = "Select the device you want to build.  Note that very complex devices may require several BGAs to build.";
	$droptext = makeDropDown("WS_plans a, characterplans b", "a.planid", "a.name", "a.planid=b.planid and b.charid=$charid");
	$droptext =~ s/name="a.planid"/name="data"/g;
	$moneytext = "Building a Weird Science device requires parts and money.  Enter the maximum amount of money you are willing to spend.";
	showbgaform2();
   }
   elsif ($btid == 8) #weird science plan
   {
	$tatext= "Please enter the name of the new device you wish to build and a brief description of its function.<BR><BR>\n";
	
	$moneytext = "This may cost you some money to produce the plan.  Enter the maximum amount you'd be willing to spend.<BR>";
	showbgaform2();
   }
   elsif ($btid == 9) #magical research
   {
	$tplfile = "bgamagic.tpl";
	$tatext = makeDropDown("characterabilities a, abilities b", "b.name", "b.name", "a.abid=b.abid and a.charid=$charid and b.type='Spell'", " onchange=\"javascript:myform.data.value=value;\"");
	showbgaform2();
   }
   elsif ($btid == 10) #influence public opinion
   {
	$tplfile = "bgainfluence.tpl";
	$tatext = "The Docket: ";
	$tatext .= makeDropDown("docket", "dname", "dname", "did > 0 and eventid=$current_episode and submittor > 0 order by dname", " onchange=\"javascript:myform.data.value=value;\"");
	$tatext .= "<BR><BR>Global Variables: ";
	$tatext .= makeDropDown("global_variables", "name", "name", "speechable=1 order by name", " onchange=\"javascript:myform.data.value=value;\"");
	showbgaform2();
   }
   elsif ($btid == 11) #ward a VL
   {
	$tplfile = "bgaward.tpl";
	$tatext = "Select the virtual location you wish to ward from the list below.";
	$droptext = makeDropDown("virtuallocations", "vlname", "vlname", "vlowner=$charid");
	$droptext =~ s/name="vlname"/name="data"/g;
	$droptext =~ s|</select>||g;
	$str = makeDropDown("virtuallocations a, VLaccess b", "a.vlname", "a.vlname", "b.charid=$charid and a.vlid=b.vlid");
	if ($droptext eq "")
	{
	   $str =~ s/name="a.vlname"/name="data"/g;
	}
	else
	{
	   $str =~ s/<select name="a.vlname">//g;
	}
	if ($str eq "")
	{
	   $droptext .= "</select>";
	}
	$droptext .= $str;
	$comptext = makeDropDown("inventory_sc a, spellcomponents b", "b.scid", "b.scname", "a.charid=$charid and a.scid=b.scid order by b.scname");
	$comptext =~ s/name="b.scid"/name="scid"/;
	showbgaform2();
   }
   elsif ($btid == 12) #consecrate a VL
   {
	$tplfile = "bgadrop.tpl";
	$tatext = "Select the virtual location you wish to consecrate from the list below.";
	$droptext = makeDropDown("virtuallocations", "vlname", "vlname", "vlowner=$charid");
	$droptext =~ s/name="vlname"/name="data"/g;
	$droptext =~ s|</select>||g;
	$str = makeDropDown("virtuallocations a, VLaccess b", "a.vlname", "a.vlname", "b.charid=$charid and a.vlid=b.vlid");
	if ($droptext eq "")
	{
	   $str =~ s/name="a.vlname"/name="data"/g;
	}
	else
	{
	   $str =~ s/<select name="a.vlname">//g;
	}
	if ($str eq "")
	{
	   $droptext .= "</select>";
	}
	$droptext .= $str;
	showbgaform2();
   }
   elsif ($btid == 13) #empower a VL
   {
	$tplfile = "bgadrop.tpl";
	$tatext = "Select the virtual location you wish to empower from the list below.";
	$droptext = makeDropDown("virtuallocations", "vlname", "vlname", "vlowner=$charid");
	$droptext =~ s/name="vlname"/name="data"/g;
	$droptext =~ s|</select>||g;
	$str = makeDropDown("virtuallocations a, VLaccess b", "a.vlname", "a.vlname", "b.charid=$charid and a.vlid=b.vlid");
	if ($droptext eq "")
	{
	   $str =~ s/name="a.vlname"/name="data"/g;
	}
	else
	{
	   $str =~ s/<select name="a.vlname">//g;
	}
	if ($str eq "")
	{
	   $droptext .= "</select>";
	}
	if ($str eq "")
	{
	   $droptext .= "</select>";
	}
	$droptext .= $str;
	showbgaform2();
   }
   elsif ($btid == 15) #host a party
   {
	$tplfile = "bgahost.tpl";
	$tatext = "Select the virtual location where you wish to host the party from the list below.";
	$droptext = makeDropDown("virtuallocations", "vlid", "vlname", "vlowner=$charid");
	$droptext =~ s/name="vlid"/name="data"/g;
	$droptext =~ s|</select>||g;
	$str = makeDropDown("virtuallocations a, VLaccess b", "a.vlid", "a.vlname", "b.charid=$charid and a.vlid=b.vlid");
	if ($droptext eq "")
	{
	   $str =~ s/name="a.vlid"/name="data"/g;
	}
	else
	{
	   $str =~ s/<select name="a.vlid">//g;
	}
	$droptext .= $str;
	if ($str eq "")
	{
	   $droptext .= "</select>";
	}
        $status = dosql("select status from characterSTATs where charid=$charid") * 10;
	$moneytext = "You may spend money to assist in hosting the party.  Spending money will add to your chance of throwing a good party.  For every $status you spend, we'll give you a +1 to your roll (up to a +6).";
	showbgaform2();
   }
   elsif ($btid == 16) #perform a craft
   {
	$tplfile = "bgahost.tpl";
	$tatext = "Select the craft skill you wish to use to make money.";
	$droptext = makeDropDown("characterabilities", "text", "text", "charid=$charid and abid=82");
	$droptext =~ s/name="text"/name="data"/g;
	$moneytext = "Producing something with your craft costs money for materials.  Enter the maximum amount you'd be willing to spend.  Higher materials means a higher price for the finished object.";
	showbgaform2();
   }
   elsif ($btid == 17) #perform
   {
	$tplfile = "bgahost.tpl";
	$tatext = "Select the performance skill you wish to use to make money. <i>Note that using this skill also counts as Staying in the Public Eye for purposes of Fame</i>";
	$droptext = makeDropDown("characterabilities", "text", "text", "charid=$charid and abid=84");
	$droptext =~ s/name="text"/name="data"/g;
	$moneytext = "Performing costs money for advertising, costumes, and the like.  Enter the maximum amount you'd be willing to spend.  The more you spend, the more you are likely to get in return.";
	showbgaform2();
   }
   elsif ($btid == 18) #stay in public eye
   {
	$data = "Stay in the Public Eye";
	
	#print $CGI->header;
	#print "$sql<BR>\n";
	#print "$data<BR>\n";

	print $CGI->redirect("$thispage?submit=Add&charid=$charid&data=$data&priority=$priority&$keyfield=$keyvalue&btid=$btid");
   }
   elsif ($btid == 20) #Thwart
   {
	$tatext= "Enter the name of the character(s) and the BGA you believe said character(s) are doing.   You do not need to mention your skills or what you have learned already.  We can get that information from the database and from your journal.  \n";
	$tatext .= "<i>Keep in mind that the GMs have to go through <i>hundreds</i> of BGAs.  Please be brief.  We may deduct from your roll if you are overly verbose.</i><BR><BR>\n";
	
	$moneytext = "You may spend money to assist in your thwarting.  Spending money will add to your chance of success.<BR>";
	
	showbgaform2();
   }
   elsif ($btid == 23) #donate to the fund
   {
	$moneytext = "Enter the amount you wish to donate to the fund created by the Antiquities Protection & Restoration Act.<BR>";
	$tplfile = "bga3.tpl";
	
	showbgaform2();
    }
   else #other
   {
	$tatext= "Do something that is not handled by the main list.  The GMs must manually handle this, so it may take longer to get your results.  Enter your Between Games Action below.  Note that \"informational\" BGAs such as, \"I set up a bird feeder in my back yard,\" or \"I go to Paris,\" will not garner a response from the GMs.<BR><BR>\n";
	$tatext .= "<i>Keep in mind that the GMs have to go through <i>hundreds</i> of BGAs.  Please be brief.  We may deduct from your results if you are overly verbose.</i><BR><BR>\n";
	
	$moneytext = "Most BGAs cost money to perform.  Enter the money you are willing to spend on this BGA.<BR>";
	showbgaform2();
   }
}

sub showbgaform2
{
	print $CGI->header;
	$doctitle = "Manage ".$heading."s for $charname";
	ParseForm($header);
	print "<h1>$doctitle</h1>\n";
	print "<h2>Step Two</h2>\n";
	
	$yourmoney = getMoney($charid);
	
	print "<form action=\"$thispage\" name=\"myform\" method=\"post\">";
	ParseForm($tplfile);
	
	if ($keyvalue eq "")
	{
		print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>"; 	
	}
	else
	{
		print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>"; 	
	}
 	print "</form>";
 	
	print "<br><hr><a href=\"$thispage?charid=$charid\">Return to BGAs</a>."; 
	print "<br><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}

sub fillvars()
{
	$tc = $charid;
	filltable();
	$charid=$tc;
	$bga_types = createBGAdropdown();
	$bga_list = createBGAlist();
	
	if ($priority == 0)
	{
	  $priority = dosql("select max(priority) from bgas where charid=$charid;") + 1;
	}
}

sub createBGAdropdown
{
    local ($db) = dbconnect();
    $SQL = "select * from bgatypes order by text";
    
    local($query) = $db->prepare($SQL);
    $query->execute;

    local ($num) = 0;
    local($retVal) = "<select name=\"btid\">\n";
    while ($resptr = $query->fetchrow_hashref())
    {
        if ($resptr->{"text"} eq "Other")
        {
           $num = $resptr->{"btid"};
        }
        elsif (bgaok($resptr->{"stat_req"},$charid) > 0)
        {
           $selected = "";
           if ($resptr->{"btid"} == $btid)
           {
             $selected = "SELECTED";
           }
    	   $retVal .= "<option value=\"".$resptr->{"btid"}."\" $selected>".$resptr->{"text"}."</option>\n";
    	}
    }
    if ($num > 0)
    {
    	$retVal .= "<option value=\"$num\">Other</option>\n";
    }
    $retVal .= "</select>\n";
    $query->finish;
    $db->disconnect;
    return $retVal;
}

sub createBGAlist
{
    local ($db) = dbconnect();
    $SQL = "select * from bgatypes order by text";
    
    local($query) = $db->prepare($SQL);
    $query->execute;

    local ($num) = 0;
    local($retVal) = "<table border=1 width=100%>\n";
    $retVal .= "<tr>\n";
    $retVal .= "<td width=20%><b>Action</b></td>\n";
    $retVal .= "<td><b>Explanation</b></td>\n";
    $retVal .= "</tr>\n";
    while ($resptr = $query->fetchrow_hashref())
    {
        if (bgaok($resptr->{"stat_req"},$charid) > 0)
        {
    		$retVal .= "<tr>\n";
    		$retVal .= "<td bgcolor=\"$bgcolor\">".$resptr->{"text"}."</td>\n";
    		$retVal .= "<td bgcolor=\"$bgcolor\">".$resptr->{"explanation"}."</td>\n";
    		$retVal .= "</tr>\n";
    	}
    }
    $retVal .= "</table>\n";
    $query->finish;
    $db->disconnect;
    return $retVal;
}

sub bgaok()
{
   local ($compval) = $_[0];
   local ($charid) = $_[1];
  
   $bgcolor = "FFFFFF";
   if ($compval eq "")
   {
     return 1;
   }
   
   if ($compval eq "occupation")
   {
      $sql = "select count(charid) from characteroccupations where charid=$charid;";
      #print "$sql<BR>";
      return dosql($sql);
   }
   
   $bgcolor = "EEEEEE";
   $sql = "select $compval from characterSTATs where charid=$charid;";
   #print "$sql<BR>";
   local($val) = dosql($sql) + 0;
   
   $val += getlevel($compval);
   
   return $val;
}

sub showFreeBGAMenu()
{
	print "<H2>Free Action Menu</H2>\n";
	print "<p><i>The following actions are free Between Game Actions.  You may perform as many of them between games as you wish.  They are automatically handled by the database.</i></p>\n";
	print "<ul>\n";
	print "<li><a href=\"docketforplayers.pl?charid=$charid\">Manage your docket items.</a></li>\n";
	print "<li><a href=\"journal.pl?charid=$charid\">Manage your journal</a></li>\n";
	print "<li><a href=\"bgafree.pl?charid=$charid&action=money\">Transfer money to another character</a></li>\n";
	print "<li><a href=\"bgafree.pl?charid=$charid&action=vl\">Manage access to your Virtual Locations</a></li>\n";
	print "<li><a href=\"bgafree.pl?charid=$charid&action=buyinvest\">Buy Investments</a></li>\n";
	print "<li><a href=\"bgafree.pl?charid=$charid&action=sellinvest\">Sell Investments</a></li>\n";
	print "<li><a href=\"xp.pl?charid=$charid\">Spend XP</a></li>\n";
	print "<li>Manage your SubStatus Freebies</a></li>\n";
	if (dosql("select inspiration from characterSTATs where charid=$charid;") + 0 > 0)
	{
		print "<li><a href=\"bgafree.pl?charid=$charid&action=wspart\">Purchase Weird Science Part</a></li>\n";
		print "<li><a href=\"bgafree.pl?charid=$charid&action=wsaccess\">Set Access to Your Weird Science Plans</a></li>\n";
		print "<li>Sell a Weird Science Device</li>\n";
	}
	if (dosql("select mana from characterSTATs where charid=$charid;") + 0 > 0)
	{
		print "<li><a href=\"bgafree.pl?charid=$charid&action=spcomp\">Purchase Spell Component</a></li>\n";
	}
	print "<br>\n";
	print "</ul>\n";
}

sub createAddBGAsql()
{
	$btid = $CGI->param("btid") + 0;
	$conspirators = $CGI->param("conspirators");
	$conspirators =~ s/'/''/g;
	local ($retStr) = "";
	if ($btid == 10) #influence public opinion
	{
	   $data = "<" . $CGI->param("favors") . ">" . $CGI->param("data");
	   $data =~ s/'/''/g;
	   $retStr="insert into $table (charid,btid,data,money,priority,conspirators) values ($charid,$btid,'$data',".$CGI->param("money").",".$CGI->param("priority").",'$conspirators');";
	}
	elsif ($btid == 4 || $btid == 23) #Gamble or donate to fund
	{
	   $data = "".$CGI->param("money");
	   $retStr="insert into $table (charid,btid,data,money,priority,conspirators) values ($charid,$btid,'$data',".$CGI->param("money").",".$CGI->param("priority").",'$conspirators');";
	}
	elsif ($btid == 7) #WS Build
	{
	   $data = $CGI->param("data");
	   $data = "<!--$data-->" . dosql("select name from WS_plans where planid=$data;");
	   $data =~ s/'/''/g;
	   $retStr="insert into $table (charid,btid,data,money,priority,conspirators) values ($charid,$btid,'$data',".$CGI->param("money").",".$CGI->param("priority").",'$conspirators');";
	}
	elsif ($btid == 11) #Ward
	{
	   $data = "<!--" . $CGI->param("scid") . "-->" . $CGI->param("data");
	   $data =~ s/'/''/g;
	   $retStr="insert into $table (charid,btid,data,money,priority,conspirators) values ($charid,$btid,'$data',0,".$CGI->param("priority").",'$conspirators');";
	}
	elsif ($btid == 15) #Host
	{
	   $data = $CGI->param("data");
	   $name = dosql("select vlname from virtuallocations where vlid='$data';"); 
	   $data = "<!--" . $CGI->param("data") . "-->" . $name;
	   $data =~ s/'/''/g;
	   $retStr="insert into $table (charid,btid,data,money,priority,conspirators) values ($charid,$btid,'$data',".$CGI->param("money").",".$CGI->param("priority").",'$conspirators');";
	}
	else
	{
	   $retStr = filltablefromCGI($table, 1);
	}
	
	return $retStr;
}

sub createChangeBGAsql()
{
	$btid = $CGI->param("btid") + 0;
	$conspirators = $CGI->param("conspirators");
	$conspirators =~ s/'/''/g;
	local ($retStr) = "";
	if ($btid == 10) #influence public opinion
	{
	   $data = "<!--" . $CGI->param("favors") . "-->" . $CGI->param("data");
	   $data =~ s/'/''/g;
	   $retStr="update $table  set data='$data', money=".$CGI->param("money").",priority=".$CGI->param("priority").", conspirators='$conspirators' where $keyfield=$keyvalue;";
	}
	elsif ($btid == 4 || $btid == 23) #Gamble or donate to fund
	{
	   $data = "".$CGI->param("money");
	   $retStr="update $table  set data='$data', money=".$CGI->param("money").",priority=".$CGI->param("priority").", conspirators='$conspirators' where $keyfield=$keyvalue;";
	}
	elsif ($btid == 7) #WS Build
	{
	   $data = $CGI->param("data");
	   $data = "<!--$data-->" . dosql("select name from WS_plans where planid=$data;");
	   $data =~ s/'/''/g;
	   $retStr="update $table  set data='$data', money=".$CGI->param("money").",priority=".$CGI->param("priority").", conspirators='$conspirators' where $keyfield=$keyvalue;";
	}
	elsif ($btid == 11) #Ward
	{
	   $data = "<!--" . $CGI->param("scid") . "-->" . $CGI->param("data");
	   $data =~ s/'/''/g;
	   $retStr="update $table  set data='$data',priority=".$CGI->param("priority").", conspirators='$conspirators' where $keyfield=$keyvalue;";
	}
	elsif ($btid == 15) #Host
	{
	   $data = $CGI->param("data");
	   $name = dosql("select vlname from virtuallocations where vlid='$data';"); 
	   $data = "<!--" . $CGI->param("data") . "-->" . $name;
	   $data =~ s/'/''/g;
	   $retStr="update $table  set data='$data', money=".$CGI->param("money").",priority=".$CGI->param("priority").", conspirators='$conspirators' where $keyfield=$keyvalue;";
	}
	else
	{
	   $retStr = filltablefromCGI($table, 0);
	}
	
	return $retStr;
}

# ********************
# * makeCharDropDown *
# ********************
# * makeCharDropDown makes a drop down field from characters.
sub makeCharDropDown
{
local($selectname) = $_[0];
local($value) = $_[1];
local ($db) = dbconnect();
$SQL = "select a.charid, concat(b.pfirst, ' ', b.plast) from characters a, players b, playercharacters c, characterSTATs d where c.pccharid=a.charid and b.playerid=c.pcplayerid and a.chartype != $test_character and d.charid=a.charid and a.charid > 0 order by a.clast";
    
local($query) = $db->prepare($SQL);
$query->execute;

local ($retVal) = "";

#Check to make sure $query is not empty
    if ($query->rows > 0)
    {
        $retVal = "<select name=\"$selectname\">\n";
        local (@array);
        while (@array = $query->fetchrow_array)
        {
          if ("$array[0]" eq "$value")
          {
            $retVal .= "<option value=\"$array[0]\" SELECTED>".getCharName($array[0])." ($array[1])</option>\n";
          }
          else
          {
            $retVal .= "<option value=\"$array[0]\">".getCharName($array[0])." ($array[1])</option>\n";
          }
        }
        $retVal .= "</select>\n";
    }
$query->finish;
$db->disconnect;
return $retVal;
}
