#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "journal.pl";
$table = "journal";
$heading = "Journal";
$keyfield = "charid";
$keyvalue = $CGI->param($keyfield);
$namefield = "entrydate";
$tplfile = "journal.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to view Journals"));
}
elsif ($action eq "award")
{
	#print $CGI->header;
	local($db) = dbconnect();
	local ($sql) = "select charid from $table where charid > 0 group by charid;";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	while (@array = $query->fetchrow_array)
	{
	   updateXP($array[0],1,"From Having a Journal");
	}
	$query->finish;
	$db->disconnect;
	print $CGI->redirect("gmjournal.pl?error=" . encodeURL("Players have been awarded XP."));
}
else
{
	print $CGI->header;
	$doctitle = "View Journals";
	ParseForm($header);
	
	if ("$errstr" ne "")
	{
		print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle</H1>\n";
	
	print "<form action=\"journal.pl\" method=\"post\">\n";
	
	$datestr = dosql("select eventend from events where eventid=$previous_episode;");
		
	$year = substr($datestr, 0, 4);
	$month = substr($datestr, 5, 2) - 1;
	$day = substr($datestr, 8, 2);
	
   	@months = ('January','February','March','April','May','June','July','August','September','October','November','December');
   	
	print "View <b>all</b> Journals since: ";
	
	print makeArrayDropDown([@months],"month", [$months[$month]], "", 1);
	
	print " <input name=\"day\" type=\"text\" size=3 value=\"$day\">";
	
	print ", <input name=\"year\" type=\"text\" size=8 value=\"$year\"> ";
	
	print "<input type=submit value=\"Go\">\n";
	
	print "<input type=hidden name=action value=\"bydate\">\n";
	
	print "</form><BR>\n";
		
	showdata();

	#print "<br><a href=\"gmjournal.pl?action=award\">Award XP to Players</a><BR>\n";

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
		
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select charid from characters order by clast;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Character</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "<td><b>Character</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	$oddrow = 0;
	local (@array);
	while (@array = $query->fetchrow_array)
	{
	   $num = dosql("select count(charid) from $table where charid=$array[0];") + 0;
	   if ($num > 0)
	   {
	   	if ($oddrow % 2 == 0)
	   	{
	   		print "<tr>\n";
	   	}
	   	print "<td>".getCharPlayerStr($array[0])."</td>\n";
	   	print "<td><a href=\"$thispage?$keyfield=$array[0]\">View</a></td>\n";
	   	if ($oddrow % 2 == 1)
	   	{
	   		print "</tr>\n";
	   	}
	   	$oddrow++;
	   }
	}
	$query->finish;
	$db->disconnect;
	print "</table>\n";
}

