#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$krid = $CGI->param("krid");
$pid = getPlayerID();
$access = getAccessLevel($pid);

#Fill Variables
local($db) = dbconnect();
local($tab) = $db->prepare("explain keyroles");
$tab->execute;
$i = 0;
while (@arrtemp = $tab->fetchrow_array)
{
  $arr[$i] = $arrtemp[0];
  $arrTypes[$i] = $arrtemp[1];
  #print "$arr[$i] - $arrTypes[$i]<br>\n";
  $i++;
}
$numFields = $i;
$tab->finish;
local($query) = $db->prepare("select * from keyroles where krid = $krid");
$query->execute;
@cqquery = $query->fetchrow_array;
for ($k=0;$k<$tab->rows;$k++)
{
$cqquery[$k] =~ s/'/\\'/g;
$cqquery[$k] =~ s/"/\"/g;
$cqquery[$k] =~ s/\n/<BR>/g;
#print "\$$arr[$k] = $cqquery[$k]<br>\n";
    if ($arrTypes[$k] eq 'tinyint(1)')
    {
	if ($cqquery[$k] > 0)
	{
	    eval("\$$arr[$k] = 'yes'");
	}
	else
	{
	    eval("\$$arr[$k] = 'no'");
	}
    }
    else
    {
	eval("\$$arr[$k] = '$cqquery[$k]'");
    }
}
$query->finish;

$db->disconnect;


print $CGI->header();
print"<html>\n";
print"<head>\n";
print"<link href=\"../brassy.css\" rel=\"stylesheet\" type=\"text/css\">\n";
print"<title>$krname</title>\n";
print"</head>\n";
print"<body>\n";

print"<p>\n";
print"<H1>$krname</H1>\n";

print"<b>Description:</b><BR>$krdescription<BR><BR>\n";

print"<b>Requirements:</b><BR>$krrequirements<BR><BR>\n";

print"<b>Abilities:</b> ".getmyabilities()."<BR><BR>\n";

if ($access >= $gm_access)
{
	print"<b>Characters:</b><BR>\n";
	print getmycharacters();
}

print"</p>\n";

print"</body>\n";
print"</head>\n";

exit 0;

sub getmyabilities()
{
	$totalcost = 0;
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select a.kraid, a.abid, b.name, b.type, a.level, a.text, a.difficulty, a.cost from keyroleabilities a, abilities b where a.krid=$krid and a.abid=b.abid order by b.type, b.name;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Level</b></td>\n";
	$retstr .= "<td><b>Type</b></td>\n";
	$retstr .= "<td><b>Name</b></td>\n";
	$retstr .= "<td><b>Text</b></td>\n";
	$retstr .= "<td><b>Difficulty</b></td>\n";
	$retstr .= "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $retstr .= "<tr>\n";
	   $retstr .= "<td>".$resptr->{"level"}."</td>\n";
	   $retstr .= "<td>".$resptr->{"type"}."</td>\n";
	   $retstr .= "<td>".$resptr->{"name"}."</td>\n";
	   $retstr .= "<td>".$resptr->{"text"}."</td>\n";
	   $retstr .= "<td>".$resptr->{"difficulty"}."</td>\n";
	   $retstr .= "</tr>\n";
	}
	$retstr .= "</table>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}

sub getmycharacters()
{
	$totalcost = 0;
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select * from keyrolecharacters where krid=$krid;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1 width=100%>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Character Name</b></td>\n";
	$retstr .= "<td><b>Type</b></td>\n";
	$retstr .= "<td><b>Player Name</b></td>\n";
	$retstr .= "</tr>\n";
	local ($num) = 0;
	while ($resptr = $query->fetchrow_hashref())
	{
	   local ($charid) = $resptr->{"charid"};
	   $retstr .= "<tr>\n";
	   $retstr .= "<td>".getCharName($charid)."</td>\n";
	   $retstr .= "<td>".getCharTypeFromCharID($charid)."</td>\n";
	   $retstr .= "<td>".getFullNameFromCharID($charid)."</td>\n";
	   $retstr .= "</tr>\n";
	}
	$retstr .= "</table>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}