#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;

$pid = getPlayerID();
$al = getAccessLevel($pid);
$thispage = "main.pl";  	#Name of this web page
$tabnum = $CGI->param("tabnum") + 0;
if ($tabnum == 0)
{
	$tabnum = dosql("select tabnum from pagedefaults where playerid=$plid and pageid='$thispage';") + 0;
}
else
{
	setTabNum($thispage,$pid,$tabnum)
}

if ($al < $player_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You must log in first."));
}
else
{
	print $CGI->header();
	$playername = getFullNameFromID($pid);
	
	$db = dbconnect();

	ParseForm($header);
	ParseForm("tabs.tpl");
	
	print "<style TYPE=\"text/css\" MEDIA=screen>\n";
	print "div { \n";
	print "    border: thin solid Black; \n";
	print "    padding-left: 7px; \n";
	print "    padding-right: 7px;\n";
	print "    margin-bottom: 1px;\n";
	print "};\n";
	print "</style>\n";

	if ($CGI->param("error") ne "")
	{
		print "<br><font color=\"red\">" . $CGI->param("error") . "</font><br><br>\n";
	}
	print "<p>Welcome $playername</p><H1>$campaign Player Database Main Menu</H1>\n";
	
	showTabs();
	getPageDefaults($pid);
	
	local $sql = "select count(pqplayerid) from playerquestionnaires where pqplayerid = $pid";
	$playerquest = dosql($sql) + 0;
	$sql = "select count(pcplayerid) from playercharacters where pcplayerid = $pid";
	$charactercount = dosql($sql) + 0;
	
	print "<table width=100% border=0 cellspacing=0>\n";
	print "<tr><td width=25% valign=top style=\"border: thin solid Black; TEXT-ALIGN: top; padding-left: 7px; padding-right: 7px;\">\n";

	printMenu($tabnum,0);
	printItems($tabnum);
	
	print "</td>\n";
	print "<td valign=top style=\"TEXT-ALIGN: top\">\n";

	displayNews();
	displayAnnouncements();
	printPlayerQuestLink();
	printEventMenu($pid);
	printActionItemsMenu($pid);
	printCharactersMenu();
	printServiceCredits();
	printRecentPlayers();
	
	print "</td></tr>\n";
	print "</table>\n";
	
	print "<a href=\"./login.pl?logout=1\"><img src=\"icons/back8.png\" border=0 align=left></a>&nbsp;&nbsp;<a href=\"./login.pl?logout=1\">Log Off</a>\n";
	print "<br><hr>\n";
	
	$db->disconnect;

	ParseForm($footer);
}


sub showTabs()
{
	local ($tottabs) = 1;
	print "<table>\n";
	print "<tr>\n";
	
	local $sql = "select * from menuheader where parent=1 or parent=0;";
	local($query) = $db->prepare($sql);
	$query->execute;
	local $resptr;
	while ($resptr = $query->fetchrow_hashref())
	{
            if (eval($resptr->{"varexpr"}))
            {
		$name = $resptr->{"name"};
		$key = $resptr->{"mhid"};
		if ($tabnum == 0)
		{
			$tabnum = $key;
		}
		if ($tabnum == $key)
		{
			print "<td class=\"blacktab\">$name</td>\n";
		}
		else
		{
			print "<td class=\"greytab\" OnClick=\"document.location ='$thispage?tabnum=$key'\">$name</td>\n";
		}
		$tottabs = $tottabs + 1;
		if ($tottabs % 7 == 0)
		{
			print "</tr><tr>\n";
		}
	    }
	}
	$query->finish;
	print "</tr>\n";
	print "</table>\n";
}

# ************************
# * printServiceCredits *
# ************************
sub printServiceCredits()
{
	local (%sum);
	local ($sql) = "select * from playerSC where playerid=$pid order by eventid, entrydate;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	if ($query->rows > 0)
	{
      		print "<div>\n";
      		print "<H2>Your Service Credits</H2>\n";
		print "<table border=1>\n";
		print "<tr>\n";
		print "<td><b>Credit</b></td>\n";
		print "<td><b>Value</b></td>\n";
		print "<td><b>Event</b></td>\n";
		print "<td><b>Notes</b></td>\n";
		print "<td><b>Date</b></td>\n";
		print "</tr>\n";
		while ($resptr = $query->fetchrow_hashref())
		{
		   $key = $resptr->{"scid"};
		   if ($resptr->{"scid"} > 0)
		   {
			   $credit = dosql("select name from service_credits where scid=".$resptr->{"scid"}.";");
			   $value = dosql("select value from service_credits where scid=".$resptr->{"scid"}.";");
		   }
		   else
		   {
			   $credit = "Other";
			   $value = $resptr->{"value"};
		   }
		   $notes = $resptr->{"notes"};
		   $entrydate = $resptr->{"entrydate"};
		   $eventname = dosql("select eventname from events where eventid = ".$resptr->{"eventid"}.";");
		   print "<tr>\n";
		   print "<td>$credit</td>\n";
		   print "<td>\$$value.00</td>\n";
		   print "<td>$eventname</td>\n";
		   print "<td>$notes</td>\n";
		   print "<td>$entrydate</td>\n";
		   print "</tr>\n";
		   $sum{$eventname} += $value;
		}

		foreach $eventname (sort keys %sum)
		{
		   print "<tr>\n";
		   print "<td><i>Sum</i></td>\n";
		   print "<td><i>\$".$sum{$eventname}.".00</i></td>\n";
		   print "<td colspan=3><i>$eventname</i></td>\n";
		   print "</tr>\n";
		}
		print "</table>\n";
		print "<p><a href=\"servicecredits.pl\">View Service Credits</a></p>\n";
		print "</div>\n";
	}
	$query->finish;
}

# ************************
# * printCharactersMenu *
# ************************
sub printCharactersMenu()
{
	local ($sql) = "Select * from characters, playercharacters, chartypes where pccharid = charid and chartype = ctypeid and pcplayerid = $pid order by chartype, clast;";
	#print "$sql<BR>\n";
	local($query) = $db->prepare($sql);
	$query->execute;
	
	local $liststr = '';

	while ($resptr = $query->fetchrow_hashref())
	{
	  $liststr .= displaythechar($resptr);
	}
	if ($liststr ne '')
	{
      		print "<div>\n";
      		print "<H2>Your Characters</H2>\n";
		print "$liststr<BR>\n";
      		print "</div>\n";
	}

}

sub displaythechar()
{
    local($resptr) = $_[0];
    local $mytype = $resptr->{"chartype"} + 0;
    local $charid = $resptr->{"charid"};
    local $retStr = '';
    
    filltraits($mytype);
    
    $retStr .= "<table width=100% border=0 cellspacing=0 style=\"border: thin solid Black;\">\n";
    $retStr .= "<tr>\n";
    $retStr .= "<td style=\"font-weight: bold; background-color: $headercolor; border-bottom: none;\">\n";
    if ($al >= $charcreatelevel)
    {
    	$retStr .= "<A NAME=\"".$resptr->{"charid"}."\"></A><a href=\"characters.pl?action=edit&charid=$charid\" Title=\"Click to Edit Character Details\">".getCharName($resptr->{"charid"})."</a>";
    }
    else
    {
    	print getCharName($resptr->{"charid"});
    }
    $retStr .= "</td>\n";
    $retStr .= "<td width=30% style=\"font-weight: bold; background-color: $headercolor; border-bottom: none;\">\n";
    $mychartype = dosql("select ctypedesc from chartypes where ctypeid=$mytype;");
    $retStr .=  $mychartype;
    $retStr .= "</td>";
    $retStr .= "</tr>\n";

    $retStr .= "<tr>\n";
    $retStr .= "<td colspan=2 style=\"background-color: $backgroundcolor;\">\n"; 
    if ($al >= $charcreatelevel)
    {
    	$retStr .= "<a href=\"charinfo.pl?charid=$charid\">Edit Public Info Page</a>\n";
    }
    if ($resptr->{"chtmllink"} ne "")
    {
    	$retStr .= " -- <a href=\"charhtml/".$resptr->{"chtmllink"}."\" target=_new>View Character Sheet</a>";
    }
    $allowjournal = $allowjournal + 0;
    if ($allowjournal > 0)
    {
       $retStr .= " -- <a href=\"journal.pl?charid=$charid\">Manage Journal</a>\n";
    }
    if ($mytype == $player_character && $al >= $charcreatelevel && $gamestage >= 2)
    {
       $retStr .= " -- <a href=\"bga.pl?charid=$charid\">Between Game Actions</a>\n";
    }
    $dostats = $dostats + 0;
    if ($dostats > 0 || $al >= $gm_access)
    {
       if ($resptr->{"charstatsapproved"} > 0)
       {
	  $retStr .= " -- <a href=\"dispstats.pl?charid=$charid\">View STATs</a>";
	  if ($al >= $gm_access && $gamestage >= 2)
	  {
	     $retStr .= " -- <a href=\"stats.pl?charid=$charid\">Edit STATs</a>.  ";
	  }
	  
	  if ($al >= $charcreatelevel  && $gamestage >= 2)
	  {
	  	$retStr .= " -- <a href=\"xp.pl?charid=$charid\">Spend XP</a>\n";
	  }

       }
       elsif ($al >= $charcreatelevel && $dostats > 0)
       {
	  $retStr .= " -- <a href=\"stats.pl?charid=$charid\">Edit STATs</a>.  ";
       }
    }    
    $retStr .= "</td>";
    $retStr .= "</tr>\n";
    $retStr .= "</table>\n";
    
    return $retStr;
}

# ************************
# * printActionItemsMenu *
# ************************
sub printActionItemsMenu()
{
	local $sql = "select count(playerid) from playeractionitems where playerid=$pid and completed = 0";
	local $num = dosql($sql) + 0;
	if ($num > 0)
	{
      		print "<div>\n";
      		print "<H2>Action Items</H2>\n";
		print "<b>You have $num incomplete Action Items.</b><BR>\n";
		print "<a href=\"action.pl\">View Action Items</a><BR><BR>\n";
      		print "</div>\n";
	}

}

# **********************
# * printRecentPlayers *
# **********************
sub printRecentPlayers()
{
     if ($al >= $gm_access)
     {
      	print "<div>\n";
      	print "<H2>Recent Players</H2>\n";
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Date</b></td>\n";
	print "</tr>\n";
	local $sql = "select pfirst, plast, lidate from players, loggedin where playerid=liplayerid order by lidate desc;";
	local ($query) = $db->prepare($sql);
	$query->execute;
      	local $num = 0;
	while (($num < 10) && ($resptr = $query->fetchrow_hashref()))
	{
	   print "<tr>\n";
	   print "<td>".$resptr->{"pfirst"}." ".$resptr->{"plast"}."</td>\n";
	   print "<td>".$resptr->{"lidate"}."</td>\n";
	   print "</tr>\n";
	   $num++;
	}
	$query->finish;
	print "</table>\n";
	print "</div>\n";
     }

}

# ************************
# * printPlayerQuestLink *
# ************************
sub printPlayerQuestLink()
{
	if ($playerquest == 0)
	{
      		print "<div>\n";
      		print "<H2>Player Questionnaire</H2>\n";
		print "<p>You have not filled out your Player Questionnaire.</p>\n";
		print "<p><a href=\"playquest.pl?mode=new&pqplayerid=$pid\">Click here</a> to fill one out now.</p>\n";
		print "<p><i>Your Player Questionnaire is an important step in the casting process.  Please fill it out.</p>\n";
      		print "</div>\n";
	}
}

# ******************
# * displayNews	   *
# ******************
sub displayNews()
{
	local ($sql) = "select * from news where display=1 order by entrydate desc;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local $liststr = "";
	local $i = 0;
	local $shownews = 'inline';
	while ($resptr = $query->fetchrow_hashref())
	{
	   $liststr .= "<span id=\"span$i\" style=\"display: $shownews;\">\n";
	   $liststr .= "<H2>".$resptr->{"title"}."</H2>\n";
	   $liststr .= "<p>";
	   $liststr .= $resptr->{"article"};
	   $liststr .= "</p>\n";
	   $liststr .= "<p align=right><i>-- ".getFullNameFromID($resptr->{"playerid"}).", ".myFormatDate($resptr->{"entrydate"})."</i></p>\n";
	   $liststr .= "</span>\n";
	   $i++;
	   $shownews = 'none';
	}
	$query->finish;
	
	if ($i > 1)
	{
	   $shownews = 'inline';
	}
	
	if ($liststr ne "")
	{
		print "<div>\n";
		print "$liststr\n";
		print "<table width=100% border = 0>\n";
		print "<tr><td>\n";
		print "<a href=\"javascript:PrevNews()\">\n";
		print "<img src=\"icons/back8.png\" border = 0 id=\"leftNewsArrow\" style=\"display: $shownews;\">\n";
		print "</a></td><td align=right>\n";
		print "<a href=\"javascript:NextNews()\">\n";
		print "<img src=\"icons/next8.png\" border = 0 id=\"rightNewsArrow\" style=\"display: none;\">\n";
		print "</a></td></tr>\n";
		print "</table>\n";
		print "</div>\n";
	}
	
	print "<script language=\"javascript\">\n";
	print "var curNews = 0;\n";
	print "var maxNews = $i;\n";
	print "function PrevNews()\n";
	print "{\n";
	print "	   var element = document.getElementById('span' + curNews);\n";
	print "	   element.style[\"display\"] = \"none\";\n";
	print "	   curNews = curNews + 1;\n";
	print "	   element = document.getElementById('span' + curNews);\n";
	print "	   element.style[\"display\"] = \"inline\";\n";
	print "	   element = document.getElementById('rightNewsArrow');\n";
	print "	   element.style[\"display\"] = \"inline\";\n";
	print "	   element = document.getElementById('leftNewsArrow');\n";
	print "	   if (curNews == maxNews - 1) {\n";
	print "	      element.style[\"display\"] = \"none\";\n";
	print "    } else {\n";
	print "	      element.style[\"display\"] = \"inline\";\n";
	print "    } \n";
	print "}\n";
	print "function NextNews()\n";
	print "{\n";
	print "	   var element = document.getElementById('span' + curNews);\n";
	print "	   element.style[\"display\"] = \"none\";\n";
	print "	   curNews = curNews - 1;\n";
	print "	   element = document.getElementById('span' + curNews);\n";
	print "	   element.style[\"display\"] = \"inline\";\n";
	print "	   element = document.getElementById('leftNewsArrow');\n";
	print "	   element.style[\"display\"] = \"inline\";\n";
	print "	   element = document.getElementById('rightNewsArrow');\n";
	print "	   if (curNews == 0) {\n";
	print "	      element.style[\"display\"] = \"none\";\n";
	print "    } else {\n";
	print "	      element.style[\"display\"] = \"inline\";\n";
	print "    } \n";
	print "}\n";
	print "</script>\n";
	
}

# **************************
# * displayAnnouncements   *
# **************************
sub displayAnnouncements()
{
	local ($sql) = "select * from announcement where display=1 order by displaydate desc;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local $liststr = "";
	local $i = 0;
	local $shownews = 'inline';
	while ($resptr = $query->fetchrow_hashref())
	{
	   $liststr .= "<span id=\"span$i\" style=\"display: $shownews;\">\n";
	   $liststr .= "<H2>".$resptr->{"title"}."</H2>\n";
	   $liststr .= "<p>";
	   $liststr .= $resptr->{"article"};
	   $liststr .= "</p>\n";
	   $liststr .= "<p align=right><i>-- ".$resptr->{"madeby"}.", ".myFormatDate($resptr->{"displaydate"})."</i></p>\n";
	   $liststr .= "</span>\n";
	   $i++;
	   $shownews = 'none';
	}
	$query->finish;
	
	if ($i > 1)
	{
	   $shownews = 'inline';
	}
	
	if ($liststr ne "")
	{
		print "<div>\n";
		print "<h2>News Items</h2>\n";
		print "$liststr\n";
		print "<table width=100% border = 0>\n";
		print "<tr><td>\n";
		print "<a href=\"javascript:PrevAnnounce()\">\n";
		print "<img src=\"icons/back8.png\" border = 0 id=\"leftNewsArrow\" style=\"display: $shownews;\">\n";
		print "</a></td><td align=right>\n";
		print "<a href=\"javascript:NextAnnounce()\">\n";
		print "<img src=\"icons/next8.png\" border = 0 id=\"rightNewsArrow\" style=\"display: none;\">\n";
		print "</a></td></tr>\n";
		print "</table>\n";
		print "</div>\n";
	}
	
	print "<script language=\"javascript\">\n";
	print "var curAnnounce = 0;\n";
	print "var maxAnnounce = $i;\n";
	print "function PrevAnnounce()\n";
	print "{\n";
	print "	   var element = document.getElementById('span' + curAnnounce);\n";
	print "	   element.style[\"display\"] = \"none\";\n";
	print "	   curAnnounce = curNews + 1;\n";
	print "	   element = document.getElementById('span' + curAnnounce);\n";
	print "	   element.style[\"display\"] = \"inline\";\n";
	print "	   element = document.getElementById('rightNewsArrow');\n";
	print "	   element.style[\"display\"] = \"inline\";\n";
	print "	   element = document.getElementById('leftNewsArrow');\n";
	print "	   if (curAnnounce == maxAnnounce - 1) {\n";
	print "	      element.style[\"display\"] = \"none\";\n";
	print "    } else {\n";
	print "	      element.style[\"display\"] = \"inline\";\n";
	print "    } \n";
	print "}\n";
	print "function NextAnnounce()\n";
	print "{\n";
	print "	   var element = document.getElementById('span' + curAnnounce);\n";
	print "	   element.style[\"display\"] = \"none\";\n";
	print "	   curNews = curAnnounce - 1;\n";
	print "	   element = document.getElementById('span' + curAnnounce);\n";
	print "	   element.style[\"display\"] = \"inline\";\n";
	print "	   element = document.getElementById('leftNewsArrow');\n";
	print "	   element.style[\"display\"] = \"inline\";\n";
	print "	   element = document.getElementById('rightNewsArrow');\n";
	print "	   if (curAnnounce == 0) {\n";
	print "	      element.style[\"display\"] = \"none\";\n";
	print "    } else {\n";
	print "	      element.style[\"display\"] = \"inline\";\n";
	print "    } \n";
	print "}\n";
	print "</script>\n";
	
}

# ******************
# * printEventMenu *
# ******************
# * printEventMenu prints out the list of Event menu options.
# * It takes the playerid as a parameter.
sub printEventMenu()
{
   local $liststr = "";
   local $liststr2 = "";
   local $liststr3 = "";
   local $sql = "select * from events where eventregavailable > 0";
   local($query) = $db->prepare($sql);
   $query->execute;
   while ($resptr = $query->fetchrow_hashref())
   {
     local $eventid = $resptr->{"eventid"};
     $liststr2 .= "<tr><td>" .$resptr->{"eventname"}. "</td>\n";
     $liststr2 .= "<td>".myFormatDate($resptr->{"eventstart"})." - ".myFormatDate($resptr->{"eventend"})."</td>\n";

     $sql = "select reglevel, balance from eventplayers where playerid=$pid and eventid=$eventid;";
     local($query2) = $db->prepare($sql);
     $query2->execute;
     if ($query2->rows == 0)
     {
        $liststr .= "<li><a href=\"signup.pl?submit=Create&eventid=$eventid\">".$resptr->{"eventname"}."</a> (".myFormatDate($resptr->{"eventstart"})." - ".myFormatDate($resptr->{"eventend"}).")</li>";
        $liststr2 .= "<td>Not Registered -- <a href=\"signup.pl?submit=Create&eventid=$eventid\">Register Now</a></td>\n";
        $liststr2 .= "<td>&nbsp;</td>\n";
     }
     else
     {
	@array = $query2->fetchrow_array;
	if ($array[0] == $registered)
	{
            $liststr3 .= "<li><a href=\"signup.pl?submit=Create&eventid=$eventid\">".$resptr->{"eventname"}."</a> (".myFormatDate($resptr->{"eventstart"})." - ".myFormatDate($resptr->{"eventend"}).")</li>";
	}
	
        $liststr2 .= "<td>$player_registration[$array[0]]</td>\n";
        if ($array[0] >= $registered)
        {
        	$tot = $array[1];
        	local ($sql) = "select sum(value) from playerSC where playerid=$pid and eventid=$eventid;";
        	$tot -= dosql($sql);
        	local ($sql) = "select sum(b.value) from playerSC a, service_credits b where a.playerid=$pid and a.eventid=$eventid and a.scid=b.scid;";
        	$tot -= dosql($sql);
        	if ($tot <= 0)
        	{
        		$liststr2 .= "<td>Paid In Full</td>\n";
        	}
        	else
        	{
        		$liststr2 .= "<td>\$$tot.00</td>\n";
        	}
        }
        else
        {
        	$liststr2 .= "<td>&nbsp;</td>\n";
        }
     }
     $liststr2 .= "</tr>";
     $query2->finish;
   }
      
   $query->finish;

   $registered = 1;
   if ($liststr ne "")
   {
      $registered = 0;
   }

   if ($liststr2 ne '')
   {
	print "<div>\n";
	print "<H2>Event Registration</H2>\n";
	if ($liststr ne '')
	{
	   print "<p><i>You have not yet registered for the following events:</i></p>\n";
	   print "<ul>$liststr</ul>\n";
	}

	if ($liststr3 ne '')
	{
	   print "<p><i>You have not yet paid for the following events:</i></p>\n";
	   print "<ul>$liststr3</ul>\n";
	}

	print "<H2>Upcoming Events</H2>\n";
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Event Name</b></td>\n";
	print "<td><b>Dates</b></td>\n";
	print "<td><b>You are...</b></td>\n";
	print "<td><b>Balance (including service credits)</b></td>\n";
	print "</tr>\n";
	print "$liststr2\n";
	print "</table>\n";

	print "<a href=\"signup.pl\">View Events & Register</a><BR><BR>\n";
	print "</div>\n";
   }
}


# *************
# * printMenu *
# *************
sub printMenu()
{
   local $curparent = $_[0];
   local $recurlevel = $_[1];
   
   $levstr1[0] = "<H2>";
   $levstr2[0] = "</H2>";
   
   $levstr1[1] = "<u><b>";
   $levstr2[1] = ":</b></u>";
   
   if ($recurlevel > 1)
   {
      $recurlevel = 1;
   }
   
   local($sql) = "select * from menuheader where parent=$curparent order by name;";
   #print "$sql<BR>\n";
   local($query) = $db->prepare($sql);
   $query->execute;
   local $resptr;
   while ($resptr = $query->fetchrow_hashref())
   {
	#print $resptr->{"varexpr"}."<BR>";
	#print eval($resptr->{"varexpr"})."<BR>";
        if (eval($resptr->{"varexpr"}))
        {
	    print "$levstr1[$recurlevel]".$resptr->{"name"}."$levstr2[$recurlevel]\n";
	    printItems($resptr->{"mhid"});
	    printMenu($resptr->{"mhid"}, $regcurlevel+1);
        }
   }
   $query->finish;
}

sub printItems()
{
	local $curparent = $_[0];
	local ($sql) = "select * from menuitem where parent = $curparent order by name;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
   	local $resptr;
	#print "<ul>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	  #print $resptr->{"varexpr"}."<BR>";
	  #print eval($resptr->{"varexpr"})."<BR>";
          if (eval($resptr->{"varexpr"}))
          {
		#print "<li>";
		print $resptr->{"info"};
		local ($urlstr) = $resptr->{"link"};
		$urlstr .= $pagedefs{$resptr->{"link"}};
		$linkparms = $resptr->{"linkparams"};
		$linkparms = eval qq/"$linkparms"/;
		if ($linkparms ne "")
		{
		   if ($urlstr ne $resptr->{"link"})
		   {
			$urlstr .= "&$linkparms";
		   }
		   else
		   {
			$urlstr .= "?$linkparms";
		   }
		}
		print " <a href=\"$urlstr\">".$resptr->{"name"}."</a>\n";
		print "<BR>\n";
		#print "</li>\n";
	   }
	}
	#print "</ul>\n";
	$query->finish;
}

sub getPageDefaults()
{
   local($sql) = "select pageid, defstring from pagedefaults where playerid=$pid;";
   #print "$sql<BR>\n";
   local($query) = $db->prepare($sql);
   $query->execute;
   local(@array);
   %pagedefs = ();
   while (@array = $query->fetchrow_array)
   {
       $pagedefs{$array[0]} = $array[1]; 
       #print "$array[0] -- $array[1] -- $array[2] -- \n";
       #print "$pagedefs{$array[0]}<BR>\n";
   }
   $query->finish;
}