#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "occupations.pl";
$table = "occupations";
$heading = "Occupation";
$keyfield = "oid";
$keyvalue = $CGI->param($keyfield);
$namefield = "oname";
$tplfile = "jobs.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit $heading(s)!"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $heading</H1>\n";
	}
	print "<form action=\"$thispage\" method=\"post\">";
	if ($tplfile eq "")
	{
		local($dbvar) = dbconnect();
		local($query) = $dbvar->prepare("explain $table");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $dbvar->prepare("select * from $table where $keyfield = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$dbvar->disconnect;
		print "</table>";
	}
	else
	{
	     fillvars();
	     ParseForm($tplfile);
	}
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	@names = $CGI->param;
	$SQL = "INSERT into $table (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		$SQL .= "$i, ";
	    }

	}
	chop $SQL;
	chop $SQL;
	$SQL .= ") values (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		local($myCGI) = $CGI->param($i);
		$myCGI =~ s/'/''/g;
		$SQL .= "'" . $myCGI . "', ";
	    }
	 }
	chop $SQL;
	chop $SQL;
	$SQL .= ");";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	@names = $CGI->param;
	$SQL = "UPDATE $table set ";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		local($myCGI) = $CGI->param($i);
		$myCGI =~ s/'/''/g;
		$SQL .= "$i = '" . $myCGI . "', ";
	    }
	}
	chop $SQL;
	chop $SQL;
	$SQL .= " where $keyfield = $keyvalue;";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$SQL = "delete from $table where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$SQL = "delete from characteroccupations where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$SQL = "delete from occupationabilities where $keyfield = $keyvalue;";
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Deleted"));
}
elsif ($action eq "addabilities")
{
	print $CGI->header();
	ParseForm($header);
	fillvars();
	print "<font color=red>$errstr</font><BR><BR>\n";
	print "<h1>Add/Edit Abilities for $oname</H1>\n";
	print "<form action=\"$thispage\" name=\"myform\" method=\"post\">\n";
	$myabilities = getmyabilities();
	$abilitiesstr = getabilitiesstr();
	print "<H2>Required Abilities</h2>\n";
	print "$myabilities<BR>\n";
	print "<a href=\"javascript:createredirect('$thispage?action=updateabilities');\">Update</a>&nbsp;&nbsp;&nbsp;&nbsp;\n";
	print "<a href=\"javascript:createredirect('$thispage?action=finishabilities');\">Done</a>\n";
	print "<H2>Available Abilities</h2>\n";
	print "$abilitiesstr<BR>\n";
	ParseForm("stats/stats-js.tpl");
	print "<input type=hidden name=\"$keyfield\" value=\"$keyvalue\">\n";
	print "</form>\n";
	ParseForm($footer);
}
elsif ($submit eq "AddAbility")
{
	#print $CGI->header();
	updateAbilities();

	local ($abid) = $CGI->param("abid");
	local($db) = dbconnect();
	$sql = "insert into occupationabilities ($keyfield, abid, minlevel) values ($keyvalue, $abid, 0);";
	#print "$sql<BR>";
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=addabilities&$keyfield=$keyvalue");
}
elsif ($submit eq "RemoveAbility")
{
	#print $CGI->header();
	updateAbilities();

	local ($ocabid) = $CGI->param("ocabid");
	local($db) = dbconnect();
	$sql = "delete from occupationabilities where ocabid=$ocabid;";
	#print "$sql<BR>";
	$db->do($sql);
	$db->disconnect;

	print $CGI->redirect("$thispage?action=addabilities&$keyfield=$keyvalue");
}
elsif ($action eq "updateabilities")
{
	#print $CGI->header();
	updateAbilities();
	
	print $CGI->redirect("$thispage?action=addabilities&$keyfield=$keyvalue");
}
elsif ($action eq "finishabilities")
{
	#print $CGI->header();
	updateAbilities();
	
	print $CGI->redirect("$thispage");
}
elsif ($action eq "editcharacters")
{
	print $CGI->header();
	ParseForm($header);
	fillvars();
	print "<h1>Add/Edit Characters for $oname</H1>\n";
	print "<a href=\"$thispage\">Done</a><BR><BR>\n";
	showChars();
	print "<BR><a href=\"$thispage\">Done</a>\n";
	ParseForm($footer);
}
elsif ($action eq "addchar")
{
	#print $CGI->header();
	local ($charid) = $CGI->param("charid");
	local($db) = dbconnect();
	$SQL = "insert into characteroccupations (charid, $keyfield) values ($charid, $keyvalue);";
	#print "$SQL<BR>\n";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=editcharacters&$keyfield=$keyvalue");
}
elsif ($action eq "delchar")
{
	#print $CGI->header();
	local ($charid) = $CGI->param("charid");
	local($db) = dbconnect();
	$SQL = "delete from characteroccupations where charid=$charid and $keyfield=$keyvalue;";
	#print "$SQL<BR>\n";
	$db->do($SQL);
	$db->disconnect;
	print $CGI->redirect("$thispage?action=editcharacters&$keyfield=$keyvalue");
}
elsif ($action eq "dump")
{
	print $CGI->header();
	ParseForm($header);
	print "<h1>Occupations Info Dump</h1>\n";
	local($db) = dbconnect();
	local ($sql) = "select * from $table order by req_status desc;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Occupation</b></td>\n";
	print "<td><b>Status Req</b></td>\n";
	print "<td><b>Min BGP Income</b></td>\n";
	print "<td><b>Avg BGP Income</b></td>\n";
	print "<td><b>Max BGP Income</b></td>\n";
	print "<td><b>Min BGA Income</b></td>\n";
	print "<td><b>Avg BGA Income</b></td>\n";
	print "<td><b>Max BGA Income</b></td>\n";
	print "<td><b>Skill Threshold</b></td>\n";
	print "<td><b>Min Skill Bonus</b></td>\n";
	print "<td><b>Avg Skill Bonus</b></td>\n";
	print "<td><b>Max Skill Bonus</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "<tr>\n";
	   print "<td>".$resptr->{"oname"}."</td>\n";
	   print "<td>".$resptr->{"req_status"}."</td>\n";
	   print "<td>".$resptr->{"base_income"}."</td>\n";
	   print "<td>".($resptr->{"base_income"} + ($resptr->{"d10_base_income"} * 5))."</td>\n";
	   print "<td>".($resptr->{"base_income"} + ($resptr->{"d10_base_income"} * 10))."</td>\n";
	   print "<td>".$resptr->{"base_bga_income"}."</td>\n";
	   print "<td>".($resptr->{"base_bga_income"} + ($resptr->{"d10_bga_income"} * 5))."</td>\n";
	   print "<td>".($resptr->{"base_bga_income"} + ($resptr->{"d10_bga_income"} * 10))."</td>\n";
	   print "<td>".$resptr->{"skill_bonus_threshold"}."</td>\n";
	   print "<td>".$resptr->{"base_skill_bonus"}."</td>\n";
	   print "<td>".($resptr->{"base_skill_bonus"} + ($resptr->{"d10_skill_bonus"} * 5))."</td>\n";
	   print "<td>".($resptr->{"base_skill_bonus"} + ($resptr->{"d10_skill_bonus"} * 10))."</td>\n";
	   print "</tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
	print "<br><a href=\"$thispage\">Return</a>."; 
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>Manage ".$heading."s</h1>\n";

	print "<a href=\"$thispage?action=new\">ADD a NEW $heading</a><BR><BR>\n";
	
	showoccupations();

	print "<BR><BR><a href=\"$thispage?action=dump\">Info Dump of Occupations</a><BR><BR>\n";
	
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showoccupations()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Occupation</b></td>\n";
	print "<td><b>Description</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "<tr>\n";
	   print "<td>".$resptr->{"oname"}."</td>\n";
	   print "<td>".$resptr->{"odesc"}."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield=".$resptr->{"$keyfield"}."\">Edit</a>\n";
	   print " -- <a href=\"javascript:deleteConfirm('".$resptr->{"$namefield"}."',".$resptr->{"$keyfield"}.");\">Delete</a>\n";
	   print " -- <a href=\"$thispage?action=editcharacters&$keyfield=".$resptr->{"$keyfield"}."\">Add Characters</a>\n";
	   print " -- <a href=\"$thispage?action=addabilities&$keyfield=".$resptr->{"$keyfield"}."\">Add Abilities</a>\n";
	   print " -- <a href=\"\" onClick=\"javascript:window.open('occpop.pl?$keyfield=".$resptr->{"$keyfield"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">Display</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	filltable();
}

sub getmyabilities()
{
	$totalcost = 0;
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select a.ocabid, b.name, a.minlevel, a.text, b.req_text, b.abid from occupationabilities a, abilities b where a.$keyfield=$keyvalue and a.abid=b.abid order by b.name, a.text;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Min Level</b></td>\n";
	$retstr .= "<td><b>Name</b></td>\n";
	$retstr .= "<td><b>Text</b></td>\n";
	$retstr .= "<td><b>Action</b></td>\n";
	$retstr .= "</tr>\n";
	local ($num) = 0;
	while ($resptr = $query->fetchrow_hashref())
	{
	   $retstr .= "<tr>\n";
	   $retstr .= "<td><input type=text name=minlevel_$num value=\"".$resptr->{"minlevel"}."\" maxsize=3 size=3>\n";
	   $retstr .= "<input type=hidden name=\"ocabid_$num\" value=\"".$resptr->{"ocabid"}."\"></td>\n";
	   $retstr .= "<td><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">".$resptr->{"name"}."</a></td>\n";
	   $retstr .= "<td><input type=text name=\"text_$num\" value=\"".$resptr->{"text"}."\" size=70></td>\n";
	   $retstr .= "<td><a href=\"javascript:createredirect('$thispage?ocabid=".$resptr->{"ocabid"}."&submit=RemoveAbility')\">Remove</a></td>";
	   $retstr .= "</tr>\n";
	   $num++;
	}
	$retstr .= "</table>\n";
	$retstr .= "<input type=hidden name=num_abs value=$num>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}

sub getabilitiesstr()
{
	local ($retstr) = "";
	local($db) = dbconnect();
	local ($sql) = "select * from abilities where allowed!='None' order by type, name;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	$retstr .= "<table border=1>\n";
	$retstr .= "<tr>\n";
	$retstr .= "<td><b>Name</b></td>\n";
	$retstr .= "<td><b>Type</b></td>\n";
	$retstr .= "<td><b>Action</b></td>\n";
	$retstr .= "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
		$retstr .= "<tr>\n";
		$retstr .= "<td>".$resptr->{"name"}."</td>\n";
		$retstr .= "<td>".$resptr->{"type"}."</td>\n";
		$retstr .= "<td><a href=\"href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">Display</a>\n";
		$retstr .= " -- <a href=\"javascript:createredirect('$thispage?abid=".$resptr->{"abid"}."&submit=AddAbility')\">Add</a>\n";
		$retstr .= "</tr>\n";
	}
	$retstr .= "</table>\n";
	$query->finish;
	$db->disconnect;
	return $retstr;
}

sub updateAbilities()
{
	#print $CGI->header;
	local ($numabs) = $CGI->param("num_abs") * 1;
	local($db) = dbconnect();
	for ($num = 0; $num < $numabs; $num++)
	{
	  local ($minlevel) = $CGI->param("minlevel_$num");
	  local ($ocabid) = $CGI->param("ocabid_$num");
	  local ($text) = $CGI->param("text_$num");
	  $text =~ s/'/''/g;
	  $sql = "update occupationabilities set minlevel=$minlevel, text='$text' where ocabid=$ocabid;";   
	  #print "$sql<BR><BR>";
	  $db->do($sql);
	}
	$db->disconnect;
}


sub showChars()
{
	local($db) = dbconnect();
	$SQL = "select charid from characters order by clast;";
	#print "$SQL<BR>";
	local($query) = $db->prepare($SQL);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Character Name</b></td>\n";
	print "<td><b>Has This Occupation</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	if ($query->rows > 0)
	{
	   local (@array);
	   while (@array = $query->fetchrow_array)
	   {
		   print "<tr>\n";
		   print "<td><a href=\"charquest.pl?mode=review&cqcharid=$array[0]\" target=_new>".getCharName($array[0])."</a> <i>(".getFullNameFromCharID($array[0]).")</i></td>\n";
		   if (isLinked($array[0]))
		   {
			print "<td><b>Yes</b></td>\n";
			print "<td><a href=\"$thispage?action=delchar&charid=$array[0]&$keyfield=$keyvalue\">Remove</a> -- \n";
		   }
		   else
		   {
			print "<td>No</td>\n";
			print "<td><a href=\"$thispage?action=addchar&charid=$array[0]&$keyfield=$keyvalue\">Add</a>\n";
		   }
	   	   print " -- <a href=\"\" onClick=\"javascript:window.open('occpop.pl?$keyfield=$keyvalue&charid=$array[0]','','width=450,height=550,left = 500,top = 100,scrollbars=1,resizable=1');\">Test</a>\n";
		   print "</tr>\n";
	   }
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}


sub isLinked()
{
  local($varID) = $_[0];
  local($db) = dbconnect();
  local ($SQL) = "select * from characteroccupations where charid=$varID and $keyfield=$keyvalue;";
  #print "$SQL<BR>";
  local($query) = $db->prepare($SQL);
  $query->execute;
  local ($retval) = $query->rows;
  $query->finish;
  $db->disconnect;
  return $retval;
}
