#!/usr/bin/perl

require 'stat_inc.pl';
require 'g_invest.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "printcomp.pl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to visit this page!"));
}
elsif ($CGI->param("xl") ne "")
{
	print $CGI->header(-type  =>  'application/vnd.ms-excel', -filename  =>  'spcomp.xls');
	#print $CGI->header;
				
	$db = dbconnect();
	local ($sql) = "select a.scname, a.scdesc, c.charid from spellcomponents a, spellcomponentslink b, spellcomponentscharacterlink c where a.scid = b.scid and b.sclid=c.sclid order by c.charid;";
	#print "$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	
	print "<table border=0>\n";
        print "<tr>\n";
        print "<td><b>Name</b></td>\n";
        print "<td><b>Desc</b></td>\n";
        print "<td><b>Char</b></td>\n";
        print "</tr>\n";
	while (@array = $query->fetchrow_array())
	{
	   print "<tr>\n";
	   print "<td>$array[0]</td>\n";
	   print "<td>$array[1]</td>\n";
	   print "<td>".getCharName($array[2])."</td>\n";
	   print "</tr>\n";
	}
	$query->finish;
	
	$sql = "select a.scname, a.scdesc from spellcomponents a order by a.scname;";
	$query = $db->prepare($sql);
	$query->execute;
	
	while (@array = $query->fetchrow_array())
	{
	   print "<tr>\n";
	   print "<td>$array[0]</td>\n";
	   print "<td>$array[1]</td>\n";
	   print "<td>None</td>\n";
	   print "</tr>\n";
	   print "<tr>\n";
	   print "<td>$array[0]</td>\n";
	   print "<td>$array[1]</td>\n";
	   print "<td>None</td>\n";
	   print "</tr>\n";
	}
	$query->finish;
	
	print "</table>\n";
	
	
	$db->disconnect;
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<h1>Print Spell Components</H1>\n";
	
	print "1.  Step One.  Download the Microsoft XL Document.<BR>\n";
	print "Save this document as spcomp.xls in your Brassy's folder:\n";
	print "<a href=\"$thispage?xl=1\" target=_new>Click me</a><BR><BR>\n";
		
	print "2.  Step Two.  Download the Microsoft Word Document.<BR>\n";
	print "Save this document as spcomp.doc in your Brassy's folder:\n";
	print "<a href=\"doclib/spcomp.doc\" target=_new>Click me</a><BR><BR>\n";
		
	print "3.  Step Three.  Open and print the Microsoft Word Document.<BR>\n";
	print "Open spcomp.doc in Microsoft Word.  Perform the mail merge. Then print.<BR><BR>\n";

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
exit 0;

