#!/usr/bin/perl

require 'gmnote_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#$CGI->setopt('timeout', 30);

#globals for this file
$thispage = "printgmnotes.pl";
$table = "character";
$keyvalue = $CGI->param($keyfield);
$tplfile = "x.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to visit this page!"));
}
else
{
	#print $CGI->header(-type  =>  'application/msword', -filename  =>  'gmnotes.doc');
	print $CGI->header;
				
	$db = dbconnect();
	$sql = "select ctypeid, ctypedesc from chartypes order by ctypedesc;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	while (@array = $query->fetchrow_array)
	{
	   	print "<H1>$array[1]</H1>\n";
	   	$sql = "select charid from characters where chartype = $array[0]";
		local ($query2) = $db->prepare($sql);
		$query2->execute;
		local (@array2);
		while (@array2 = $query2->fetchrow_array)
		{
		   	$charname = getCharName($array2[0]);
		   	print "<H2>$charname</H2>\n";
			showgmnotesummary($array2[0]);
		}
		$query2->finish;
	}
	$query->finish;
	$db->disconnect;
	print "####################################################################<BR>\n";
}
exit 0;

sub showgmnotesummary()
{
	local $charid = $_[0];

	$sql = "select a.summary, a.notes from gmnotes a join linknotes b on a.gmnid=b.gmnid where b.linktable='characters' and b.linkid=$charid order by a.entrydate;";
	local ($query3) = $db->prepare($sql);
	$query3->execute;
	print "<ul>\n";
	local (@array3);
	while (@array3 = $query3->fetchrow_array)
	{
		print "<li><b>$array3[0]</b>:  \n";
		print "$array3[1]</li>\n";
	}
	$query3->finish;
	
	if (0)
	{
		$sql = "select * from gmnotes a join linknotes b on a.gmnid=b.gmnid where b.linktable='charactergroups' order by a.entrydate;";
		#print "$sql<BR>\n";  
		$query3 = $db->prepare($sql);
		$query3->execute;
		local($resptr);
		while ($resptr = $query3->fetchrow_hashref())
		{
		   local($groupid) = $resptr->{"linkid"};
		   $sql = "select count(charid) from charactergroupmembers where groupid=$groupid and charid=$charid;";
		   #print "$sql<BR>\n"; 
		   local($ismember) = dosql($sql) + 0;
		   $sql = "select count(linkid) from linknotes where gmnid=".$resptr->{"gmnid"}." and linktable='characters' and linkid=$charid;";
		   #print "$sql<BR>\n"; 
		   local($includechar) = dosql($sql) + 0;
		   if ($ismember > 0 && $includechar == 0)
		   {
			local($summary) = $resptr->{"summary"};
			local($notes) = $resptr->{"notes"};
			print "<li><i><b>$summary</b>:  \n";
			print "$notes</i></li>\n";
		   }
		}
		$query3->finish;
	}
	print "</ul>\n";

}