#!/usr/bin/perl

require 'stat_inc.pl';
require 'g_invest.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "printvl.pl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to visit this page!"));
}
elsif ($CGI->param("xl") ne "")
{
	print $CGI->header(-type  =>  'application/vnd.ms-excel', -filename  =>  'vls.xls');
	#print $CGI->header;
				
	$db = dbconnect();
	
	print "<table border=0>\n";
        print "<tr>\n";
        print "<td><b>Name</b></td>\n";
        print "<td><b>Desc</b></td>\n";
        print "<td><b>Char</b></td>\n";
        print "<td><b>Player</b></td>\n";
        print "<td><b>Fancy</b></td>\n";
        print "<td><b>Secure</b></td>\n";
        print "<td><b>Location</b></td>\n";
        print "<td><b>Inventory</b></td>\n";
        $maxsecret = dosql("select count(vlsid) from VLstats;");
 	local ($sql) = "select vlsid, vlsname from VLstats order by vlsid;";
	#print "$sql<BR>";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	local (@vlsid);
	$i = 0;
	while (@array = $query->fetchrow_array())
	{
        	print "<td><b>$array[1]</b></td>\n";	
        	$vlsid[$i] = $array[0];
        	$i++;
	}
	$query->finish;
        print "<td><b>Access</b></td>\n";
        print "</tr>\n";
        
	$sql = "select * from virtuallocations a, characters b where a.vlowner=b.charid and b.chartype <= $cast_character order by a.vlowner;";
	#print "$sql<BR>";
	$query = $db->prepare($sql);
	$query->execute;	
	while ($resptr = $query->fetchrow_hashref())
	{
	   $vlid = $resptr->{"vlid"};
	   print "<tr>\n";
	   print "<td>".$resptr->{"vlname"}."</td>\n";
	   print "<td>".$resptr->{"vldesc"}."</td>\n";
	   print "<td>".getCharName($resptr->{"vlowner"})."</td>\n";
	   print "<td>".getFullNameFromCharID($resptr->{"vlowner"})."</td>\n";
	   $val = getVLtotal($vlid,"vl_fancy", "vla_fancy");
	   print "<td>$val</td>\n";
	   $val = getVLtotal($vlid,"vl_secure", "vla_secure");
	   print "<td>$val</td>\n";
   	   $val = getVLtotal($vlid,"vl_location", "vla_location");
	   print "<td>$val</td>\n";
	   $val = getVLtotal($vlid,"vl_inventory", "vla_inventory");
	   print "<td>$val</td>\n";
	   for ($i = 0; $i < $maxsecret; $i++)
	   {
	     $val = dosql("select sum(vlslevel) from VLstatlink where vlid=$vlid and vlsid=$vlsid[$i];");
	     print "<td>$val</td>\n";
	   }
	   print "<td>";
	   $sql = "select charid from VLaccess where vlid=$vlid;";
	   $query2 = $db->prepare($sql);
	   $query2->execute;
	   local (@array);
	   while (@array = $query2->fetchrow_array())
	   {
	   	print getCharName($array[0]);
	   	print " (".getFullNameFromCharID($array[0])."), ";
	   }
	   print "</td>\n";
	   $query2->finish;
	   print "</tr>\n";
	}
	$query->finish;
		
	print "</table>\n";
	
	
	$db->disconnect;
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<h1>Print Virtual Locations</H1>\n";
	
	print "1.  Step One.  Download the Microsoft XL Document.<BR>\n";
	print "Save this document as vls.xls in your Brassy's folder:\n";
	print "<a href=\"$thispage?xl=1\" target=_new>Click me</a><BR><BR>\n";
		
	print "2.  Step Two.  Download the Microsoft Word Document.<BR>\n";
	print "Save this document as vls.doc in your Brassy's folder:\n";
	print "<a href=\"doclib/vls.doc\" target=_new>Click me</a><BR><BR>\n";
		
	print "3.  Step Three.  Open and print the Microsoft Word Document.<BR>\n";
	print "Open vls.doc in Microsoft Word.  Perform the mail merge. Then print.<BR><BR>\n";

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}
exit 0;

