#!/usr/bin/perl

require 'stat_inc.pl';
require 'g_invest.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "restok.pl";
$table = "character";
$heading = "x";
$keyfield = "x";
$keyvalue = $CGI->param($keyfield);
$namefield = "x";
$tplfile = "x.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to visit this page!"));
}
else
{
	print $CGI->header(-type  =>  'application/vnd.ms-excel', -filename  =>  'tokens.xls');
				
	$db = dbconnect();
	local ($sql) = "select c.pccharid from players a, eventplayers b, playercharacters c, characters d where a.playerid=b.playerid and b.eventid=$current_episode and b.reglevel > $not_attending and c.pcplayerid=a.playerid and c.pccharid > 0 and c.pccharid=d.charid and d.chartype <= $cast_character order by a.plast;";
	local ($query) = $db->prepare($sql);
	$query->execute;
	local (@array);
	
	print "<table border=0>\n";
        print "<tr>\n";
        print "<td>CharName</td>\n";
        print "<td>PlayerName</td>\n";
        print "</tr>\n";
	while (@array = $query->fetchrow_array())
	{
	   $charid = $array[0];
	   $count = getnumresourcetokens($charid);
	   for ($i = 0; $i < $count; $i++)
	   {
		   print "<tr>\n";
		   print "<td>".getCharName($charid)."</td>\n";
		   print "<td>".getFullNameFromCharID($charid)."</td>\n";
		   print "</tr>\n";
	   }
	}
	print "</table>\n";
	
	$query->finish;
	
	$db->disconnect;
}
exit 0;

sub getnumresourcetokens()
{
   local($varID) = $_[0];
   local($db) = dbconnect();
   local ($sql) = "select status from characterSTATs where charid=$varID;";
   #print $sql;
   local($retval) = "0";
   local($query) =$db->prepare($sql);
   $query->execute;
   local (@array);
   @array = $query->fetchrow_array;
   $retval = $array[0];
   $query->finish;
   
   $retval += getlevel("GENUINE CURIOUSITY/FAMOUS");
   $retval -= getlevel("SOCIAL STIGMA ______________");
   
   $sql = "select c.level, a.level from characterresourcetypelink a, resourcetypes b, characterabilities c where a.charid=$varID and a.typeid=b.typeid and b.type='Votes' and c.caid=a.abid;";
   #print "$sql<BR>\n";
   $query =$db->prepare($sql);
   $query->execute;
   while (@array = $query->fetchrow_array)
   {
      if ($array[1] == 1) #low
      {
        $retval += int($array[0] / 2);
      }
      if ($array[1] == 2) #average
      {
        $retval += $array[0];
      }
      if ($array[1] == 3) #high
      {
        $retval += $array[0] * 2;
      }
      if ($array[1] == 4) #super
      {
        $retval += $array[0] * 3;
      }
   }
   
  
   $sql = "select c.level, a.level from keyrolerresourcetypelink a, resourcetypes b, keyroleabilities c, keyrolecharacters d where a.typeid=b.typeid and b.type='Votes' and c.kraid=a.abid and a.krid=d.krid and d.charid=$varID;";
   #print "$sql<BR>\n";
   $query =$db->prepare($sql);
   $query->execute;
   while (@array = $query->fetchrow_array)
   {
      if ($array[1] == 1) #low
      {
        $retval += int($array[0] / 2);
      }
      if ($array[1] == 2) #average
      {
        $retval += $array[0];
      }
      if ($array[1] == 3) #high
      {
        $retval += $array[0] * 2;
      }
      if ($array[1] == 4) #super
      {
        $retval += $array[0] * 3;
      }
   }

   $query->finish;
   $db->disconnect;
   return int($retval/3);
}
