#!/usr/bin/perl

require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "showplayer.pl";
$table = "charinfo";
$keyfield = "charid";
$keyvalue = $CGI->param($keyfield);
$namevalue = getCharName($keyvalue);
$errstr = $CGI->param("error");

print $CGI->header;

$doctitle = "$namevalue";
$bgpicture = "";

fillvars();
ParseForm("$header");
ParseForm($templatefile);
ParseForm($footer);

exit 0;

sub fillvars()
{
	filltable();
	
	$charname = $namevalue;
	$initial = substr($charname, 0, 1);
	$charname =~ s/$initial//;
	
	$info =~s/\n/<BR>\n/g;
	
	$headerblock = "";
	if ($showplayer eq "CHECKED")
	{
	  $headerblock .= "Player: " . getFullNameFromID(getPIDFromCharID($charid));
	  $headerblock .= "<BR>\n";
	}
	if ($showstatus eq "CHECKED")
	{
	  $headerblock .= "Status: ";
	  $status = dosql("select status from characterSTATs where charid=$charid") + 0;
	  $headerblock .= "$status, $statusText[$status]";
	  $headerblock .= "<BR>\n";
	}
	if ($showbirthday eq "CHECKED")
	{
	  $headerblock .= "Birthday: ";
	  $headerblock .= myFormatDate(dosql("select cqchardob from charquestionnaires where cqcharid=$charid"));
	  $headerblock .= "<BR>\n";
	}
	if ($shownationality eq "CHECKED")
	{
	  $headerblock .= "Nationality: ";
	  $headerblock .= dosql("select cqcharnationality from charquestionnaires where cqcharid=$charid");
	  $headerblock .= "<BR>\n";
	}
	if ($showmaritalstatus eq "CHECKED")
	{
	  $married .= dosql("select cqmarried from charquestionnaires where cqcharid=$charid") + 0;
	  $marstat[0] = "Single";
	  $marstat[1] = "Married";
	  $headerblock .= "Martial Status: $marstat[$married]";
	  $headerblock .= "<BR>\n";
	}
	if ($showspousename eq "CHECKED")
	{
	  $headerblock .= "Spouse: ";
	  $headerblock .= dosql("select cqspouse from charquestionnaires where cqcharid=$charid");
	  $headerblock .= "<BR>\n";
	}
	if ($showaddress eq "CHECKED")
	{
	  $headerblock .= "Address: ";
	  $headerblock .= dosql("select cqcharaddress from charquestionnaires where cqcharid=$charid");
	  $headerblock .= "<BR>\n";
	}
	if ($showreligion eq "CHECKED")
	{
	  $headerblock .= "Religion: ";
	  $headerblock .= dosql("select cqrelcurrent from charquestionnaires where cqcharid=$charid");
	  $headerblock .= "<BR>\n";
	}
	if ($showoccupation eq "CHECKED")
	{
	  $headerblock .= "Occupation: ";
	  $headerblock .= dosql("select a.oname from occupations a join characteroccupations b on a.oid=b.oid where b.charid=$charid");
	  $headerblock .= "<BR>\n";
	}
	if ($showkeyroles eq "CHECKED")
	{
	  $headerblock .= "Key Roles: ";
	  $headerblock .= dosql("select a.krname from keyroles a join keyrolecharacters b on a.krid=b.krid where b.charid=$charid");
	  $headerblock .= "<BR>\n";
	}
	$picurl = "";

	if ($showpic eq "CHECKED")
	{
	  $picurl = "<img src=\"";
	  $picurl .= dosql("select cpiclink from characters where charid=$charid;");
	  $picurl .= "\" align=right style=\"border: medium solid black;\">\n";

	}
	
	$table = "templates";
	$keyfield = "tid";
	$keyvalue = $template;
	filltable();
}

