#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "showquest.pl";
$table = "players";
$heading = "Player Info";
$keyfield = "playerid";
$keyvalue = $CGI->param($keyfield);
#$tplfile = "status.tpl";

if ($al < $writer_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to review player questionaires."));
}
else
{
	print $CGI->header(-type  =>  'application/vnd.ms-excel', -filename  =>  'playerquest.xls');
	showPlayers();
}

exit 0;

sub showPlayers()
{
	local($db) = dbconnect();
	print "<table border = 1><BR>\n";
	local($tab) = $db->prepare("explain playerquestionnaires");
	$tab->execute;
	local (@arrtemp);
	local (@headers);
	local($i) = 0;
	while (@arrtemp = $tab->fetchrow_array)
	{
	  $headers[$i] = $arrtemp[0];
	  $i++;
	}
	print "<tr>\n";
	print "<td><b>Last Name</b></td>\n";
	print "<td><b>First Name</b></td>\n";
	foreach $term (@headers) 
	{
	   print "<td><b>$term</b></td>\n";
	}
	print "</tr>\n";
	$numFields = $i;
	$tab->finish;
	local ($sql) = "select * from playerquestionnaires a join players b on a.pqplayerid=b.playerid;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "<tr>\n";
	   print "<td>".$resptr->{"plast"}."</td>\n";
	   print "<td>".$resptr->{"pfirst"}."</td>\n";
	   foreach $term (@headers) 
	   {
	       print "<td>".$resptr->{"$term"}."</td>\n";
	   }
	   print "</tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}
