#!/usr/bin/perl

# Require and Use
# * These statements alert perl.exe that
# * you are going to be using functions, 
# * subroutines, and methods from other
# * perl programs. "require" is used for a
# * perl library, and the "use" statement 
# * is usually used to reference a perl
# * object (usually referred to as a 
# * module).
require 'common.pl';
use DBI;
use CGI;
use CGI::Cookie;

$CGI = new CGI;
$pid = getPlayerID();

#globals for this file
$thispage = "signup.pl";
$table = "eventplayers";
$heading = "your Registration";
$keyfield = "eventid";
$keyvalue = $CGI->param($keyfield);
$namefield = "eventname";
$tplfile = "signup.tpl";

if ($pid == 0 or $CGI->param("submit") eq "Create" or $CGI->param("submit") eq "Update" or $CGI->param("submit") eq "View")
{
	print $CGI->header();
	ParseForm($header);
	fillvars();
	
	$reglevel = dosql("select reglevel from eventplayers where eventid=$eventid and playerid=$pid");
	
	if ($pid == 0)
	{
		print "<H1>$campaign Event View</H1>\n";
	}
	elsif ($reglevel < $registered)
	{
		print "<H1>$campaign Event Registration</H1>\n";
	}
	elsif ($reglevel == $registered)
	{
		print "<H1>$campaign Event Payment/Comfirmation</H1>\n";
	}
	else
	{
		print "<H1>$campaign Event View</H1>\n";
	}
	
	print "<table width=100% border=0>\n";
	
	print "<tr><td valign=top width=50%>\n";
	
	print "<H1>$eventname</H1>\n";
	
	print "<p>$startstring - $endstring</p>\n";
	
	print "<H2>Location - $vname</H2>\n";
	
	print "<p>$vaddress1<BR>\n";
	print "$vcity, $vstate  $vzip </p>\n";
	
	if ("$vroomrates" ne "")
	{
		print "<p>Rooms: $vroomrates</p>\n";
	}
	
	if ("$vfrontdeskphone" ne "")
	{
		print "<p>Reservations: $vfrontdeskphone</p>\n";
	}
	
	if ("$vweb" ne "")
	{
		print "<p><a href=\"$vweb\" target=_new>Click here for website</a> (pops)</p>\n";
	}
	
	if ("$vdirections" ne "")
	{
		print "<p>Directions: $vdirections</p>\n";
	}
		
	if ("$showchildpolicy" eq $ischecked[1])
	{
		print "<p><a href=\"\" onClick='javascript:window.open(\"child.html\",\"\",\"width=600,height=700,left = 50,top = 50,scrollbars = 1\")'>$campaign Childrens' Policy</a> (pops)</p>\n";
	}
	
	if ($pid > 0)
	{
		print "</td><td valign=top style=\"border: thin solid Black; padding-left: 7px; padding-right: 7px; \">\n";

		if ($reglevel < $registered)
		{
			print "<form action=\"$thispage\" method=\"post\">";
			print "<H2>How to Register</H2>\n";

			print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
			print "<input type=\"hidden\" name=\"eventname\" value=\"$eventname\">\n";
			
			print "<p>You are currently <i>$player_registration[$reglevel]</i> for this event.</p>\n";
			
			if ($eventcost == 0)
			{
				print "<p>Cost: Free</p>\n";
				$sql = "select * from eventsreglevelslink a join eventreglevels b on a.erlid = b.erlid where a.eventid=$keyvalue";
				local($db) = dbconnect();
				local($query) = $db->prepare($sql);
				$query->execute;
				while ($resptr = $query->fetchrow_hashref())
				{
					print "<input type=\"submit\" name=\"submit\" value=\"".$resptr->{"name"}."\"> &nbsp; &nbsp; &nbsp;";
				}
				$query->finish;
				$db->disconnect;
				print "<input type=\"hidden\" name=\"action\" value=\"regme\">\n";
			}
			else
			{
				print "<p>Cost: $eventcost</p>\n";
				print "<input type=\"submit\" name=\"submit\" value=\"Sign Me Up\"> &nbsp; &nbsp; &nbsp;";
			}

			print "<input type=\"submit\" name=\"submit\" value=\"I Cannot Attend\"><BR>";
			print "</form>\n";
		}
		elsif ($reglevel < $registeredpaid)
		{
		   print "<h2>Pay for the Game</h2>\n";

		   print "<p>You are currently <i>$player_registration[$reglevel]</i> for this event.</p>\n";

		   print "<table border=1 cellspacing=0 cellpadding=1><tr>\n";

		   $sql = "select * from eventsreglevelslink a join eventreglevels b on a.erlid = b.erlid where a.eventid=$keyvalue";
		   local($db) = dbconnect();
		   local($query) = $db->prepare($sql);
		   $query->execute;
		   while ($resptr = $query->fetchrow_hashref())
		   {		
			print "<td align=center>\n";
			print "<form action=\"https://www.paypal.com/cgi-bin/webscr\" method=\"post\">\n";
			print "<input type=hidden name=\"cmd\" value=\"_xclick\">\n";
			print "<input type=hidden name=\"business\" value=\"$paypalemail\">\n";
			$myname = $resptr->{"name"};
			$realcost = $resptr->{"realcost"};
			$realcost = ($realcost*1.03)+0.5;
			$realcost = int($realcost*100)/100;
			$description = $resptr->{"description"};
			print "<input type=hidden name=\"amount\" value=\"$realcost\">\n";
			print "<input type=hidden name=\"no_shipping\" value=\"1\">\n";
			print "<input type=hidden name=\"item_name\" value=\"$campaign Registration: $eventname -- $myname\">\n";
			print "<input type=hidden name=\"item_number\" value=\"brct2\">\n";
			print "<input type=hidden name=\"cn\" value=\"Notes\">\n";
			print "<input type=hidden name=\"currency_code\" value=\"USD\">\n";
			print "<input type=hidden name=\"lc\" value=\"US\">\n";
			print "<input type=hidden name=\"return\" value=\"$siteURL/$thispage?submit=Pay&$keyfield=$keyvalue\">\n";
			print "<input type=hidden name=\"cancel_return\" value=\"$siteURL/$thispage\">\n";
			print "<input type=image src=\"".$resptr->{"picloc"}."\" border=0 name=submit alt=\"$description\"><BR>\n";
			print "$myname: &#36;$realcost<BR>\n";
			print "<i><font size=smaller>$description</font></i><BR>\n";
			print "</form>";
			print "</td>\n";
		   }
		   $query->finish;
		   $db->disconnect;

		   print "</tr></table>\n";

		   print "<p><i>Your payment includes an additional service charge from PayPal.</i></p>";
		}
		elsif ($reglevel >= $registeredpaid)
		{
			print "<form action=\"$thispage\" method=\"post\">";
			print "<H2>Change your Registration</H2>\n";

			print "<p>You are currently <i>$player_registration[$reglevel]</i> for this event.</p>\n";

			print "<p>Cost: $eventcost</p>\n";

			print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
			print "<input type=\"hidden\" name=\"eventname\" value=\"$eventname\">\n";

			print "<input type=\"submit\" name=\"submit\" value=\"I Cannot Attend\"><BR>";
			print "</form>\n";
		}
	}

	
	print "</td></tr></table>\n";
	
	print "<H2>Information</H2>\n";
	
	print "<p>$eventtext</p>\n";
	
	if ($pid == 0)
	{
		print "<br><hr><a href=\"login.pl\">Log In</a>.";
	}
	else
	{
		print "<br><hr><a href=\"main.pl\">Main Menu</a>.";
	}
	ParseForm($footer);
}
elsif (($CGI->param("submit") eq "Sign Me Up"))
{
	#delete first
	local($db) = dbconnect();
	local($sql) = "delete from eventplayers where $keyfield=$keyvalue and playerid=$pid";
	$db->do($sql);
	# Insert and Redirect
	$sql = "INSERT into eventplayers (eventid, playerid, reglevel) values ($keyvalue, $pid, $registered)";
	$db->do($sql);
	$db->disconnect;
	$eventname = $CGI->param("eventname");
	print $CGI->redirect("$thispage?submit=Update&eventid=$keyvalue&error=" . encodeURL("You have been registered for $eventname."));
}
elsif ($CGI->param("action") eq "regme")
{
	$redirstr = "You have registered, but due to a database error it was not recorded.  The GM has been alerted and you will be confirmed ASAP.";
	$eventname = "Unknown";
	
	#delete first
	local($sql) = "delete from eventplayers where eventid=$keyvalue and playerid=$pid";
	dosql($sql);
	# Insert and Redirect
	$sql = "INSERT into eventplayers (eventid, playerid, reglevel) values ($keyvalue, $pid, $registeredpaid)";
	dosql($sql);
	$eventname = dosql(" select eventname from events where eventid=$keyvalue;");
	$redirstr = "You are registered for $eventname.";
	
	$fullname = getFullNameFromID($pid);
	$email = getEmailFromID($pid);
	$date = getDate();

	open(MAIL, "| /usr/sbin/sendmail -oi -t") or print "couldn't send mail: $!<BR>";
	print MAIL "From: $contact\n";
	print MAIL "To: $gmlist\n";
	print MAIL "Cc: $email\n";
	print MAIL "Subject: $fullname is registered for $campaign\n";
	print MAIL "\n";
	print MAIL "$fullname has paid for the $campaign Event: $eventname.\n";
	print MAIL "Congratulations.\n";
	print MAIL "Today's date: $date\n";
	print MAIL "---------------------------------------------------------------------------\n";
	close(MAIL);
	
	print $CGI->redirect("$thispage?error=" . encodeURL($redirstr));
}
elsif ($CGI->param("merchant_return_link") eq "Return to Merchant")
{
	$count = dosql("select count(epid) from eventplayers where playerid=$pid and reglevel=$registered;") + 0;
	$redirstr = "You have paid, but due to a database error your payment was not recorded.  The GM has been alerted and you will be confirmed ASAP.";
	$eventname = "Unknown";
	
	if ($count == 1) #only one event
	{
		$eventid = dosql("select eventid from eventplayers where playerid=$pid and reglevel=$registered;") + 0;
		#delete first
		local($sql) = "delete from eventplayers where eventid=$eventid and playerid=$pid";
		dosql($sql);
		# Insert and Redirect
		$sql = "INSERT into eventplayers (eventid, playerid, reglevel) values ($eventid, $pid, $registeredpaid)";
		dosql($sql);
		$eventname = dosql(" select eventname from events where eventid=$eventid;");
		$redirstr = "You have paid for $eventname.";
	}
	
	$fullname = getFullNameFromID($pid);
	$email = getEmailFromID($pid);
	$date = getDate();

	open(MAIL, "| /usr/sbin/sendmail -oi -t") or print "couldn't send mail: $!<BR>";
	print MAIL "From: $contact\n";
	print MAIL "To: $gmlist\n";
	print MAIL "Cc: $email\n";
	print MAIL "Subject: $fullname has paid for $campaign\n";
	print MAIL "\n";
	print MAIL "$fullname has paid for the $campaign Event: $eventname.\n";
	if ($balance > 0)
	{
	print MAIL "\n";
	print MAIL "You still owe a balance of: \$$balance.\n";
	print MAIL "Balance due by three months before the start of the event.\n";
	print MAIL "\n";
	}
	print MAIL "Congratulations.\n";
	print MAIL "Today's date: $date\n";
	print MAIL "---------------------------------------------------------------------------\n";
	close(MAIL);
	
	print $CGI->redirect("$thispage?error=" . encodeURL($redirstr));
}
elsif (($CGI->param("submit") eq "I Cannot Attend"))
{
	#delete first
	local($db) = dbconnect();
	local($sql) = "delete from eventplayers where $keyfield=$keyvalue and playerid=$pid";
	$db->do($sql);
	# Insert and Redirect
	$sql = "INSERT into eventplayers (eventid, playerid, reglevel) values ($keyvalue, $pid, $not_attending)";
	$db->do($sql);
	$db->disconnect;
	$eventname = $CGI->param("eventname");
	print $CGI->redirect("$thispage?error=" . encodeURL("You have set that you cannot attend $eventname."));
}
else
{
	print $CGI->header();
	ParseForm($header);
	if ($CGI->param("error") ne "")
	{
	    print "<font color=\"red\">" . $CGI->param("error") . "</font><br>\n";
	}
	print "\n<H1>Edit $heading</H1>";
	$db = dbconnect();
	local($query) = $db->prepare("select * from events where eventregavailable > 0;");
	$query->execute;
	print "<table cellspacing=0 style=\"border: thin solid Black;\">\n";
	print "<tr>\n";
	print "<td style=\"border: thin solid Black;\"><b>Event Name</b></td>\n";
	print "<td style=\"border: thin solid Black;\"><b>Dates</b></td>\n";
	print "<td style=\"border: thin solid Black;\"><b>You are...</b></td>\n";
	print "<td style=\"border: thin solid Black;\"><b>Balance</b></td>\n";
	print "</tr>\n";
	local ($resptr);
	   while ($resptr = $query->fetchrow_hashref())
	   {
	      print "<tr>";
	      print "<td style=\"border-right: thin solid Black;\">" .$resptr->{"eventname"}. "</td>";
	      print "<td style=\"border-right: thin solid Black;\">".myFormatDate($resptr->{"eventstart"})." - ".myFormatDate($resptr->{"eventend"})."</td>\n";
	      local $sql = "select a.balance, a.reglevel from eventplayers a where a.playerid=$pid and a.eventid=".$resptr->{"eventid"};
	      local($query2) = $db->prepare($sql);
	      $query2->execute;
	      if ($query2->rows == 0)
	      {
		print "<td style=\"border-right: thin solid Black;\">Not Registered. -- ";
		print "<a href=\"$thispage?submit=Create&eventid=".$resptr->{"eventid"}."\">Register Now</a>";
		print "</td>";
		print "<td>N/A</td>\n";
	      }
	      else
	      {
		@array = $query2->fetchrow_array;
		print "<td style=\"border-right: thin solid Black;\">$player_registration[$array[1]]. -- ";
		print "<a href=\"$thispage?submit=Update&eventid=".$resptr->{"eventid"}."\">Modify</a>";
		print " -- <a href=\"$thispage?submit=View&eventid=".$resptr->{"eventid"}."\">View</a>";
		print "</td>";
		$balance = $array[0];
		if ($array[1] < 3)
		{
		   print "<td>Unpaid</td>\n";
		}
	        elsif ($balance > 0)
	        {
		   print "<td>You owe: \$$balance</td>\n";
	        }
	        else
	        {
		   print "<td>Paid in Full</td>\n";
	        }
	      }
	      $query2->finish;
              print "</tr>\n";
              print "<tr><td>\n";
              print "<h3>Service Credits</h3>\n";
              print "</td></tr>\n";
             showServiceCredits($resptr->{"eventid"});
           }
	print "</table>\n";
	$query->finish;
	$db->disconnect;
	print "<br><hr><a href=\"main.pl\">Main Menu</a>.";
	ParseForm($footer);
}

sub showServiceCredits()
{
	local($eventid) = $_[0];
	local($sql) = "select * from playerSC where playerid=$pid and eventid=$eventid order by entrydate;";
	local($query) = $db->prepare($sql);
	$query->execute;
	local ($resptr);
	local ($sum) = 0;
	while ($resptr = $query->fetchrow_hashref())
	{
              if ($resptr->{"scid"} == 0)
              {
              	$name = $resptr->{"notes"};
              	$value = $resptr->{"value"};
              }
              else
              {
               	$name = dosql("select name from service_credits where scid = ".$resptr->{"scid"}.";");
               	$value = dosql("select value from service_credits where scid = ".$resptr->{"scid"}.";");
              }
              print "<tr>\n";
	      print "<td>$name</td>\n";
	      print "<td>\$$value.00</td>\n";
              print "</tr>\n";
	      $sum += $value;
	}
	$query->finish;	
        print "<tr>\n";
	print "<td style=\"border-bottom: thin solid Black;\"><i>Total:</i></td>\n";
	print "<td style=\"border-bottom: thin solid Black;\"><i>\$$sum.00</i></td>\n";
	print "<td style=\"border-bottom: thin solid Black; align: right;\"><i>Balance After Service Credits: </i></td>\n";
	$balance -= $sum;
	if ($balance > 0)
	{
		print "<td style=\"border-bottom: thin solid Black;\"><i>\$$balance.00</i></td>\n";
	}
	else
	{
		print "<td style=\"border-bottom: thin solid Black;\"><i>Paid In Full</i></td>\n";
	}	
        print "</tr>\n";
}

sub fillvars()
{

	addfields("events","eventid",$keyvalue);
	addfields("venues","venueid",$venueid);

	$startstring = myFormatDate($eventstart);
	$endstring = myFormatDate($eventend);

}

sub addfields()
{
	local($mytab) = $_[0];
	local($mykey) = $_[1];
	local($myval) = $_[2];

	local($db) = dbconnect();
	local($tab) = $db->prepare("explain $mytab");
	$tab->execute;
	$i = 0;
	while (@arrtemp = $tab->fetchrow_array)
	{
	  $arr[$i] = $arrtemp[0];
	  $arrTypes[$i] = $arrtemp[1];
	#print "$arr[$i] - $arrTypes[$i]<br>\n";
	  $i++;
	}
	$numFields = $i;
	$tab->finish;
	$sql = "select * from $mytab where $mykey = $myval";
	#print "$sql<BR>";
	local($query) = $db->prepare($sql);
	$query->execute;
	@cqquery = $query->fetchrow_array;
	for ($k=0;$k<$tab->rows;$k++)
	{
	$cqquery[$k] =~ s/'/\\'/g;
	$cqquery[$k] =~ s/"/\"/g;
	#print "\$$arr[$k] = $cqquery[$k]<br>\n";
	    if ($arrTypes[$k] eq 'tinyint(1)')
	    {
		if ($cqquery[$k] > 0)
		{
		    eval("\$$arr[$k] = 'CHECKED'");
		}
		else
		{
		    eval("\$$arr[$k] = ''");
		}
	    }
	    else
	    {
		eval("\$$arr[$k] = '$cqquery[$k]'");
	    }
	}
	$query->finish;
	$db->disconnect;

}