#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

# *************
# * dbconnect *
# *************
# * dbconnect returns a database connection
# * to the vialarp_signals database
sub dbconnectSuper()
{
	if ("$superuser" eq "" || "$superpass" eq "")
	{
	   return dbconnect();
	}

	local($db) = DBI->connect("$whichDBI:$database:$hostname", $superuser, $superpass, {
	      PrintError => 1,   ### Do report errors via warn(  )
	      RaiseError => 0    ### Don't report errors via die(  )
	});
	return $db;
}




$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "sql.pl";
$tplfile = "sql.tpl";
$mysql = $CGI->param("mysql");
$results = "";

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to do direct sql."));
}

print $CGI->header;
ParseForm($header);
print "<H1>Enter Direct SQL</h1>\n";

print "<form action=\"$thispage?\" method=\"post\">";
print "<textarea name=mysql COLS=80 ROWS=10>$mysql</textarea>";
print "<input type=\"submit\" name=\"submit\" value=\"Enter\"><BR>";
print "</form>\n";

if ($submit ne "")
{
   $db = dbconnectSuper();
   $query = $db->prepare($mysql);
   $query->execute;

   print "<H2>Results</H2>\n";
   
   if ($query->err eq "")
   {
     print "Query Returned: " . $query->rows . " rows<BR>\n";
     @row = $query->fetchrow_array();
     $size = @row;
     print "Query Returned: " . $size . " columns<BR>\n";
     print "<table border=1 width=100%>\n";
     print "<tr>\n";
     for ($k=0;$k<$size;$k++)
     {
     	print "<td>$row[$k]</td>\n";
     }
     print "</tr>\n";
     while ( @row = $query->fetchrow_array() ) 
     {
        print "<tr>\n";
        for ($k=0;$k<$size;$k++)
        {
     	     print "<td>$row[$k]</td>\n";
        }
        print "</tr>\n";
     }
     print "</table>\n";
   }
   else
   {
     print "Query Returned: " . $query->err . " - " . $query->errstr . "<BR>\n";
   }
	
   $query->finish;
   $db->disconnect;
}



print "<br><hr><a href=\"login.pl\">Main menu</a>."; 

ParseForm($footer);


exit 0;

