#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "timelineforplayers.pl";
$table = "timeline";
$heading = "Timeline Entry";
$keyfield = "tid";
$keyvalue = $CGI->param($keyfield);
$namefield = "text";
$tplfile = "timeline.tpl";
$errstr = $CGI->param("error");

local (@months);
$months[0] = "Unknown";
$months[1] = "January";
$months[2] = "February";
$months[3] = "March";
$months[4] = "April";
$months[5] = "May";
$months[6] = "June";
$months[7] = "July";
$months[8] = "August";
$months[9] = "September";
$months[10] = "October";
$months[11] = "November";
$months[12] = "December";


if ($action eq "new")
{
	print $CGI->header();
	ParseForm($header);
	print "<H1>Add $heading</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">";
	if ($tplfile eq "")
	{
		local($dbvar) = dbconnect();
		local($query) = $dbvar->prepare("explain $table");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $dbvar->prepare("select * from $table where $keyfield = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on" or $arrVals[$i] eq "1")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked value=\"1\">";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$dbvar->disconnect;
		print "</table>";
	}
	else
	{
	     fillvars();
	     ParseForm($tplfile);
	}
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Send an e-mail
	@names = $CGI->param;
	$SQL = "INSERT into $table (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		$SQL .= "$i, ";
	    }

	}
	chop $SQL;
	chop $SQL;
	$SQL .= ") values (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit"))
	    {
		local($myCGI) = $CGI->param($i);
		$myCGI =~ s/'/''/g;
		$SQL .= "'" . $myCGI . "', ";
	    }
	 }
	chop $SQL;
	chop $SQL;
	$SQL .= ");";
	#print "$SQL<BR>";
	
	$email = getEmailFromID($pid);
	$fullname = getFullNameFromID($pid);
	open(MAIL, "| /usr/sbin/sendmail  -oi -t") or die "couldn't send mail: $!";
	print MAIL "From: $contact\n";
	print MAIL "To: $contact\n";
	print MAIL "Cc: $email\n";
	print MAIL "Subject: Timeline addition from $fullname\n";
	print MAIL "\n";
	print MAIL "$fullname has submitted the following timeline event:\n\n";
	print MAIL "\n";
	print MAIL $CGI->param("month") . " " . $CGI->param("day") ."," . $CGI->param("year") .":\n";
	print MAIL $CGI->param("text") ."\n";
	print MAIL "\n";
	print MAIL "---------------------------------------------------------------------------\n";
	print MAIL "To approve, enter the following in the database:\n\n";
	print MAIL "$SQL\n";
	print MAIL "---------------------------------------------------------------------------\n";
	close(MAIL);

	print $CGI->header;
	ParseForm($header);
	print "The GMs have been alerted and will respond accordingly.<BR><BR>\n";
	print "<a href=\"$thispage\">Back to Timeline</a>."; 
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>Timeline</h1>\n";

	
	showdata();

	print "<BR><BR>Think you were part of a historical event that would have impact on the campaign?  Tell the GMs <a href=\"$thispage?action=new\">here</a>.<BR><BR>\n";\

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table where public > 0 order by year, month, day;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td width=120><b>Date</b></td>\n";
	print "<td><b>Event</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield"};
	   $key = $resptr->{"$keyfield"};
	   $bgcolor = "white";
	   print "<tr bgcolor=$bgcolor>\n";
	   print "<td width=120>";
	   print $resptr->{"year"};
	   if ($resptr->{"month"} > 0)
	   {
	     print ", ".$months[$resptr->{"month"}];
	     if ($resptr->{"day"} > 0)
	     {
	       print " ".$resptr->{"day"};
	     }
	   }
	   print "</td>\n";
	   print "<td>$name</td>\n";
	   print "</tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	filltable();
	$monthdrop = makeArrayDropDown(\@months,"month",[$months[$month]],"",1);
}

