#!/usr/bin/perl

# Require and Use
# * These statements alert perl.exe that
# * you are going to be using functions, 
# * subroutines, and methods from other
# * perl programs. "require" is used for a
# * perl library, and the "use" statement 
# * is usually used to reference a perl
# * object (usually referred to as a 
# * module).
require 'common.pl';
use DBI;
use CGI;
use CGI::Cookie;

$CGI = new CGI;
$pid = getPlayerID();
if (getAccessLevel($pid) >= $developer_access)
{
    if ($CGI->param("submit") eq "")
    {
	print $CGI->header();
	ParseForm($header);
	print $CGI->start_multipart_form(-name => "form1");
	print "<br><table border=0 align=\"center\"><tr><td align=\"center\"><b>Upload A Document</b></td></tr>\n<tr><td>";
	ParseForm("upload.tpl");
	print "</td></tr>\n</table>\n";
	print $CGI->end_form;
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	ParseForm($footer);
    }
    else
    {
	#print $CGI->header();
	$fn = $CGI->param('filename');
	$fh = $CGI->param('filename');
	$subdir = $CGI->param("subdir");
	$isbin = $CGI->param("isbinary") + 0;
	
	if ($subdir eq "")
	{
	  $subdir = ".";
	}

	$fn =~ s!^.*(\\|\/)!!; 

	system ("rm $fn");
	open (OUTFILE,">$subdir/$fn") || print $CGI->redirect("login.pl?error=" . encodeURL("Error creating $subdir/$fn. Please try again."));
	while (<$fh>)
	{
	   print OUTFILE $_;
	}
	close OUTFILE;
	close $fh;
	chmod 0777, "$subdir/$fn";
	if ($isbin == 0)
	{
		system ("/usr/bin/pcfix.pl $subdir/$fn");
		system ("/usr/local/bin/pcfix.pl $subdir/$fn");
	}
	chmod 0777, "$subdir/$fn";
        print STDOUT $CGI->redirect("login.pl?error=" . encodeURL("File <a href=\"$subdir/$fn\">$fn</a> successfully uploaded."));    
        exit 0;
    }
}
else
{
print $CGI->redirect("scripts/login.pl");
exit 0;
}