#!/usr/bin/perl -D

require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;


$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "varies.pl";
$table = "characterabilities";
$heading = "Varies Abilities";
$keyfield = "abid";
$keyvalue = $CGI->param($keyfield);
$tplfile = "varies.tpl";
$errstr = $CGI->param("error");

if ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit Varies Abilities..."));
}
elsif ($submit eq "Update")
{
	#print $CGI->header();
	# Update and Redirect
	$num_abs = $CGI->param("num_abs");
	local($dbvar) = dbconnect();
	for ($num = 0; $num < $num_abs; $num++)
	{
	   $level = $CGI->param("level_$num") + 0;
	   $difficulty = $CGI->param("difficulty_$num");
	   $text = $CGI->param("text_$num");
	   $text =~ s/'/''/g;
	   $diffnum = 0;
	   if ($difficulty eq "Very Easy")
	   {
	     $diffnum = 1;
	   }
	   if ($difficulty eq "Easy")
	   {
	     $diffnum = 2;
	   }
	   if ($difficulty eq "Hard" || $difficulty eq "Varies")
	   {
	     $diffnum = 3;
	   }
	   if ($difficulty eq "Very Hard")
	   {
	     $diffnum = 4;
	   }
	   if ($diffnum > 0)
	   {
	      $cost = getcost($level, $diffnum - 1);
	      $SQL = "update $table set difficulty='$difficulty', text ='$text', cost=$cost where caid=".$CGI->param("caid_$num").";";

	   }
	   else
	   {
	   	$SQL = "update $table set difficulty='$difficulty', text ='$text' where caid=".$CGI->param("caid_$num").";";
	   }
	   #print "$SQL<BR>";
	   $dbvar->do($SQL);
	}
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
else
{
	print $CGI->header;
	ParseForm($header);
	
	print "<font color=red>$errstr</font><BR><BR>\n";
	
	print "<H1>Manage Varies Abilities</h1>\n";
	
	showvaries();

	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	ParseForm($footer);
}

exit 0;

sub showvaries()
{
	local($db) = dbconnect();
	local ($sql) = "select a.caid, a.abid, a.charid, b.name, a.text, a.difficulty, a.level from characterabilities a, abilities b where a.abid=b.abid and b.difficulty='Varies' order by b.name, a.text;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<form action=\"$thispage?\" method=\"post\">";
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Character</b></td>\n";
	print "<td><b>Ability</b></td>\n";
	print "<td><b>Text</b></td>\n";
	print "<td><b>Difficulty</b></td>\n";
	print "</tr>\n";
	$num = 0;
	while ($resptr = $query->fetchrow_hashref())
	{
	   local ($name) = $resptr->{"name"};
	   local ($difficulty) = $resptr->{"difficulty"}; 
	   local ($text) = $resptr->{"text"}; 
	   $name =~ s/_//g;
	   print "<tr>\n";
	   print "<td align=\"center\">".getCharName($resptr->{"charid"});
	   print "<BR><i>(".emailTagFromID(getPIDFromCharID($resptr->{"charid"})). ")</i></td>";
	   print "<td><a href=\"\" onClick=\"javascript:window.open('abilitypop.pl?abid=".$resptr->{"abid"}."','','width=450,height=550,left = 100,top = 100,scrollbars=1,resizable=1');\">$name</a></td>\n";
	   print "<td><input type=text name=\"text_$num\" value=\"$text\"></td>\n";
	   $diffdrop = makeDropDown('abilitydifficulty', 'difficulty', 'difficulty', "", "", $difficulty);
	   $diffdrop =~ s/"difficulty"/"difficulty_$num"/g;
	   print "<td><input type=hidden name=\"caid_$num\" value=".$resptr->{"caid"}.">";
	   print "<input type=hidden name=\"level_$num\" value=\"".$resptr->{"level"}."\">";
	   print "$diffdrop";
	   print "</td>\n";
	   print "</tr>\n";
	   $num++;
	}
	print "</table>\n";
	print "<input type=hidden name=\"num_abs\" value=$num>\n";
	print "<BR><input type=\"submit\" name=\"submit\" value=\"Update\"><BR>";
	print "</form>";
	$query->finish;
	$db->disconnect;
}


