#!/usr/bin/perl

require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "venue.pl";  	#Name of this web page
$numtabs = 1;

$tabnum = 0;

$table[0] = "venues";  		#tables you're editing
$heading[0] = "Venue";		#textual description, for example, "A parsnip"
$keyfield[0] = "venueid";	#name of the primary key field of the table.
$keyvalue = $CGI->param($keyfield[$tabnum]);	
$namefield[0] = "vname";	#the name of the name field for the table.
$namevalue = dosql("select $namefield[$tabnum] from $table[$tabnum] where $keyfield[$tabnum]=$keyvalue;");
$tplfile[0] = "venue.tpl";	#File to make specfic editing look good.
$showDataFunc[0]=\&showdata;
$fillVarsFunc[0]=\&fillvars;
$errstr = $CGI->param("error");

@tabheadings = { "", "" };
$tabheadings[0] = "Manage $heading[0]s";

if ($al < $gm_access)
{
	print $CGI->redirect("main.pl?error=" . encodeURL("You are not authorized to edit $heading[$tabnum](s)!"));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	if ($keyvalue eq "")
	{
		$doctitle = "Add $heading[$tabnum]";
	}
	else
	{
        	$doctitle = "Edit $namevalue";
	}
	ParseForm($header);
     	print "<H1>$doctitle</H1>\n";
	print "<form action=\"$thispage\" method=\"post\">\n";

	$tmpFunc = $fillVarsFunc[$tabnum];
	&$tmpFunc();
	ParseForm($tplfile[$tabnum]);

	print "<input type=\"hidden\" name=\"tabnum\" value=\"$tabnum\">\n";
	print "<input type=\"hidden\" name=\"$keyfield[$tabnum]\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"$thispage\">Return/Cancel</a>.";
	print "<br><a href=\"main.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	$sql = filltablefromCGI($table[$tabnum], 1, $keyfield[$tabnum], $keyvalue[$tabnum]);
	#print "$sql<BR>";
	local($db) = dbconnect();
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading[$tabnum] Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	$sql = filltablefromCGI($table[$tabnum], 0, $keyfield[$tabnum], $keyvalue[$tabnum]);
	#print "$sql<BR>";
	local($db) = dbconnect();
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	#print "$sql<BR>";
	local($db) = dbconnect();
	$sql = "delete from $table[$tabnum] where $keyfield[$tabnum] = $keyvalue;";
	$db->do($sql);
	$db->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$namevalue Deleted"));
}
else
{
	print $CGI->header;
	$doctitle = "Manage ".$heading[$tabnum]."s";
	ParseForm($header);
	ParseForm("tabs.tpl");
	
	if ("$errstr" ne "")
	{
	   print "<font color=red>$errstr</font><BR><BR>\n";
	}
	
	print "<H1>$doctitle </h1>\n";

	showTabs();

	print "<a href=\"$thispage?action=new\">ADD a NEW $heading[$tabnum]</a><BR><BR>\n";
	$tmpFunc = $showDataFunc[$tabnum];
	&$tmpFunc();

	print "<br><hr><a href=\"main.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield[$tabnum]=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showTabs()
{
	local ($tottabs) = 1;
	
	if ($numtabs < 2)
	{
		return;
	}
	
	print "<table>\n";
	print "<tr>\n";
	
	for ($i = 0; $i < $numtabs; $i++)
	{
	      if ($tabnum == $i)
	      {
		   print "<td class=\"blacktab\">$tabheadings[$i]</td>\n";
	      }
	      else
	      {
		   print "<td class=\"greytab\" OnClick=\"document.location ='$thispage?tabnum=$i'\">$tabheadings[$i]</td>\n";
	      }
	      $tottabs = $tottabs + 1;
	      if ($tottabs % 7 == 0)
	      {
	    	print "</tr><tr>\n";
	      }
	}
	print "</tr>\n";
	print "</table>\n";
}

sub showdata()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table[$tabnum] order by $namefield[$tabnum];";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td><b>Name</b></td>\n";
	print "<td><b>Type</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   $name = $resptr->{"$namefield[$tabnum]"};
	   $key = $resptr->{"$keyfield[$tabnum]"};
	   print "<tr>\n";
	   print "<td>$name</td>\n";
	   print "<td>".$resptr->{"vtype"}."</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield[$tabnum]=$key\">Edit</a>\n";
	   $name =~ s/'//g;
	   print " -- <a href=\"javascript:deleteConfirm('$name',$key);\">Delete</a>\n";
	   print "</td></tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub fillvars()
{
	goodfilltable($table[$tabnum], $keyfield[$tabnum], $keyvalue);

	$typeselect = makeDropDown("eventtypes", "etid", "ettext");
	$venueselect = makeDropDown("venues", "venueid", "vname");
}

