#!/usr/bin/perl

require 'stat_inc.pl';
require 'common.pl';
use DBI;
use CGI qw/:standard/;
use CGI::Cookie;

$CGI = new CGI;
$action = $CGI->param("action");
$submit = $CGI->param("submit");
$pid = getPlayerID();
$al = getAccessLevel($pid);

#globals for this file
$thispage = "virtuallocations.pl";
$table = "virtuallocations";
$heading = "a Virtual Location";
$keyfield = "vlid";
$keyvalue = $CGI->param($keyfield);
$namefield = "vlname";
#$tplfile = "virtuallocations.tpl";

if ($action eq "giveaccess")
{
	print $CGI->header();
	ParseForm($header);
        fillvars();
        print "<H1>Give Characters Access to $vlname</H1>\n";
	print "<table border = 1>\n";
	print "<tr>\n";
	print "<td><b>Character Name</b></td>\n";
	print "<td><b>Has Access?</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	local($db) = dbconnect();
	local($query) = $db->prepare("select charid from characters where charid != $vlowner and chartype <= $cast_character order by clast");
	$query->execute;
	while (@array = $query->fetchrow_array)
	{
	  print "<tr>\n";
	  local ($charid) = $array[0];
	  print "<td>".getCharName($array[0])." (".getFullNameFromCharID($charid).")</td>\n";
	  local ($sql) = "select * from VLaccess where charid=$charid and $keyfield=$keyvalue";
	  #print "$sql<BR>";
	  local($query2) = $db->prepare($sql);
	  $query2->execute;
	  if ($query2->rows > 0)
	  {
		print "<td><b>Yes</b></td>\n";
		print "<td><a href=\"$thispage?action=remaccess&charid=$charid&$keyfield=$keyvalue\">Remove Access</a></td>\n";
		print "</tr>\n";
	  }
	  else
	  {
		print "<td>No</td>\n";
		print "<td><a href=\"$thispage?action=addaccess&charid=$charid&$keyfield=$keyvalue\">Give Access</a></td>\n";
		print "</tr>\n";
	  }
	  $query2->finish;
	}
	$query->finish;
	print "</table><BR>\n";
	
	print "<a href=\"stats.pl?charid=$vlowner&tab=150\">Return to STATs for ".getCharName($vlowner)."</a><BR>\n";
	print "<a href=\"bgafree.pl?charid=$vlowner&action=vl\">Return to Virtual Locations for ".getCharName($vlowner)."</a><BR>\n";
	print "<a href=\"bga.pl?charid=$vlowner\">Return to BGAs for ".getCharName($vlowner)."</a><BR>\n";
	
	if ($al >= $gm_access)
	{
		print "<a href=\"$thispage\">Return to Virtual Locations</a><BR>\n";
	}
	
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "addaccess")
{
	# add and Redirect
	local ($charid) = $CGI->param("charid");
	$SQL = "insert into VLaccess (charid,$keyfield) values ($charid, $keyvalue);";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?action=giveaccess&$keyfield=$keyvalue");
}
elsif ($action eq "remaccess")
{
	# Remove and Redirect
	local ($charid) = $CGI->param("charid");
	$SQL = "delete from VLaccess where charid=$charid and $keyfield=$keyvalue;";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?action=giveaccess&$keyfield=$keyvalue");
}
elsif ($al < $gm_access)
{
	print $CGI->redirect("login.pl?error=" . encodeURL("You are not authorized to edit Virtual Locations."));
}
elsif ($action eq "new" || $action eq "edit")
{
	print $CGI->header();
	ParseForm($header);
	if ($keyvalue eq "")
	{
		print "<H1>Add $heading</H1>\n";
	}
	else
	{
        	print "<H1>Edit $heading</H1>\n";
	}
	print "<form action=\"$thispage?\" method=\"post\">";
	if ($tplfile eq "")
	{
		local($dbvar) = dbconnect();
		local($query) = $dbvar->prepare("explain $table");
		local(@array);
		local(@arrNames);
		$query->execute;
		local($ind) = 0;
		    while (@arrCols = $query->fetchrow_array)
		    {
		    $arrNames[$ind] = $arrCols[0];
		    $array[$ind] = $arrCols[1];
		    $ind++;
		    }
		$query->finish;
		$query = $dbvar->prepare("select * from $table where $keyfield = $keyvalue");
		$query->execute;
		local($indFirstRecord) = 0;
		print "<table border=0>\n";
		@arrVals = $query->fetchrow_array;
		$input = $arrVals[0];
		print "<tr>\n<td>$arrNames[0]:</td><td>$input</td>\n</tr>\n";
		local($i) = 0;    
		    for($i=1;$i<$ind;$i++)
		    {
			if ($array[$i] eq "tinyint(1)")
			{
			    if ($arrVals[$i] eq "on")
			    {
			    $checked = " CHECKED";
			    }
			    else
			    {
			    $checked = "";
			    }
			$input = "<input type=\"checkbox\" name=\"$arrNames[$i]\"$checked>";
			}
			elsif ($array[$i] eq "mediumtext")
			{
			$input = "<textarea name=\"$arrNames[$i]\" COLS=20 ROWS=5>$arrVals[$i]</textarea>";
			}
			else
			{
			$input = "<input type=\"text\" name=\"$arrNames[$i]\" size=20 value=\"$arrVals[$i]\">";
			}
		    print "<tr>\n<td>$arrNames[$i]:</td><td>$input</td>\n</tr>\n";
		    }
		$indFirstRecord = 1;
		$query->finish;
		$dbvar->disconnect;
		print "</table>";
	}
	else
	{
	     fillvars();
	     ParseForm($tplfile);
	     if ($type eq "Resource")
	     {
	        print "<HR>\n";
	        print "<H2>Resource Links</H2>\n";
	        print "<p><i>These links will only be saved for Abilities of type Resource.</i></p>\n";
		showResourceLinks();
	     }
	}
	print "<input type=\"hidden\" name=\"$keyfield\" value=\"$keyvalue\">\n";
	if ($keyvalue eq "")
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Add\"><BR>";
	}
	else
	{
	   print "<input type=\"submit\" name=\"submit\" value=\"Change\"><BR>";
	}
	print "</form>";
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($submit eq "Add")
{
	# Insert and Redirect
	#print $CGI->header();
	@names = $CGI->param;
	$SQL = "INSERT into $table (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit") && index($i,"rtid_") != 0)
	    {
		$SQL .= "$i, ";
	    }

	}
	chop $SQL;
	chop $SQL;
	$SQL .= ") values (";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit") && index($i,"rtid_") != 0)
	    {
		local($myCGI) = $CGI->param($i);
		$myCGI =~ s/'/''/g;
		$SQL .= "'" . $myCGI . "', ";
	    }
	 }
	chop $SQL;
	chop $SQL;
	$SQL .= ");";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Added"));
}
elsif ($submit eq "Change")
{
	#print $CGI->header();
	# Update and Redirect
	@names = $CGI->param;
	$SQL = "UPDATE $table set ";
	foreach $i(@names)
	{
	    if (($i ne $keyfield) && ($i ne "submit") && index($i,"rtid_") != 0)
	    {
		local($myCGI) = $CGI->param($i);
		$myCGI =~ s/'/''/g;
		$SQL .= "$i = '" . $myCGI . "', ";
	    }
	}
	chop $SQL;
	chop $SQL;
	$SQL .= " where $keyfield = $keyvalue;";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Updated"));
}
elsif ($action eq "delete")
{
	# delete and Redirect
	deleteVL($keyvalue);
	print $CGI->redirect("$thispage?error=" . encodeURL("$heading Deleted"));
}
elsif ($action eq "givestats")
{
	print $CGI->header();
	ParseForm($header);
        fillvars();
        print "<H1>Add Secret STATs to $vlname</H1>\n";
        print "<H2>My STATs</H2>\n";
	print "<table border = 1>\n";
	print "<tr>\n";
	print "<td><b>STAT</b></td>\n";
	print "<td><b>Character</b></td>\n";
	print "<td><b>Level</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	local($db) = dbconnect();
	$SQL= "select a.vlsname, b.charid, b.vlslevel, b.vlsid from VLstats a, VLstatlink b where b.$keyfield = $keyvalue and a.vlsid = b.vlsid;";
	#print "$SQL<BR>";
	local($query) = $db->prepare($SQL);
	$query->execute;
	local (@array);
	while (@array = $query->fetchrow_array)
	{
	  print "<tr>\n";
	  local ($charid) = $array[1];
	  print "<td>$array[0]</td>\n";
	  print "<td>".getCharName($charid)." (".getFullNameFromCharID($charid).")</td>\n";
	  print "<td>$array[2]</td>\n";
	  print "<td><a href=\"$thispage?action=remstat&$keyfield=$keyvalue&vlsid=".$array[3]."&charid=$charid\">Remove</a></td>\n";
	  print "</tr>\n";
	}
	$query->finish;
	print "</table><BR>\n";

        print "<H2>Available STATs</H2>\n";
	print "<table border = 1>\n";
	print "<tr>\n";
	print "<td><b>STAT</b></td>\n";
	print "<td><b>Description</b></td>\n";
	print "<td><b>Action</b></td>\n";
	print "</tr>\n";
	$query = $db->prepare("select * from VLstats order by vlsname;");
	$query->execute;
	while ($resptr = $query->fetchrow_hashref())	
	{
	  print "<tr>\n";
	  print "<td>".$resptr->{"vlsname"}."</td>\n";
	  print "<td>".$resptr->{"vlsdesc"}."</td>\n";
	  print "<td><a href=\"$thispage?action=addstat&$keyfield=$keyvalue&vlsid=".$resptr->{"vlsid"}."&vlowner=$vlowner\">Add</a></td>\n";
	  print "</tr>\n";
	}
	$query->finish;
	print "</table><BR>\n";

	print "<a href=\"$thispage\">Return to Virtual Locations</a><BR>\n";
	
	print "<br><hr><a href=\"login.pl\">Main Menu</a>.";
	ParseForm($footer);
}
elsif ($action eq "addstat")
{
	# add and Redirect
	#print $CGI->header;
	local ($vlowner) = $CGI->param("vlowner");
	local ($vlsid) = $CGI->param("vlsid");
	$SQL = "insert into VLstatlink (vlid,vlsid,charid) values ($keyvalue, $vlsid, $vlowner);";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?action=givestats&$keyfield=$keyvalue");
}
elsif ($action eq "remstat")
{
	# Remove and Redirect
	#print $CGI->header;
	local ($charid) = $CGI->param("charid");
	local ($vlsid) = $CGI->param("vlsid");
	$SQL = "delete from VLstatlink where charid=$charid and $keyfield=$keyvalue and vlsid=$vlsid;";
	#print "$SQL<BR>";
	local($dbvar) = dbconnect();
	$dbvar->do($SQL);
	$dbvar->disconnect;
	print $CGI->redirect("$thispage?action=givestats&$keyfield=$keyvalue");
}
else
{
	print $CGI->header;
	ParseForm($header);
	print "<H1>Virtual Locations Menu</h1>\n";

	showVLs();

	print "<BR><a href=\"$thispage?action=new\">ADD a NEW Virtual Location</a>\n";
	print "<br><hr><a href=\"login.pl\">Main menu</a>."; 
	
	print "<script language=\"javascript\">\n";
	print "var delName, jscharid;\n";
	print "function deleteConfirm(delName, jsid)\n";
	print "{\n";
	print "  var yn;\n";
	print "  yn = confirm(\"Really delete \"+delName+\"?\");\n";
	print "  if (yn)\n";
	print "  {\n";
	print "    window.location = \"$thispage?action=delete&$keyfield=\"+jsid;\n";
	print "  }\n";
	print "}\n";
	print "</script>\n";
	
	ParseForm($footer);
}

exit 0;

sub showVLs()
{
	local($db) = dbconnect();
	local ($sql) = "select * from $table order by $namefield;";
	#print "$sql<BR>";  
	local ($query) = $db->prepare($sql);
	$query->execute;
	print "<table border=1>\n";
	print "<tr>\n";
	print "<td>Name</td>\n";
	print "<td>Description</td>\n";
	print "<td>Owner</td>\n";
	print "<td>Action</td>\n";
	print "</tr>\n";
	while ($resptr = $query->fetchrow_hashref())
	{
	   print "<tr>\n";
	   print "<td>".$resptr->{"$namefield"}."</td>\n";
	   print "<td>".$resptr->{"vldesc"}."<BR>\n";
	   print "<table border=1 width=100%>";
	   print "<tr> ";
	   $val = getVLtotal($resptr->{"vlid"},"vl_fancy", "vla_fancy");
	   print "$smalltd1 Fancy: $val </td>";
	   $val = getVLtotal($resptr->{"vlid"},"vl_secure", "vla_secure");
	   print "$smalltd1 Secure: $val </td>";
	   $val = getVLtotal($resptr->{"vlid"},"vl_location", "vla_location");
	   print "$smalltd1 Location: $val </td>";
	   $val = getVLtotal($resptr->{"vlid"},"vl_inventory", "vla_inventory");
	   print "$smalltd1 Inventory: $val </td>";
	   print "</tr>\n";	
	   print showspecialVLstats($resptr->{"vlid"}, $num_vls, "vl");
	   print "</table></td>\n";
	   print "<td>".getCharName($resptr->{"vlowner"})." (".getFullNameFromCharID($resptr->{"vlowner"}).")</td>\n";
	   print "<td>";
	   print "<a href=\"$thispage?action=edit&$keyfield=".$resptr->{"$keyfield"}."\">Edit</a>\n";
	   print " -- <a href=\"$thispage?action=giveaccess&$keyfield=".$resptr->{"$keyfield"}."\">Add Characters</a>\n";
	   print " -- <a href=\"$thispage?action=givestats&$keyfield=".$resptr->{"$keyfield"}."\">Add Secret STATs</a>\n";
	   print " -- <a href=\"javascript:deleteConfirm('".$resptr->{"$namefield"}."',".$resptr->{"$keyfield"}.");\">Delete</a>\n";
	   print "</td>";
	   print "</tr>\n";
	}
	print "</table>\n";
	$query->finish;
	$db->disconnect;
}

sub showspecialVLstats()
{
  local ($vlid) = $_[0];
  local ($nums) = $_[1];
  local ($jssub) = $_[2];
  local($db) = dbconnect();
  local ($sql) = "select b.vlsname, a.vlsid, b.vlsdesc from VLstatlink a, VLstats b, virtuallocations c where a.vlid=$vlid and a.vlsid=b.vlsid and a.charid=c.vlowner and c.vlid=$vlid;";
  #print "$sql<BR>";
  local($query) = $db->prepare($sql);
  $query->execute;
  local($retstr)= "";
  local ($sub) = 0;
  if ($query->rows > 0)
  {
     $retstr .= "<tr>\n";
     local ($resptr);
     while ($resptr = $query->fetchrow_hashref())
     {
        $sql = "select vlslevel from VLstatlink where vlid=$vlid and vlsid=".$resptr->{"vlsid"}." and charid=$charid;";
   	#print "$sql<BR>";
  	local($query2) = $db->prepare($sql);
  	$query2->execute;
  	local (@myval);
  	$myval[0] = 0;
  	if ($query2->rows > 0)
  	{
  		@myval = $query2->fetchrow_array();
  	}
	$query2->finish;
        $sql = "select sum(vlslevel) from VLstatlink where vlid=$vlid and vlsid=".$resptr->{"vlsid"}.";";
   	#print "$sql<BR>";
  	$query2 = $db->prepare($sql);
  	$query2->execute;
  	local (@mysum);
  	$mysum[0] = 0;
  	if ($query2->rows > 0)
  	{
  		@mysum = $query2->fetchrow_array();
  	}
	$query2->finish;
        local ($name) = $resptr->{"vlsname"};
     	$retstr .= "$smalltd1 ";
     	$retstr .= "<i>$name: ";
     	$retstr .= $mysum[0];
     	$retstr .= "</i></td>\n";
     }
     $retstr .= "</tr>\n";
  }
  $query->finish;
  $db->disconnect;
  return $retstr;
}

sub fillvars()
{
	filltable();

	$catselect = makeDropDown("abilitycategories", "category", "category", "", "", $category);
	$challengeselect = makeDropDown("abilitychallenge", "challenge", "challenge", "", "", $challenge);
	$diffselect = makeDropDown("abilitydifficulty", "difficulty", "difficulty", "", "", $difficulty);
	$typeselect = makeDropDown("abilitytypes", "type", "type", "", "", $type);
	$allowedselect = makeDropDown("abilityallowed", "allowed", "allowed", "", "", $allowed);
}

